--requires "AudioEngine"
musicManager = musicManager or {}

musicManager._lastMusicPath = nil

musicManager._isMusicEnable = cc.UserDefault:getInstance():getBoolForKey("music_enable",true)
musicManager._isEffectEnable= cc.UserDefault:getInstance():getBoolForKey("eff_enable",true)--by.huangjunjian控制全局音效

--音乐管理类内部使用，使用者只需要关注musicManager对象即可
musicManager._sharedEngine = cc.SimpleAudioEngine:getInstance()
local engine = cc.SimpleAudioEngine:getInstance()

musicManager._currentBackMusic = nil
musicManager._preBackMusic = nil 

function musicManager.playSound(filename, isLoop)
    musicManager._sharedEngine:playEffect(filename, isLoop)
end

--设置音量
function musicManager.setVolume(value)
    musicManager._sharedEngine:setMusicVolume(value)
end
--获取音量
function musicManager.getVolume()
    return musicManager._sharedEngine:getMusicVolume()
end

function musicManager.playBackgroundMusic(fileName,isLoop)
	musicManager.playMusic(fileName,isLoop)
end


function musicManager.playMusic(fileName,isLoop)
    if isLoop == nil then
        isLoop = false
    end
    -- --如果音乐是开启，此处判断要严谨
    if musicManager.isMusicEnable() == true then
        if fileName and string.len(fileName) > 0 and cc.FileUtils:getInstance():isFileExist(fileName) == true then
            if musicManager._lastMusicPath and musicManager._lastMusicPath == fileName then
                musicManager._sharedEngine:resumeMusic()
            else
                if not cc.FileUtils:getInstance():isFileExist(fileName) then
                    return
                end
                musicManager._sharedEngine:playMusic(fileName,isLoop)
                musicManager._lastMusicPath = fileName
            end
        end
    else
        
    end
end


function musicManager.preloadAllEffect()
    local effects = {
        [1] = "res/sound_battle_victory_1.wav"
    }

    for i=1,#effects do
        musicManager._sharedEngine:preloadEffect(effects[i])
    end
end

--关闭背景音乐
function musicManager.stopBackgroundMusic()
    musicManager.stopMusic()
end

--暂停背景音乐
function musicManager.pauseBackgroundMusic()
    musicManager._sharedEngine:pauseMusic()
end

function musicManager.resumBackgroundMusic( )
    musicManager._sharedEngine:resumeMusic()
end

--音乐是否正在播放
function musicManager.isMusicPlaying()
	local ret = musicManager._sharedEngine:isMusicPlaying()
    return ret
end

--@@@@@@@@@@@@@-------音效begin-----@@@@@@@@@@@@@@@@@--
function musicManager.playEffect(pszFilePath,bLoop)
    local _soundId = 0
    --pitch = 1.0f, float pan = 0.0f, float gain = 1.0f
    if  musicManager.isEffectEnable() == true then
        if pszFilePath and string.len(pszFilePath) > 0 and cc.FileUtils:getInstance():isFileExist(pszFilePath) == true then
            if bLoop == nil then
                bLoop = false
            end
            _soundId = musicManager._sharedEngine:playEffect(pszFilePath,bLoop)
        end
    end
    return _soundId
end

function musicManager.preloadEffect(fileName)
    musicManager._sharedEngine:preloadEffect(fileName)
end

function musicManager.stopEffect(int_value)
    musicManager._sharedEngine:stopEffect(int_value)
end

function musicManager.setEffectVolume(volume)
    musicManager._sharedEngine:setEffectsVolume(volume)
end

function musicManager.stopAllEffects()
    musicManager._sharedEngine:stopAllEffects()
end

function musicManager.setMusicEnable(enable,type)--[[type传值在战斗中开启音乐播放战斗bg而不是主城by.huangjunjian]]
    musicManager._isMusicEnable = enable
    cc.UserDefault:getInstance():setBoolForKey("music_enable", enable)
    cc.UserDefault:getInstance():flush()
    if enable == true then
        musicManager.playMusic(zc.bgm.city, true)
    else
        musicManager.stopMusic()
    end
    --最好执行这行代码
    
end

function musicManager.isMusicEnable()
    return musicManager._isMusicEnable
end

function musicManager.setEffectEnable(enable)--设置中调用决定音效开启关不by。huangjunjian
    musicManager._isEffectEnable = enable
    cc.UserDefault:getInstance():setBoolForKey("eff_enable", enable)
    cc.UserDefault:getInstance():flush()
end

function musicManager.isEffectEnable()
    return musicManager._isEffectEnable
end

function musicManager.stopMusic()
    musicManager._sharedEngine:stopMusic(false)
    musicManager._lastMusicPath = nil
end
--@@@@@@@@@@@@@-------音效end-----@@@@@@@@@@@@@@@@@--


