--[[
	限时特卖活动
]]
local FlashSaleLayer = class( "FlashSaleLayer", function ()
    local layer = cc.Sprite:create()
    layer:setContentSize(975,490)
	return layer
end)

function FlashSaleLayer:create(params)
    return FlashSaleLayer.new(params)
end

function FlashSaleLayer:ctor(params)
	self:initData(params)
	self:initUI()
    local function onNodeEvent(event)
        if "cleanup" == event then
            self:onCleanup()
        end
    end
    self:registerScriptHandler(onNodeEvent)
end

function FlashSaleLayer:onCleanup()
    if self._timer then
        scheduler.unscheduleGlobal( self._timer )
        self._timer = nil
    end
    if self._timer_global then
        scheduler.unscheduleGlobal( self._timer_global )
        self._timer_global = nil
    end
end

function FlashSaleLayer:initData( params )
	-- dump(params,"限时特卖全部数据：")
    -- 存储静态表，后面限购次数和数量会用到
    local data = params.static or {}
	self._datas = {}
	for k,v in pairs(data) do
		table.insert(self._datas, v)
	end
	table.sort(self._datas, function ( a, b )
		return tonumber(a.id) < tonumber(b.id)
	end)
	
    -- 保存限购数量和限购次数
    self._staticData = {}
    for k,v in pairs(self._datas) do
        table.insert(self._staticData, {id = v.id, number = v.number})
    end
    dump(self._staticData, "fuck--")
	self._id = tonumber(params.id) or 26
	self._alreadyBuy = {}
	local buy = params.buy or {}
	for k,v in pairs(buy) do
		for k1,v1 in pairs(self._datas) do
			if tonumber(v1.id) == tonumber(k) then
				v1.count = tonumber(v1.count) - tonumber(v)
			end
		end
	end
	
	local shengyuTb = params.totalNums or {}
	for k,v in pairs(shengyuTb) do
		for k1,v1 in pairs(self._datas) do
			if tonumber(v1.id) == tonumber(k) then
				v1.number = tonumber(v1.number) - tonumber(v)
			end
		end
	end
	-- dump(self._datas,"限时特卖：")
	self._btn_table = {}
	self._curIndex = 1
	self._nowCellIndex = 0 -- tableView 当前cell
    -- 标记自动刷新界面是否已经进入
    self._bool_refresh = false
end

function FlashSaleLayer:initUI()
	local _di = zc.createSprite("res/Main/activity/flash_sale/bg.png")
	_di:setAnchorPoint(cc.p(0, 0))
	_di:setPosition(cc.p(-10, 15))
	self:addChild(_di)
	self._di = _di

    local _text_sp = zc.createSprite("res/Main/activity/flash_sale/temai.png")
    _text_sp:setPosition(cc.p(400, 260))
    self:addChild(_text_sp ,-1)
    self._text_sp = _text_sp

	local light_sprite = zc.createSprite("res/Main/activity/flash_sale/btn_normal.png")
    local _cellSize = cc.size(160, light_sprite:getContentSize().height)
	local _tbSize = cc.size(800, _cellSize.height)
    local _tableView = zc.ZCTableView:create(_tbSize)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    _tableView:setPosition((_di:getContentSize().width - _tbSize.width) * 0.5, _di:getContentSize().height - _tbSize.height + 13)
   	_di:addChild(_tableView)
    self._tableView = _tableView
    
    -- 左右按钮
    local _leftBtn = zc.createPushButton({
        normalFile = "res/Main/arena/hallFame/arrow_up.png",
        selectedFile = "res/Main/arena/hallFame/arrow_down.png",
        pos = cc.p(100 - 50, 450 - 15),
        endCallback = function ()
            -- self:scrollTableView(0)
        end,
    })
    _leftBtn:setEnable(false)
    _di:addChild(_leftBtn)
    self._leftBtn = _leftBtn

    local _node1 = zc.createSprite("res/Main/arena/hallFame/arrow_up.png")
    _node1:setFlippedX(true)
    local _node2 = zc.createSprite("res/Main/arena/hallFame/arrow_down.png")
    _node2:setFlippedX(true)
    local _rightBtn = zc.createPushButton({
        normalNode = _node1,
        selectedNode = _node2,
        pos = cc.p(_leftBtn:getPositionX() + _tbSize.width + 60, _leftBtn:getPositionY()),
        endCallback = function ()
            -- self:scrollTableView(1)
        end,
    })
    _rightBtn:setEnable(false)
    _di:addChild(_rightBtn)
    self._rightBtn = _rightBtn
    
    local function cellSizeForTable(table, idx) 
        return _cellSize.height, _cellSize.width
    end
    local function numberOfCellsInTableView()
        return #self._datas
    end

    local function tableCellAtIndex(table, cellIndex) 
        local cell = _tableView:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
            self:buildCell(cell)
        end
        local _idx = cellIndex + 1
        self:updateCell(cell, _idx)
        return cell
    end
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _tableView:registerScriptHandler(function()
        if #self._datas <= 5 then
            self._leftBtn:setVisible( false)
            self._rightBtn:setVisible(false)
        else
            local pos = _tableView:getContainer():getPosition()
            self._leftBtn:setVisible( pos < 0)
            self._rightBtn:setVisible( pos > -_cellSize.width*(#self._datas - 5))
        end
    end, cc.SCROLLVIEW_SCRIPT_SCROLL)
    _tableView:reloadData()
    self._tableView = _tableView


    -- 左下半部分
    -- 	id = 礼包id
-- 	type = 限购类型
-- 	number = 礼包数量
-- 	count = 限购次数
-- 	primeCost = 原价
-- 	discount = 折扣价
-- 	repPrice = 回购价
-- 	startTime = 开始时间
-- 	endTime = 结束时间
-- 	goods = 售卖内容
    local _info = self._datas[1]

    -- local _label_fnt = zc.createFntLabel({
    --         fnt = "res/Main/activity/flash_sale/fnt/flash_sale_num.fnt",
    --         text = "12",
    --         pos = cc.p(100, 200),
    --         addwidth = -6,
    --     })
    -- self._di:addChild(_label_fnt)
    -- 大折扣
    local _label_big_zhe = cc.Node:create()
    _label_big_zhe:setPosition(cc.p(350, 360))
    _label_big_zhe:setRotation(10)
    _di:addChild(_label_big_zhe)
    local _label_big_zhe_left = zc.createFntLabel({
    	fnt = "res/Main/activity/flash_sale/fnt/flash_sale_num.fnt",
        text = "9",
    	pos = cc.p(0, 0),
    	})
    _label_big_zhe._label_big_zhe_left = _label_big_zhe_left
    _label_big_zhe:addChild(_label_big_zhe_left)
    -- 点
    local _label_dian = zc.createFntLabel({
        fnt = "res/Main/activity/flash_sale/fnt/flash_sale_num.fnt",
        text = ".",
        pos = cc.p(_label_big_zhe_left:getPositionX() + _label_big_zhe_left:getContentSize().width * 0.5, -8),
        })
    _label_dian:setScale(0.7)
    _label_big_zhe._label_dian = _label_dian
    _label_big_zhe:addChild(_label_dian)
    -- 小数点后一位
    local _label_xiaoshu = zc.createFntLabel({
        fnt = "res/Main/activity/flash_sale/fnt/flash_sale_num.fnt",
        text = "9",
        pos = cc.p(_label_dian:getPositionX() + _label_dian:getContentSize().width / 2, 0),
        })
    _label_xiaoshu:setScale(0.75)
    _label_big_zhe:addChild(_label_xiaoshu)
    _label_big_zhe._label_xiaoshu = _label_xiaoshu
    self._big_zhe = _label_big_zhe
    -- 原价
	local _old_price_node = cc.Node:create()
	_old_price_node:setPosition(290, 160)
	_di:addChild(_old_price_node)
    self._old_price_node = _old_price_node
	local _label_old = zc.createLabel({
		text = zc.lang("old_price") ..":",
		color = cc.c3b(255, 243, 202),
		ap = cc.p(0, 0.5),
		fontSize = 19,
		})
	_old_price_node:addChild(_label_old)

	local _old_price = zc.createLabel({
		text = "999",
		fontSize = 21,
		color = cc.c3b(255, 255, 255),
		ap = cc.p(0, 0.5),
		pos = cc.p(_label_old:getPositionX() + _label_old:getContentSize().width + 10, _label_old:getPositionY()),
		})
	_old_price_node:addChild(_old_price)
	self._old_price = _old_price

	local _yuanbao = zc.createSprite("res/Main/common/common_icon_gold.png")
	_yuanbao:setScale(0.85)
    _yuanbao:setAnchorPoint(cc.p(0, 0.5))
    _yuanbao:setPosition(cc.p(_old_price:getPositionX() + _old_price:getContentSize().width + 10, _label_old:getPositionY()))
    _old_price_node:addChild(_yuanbao)

	local _huaxian = zc.createSprite("res/Main/activity/discountShop/zhekouLine.png")
	_huaxian:setAnchorPoint(cc.p(0, 0.5))
	_old_price_node:addChild(_huaxian)
	-- 现价
	local _now_price_node = cc.Node:create()
	_now_price_node:setPosition(_old_price_node:getPositionX(), _old_price_node:getPositionY() - 45)
	_di:addChild(_now_price_node)
    self._now_price_node = _now_price_node
	local _label_now = zc.createLabel({
		text = zc.lang("now_price") ..":",
		color = cc.c3b(255, 243, 202),
		ap = cc.p(0, 0.5),
		fontSize = 23,
		})
	_now_price_node:addChild(_label_now)
	local _now_price = zc.createLabel({
		text = "999",
		fontSize = 29,
		color = cc.c3b(255, 255, 255),
		ap = cc.p(0, 0.5),
		pos = cc.p(_label_now:getPositionX() + _label_now:getContentSize().width + 10, _label_now:getPositionY()),
		})
	_now_price_node:addChild(_now_price)
	self._now_price = _now_price

	local _yuanbao2 = zc.createSprite("res/Main/common/common_icon_gold.png")
	_yuanbao2:setScale(1.2)
    _yuanbao2:setAnchorPoint(cc.p(0, 0.5))
    _yuanbao2:setPosition(cc.p(_now_price:getPositionX() + _now_price:getContentSize().width + 10, _label_now:getPositionY()))
    _now_price_node:addChild(_yuanbao2)
    self._big_yuanbao = _yuanbao2
    -- 回购价

    -- 折扣倒计时
    local _discount_time_node = cc.Node:create()
	_discount_time_node:setPosition(_now_price_node:getPositionX(), _now_price_node:getPositionY() - 45)
	_di:addChild(_discount_time_node)

	local _discount_desc = zc.createLabel({
		text = zc.lang("discount_time"),
		fontSize = 23,
		color = cc.c3b(255, 243, 202),
		ap = cc.p(0, 0.5),
		})
	_discount_time_node:addChild(_discount_desc)
	self._discount_desc = _discount_desc
	-- 倒计时
	local _discount_label = zc.createLabel({
		text = "dafda",
		ap = cc.p(0, 0.5),
		fontSize = 24,
		color = cc.c3b(253, 220, 33),
		pos = cc.p(_discount_desc:getPositionX() + _discount_desc:getContentSize().width + 10, _discount_desc:getPositionY()),
		})
	_discount_time_node:addChild(_discount_label)
	self._discount_label = _discount_label
	-- 提示语句
    local _tip_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    _tip_bg:setAnchorPoint(cc.p(0, 0.5))
    _tip_bg:setPosition(cc.p(_discount_time_node:getPositionX() - 30, 30))
    _di:addChild(_tip_bg)
    local tanhao = zc.createSprite("res/Main/activity/rechargeReward/tanhao.png")
    tanhao:setAnchorPoint(cc.p(0, 0.5))
    tanhao:setPosition(cc.p(1, _tip_bg:getContentSize().height * 0.5))
    _tip_bg:addChild(tanhao)

    local _tip_desc = zc.createLabel({
    	text = zc.lang("tip_discount_tip"),
    	color = cc.c3b(217, 198, 155),
    	ap = cc.p(0, 0.5),
    	fontSize = 19,
    	pos = cc.p(tanhao:getPositionX() + tanhao:getContentSize().width, _tip_bg:getContentSize().height * 0.5),
    	})
    _tip_bg:addChild(_tip_desc)
    self._tip_desc = _tip_desc
    -- primeCost = 原价
	-- discount = 折扣价
	-- repPrice = 回购价
    
    local _zhekou = zc.createLabel({
    	text = "999" .. zc.lang("discount_text"),
    	color = cc.c3b(255, 0, 0),
    	ap = cc.p(0, 0.5),
    	fontSize = 24,
    	pos = cc.p(_tip_desc:getPositionX() + _tip_desc:getContentSize().width, _tip_bg:getContentSize().height * 0.5)
    	})
    _tip_bg:addChild(_zhekou)
    self._zhekou = _zhekou
    _tip_bg:setContentSize(cc.size(tanhao:getContentSize().width + _tip_desc:getContentSize().width + _zhekou:getContentSize().width + 10,30 ))
 	-- 右下部分
 	local _plat = zc.createSprite("res/Main/activity/flash_sale/plat.png")
 	_plat:setPosition(cc.p(750, _di:getContentSize().height * 0.5 - 100))
 	_di:addChild(_plat)
 	local _light = zc.getSpine("xianshitemai")
    _light:playAction( "idle2", true )
    -- _light:setScaleY(2)
    _light:setPosition( _plat:getPositionX(), _plat:getPositionY() + 20 )
    _di:addChild( _light )

    local _light2 = zc.getSpine("xianshitemai")
    _light2:playAction( "idle1", true )
    -- _light2:setScaleY(2)
    _light2:setPosition( _light:getPosition() )
    _di:addChild( _light2 )

  	-- 购买按钮
  	local _buy_btn = zc.createCommomBtn({
    	tag = 1,
    	text = zc.lang("buy2"),
    	pos = cc.p(_plat:getPositionX(), _plat:getPositionY() - 60),
    })
    _di:addChild(_buy_btn)
    self._buy_btn = _buy_btn
    -- 限制购买
    local _limit_buy_tip = zc.createRichLabel({
    	text = "aaa",
    	pos = cc.p(_buy_btn:getPositionX(), _buy_btn:getPositionY() - 50),
    	color = cc.c3b(),
    	fontSize = 20,
    	color = cc.c3b(217, 198, 155),
    	})
    _di:addChild(_limit_buy_tip)
    self._limit_buy_tip = _limit_buy_tip

	self:refreshUI()
end

-- flag = 0， 向左移动，其他向右移动
function FlashSaleLayer:scrollTableView( flag )
	if flag == 0 then
		self._nowCellIndex = self._nowCellIndex - 1
	else
		self._nowCellIndex = self._nowCellIndex + 1
	end

	if self._nowCellIndex <= 0 then
		self._nowCellIndex = 0
		self._leftBtn:setVisible(false)
	elseif self._nowCellIndex >= #self._datas - 5 then
		self._nowCellIndex = #self._datas - 5
		self._rightBtn:setVisible(false)
	else 
		self._leftBtn:setVisible(true)
		self._rightBtn:setVisible(true)
	end

	self._tableView:scrollToCell(self._nowCellIndex, true)
	
end

function FlashSaleLayer:buildCell( cell )
	local cellSize = cell:getContentSize()
	local _btn = zc.createPushButton({
            normalFile = "res/Main/activity/flash_sale/btn_normal.png",
    		selectedFile = "res/Main/activity/flash_sale/btn_selected.png",
            fontSize = 22,
            fontColor = cc.c3b(75, 0, 0),
            needEnableWhenMoving = false,
            needSwallow = false,
            scale = 0.9,
        })
	_btn:setPosition(cc.p(cellSize.width * 0.5, cellSize.height * 0.5))
	cell:addChild(_btn)
	cell._btn = _btn
	-- 活动开始时间
	local _big_time = zc.createLabel({
		text = "aaa",
		pos = cc.p(_btn:getContentSize().width * 0.5, _btn:getContentSize().height * 0.5 + 25),
		fontSize = 20,
		color = cc.c3b(221, 134, 103),
		outLine = true,
		})
	_btn:addChild(_big_time)
	local _little_time = zc.createLabel({
		text = "bbb",
		color = cc.c3b(221, 134, 103),
		pos = cc.p(_btn:getContentSize().width * 0.5, _btn:getContentSize().height * 0.5 - 5),
		fontSize = 20,
		outLine = true,
		})
	_btn:addChild(_little_time)
	_btn._big_time = _big_time
	_btn._little_time = _little_time
	
end

function FlashSaleLayer:updateCell( cell, index )
	local _info = self._datas[index]
	cell._btn._idx = index
	local _turnInfo = PlayerData:getLimitActiveInfoByID(self._id)
    -- dump(_turnInfo, "turnInfo:")
	if _turnInfo.openTime then
		local _openTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), tonumber(_turnInfo.openTime) + tonumber(_info.startTime) )
		cell._btn._big_time:setString(_openTime)
        local start = tonumber(_turnInfo.openTime) + tonumber(_info.startTime)
        local _little_time_str = os.date("%X", start)
		cell._btn._little_time:setString(_little_time_str)
	end
	if index == self._curIndex then
		self:setSelec(cell._btn, 1)
	else
		self:setSelec(cell._btn, 0)
	end
	cell._btn:setTouchEndedCall(function ( )
		local pre_cell = self._tableView:cellAtIndex(self._curIndex - 1)
		if pre_cell then
			self:setSelec(pre_cell._btn, 0)
		end
		self._curIndex = index
		self:setSelec(cell._btn, 1)
        self._bool_refresh = false
		self:refreshUI()
	end)
end

-- flag = 0, 不选中状态，其他为选中状态
function FlashSaleLayer:setSelec( btn, flag )
	if flag == 0 then
		btn:setSelected(false)
		btn._big_time:setColor(cc.c3b(221, 134, 103))
		btn._little_time:setColor(cc.c3b(221, 134, 103))
	else
		btn:setSelected(true)
		btn._big_time:setColor(cc.c3b(255, 255, 255))
		btn._little_time:setColor(cc.c3b(253, 220, 33))
	end
end

function FlashSaleLayer:refreshUI( )
    local _info = self._datas[self._curIndex]
    -- 主动刷新界面
    if self._timer_global then
        scheduler.unscheduleGlobal( self._timer_global )
        self._timer_global = nil
    end
    local _turnInfo_g = PlayerData:getLimitActiveInfoByID(self._id)
    if _turnInfo_g.openTime then
        self._timer_global = scheduler.scheduleGlobal(function ()
            print("定时器刷新中----")
            local act_endTime = tonumber(_turnInfo_g.openTime) + tonumber(_info.endTime) -- 活动结束时间
            local now_time = tonumber(PlayerData:getTime()) or 0   -- 当前时间
            local atc_startTime = tonumber(_turnInfo_g.openTime) + tonumber(_info.startTime) -- 活动开始时间
            if self._bool_refresh == true or now_time > act_endTime then
                scheduler.unscheduleGlobal( self._timer_global )
                self._timer_global = nil
                return
            end
            if now_time <= act_endTime and now_time >= atc_startTime then  -- 已经结束
                self._bool_refresh = true
                self:refreshUI()
                scheduler.unscheduleGlobal( self._timer_global )
                self._timer_global = nil
            end  
                 
        end, 1)
    end

	-- 大的折扣 向上取整
	local y = tonumber(_info.primeCost) or 0
    local d = tonumber(_info.discount) or 0
    local z = math.ceil(d / y * 100) / 10
    local zhengshu = math.floor(z)
    local xiaoshu = (tonumber(z) - tonumber(zhengshu)) * 10

    self._old_price:setString(_info.primeCost)
    -- self._now_price:setString(_info.discount)
    -- 小折扣向下取整
    local zhecount = tonumber(_info.repPrice) or 0
    local zhe = math.floor(zhecount / y * 100) / 10
    local zheng = math.floor(zhe)
    local xiao = (tonumber(zhe) - tonumber(zheng)) * 10

    -- flag = false 不可见 true 可见
    --  id = 礼包id
    --  type = 限购类型
    --  number = 礼包数量
    --  count = 限购次数
    --  primeCost = 原价
    --  discount = 折扣价
    --  repPrice = 回购价
    --  startTime = 开始时间
    --  endTime = 结束时间
    --  goods = 售卖内容
    local function changeLittleZhe(flag)
        if flag == false then
            self._tip_desc:setString(zc.lang("tip_limit_over"))
            self._now_price:setString(_info.repPrice)
            self._zhekou:setVisible(false)
            self._old_price_node:setPosition(290, 160 - 20)
            self._now_price_node:setPosition(self._old_price_node:getPositionX(), self._old_price_node:getPositionY() - 45)
            self._big_yuanbao:setPosition(cc.p(self._now_price:getPositionX() + self._now_price:getContentSize().width + 10, 0))
            return
        end
        self._old_price_node:setPosition(290, 160)
        self._now_price_node:setPosition(self._old_price_node:getPositionX(), self._old_price_node:getPositionY() - 45)
        self._tip_desc:setString(zc.lang("tip_discount_tip"))
        self._zhekou:setVisible(true)
        self._now_price:setString(_info.discount)
        self._big_yuanbao:setPosition(cc.p(self._now_price:getPositionX() + self._now_price:getContentSize().width + 10, 0))
        if xiao == 0 then
            self._zhekou:setString(zheng .. zc.lang("discount_text"))
        else
            self._zhekou:setString(zhe .. zc.lang("discount_text"))
        end
    end
    -- flag = 0 大折扣 1 小折扣
    local function changeBigzhe( flag )
        local zhengshu_part = 0
        local xiaoshu_part = 0
        if flag == 0 then
            zhengshu_part = zhengshu
            xiaoshu_part = xiaoshu
        else
            zhengshu_part = zheng
            xiaoshu_part = xiao
        end
        print("flag = "..flag..":".. "整数："..zhengshu_part.."小数："..xiaoshu_part)
        if xiaoshu_part <= 0 then
            self._big_zhe._label_big_zhe_left:setString(zhengshu_part)
            self._big_zhe._label_big_zhe_left:setPosition(cc.p(self._big_zhe._label_xiaoshu:getPositionX(), self._big_zhe._label_dian:getPositionY() + 8))
            self._big_zhe._label_dian:setVisible(false)
            self._big_zhe._label_xiaoshu:setVisible(false)
        else
            self._big_zhe._label_big_zhe_left:setString(zhengshu_part)
            self._big_zhe._label_big_zhe_left:setPosition(cc.p(0, 0))
            self._big_zhe._label_xiaoshu:setString(xiaoshu_part)
            self._big_zhe._label_dian:setVisible(true)
            self._big_zhe._label_xiaoshu:setVisible(true)
        end
    end
    local function checkBtnBuy( empty )
        local xiangou = tonumber(_info.count) or 0 
        if xiangou <= 0 then
            xiangou = 0
        end
        local num = tonumber(_info.number)
        if num <=0 then
            num = 0
        end
        if tonumber(_info.type) == 2 then
            if xiangou == 0 then
                self._buy_btn:setEnable(false)
            else
                self._buy_btn:setEnable(true)
            end
        else
            if xiangou == 0 or num == 0 then

                self._buy_btn:setEnable(false)
            else
                self._buy_btn:setEnable(true)
            end
        end
        
        if empty then
            self._buy_btn:setEnable(false)
        end
    end

    -- 全服，单服，个人tip
    local tp = tonumber(_info.type) or 0
    local format_str = zc.lang("tip_limit_"..tp) .. zc.lang("tip_limit_buy")..zc.lang("tip_limit_buy2")
    local info_count = tonumber(_info.count) or 0
    if info_count <= 0 then
        info_count = 0
    end
    local info_num = tonumber(_info.number) or 0
    if info_num <= 0 then
        info_num = 0
    end
    local tip_str = string.format(format_str, info_count, info_num)
    if tonumber(_info.type) == 2 then
    	format_str = zc.lang("tip_limit_"..tp).. zc.lang("tip_limit_buy")
    	tip_str = string.format(format_str, info_count)
    end
    self._limit_buy_tip:setString(tip_str) 

    -- 倒计时
    if self._timer then
        scheduler.unscheduleGlobal( self._timer )
        self._timer = nil
    end
    local _turnInfo = PlayerData:getLimitActiveInfoByID(self._id)
    if _turnInfo.openTime then
    	local act_endTime = tonumber(_turnInfo.openTime) + tonumber(_info.endTime) -- 活动结束时间
    	local now_time = tonumber(PlayerData:getTime()) or 0   -- 当前时间
    	local cha = now_time - act_endTime   -- 如果当前时间 > 活动结束时间 那活动已经结束

    	local atc_startTime = tonumber(_turnInfo.openTime) + tonumber(_info.startTime) -- 活动开始时间
    	local start_cha = atc_startTime - now_time    -- 如果活动开始时间 > 当前时间  那活动还未开启 购买按钮要置灰
    	if now_time > act_endTime then  -- 已经结束
            print("已经结束！！")
            changeBigzhe(1)
            changeLittleZhe(false)
    		checkBtnBuy()
            self._discount_label:setVisible(false)
    		self._discount_label:setPosition(self._discount_desc:getPosition())
    		self._discount_desc:setVisible(false)
            self._text_sp:setTexture("res/Main/activity/flash_sale/huigou.png")
            
    	elseif now_time < atc_startTime then   -- 没开始
            print("还没开始！！")
            changeBigzhe(0)
            changeLittleZhe(true)
            self._discount_label:setVisible(true)
    		self._discount_label:setString(zc.lang("tip_limit_unstart"))
    		checkBtnBuy("dfad")
    		self._discount_label:setPosition(self._discount_desc:getPosition())
    		self._discount_desc:setVisible(false)
            self._text_sp:setTexture("res/Main/activity/flash_sale/temai.png")
    	else
            print("开始中！")
    		-- 正常的活动时间
            changeBigzhe(0)
            changeLittleZhe(true)
            checkBtnBuy()
            self._text_sp:setTexture("res/Main/activity/flash_sale/temai.png")
    		local _startTime = tonumber(_info.startTime) or 0
			local _endTime = tonumber(_info.endTime) or 0
            local _time = act_endTime - now_time
            self._discount_label:setVisible(true)
			self._discount_label:setString(zc.getTimeHMS(_time))
            self._discount_desc:setVisible(true)
            self._discount_desc:setPosition(cc.p(0, 0))
            self._discount_label:setPosition(cc.p(self._discount_desc:getPositionX() + self._discount_desc:getContentSize().width + 10, self._discount_desc:getPositionY()))
			self._timer = scheduler.scheduleGlobal(function()
                _time = _time - 1
                if _time <= 0 then
                    self._discount_label:setVisible(false)
                    self._discount_label:setPosition(self._discount_desc:getPosition())
                    self._discount_desc:setVisible(false)
                    self._text_sp:setTexture("res/Main/activity/flash_sale/huigou.png")
                    changeBigzhe(1)
                    changeLittleZhe(false)
                    checkBtnBuy()
                    scheduler.unscheduleGlobal( self._timer )
                    self._timer = nil
                end
                self._discount_label:setString(zc.getTimeHMS(_time))
            end, 1)
    	end

    end

    -- 购买的物品
    if self._wupin_node then
    	self._di:removeChild(self._wupin_node)
    end
    self._wupin_node = cc.Node:create()
    self._di:addChild(self._wupin_node)
    local _goods_str = _info.goods or {}
    local _goods_table = {}
  	
  	local _icon_table = {}
    local tb = string.split(_goods_str, ",")
    for k,v in pairs(tb) do
    	local tb_nei = string.split(v, "|")
    	local _icon = zc.createIconByData({
				data = {
        			mainType = tonumber(tb_nei[1]),
        			type = tb_nei[2],
        			id = tonumber(tb_nei[2]),
        			num = tonumber(tb_nei[3]),
	        	},
		        scale = 0.7,
		        showCount = true,
			})
    	_icon:setTouchEndedShowTip()
    	self._wupin_node:addChild(_icon)
    	table.insert(_icon_table, _icon)
    end
    local pos_table = {}
    local icon_count = #_icon_table
    local icon_width = 100
    if icon_count == 6 then
    	self._wupin_node:setPosition(cc.p(750, self._buy_btn:getPositionY() + 180))
    	table.insert(pos_table, cc.p(-icon_width, icon_width * 0.5))
    	table.insert(pos_table, cc.p(0, icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width, icon_width * 0.5))
    	table.insert(pos_table, cc.p(-icon_width, -icon_width * 0.5))
    	table.insert(pos_table, cc.p(0, -icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width, -icon_width * 0.5))
    elseif icon_count == 5 then
    	self._wupin_node:setPosition(cc.p(750, self._buy_btn:getPositionY() + 180))
    	table.insert(pos_table, cc.p(-icon_width, icon_width * 0.5))
    	table.insert(pos_table, cc.p(0, icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width, icon_width * 0.5))
    	table.insert(pos_table, cc.p(-icon_width * 0.5, -icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width * 0.5, -icon_width * 0.5))
    elseif icon_count == 4 then
    	self._wupin_node:setPosition(cc.p(750, self._buy_btn:getPositionY() + 180))
    	table.insert(pos_table, cc.p(-icon_width * 0.5, icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width * 0.5, icon_width * 0.5))
    	table.insert(pos_table, cc.p(-icon_width * 0.5, -icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width * 0.5, -icon_width * 0.5))
    elseif icon_count == 3 then
    	self._wupin_node:setPosition(cc.p(750, self._buy_btn:getPositionY() + 180))
    	table.insert(pos_table, cc.p(-icon_width * 0.5, icon_width * 0.5))
    	table.insert(pos_table, cc.p(icon_width * 0.5, icon_width * 0.5))
    	table.insert(pos_table, cc.p(0, -icon_width * 0.5))
    elseif icon_count == 2 then
    	self._wupin_node:setPosition(cc.p(750, self._buy_btn:getPositionY() + 155))
    	table.insert(pos_table, cc.p(-icon_width * 0.5, 0))
    	table.insert(pos_table, cc.p(icon_width * 0.5, 0))
    elseif icon_count == 1 then
    	self._wupin_node:setPosition(cc.p(750, self._buy_btn:getPositionY() + 155))
    	table.insert(pos_table, cc.p(0, 0))
    else
    	print("滚犊子，除了123456没有！！")
    end
    
    for i,v in pairs(_icon_table) do
    	v:setPosition(pos_table[i])
    end
    -- 购买按钮
    self._buy_btn:setTouchEndedCall(function ( )
        local _price = tonumber(self._now_price:getString())   -- 当前的价格
        print("当前价格：".._price)
		local comfirm =  ZCConfirmDialog:createWithParams({
                title = zc.lang("prompt"),
                msg = string.format(zc.lang("tip_buy_limit_goods"), _price),
                showDi = true,
                rightCallback = function()
                    zc.sendHttp({
                        apiName = "buy",
                        params = {id = self._curIndex, price = _price},
                        successCallback = function( backData )
                           dump(backData ,"购买返回：")
                           backData.noAnimation = true
                           PlayerData:updataData( backData )
                           zc.createShowReward( backData )
                           local returnTb = backData.totalNums or {}
                           for k,v in pairs(returnTb) do
                           		for k1,v1 in pairs(self._datas) do
                           			if tonumber(v1.id) == tonumber(k) then
                           				v1.number = tonumber(self._staticData[tonumber(k)].number) - tonumber(v)
                           			end 
                           		end
                           end
                           local info = self._datas[self._curIndex] or {}
                           info.count = tonumber(info.count) - 1
                           self:refreshUI()
                        end,
                        errorCallback = function( errorCode, errorMsg )
                            zc.tipInfo(LANGUAGE_GETERRORTIP(errorMsg))
                            self:refreshNumbers()
                        end,
                    })
                end
            })
		self:getParent():getParent():addChild(comfirm)
    end)

end

function FlashSaleLayer:refreshNumbers()
    -- 刷新剩余数量
    print("刷新剩余数量")
    zc.sendHttp({
        apiName = "main",
        params = {},
        successCallback = function(backData)
            local data = backData.totalNums or {}
            for k,v in pairs(data) do
                for k1,v1 in pairs(self._datas) do
                    if tonumber(v1.id) == tonumber(k) then
                        v1.number = tonumber(self._staticData[tonumber(k)].number) - tonumber(v)
                        print("shuaxin:"..v1.number)
                    end
                end
           end
           self:refreshUI()
        end
        })
end

return FlashSaleLayer