--[[
	次日登陆
	唐实聪
	2016.9.7
]]
local SecondDayLayer = class("SecondDayLayer", function()
	return zc.createNormalDialog()
end)

function SecondDayLayer:create( params )
	return SecondDayLayer.new( params )
end

function SecondDayLayer:ctor( params )
	self:initData( params )
	self:initUI()
end

function SecondDayLayer:initData( params )
    self._status = tonumber( params.status ) or 0
    self._heroId = 18
	self._qualifications = gameData.getDataFromCacheWithPrimaryKey("hero", self._heroId).qualifications

	self._skillData = zc.getHeroSkillData({heroId = self._heroId})

	self._callback = params.callback

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function SecondDayLayer:initUI()
	local _bg = cc.Sprite:create( "res/Main/activity/secondDay/bg.png" )
	_bg:setPosition( self._width/2, self._height/2 )
	self:addChild( _bg )

	-- 资质
	do
		local _posX = 907
		local _posY = 290
		local _qualificationsBg2 = cc.Sprite:create( "res/Main/role/qualifications_bg2.png" )
		-- _qualificationsBg2:setScale( 0.45 )
		_qualificationsBg2:setPosition( _posX, _posY )
		_bg:addChild( _qualificationsBg2 )
		local _qualificationsBg = cc.Sprite:create( "res/Main/role/qualifications_bg.png" )
		_qualificationsBg:setScale( 0.45 )
		_qualificationsBg:setPosition( _posX, _posY )
		_bg:addChild( _qualificationsBg )
		local _qualificationsSp = cc.Sprite:create( zc.getHeroQualificationsPath( self._qualifications, 2 ) )
		_qualificationsSp:setPosition( _posX, _posY )
		_qualificationsSp:setScale( 0.55 )
		_bg:addChild( _qualificationsSp )
	end

	-- 技能
	for i, v in ipairs( self._skillData ) do
		local _posX = 620 + 110*i
		local _posY = 222
		local _skill = zc.createIconByData({
            data = {
	            mainType=zc.mainTypeSkill,
	            type=v.id, 
	            id=v.id,
	        },
	        pos = cc.p( _posX, _posY ),
	        listener = function()
	            zc.createSkillInfoPop({id = v.id, level = v.level})
	        end
        })
        _skill:setScale( 0.86 )
        _bg:addChild( _skill )
        if v.skillType == 2 then
            -- 必杀
            local _tag = cc.Sprite:create( "res/Main/pub/critical.png" )
            _tag:setPosition( _posX, _posY - 45 )
            _bg:addChild( _tag )
        elseif v.skillType == 3 then
            -- 奥义
            local _tag = cc.Sprite:create( "res/Main/pub/aoyi.png" )
            _tag:setPosition( _posX, _posY - 45 )
            _bg:addChild( _tag )
        end
	end

	-- 按钮
	local _btn = nil
	_btn = zc.createCommomBtn({
		tag = 1,
		btnText = zc.lang("qianwang_2"),
		pos = cc.p( 820, 129 ),
		endCallback = function()
			LayerManager.removeLayout()
            zc.createActivityPop({sType = 1, idx = 1})
		end
	})
	_bg:addChild( _btn )
	if self._status == 0 then
		-- 未完成
		_btn:setEnable( false )
		_btn:setText(zc.lang("un_finish"))
	end
end

return SecondDayLayer