--[[
	开服七天乐
	唐实聪
	2016.6.24
]]
local SevenDayPop = class("SevenDayPop", function()
	return zc.createNormalDialog()
end)

function SevenDayPop:create( params )
	return SevenDayPop.new( params )
end

function SevenDayPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:refreshTab()
	self:refresh()
	self:startTimer()
	self:refreshDayRedDot()
	self:refreshTabRedDot()
end

function SevenDayPop:initData( params )
	--红点状态
	self._status = 0

	-- 静态表数据
	local _list = {}
	local _datas = gameData.getAllDataWithNoClone("sevenDay")
	for i, v in pairs(_datas) do
		local _tmp = clone( v )
		local _reward = {}
		for j, u in ipairs( string.split( _tmp.awards, "," ) ) do
			local _item = string.split( u, "|" )
			_reward[#_reward + 1] = {
				itemType = _item[1],
				itemId = _item[2],
				itemNum = _item[3],
			}
		end
		_tmp.reward = _reward
		_list[tonumber( _tmp.id )] = _tmp
	end
	self._list = _list
	-- dump( self._list, "self._list" )
	-- 后端数据
	local _data = {}
	for i = 1, 7 do
		_data[i] = {}
		for j = 1, 4 do
			_data[i][j] = {}
		end
	end
	for i, v in ipairs( params.taskList ) do
		v.taskId = tonumber( v.taskId ) or 1
		local _day = tonumber( _list[v.taskId].days ) or 1
		local _type = tonumber( _list[v.taskId].type ) or 1
		v.type = _type
		local _status = tonumber( v.status ) or 1
		_status = _status%3
		v.status = _status
		if _data[_day] then --策划要写个第10000天 蛋疼
			local _index = #_data[_day][_type] + 1
			_data[_day][_type][_index] = v
		end
	end
	-- 排序
	for i = 1, 7 do
		for j = 1, 4 do
			table.sort(_data[i][j], function( a, b )
				if a.status ~= b.status then
					return a.status > b.status
				else
					return a.taskId < b.taskId
				end
			end)
		end
	end
	self._data = _data
	-- dump( self._data, "self._data" )

	-- 次日数据
	PlayerData.info.secondDay = _data[2][1][1]
	if PlayerData.info.secondDay and tonumber(PlayerData.info.secondDay.status) == 0 then
		PlayerData.info.secondDay.status = 3
	end

	-- 时间数据
	-- 今天第几天
	self._today = tonumber( params.time.day ) or 0
	-- 活动时间
	self._actTime = ( tonumber( params.time.actTime ) or 0 ) - PlayerData:getTime()
	-- 领奖时间
	self._recTime = ( tonumber( params.time.recTime ) or 0 ) - PlayerData:getTime()

	self._dayIndex = 1
	self._dayBtn = {}
	self._tabIndex = 1
	self._tabBtn = {}

	self._size = self:getContentSize()

	self._record = {}
end

-- 对当前天和tab的数据重新排序
function SevenDayPop:sortData()
	table.sort(self._data[self._dayIndex][self._tabIndex], function( a, b)
		if a.status ~= b.status then
			return a.status > b.status
		else
			return a.taskId < b.taskId
		end
	end)
end

function SevenDayPop:initUI()
    -- 通用背景
    local _commonBg = cc.Sprite:create( "res/Main/common/common_bg.jpg" )
    _commonBg:setPosition( self._size.width/2, self._size.height/2 )
    self:addChild( _commonBg )
    zc.setBgSize( _commonBg )
	-- 背景
	local bg = cc.Sprite:create( "res/Main/common/popBg/popBg_orange.png" )
	bg:setPosition( self._size.width/2, self._size.height/2 )
	self:addChild( bg )
	local bgSize = bg:getContentSize()
	self._bg = bg
	self._bgWidth = bgSize.width
	self._bgHeight = bgSize.height
	-- activityBg
	local activityBg = cc.Sprite:create( "res/Main/shop/shopBg.jpg" )
	activityBg:setAnchorPoint( 0.5, 1 )
	activityBg:setScaleY( 0.99 )
	activityBg:setPosition( bgSize.width/2, bgSize.height - 50 )
	bg:addChild( activityBg )
	-- day
	self:initDay()
	-- tab
	self:initTab()
    -- bottom
    self:initBottom()
    -- frame
    local frame = ccui.Scale9Sprite:create( cc.rect( 13, 60, 9, 62 ), "res/Main/common/frame_s.png" )
    frame:setContentSize( bgSize.width - 4, bgSize.height + 4 )
    frame:setPosition( bgSize.width/2, bgSize.height/2 )
    bg:addChild( frame )
    -- title
    local title = cc.Sprite:create( "res/Main/activity/sevenDay/title.png" )
	title:setPosition( 70, self._bgHeight - 7 )
	bg:addChild( title )
end

-- 七天
function SevenDayPop:initDay()
	for i = 1, 6 do
		local dayBtn = zc.createPushButton({
			normalFile = "res/Main/activity/sevenDay/tab_u.png",
			selectedFile = "res/Main/activity/sevenDay/tab_d.png",
			anchor = cc.p( 0.5, 0 ),
			pos = cc.p( -18 + 105*i, 419 ),
			endCallback = function()
				if self._dayIndex ~= i then
					if self._today < i then
						-- 未开启
						-- zc.tipInfo( "第"..i.."天开启" )
						zc.createSourcePop("SevenDayPreviewPop", "src/layer/activity/SevenDayPreviewPop.lua", {day = i})
						return
					end
					self._dayBtn[self._dayIndex]:setSelected( false )
					self._dayBtn[self._dayIndex]:setLocalZOrder( 0 )
					self._dayIndex = i
					self._dayBtn[self._dayIndex]:setSelected( true )
					self._dayBtn[self._dayIndex]:setLocalZOrder( 2 )
					self:refreshTab()
					self:refresh()
					self:refreshTabRedDot()
				end
			end
		})
		self._bg:addChild( dayBtn )
		self._dayBtn[i] = dayBtn
		local dayLabel = zc.createLabel({
			text = string.format(zc.lang("di_x_day"), i),
	        fontSize = 22,
	        color = cc.c3b( 93, 72, 67 ),
	        ap = cc.p( 0.5, 0.5 ),
	        pos = cc.p( dayBtn:getBoundingBox().width/2, dayBtn:getBoundingBox().height/2 - 4 ),
		})
		dayBtn:addChild( dayLabel )

        -- 添加红点
        local _redDot = cc.Sprite:create( "res/Main/common/common_red_point.png" )
        _redDot:setAnchorPoint( 1, 1 )
        _redDot:setPosition( dayBtn:getBoundingBox().width + 5, dayBtn:getBoundingBox().height )
        _redDot:setVisible( false )
        dayBtn:addChild( _redDot )
        dayBtn._redDot = _redDot
	end
	do
		-- 第七天
		local i = 7
		local _normal = ccui.Scale9Sprite:create( cc.rect( 20, 0, 74, 32 ), "res/Main/activity/sevenDay/tab_u.png" )
		_normal:setContentSize( 193, 46 )
		local _selected = ccui.Scale9Sprite:create( cc.rect( 20, 0, 74, 32 ), "res/Main/activity/sevenDay/tab_d.png" )
		_selected:setContentSize( 193, 46 )
		local dayBtn = zc.createPushButton({
			normalNode = _normal,
			selectedNode = _selected,
			anchor = cc.p( 0.5, 0 ),
			pos = cc.p( 757, 419 ),
			endCallback = function()
				if self._dayIndex ~= i then
					if self._today < i then
						-- 未开启，第七天直接预览兵器
						zc.createSourcePop("SevenDayWeaponPop", "src/layer/activity/SevenDayWeaponPop.lua", {})
						return
					end
					self._dayBtn[self._dayIndex]:setSelected( false )
					self._dayBtn[self._dayIndex]:setLocalZOrder( 0 )
					self._dayIndex = i
					self._dayBtn[self._dayIndex]:setSelected( true )
					self._dayBtn[self._dayIndex]:setLocalZOrder( 2 )
					self:refreshTab()
					self:refresh()
					self:refreshTabRedDot()
				end
			end
		})
		self._bg:addChild( dayBtn )
		self._dayBtn[i] = dayBtn
		local dayLabel_1 = zc.createLabel({
			text = string.format(zc.lang("di_x_day"), i),
	        fontSize = 22,
	        color = cc.c3b( 93, 72, 67 ),
	        ap = cc.p( 0.5, 0.5 ),
	        pos = cc.p( 57, dayBtn:getBoundingBox().height/2 - 4 ),
		})
		dayBtn:addChild( dayLabel_1 )
		local dayLabel_2 = zc.createLabel({
			text = zc.lang("presented"),
	        fontSize = 24,
	        color = zc.COLOR_RED,
	        outLine = true,
	        ap = cc.p( 0.5, 0.5 ),
	        pos = cc.p( dayLabel_1:getPositionX() + 48, dayLabel_1:getPositionY() + 2 ),
		})
		dayBtn:addChild( dayLabel_2, 3 )
		local dayLabel_3 = cc.Sprite:create( "res/Main/activity/sevenDay/weapon_sp.png" )
		dayLabel_3:setPosition( dayLabel_2:getPositionX() + 45, dayLabel_1:getPositionY() )
		dayBtn:addChild( dayLabel_3, 3 )

        -- 添加红点
        local _redDot = cc.Sprite:create( "res/Main/common/common_red_point.png" )
        _redDot:setAnchorPoint( 1, 1 )
        _redDot:setPosition( dayBtn:getBoundingBox().width + 5, dayBtn:getBoundingBox().height )
        _redDot:setVisible( false )
        dayBtn:addChild( _redDot )
        dayBtn._redDot = _redDot
	end
	self._dayBtn[self._dayIndex]:setSelected( true )
	self._dayBtn[self._dayIndex]:setLocalZOrder( 2 )
end

-- tab
function SevenDayPop:initTab()
	for i = 1, 4 do
		local tabBtn = zc.createTypeBtn({
			pos = cc.p( 103, 446 - 80*i ),
			endCallback = function()
				if self._tabIndex ~= i then
					self._tabBtn[self._tabIndex]:setSelected( false )
					self._tabIndex = i
					self._tabBtn[self._tabIndex]:setSelected( true )
					self:refresh()
				end
			end
		})
		self._bg:addChild( tabBtn, 2 )
        -- 添加红点
        local _redDot = cc.Sprite:create( "res/Main/common/common_red_point.png" )
        _redDot:setAnchorPoint( 1, 1 )
        _redDot:setPosition( tabBtn:getContentSize().width + 5, tabBtn:getContentSize().height )
        _redDot:setVisible( false )
        tabBtn:addChild( _redDot )
        tabBtn._redDot = _redDot
		self._tabBtn[i] = tabBtn
	end
end

-- 创建第一种背景
function SevenDayPop:initBg_1()
	local _bg_1 = cc.Sprite:create( "res/Main/activity/sevenDay/bg_1.png" )
	_bg_1:setAnchorPoint( 0.5, 1 )
	_bg_1:setPosition( self._bgWidth/2, 422 )
	self._bg:addChild( _bg_1, 1 )
	self._bg_1 = _bg_1
	-- tableview
    local cellWidth = 668
	local tableview = zc.ZCTableView:create( cc.size( cellWidth, 330 ) )
    tableview:setBounceable( true )
    tableview:setInertia( true )
    tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableview:setPosition( cc.p( 160, 11 ) )
    tableview:setDelegate()
    tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellHeight = 126
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, cellWidth, cellHeight )
        end
        self:updateCell( cell, index + 1 )

        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._data[self._dayIndex][self._tabIndex]
    end
    tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _bg_1:addChild(tableview)
    self._tableview = tableview
end
function SevenDayPop:buildCell( cell, cellWidth, cellHeight )
	-- bg
	local bg = cc.Sprite:create( "res/Main/activity/sevenDay/cell_bg.png" )
	bg:setPosition( cellWidth/2, cellHeight/2 - 5 )
	cell:addChild( bg )
	local bgWidth = bg:getContentSize().width
	local bgHeight = bg:getContentSize().height
	-- titleBg
	local titleBg = cc.Sprite:create( "res/Main/activity/sevenDay/title_bg.png" )
	titleBg:setAnchorPoint( 0, 1 )
	titleBg:setPosition( -2, bgHeight + 3 )
	bg:addChild( titleBg )
	-- titleLabel
	local titleLabel = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1.5,
        color = display.COLOR_TAB_NORMAL_COLOR1,
        color2 = display.COLOR_TAB_NORMAL_COLOR2,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 15, titleBg:getContentSize().height/2 ),
	})
	titleBg:addChild( titleLabel )
	cell._titleLabel = titleLabel
	-- icon
	local icons = cc.Sprite:create()
	icons:setContentSize( 330, bgHeight )
	icons:setAnchorPoint( 0, 0 )
	icons:setPosition( 10, 0 )
	bg:addChild( icons )
	cell._icons = icons
	-- 进度
	local complete = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1.5,
        color = zc.COLOR_RED,
        color2 = cc.c3b( 87, 0, 0 ),
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( 547, 95 ),
	})
	bg:addChild( complete )
	cell._complete = complete
	-- fetch
	local fetch = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("fetch_2"),
		pos = cc.p( 557, 40 ),
		needSwallow = false,
		needEnableWhenMoving = false,
		endCallback = function()
			local _flag = false
			local _data = nil
			local _list = nil
			-- 七日送武器
			if self._dayIndex == 7 and self._tabIndex == 1 then
				_data = self._data[self._dayIndex][self._tabIndex][cell._index]
				_list = self._list[_data.taskId]
				local _conditions = tonumber( string.split( _list.conditions, "|" )[1] ) or 0
				if _conditions == 48 then
					_flag = true
				end
			end
			if _flag then
				zc.createSourcePop("SevenDayWeaponPop", "src/layer/activity/SevenDayWeaponPop.lua", {_list = _list, _data = _data, _callback = function()
	                self._data[self._dayIndex][self._tabIndex][cell._index].status = 0
					self:sortData()
					self._tableview:reloadDataAndScrollToCurrentCell()
					self:refreshDayRedDot()
					self:refreshTabRedDot()
				end})
			else
				-- local _taskId = self._data[self._dayIndex][self._tabIndex][cell._index] or {}
				-- _taskId = tonumber(_taskId.taskId) or 0
				-- -- 次日送武将
				-- if self._dayIndex == 2 and self._tabIndex == 1 and _taskId == 47 then
				-- 	zc.createSecondDayLayer( true, function()
		  --               self._data[self._dayIndex][self._tabIndex][cell._index].status = 0
				-- 		self:sortData()
				-- 		self._tableview:reloadDataAndScrollToCurrentCell()
				-- 		self:refreshDayRedDot()
				-- 		self:refreshTabRedDot()
				-- 	end)
				-- 	return
				-- end
				zc.sendHttp({
					apiName = "SevenDay_delivery",
					params = {id = cell._id},
					successCallback = function(backData)
		                local _weaponInfo = nil
		                for i, v in ipairs( backData.clientItems ) do
		                 	if tonumber( v.type ) == 3 then
		                 		-- 资源
		                		PlayerData:updataData( backData )
		                 		_weaponInfo = PlayerData:getWeaponInfoInfoById( v.model.id )
		                 		break
		                 	end
		                end
		                if _weaponInfo then
		                	-- 兵器
		                	zc.createPop("makeGodWeapon", {info = _weaponInfo, onlyShow = true})
		                else
		                	backData.noAnimation = true
		                	-- 道具
		                	zc.createShowReward( backData )
		                	-- 资源
		                	PlayerData:updataData( backData )
		                end

		                self._data[self._dayIndex][self._tabIndex][cell._index].status = 0
						self:sortData()
						self._tableview:reloadDataAndScrollToCurrentCell()
						self:refreshDayRedDot()
						self:refreshTabRedDot()
					end,
				})
			end
		end,
	})
	bg:addChild( fetch )
	cell._fetch = fetch

	-- goto
	local _goto = zc.createCommomBtn({
		tag = 2,
		text = zc.lang("qianwang_2"),
		pos = cc.p( 557, 40 ),
		needSwallow = false,
		needEnableWhenMoving = false,
		endCallback = function()
			local _data = self._data[self._dayIndex][self._tabIndex][cell._index]
			local _list = self._list[_data.taskId]
			LayerManager.removeLayout()
            zc.toReceiveRewardsView( _list.conditions )
		end
	})
	bg:addChild( _goto )
	cell._goto = _goto
	-- fetched
	local fetched = cc.Sprite:create( "res/Main/activity/monthSign/fetched.png" )
	fetched:setPosition( 557, cellHeight/2 )
	bg:addChild( fetched )
	cell._fetched = fetched
end
function SevenDayPop:updateCell( cell, index )
	-- 数据
	local _data = self._data[self._dayIndex][self._tabIndex][index]
	local _list = self._list[_data.taskId]
	-- dump( _data, "_data" )
	-- 说明
	cell._titleLabel:setText( _list.desc )
	-- 奖励
	self:refreshReward( cell._icons, _list )
	-- 状态
	local _status = _data.status
	cell._fetch:setScale( 1 )
	cell._goto:setScale( 1 )
	if _status == 1 then
		-- 未完成
		cell._fetch:setVisible( false )
		cell._goto:setVisible( true )
		cell._fetched:setVisible( false )
		-- 进度
		if tonumber( _list.schedule ) == 1 then
			cell._complete:setText( _data.arg.."/".._data.conditions )
		else
			cell._complete:setText( "" )
		end
	elseif _status == 2 then
		-- 可领取
		cell._fetch:setVisible( true )
		cell._goto:setVisible( false )
		cell._fetched:setVisible( false )
		-- 进度
		cell._complete:setText( "" )
	else
		-- 已领取
		cell._fetch:setVisible( false )
		cell._goto:setVisible( false )
		cell._fetched:setVisible( true )
		-- 进度
		cell._complete:setText( "" )
	end
	cell._id = _data.id
	cell._index = index

	-- 预览
	if self._today < self._dayIndex then
		local _flag = false
		if self._dayIndex == 7 and self._tabIndex == 1 then
			local _conditions = tonumber( string.split( _list.conditions, "|" )[1] ) or 0
			if _conditions == 48 then
				_flag = true
			end
		end
		if _flag then
			-- 六把兵器
			cell._fetch:setEnable( true )
			cell._fetch:setVisible( true )
			cell._fetch:setText(zc.lang("preview"))
			cell._goto:setVisible( false )
			cell._fetched:setVisible( false )
		else
			cell._fetch:setEnable( false )
			cell._goto:setEnable( false )
		end
	end

	-- 活动已结束
	if self._actTime < 0 then
		cell._goto:setEnable( false )
		cell._goto:setText(zc.lang("have_finished"))
	end
end
-- 刷新奖励
function SevenDayPop:refreshReward( icons, data )
	icons:removeAllChildren()
	for i, v in ipairs( data.reward ) do
		local _icon = zc.createIconByData({
	        data = {
	            mainType = v.itemType,
	            type = v.itemId, 
	            id = v.itemId,
	            num = v.itemNum,
	        },
	        showDetailPop = true,
	        pos = cc.p( 80*( i - 0.5 ), 47 ),
		})
		_icon:setScale( 0.6 )
		icons:addChild( _icon )
	end
end

-- 创建第二种背景
function SevenDayPop:initBg_2()
	-- cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/buildings.plist", "res/Main/home/buildings.pvr.ccz")
	local _bg_2 = cc.Sprite:create( "res/Main/activity/sevenDay/bg_1.png" )
	_bg_2:setAnchorPoint( 0.5, 1 )
	_bg_2:setPosition( self._bgWidth/2, 422 )
	self._bg:addChild( _bg_2, 1 )
	self._bg_2 = _bg_2
	-- 蓝底
	local _blueBg = cc.Sprite:create( "res/Main/activity/sevenDay/blue_bg.png" )
	_blueBg:setPosition( _bg_2:getContentSize().width - 346, _bg_2:getContentSize().height/2 )
	_bg_2:addChild( _blueBg )
	-- 奖励背景
	local _rewardBg = cc.Sprite:create()
	_rewardBg:setPosition( _bg_2:getContentSize().width - 464, _bg_2:getContentSize().height/2 )
	_bg_2:addChild( _rewardBg )
	self._rewardBg = _rewardBg
	-- 妞
	local _girl = zc.createSprite("res/Main/activity/sevenDay/nvshen.png")
    -- _girl:playAction( "5_n", true )
    _girl:setScale( 0.6 )
    _girl:setPosition( _rewardBg:getPositionX(), _rewardBg:getPositionY() + 40 )
    _bg_2:addChild( _girl )
    self._girl = _girl
    -- 盘子
    local _plate = cc.Sprite:create( "res/Main/activity/sevenDay/plate.png" )
    _plate:setPosition( _rewardBg:getPositionX(), 75 )
    _bg_2:addChild( _plate )
    self._plate = _plate
    -- 特效
    local _light = zc.getSpine("huodong")
    _light:playAction( "idle", true )
    _light:setPosition( _plate:getPositionX(), _plate:getPositionY() + 90 )
    _bg_2:addChild( _light )
    self._light = _light
    -- 限量背景
    local _limitBg = cc.Sprite:create( "res/Main/activity/sevenDay/limit_bg.png" )
    _limitBg:setAnchorPoint( 0, 1 )
    _limitBg:setPosition( 0, 315 )
    _rewardBg:addChild( _limitBg )
    self._limitBg = _limitBg
	-- 限量
	local _limit = zc.createLabel({
    	text = zc.lang("limit_num"),
        fontSize = 30,
        stroke = true,
        pixel = 1,
        color = cc.c3b( 255, 222, 0 ),
        ap = cc.p( 0, 1 ),
        pos = cc.p( 177, _bg_2:getContentSize().height - 72 ),
	})
	_limit:setRotation( -45 )
	_bg_2:addChild( _limit )
	self._limit = _limit
	-- 名字背景
	local _nameBg = zc.createSprite("res/Main/home/activityDi.png")
	_nameBg:setPosition( _rewardBg:getPositionX(), 50 )
	_nameBg:setScaleX( 1.5 )
	_bg_2:addChild( _nameBg )
	self._nameBg = _nameBg
	-- 兵器图标
	local _weaponIcon = cc.Sprite:create()
	_weaponIcon:setPosition( 330, 50 )
	_bg_2:addChild( _weaponIcon, 1 )
	self._weaponIcon = _weaponIcon
	-- 兵器名字
	local _weaponName = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 360, _weaponIcon:getPositionY() ),
	})
	_bg_2:addChild( _weaponName, 1 )
	self._weaponName = _weaponName
	-- 原价
	local _oriPriceText = zc.createLabel({
		text = zc.lang("old_price") .. ":",
        fontSize = 20,
        outLine = true,
        pixel = 1,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 637, 253 ),
	})
	_bg_2:addChild( _oriPriceText )
	local _oriPriceIcon = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
	_oriPriceIcon:setPosition( 713, 253 )
	_bg_2:addChild( _oriPriceIcon )
	local _oriPriceNum = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 740, 253 ),
	})
	_bg_2:addChild( _oriPriceNum )
	self._oriPriceNum = _oriPriceNum
	-- 横线
	local _line = cc.Sprite:create( "res/Main/activity/sevenDay/line.png" )
	_line:setPosition( 709, 253 )
	_bg_2:addChild( _line )
	-- 现价
	local _curPriceText = zc.createLabel({
		text = zc.lang("now_price") .. ":",
        fontSize = 20,
        outLine = true,
        pixel = 1,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 637, 213 ),
	})
	_bg_2:addChild( _curPriceText )
	local _curPriceIcon = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
	_curPriceIcon:setPosition( 713, 213 )
	_bg_2:addChild( _curPriceIcon )
	local _curPriceNum = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 740, 213 ),
	})
	_bg_2:addChild( _curPriceNum )
	self._curPriceNum = _curPriceNum
	-- 购买
	local _buyBtn = zc.createCommomBtn({
		tag = 3,
		text = "",
		scale = 0.7,
		labScale = true,
		pos = cc.p( 709, 82 ),
		endCallback = function()
			local _data = self._data[self._dayIndex][self._tabIndex][1]
			local _id = tonumber( _data.id ) or 0
			if _id ~= 0 then
				zc.sendHttp({
					apiName = "SevenDay_delivery",
					params = {id = _id},
					successCallback = function(backData)
						zc.tipInfo(zc.lang("tips_buy_success"))
		                PlayerData:updataData( backData )
		                self._data[self._dayIndex][self._tabIndex][1].status = 0
						self._buyBtn:setEnable( false )
						self._buyBtn:setText(LANGUAGE_SHOP.bought)
						self:refreshDayRedDot()
						self:refreshTabRedDot()
					end,
				})
			end
		end
	})
	_bg_2:addChild( _buyBtn )
	self._buyBtn = _buyBtn
end
function SevenDayPop:refreshBg_2()
	-- 数据
	local _data = self._data[self._dayIndex][self._tabIndex][1]
	if not _data then
		return
	end
	local _list = self._list[_data.taskId]
	local _itemType = tonumber( _list.reward[1].itemType ) or 0
	local _itemId = tonumber( _list.reward[1].itemId ) or 0
	local _itemNum = tonumber( _list.reward[1].itemNum ) or 0
	if self._item then
		self._item:removeFromParent()
		self._item = nil
	end
	if _itemType == zc.mainTypeSoldier then
		-- 武将
		self._rewardBg:setTexture( "res/Main/activity/sevenDay/hero_bg.png" )
		self._girl:setVisible( false )
		self._plate:setVisible( false )
		self._light:setVisible( false )
		self._limit:setVisible( true )
		self._limitBg:setVisible( true )
		local _heroData = gameData.getDataFromCacheWithPrimaryKey("hero", _itemId)
		local action = 1
		local hero = zc.battle.createHeroArmature({fileName = _heroData.modelId , async = true, asyncCallback = function ( _armature,fileName,num )
            if _armature then
            	_armature:setScaleX( -1 )
                _armature:getAnimation():play("idle")
			    local function animationEvent(armatureBack,movementType,movementID)
			        if movementType == ccs.MovementEventType.complete then
			            _armature:getAnimation():play("idle")
			        end
			    end
			    _armature:getAnimation():setMovementEventCallFunc(animationEvent)
			    -- 按钮
			    local heroBtn = zc.createPushButton({
			        touchSize = cc.size( 200, 210 ),
			        pos = cc.p( self._rewardBg:getPositionX(), 95 ),
			        endCallback = function()
			            local _action = zc.random(1, 3)
			            if action == _action then
			                if _action < 3 then
			                    _action = _action + 1
			                else 
			                   _action = 1 
			                end
			            end
			            action = _action
			            local _actions = {"atk3", "atk", "atk0"}
			            if _armature then
			                _armature:getAnimation():play( _actions[_action], -1, 0 )
			            end
			        end
			    })
			    self._bg_2:addChild( heroBtn )
            end
        end})
        hero:setPosition( self._rewardBg:getPositionX(), 100 )
	    self._bg_2:addChild( hero )
		self._item = hero
        self._record[_heroData.modelId] = true
		self._weaponIcon:setVisible( true )
		self._weaponIcon:setTexture( zc.getHeroTypeImg( _heroData.weaponType ) )
		self._weaponName:setText( _heroData.name )
		self._weaponName:setPositionX( 360 )
	elseif _itemType == zc.mainTypeWeapon then
		-- 兵器
		self._rewardBg:setTexture( "res/Main/activity/sevenDay/item_bg.png" )
		self._girl:setVisible( true )
		self._plate:setVisible( true )
		self._light:setVisible( true )
		self._limit:setVisible( false )
		self._limitBg:setVisible( false )
		local _weaponData = gameData.getDataFromCacheWithPrimaryKey("weapon", _itemId)
		local _weapon = cc.Sprite:create( "res/Main/weapon/weaponImage/".._weaponData.iconId..".png" )
		local _type = tonumber( _weaponData.type ) or 0
		if _type == 1 then
			-- 长柄兵器
			_weapon:setRotation( -90 )
		elseif _type == 2 or _type == 4 then
			_weapon:setRotation( 90 )
		end
		_weapon:setAnchorPoint( 0.5, 0.5 )
		_weapon:setPosition( self._rewardBg:getPositionX(), 190 )
		zc.showWeaponEffect( _weapon, _itemId )
		local _btn = ccui.Widget:create()
		_btn:setContentSize( _weapon:getContentSize() )
		_btn:setTouchEnabled( true )
		_btn:setPosition( _weapon:getContentSize().width/2, _weapon:getContentSize().height/2 )
		_btn:onTouch(function(event)
			if event.name == "began" then
				if zc.getPop("itemDetail")  then 
				    zc.closePop("itemDetail")
				end
				zc.createPop("itemDetail", {
					pos = _weapon:convertToWorldSpace( cc.p( 0, 0 ) ),
					params = {
			            mainType=_itemType,
			            type=_itemId,
			            id=_itemId,
					},
				})
            elseif event.name == "ended" then
				if zc.getPop("itemDetail")  then 
				    zc.closePop("itemDetail")
				end
			elseif event.name == "canceled" then
				if zc.getPop("itemDetail")  then 
				    zc.closePop("itemDetail")
				end
        	end
        end)
		_weapon:addChild( _btn )
		self._bg_2:addChild( _weapon )
		_weapon:runAction(
			cc.RepeatForever:create(
				cc.Sequence:create(
					cc.MoveBy:create( 2, cc.p( 0, 10 ) ),
					cc.MoveBy:create( 2, cc.p( 0, -10 ) )
				)
			)
		)
		self._item = _weapon
		self._weaponIcon:setVisible( true )
		self._weaponIcon:setTexture( zc.getHeroTypeImg( _weaponData.type ) )
		self._weaponName:setText( _weaponData.name )
		self._weaponName:setPositionX( 360 )
	else
		-- 其他
		self._rewardBg:setTexture( "res/Main/activity/sevenDay/item_bg.png" )
		self._girl:setVisible( true )
		self._plate:setVisible( true )
		self._light:setVisible( true )
		self._limit:setVisible( false )
		self._limitBg:setVisible( false )
		local _item, _itemInfo = zc.createIconByData({
	        data = {
	            mainType=_itemType,
	            type=_itemId, 
	            id=_itemId,
	            -- num=_itemNum,
	        },
		})
		_item:setTouchEndedShowTip()
		_item:setAnchorPoint( 0.5, 0.5 )
		_item:setPosition( self._rewardBg:getPositionX(), 190 )
		self._bg_2:addChild( _item )
		_item:setOpacity( 0 )
		-- _item:setScale( 1.3 )
		_item:runAction(
			cc.RepeatForever:create(
				cc.Sequence:create(
					cc.MoveBy:create( 2, cc.p( 0, 10 ) ),
					cc.MoveBy:create( 2, cc.p( 0, -10 ) )
				)
			)
		)
		self._item = _item
		self._weaponIcon:setVisible( false )
		self._weaponName:setText( _itemInfo.name.." x".._itemNum )
		self._weaponName:setPositionX( 367 - self._weaponName:getContentSize().width/2 )
	end
	local _price = string.split( _list.conditions, "|" )
	self._oriPriceNum:setText( _price[2] )
	self._curPriceNum:setText( _price[3] )
	if _data.status == 0 then
		-- 已拥有
		self._buyBtn:setEnable( false )
		self._buyBtn:setText(LANGUAGE_SHOP.bought)
	else
		self._buyBtn:setEnable( true )
		self._buyBtn:setText(LANGUAGE_SHOP.buy_space)
	end
	-- 预览
	if self._today < self._dayIndex then
		self._buyBtn:setEnable( false )
	end
end

function SevenDayPop:initBottom()
	-- bottom
    local bottom = ccui.Scale9Sprite:create( cc.rect( 20, 10, 549, 71 ), "res/Main/role/trinket/sellDi.png" )
    bottom:setContentSize( 862, 58 )
    bottom:setAnchorPoint( 0.5, 0 )
    bottom:setPosition( self._bgWidth/2 + 1, 10 )
    self._bg:addChild( bottom )
    -- 活动日期
    local _activityTimeBg = ccui.Scale9Sprite:create( cc.rect( 12, 11, 14, 10 ), "res/Main/role/common/name_bg.png" )
    _activityTimeBg:setContentSize( 230, 30 )
    _activityTimeBg:setPosition( 180, 40 )
    self._bg:addChild( _activityTimeBg )
    local _activityTime = zc.createLabel({
    	text = zc.lang("activity_time") .. ":    ",--.._openTime.."  ~  ".._endTime,
        fontSize = 20,
        color = display.COLOR_TAB_NORMAL_COLOR1,
        color2 = display.COLOR_TAB_NORMAL_COLOR2,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 80, 40 ),
	})
    self._bg:addChild( _activityTime )
	self._activityTime = _activityTime
	-- 领奖时间
	local _rewardTimeBg = ccui.Scale9Sprite:create( cc.rect( 12, 11, 14, 10 ), "res/Main/role/common/name_bg.png" )
    _rewardTimeBg:setContentSize( 230, 30 )
    _rewardTimeBg:setPosition( 650, 40 )
    self._bg:addChild( _rewardTimeBg )
    local _rewardTime = zc.createLabel({
    	text = zc.lang("get_reward_time") .. ":    ",--.._openTime.."  ~  ".._endTime,
        fontSize = 20,
        color = display.COLOR_TAB_NORMAL_COLOR1,
        color2 = display.COLOR_TAB_NORMAL_COLOR2,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 550, 40 ),
	})
    self._bg:addChild( _rewardTime )
	self._rewardTime = _rewardTime
end

-- 切换日期，刷新tab
function SevenDayPop:refreshTab()
	-- tab位置
	local _tab = {}
	for i = 1, 4 do
		if #self._data[self._dayIndex][i] > 0 then
			-- 可见
			_tab[#_tab + 1] = i
			self._tabBtn[i]:setVisible( true )
			local _taskId = self._data[self._dayIndex][i][1].taskId
			self._tabBtn[i]:setText( self._list[_taskId].name )
		else
			-- 不可见
			self._tabBtn[i]:setVisible( false )
		end
	end
	local _height = 320/#_tab
	for i, v in ipairs( _tab ) do
		self._tabBtn[v]:setPositionY( 406 - ( i - 0.5 )*_height )
	end
	-- 选中tab
	self._tabBtn[self._tabIndex]:setSelected( false )
	self._tabIndex = 1
	self._tabBtn[self._tabIndex]:setSelected( true )
end
function SevenDayPop:refresh()
	if self._tabIndex ~= 4 then
		if not self._bg_1 then
			self:initBg_1()
		else
			self._bg_1:setVisible( true )
		end
		self._tableview:reloadData()
		if self._bg_2 then
			self._bg_2:setVisible( false )
		end
	else
		if not self._bg_2 then
			self:initBg_2()
		else
			self._bg_2:setVisible( true )
		end
		self:refreshBg_2()
		if self._bg_1 then
			self._bg_1:setVisible( false )
		end
	end
end

function SevenDayPop:startTimer()
	self._timer = scheduler.scheduleGlobal(function()
		self:tick()
	end, 1)
	self:tick()
end
function SevenDayPop:tick()
	local _continue = false
	if self._actTime > 0 then
		_continue = true
		self._actTime = self._actTime - 1
		self._activityTime:setText( zc.lang("activity_time") .. ": "..zc.getTimer( self._actTime, 1 ) )
	else
		self._activityTime:setText( zc.lang("activity_time") .. ": " .. zc.lang("have_finished"))
	end
	if self._recTime > 0 then
		_continue = true
		self._recTime = self._recTime - 1
		self._rewardTime:setText( zc.lang("get_reward_time") .. ": "..zc.getTimer( self._recTime, 1 ) )
	else
		self._rewardTime:setText( zc.lang("get_reward_time") .. ": " .. zc.lang("have_finished"))
	end
	if not _continue then
		self:stopTimer()
	end
end

function SevenDayPop:stopTimer()
	if self._timer then
		scheduler.unscheduleGlobal( self._timer )
		self._timer = nil
	end
end

function SevenDayPop:onCleanup()
	self:stopTimer()
	-- 刷新红点
	local _flag = false
	for i = 1, self._today do
		local v = self._data[i] or {}
		-- 每天
		for j, u in pairs( v ) do
			-- 每个tab
			if j ~= 4 then
				for k, w in pairs( u ) do
					-- 每个任务
					local _status = tonumber( w.status ) or 0
					local _taskId = tonumber( w.taskId ) or 0
					if _status == 2 and self._list[_taskId] then
						_flag = true
						break
					end
				end
				if _flag then
					break
				end
			end
		end
		if _flag then
			break
		end
	end
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "sevenDay", status = _flag}})
end

function SevenDayPop:refreshDayRedDot()
	self._status = 0

	for i = 1, self._today do
		-- 每天
		local _day = false
		for j, u in pairs( self._data[i] or {} ) do
			-- 每个tab
			if j ~= 4 then
				for k, w in pairs( u ) do
					-- 每个任务
					if w.status == 2 then
						_day = true
						break
					end
				end
				if _day then
					break
				end
			end
		end
		if self._dayBtn[i] then
			self._dayBtn[i]._redDot:setVisible( _day )
		end
		if self._dayBtn[i] then
			if self._dayBtn[i]._redDot:isVisible() then
				self._status = 1
			end
		end

	end

	for i = self._today + 1, #self._dayBtn do
		if self._dayBtn[i] then
			self._dayBtn[i]._redDot:setVisible( false )
		end
		if self._dayBtn[i] then
			if self._dayBtn[i]._redDot:isVisible() then
				self._status = 1
			end
		end
	end
end

function SevenDayPop:refreshTabRedDot()

	for i, v in pairs( self._data[self._dayIndex] or {} ) do
		local _tab = false
		if i ~= 4 then
			for j, u in pairs( v ) do
				-- 每个任务
				if u.status == 2 then
					_tab = true
					break
				end
			end
		end
		self._tabBtn[i]._redDot:setVisible( _tab )

		if self._tabBtn[i]._redDot:isVisible() then
			self._status = 1
		end
	end

	PlayerData:updateRedDotData(17, self._status)
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_FOODSRED,data = {}})

end


return SevenDayPop