-- FileName: WeaponBoxLayer.lua
-- Author: wangming
-- Date: 2016-12-01
-- Purpose: 黑市
--[[TODO List]]
local WeaponBoxLayer = class("WeaponBoxLayer", function()
	local layer = cc.Sprite:create()
    layer:setContentSize( 720, 463 )
	return layer
end)

function WeaponBoxLayer:create( params )
	return WeaponBoxLayer.new( params )
end

function WeaponBoxLayer:ctor( params )
	local _params = params or {}
	self._times = tonumber(_params.times) or 0
    self._times = self._times + 1
    self.activityType = params.activityType

    local _openTime, _endTime = 0, 0
    local _turnInfo = PlayerData:getActivityInfoById(6)
	if _turnInfo.openTime and _turnInfo.endTime then
        _openTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.openTime)
        _endTime = os.date("%m" .. zc.lang("date_month") .. "%d" .. zc.lang("date_day_1"), _turnInfo.endTime)
    end

	local _size = self:getContentSize()
	-- 背景
    local bg
    if self.activityType == 2 then
        -- bg = zc.createSprite("res/Main/activity/weaponBox/bg.jpg")
        bg = ccui.Scale9Sprite:create(cc.rect(1,1,680,450),"res/Main/activity/weaponBox/bg.jpg")
        bg:setContentSize(925,475)
        bg:setPosition(_size.width*0.5 - 10, _size.height + 25)
    else
        bg = zc.createSprite("res/Main/activity/weaponBox/bg.jpg")
        bg:setPosition(_size.width*0.5 + 1, _size.height + 2)
    end
	bg:setAnchorPoint(0.5, 1)
	
	self:addChild(bg)
	local _bgSize = bg:getContentSize()

    local _pos = cc.p((_bgSize.width - 55)*0.5, _bgSize.height*0.5 + 20)
    local _shadow = zc.createSprite("res/Main/activity/weaponBox/shadow.png")
    _shadow:setAnchorPoint(0.5, 1)
    _shadow:setPosition(_pos.x, _pos.y - 100)
    bg:addChild(_shadow)
    self._shadow = _shadow
    
	local _boxSpine = zc.createSpine({
        fileName = "huodong_baoxiang",
        actName = "idle",
        loop = true,
    })
    _boxSpine:setPosition(_pos)
    bg:addChild(_boxSpine)
    self._boxSpine = _boxSpine


	local _titleBtn = zc.createPushButton({
		normalFile = "res/Main/activity/weaponBox/title.png",
		pos = cc.p(60, 350),
		endCallback = function()
            self:createTotolShow()
        end,
	})
	bg:addChild(_titleBtn)

	local _barDi = zc.createSprite("res/Main/activity/weaponBox/bar.png")
	_barDi:setPosition(_bgSize.width - 55, _bgSize.height*0.5)
	bg:addChild(_barDi)
	self:createBar(_barDi)
	-- 底
    local timeBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(400, 33))
    timeBg:setAnchorPoint(0.5, 0)
    timeBg:setPosition(_bgSize.width*0.5, 0)
    bg:addChild(timeBg)

    -- local timeLab = zc.createRichLabel({
    --     text = zc.lang("activity_time") .. "：" .. _openTime .. " ~ " .. _endTime,
    --     fontSize = 20,
    --     pos = cc.p(timeBg:getContentSize().width*0.5, timeBg:getContentSize().height*0.5),
    --     color = cc.c3b(230, 224, 163),
    -- })
    -- timeBg:addChild(timeLab)

    local _leftBtn = zc.createCommomBtn({
		tag = 2,
		text = zc.lang("open_one_times"),
		pos = cc.p(_bgSize.width*0.5 - 180, 70),
		endCallback = function()
			self:doBuy(1)
		end
	})
	bg:addChild(_leftBtn)

	local _costLeftLab = zc.createRichLabel({
        fontSize = 20,
    })  
    _costLeftLab:setPosition(_leftBtn:getPositionX(), _leftBtn:getPositionY() + 50)
    bg:addChild(_costLeftLab)
    self._costLeftLab = _costLeftLab

	local _rightBtn = zc.createCommomBtn({
		tag = 1,
		text = zc.lang("open_ten_times"),
		pos = cc.p(_bgSize.width*0.5 + 120, _leftBtn:getPositionY()),
		endCallback = function()
			self:doBuy(2)
		end
	})
	bg:addChild(_rightBtn)

	local _costRightLab = zc.createRichLabel({
        fontSize = 20,
    })  
    _costRightLab:setPosition(_rightBtn:getPositionX(), _rightBtn:getPositionY() + 50)
    bg:addChild(_costRightLab)
    self._costRightLab = _costRightLab

    self:freshCost()
end

function WeaponBoxLayer:freshCost()
	local _time = self._times
	local _costData1 = zc.getConsumePriceData(49, _time)
	local _costNum1 = tonumber(_costData1.price) or 0
	if _costNum1 == 0 then
		self._costLeftLab:setString(zc.lang("free"))
	else
		self._costLeftLab:setString(zc.getResRichText(zc.dataTypeGold, _costNum1))
	end
	local _costNum2 = _costNum1
	for i=1, 9 do
		_time = _time + 1
		local _costData2 = zc.getConsumePriceData(49, _time)
		_costNum2 = _costNum2 + (tonumber(_costData2.price) or 0)
	end
	if _costNum2 == 0 then
		self._costRightLab:setString(zc.lang("free"))
	else
		self._costRightLab:setString(zc.getResRichText(zc.dataTypeGold, _costNum2))
	end

    
end

function WeaponBoxLayer:createBar( barDi )
	local _dbs = gameData.getAllDataWithNoClone("bonuspreview")
	local _datas = {}
	self._seatNum = table.nums(_dbs)
	for k,v in pairs(_dbs) do
		table.insert(_datas, v)
	end
	local _count = 0
	for k,v in pairs(_dbs) do
		table.insert(_datas, v)
		_count = _count + 1
		if _count == 5 then
			break
		end
	end
	local _nums = #_datas
	if _nums == 0 then
		return
	end
	local _tableSize = cc.size(barDi:getContentSize().width, barDi:getContentSize().height - 180)
	self._pubSize = _tableSize
	self._minScale = 0.65
    self._baseScale = 0.8
    local tableView = zc.ZCTableView:create(_tableSize)
    tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    tableView:setBounceable(true)
    tableView:setInertia(false)
    tableView:setAutoAlign(true)
    tableView:setDelegate()
    tableView:setPosition(0, 90)
    tableView:setTouchEnabled(false)
    barDi:addChild(tableView)

    local _cellSize = cc.size(_tableSize.width, _tableSize.height*0.2)

    local function scorllviewScriptScroll( table ) --这里只对卷轴相对中心位置调整scale
        self:scorllviewScriptScroll(table)
    end
    local function numberOfCellsInTableView( table )
        return _nums
    end
    local function cellSizeForTable( table, idx )
        return _cellSize.height, _cellSize.width  
    end
    local function tablePageAfterSliding( table, cell )
        self:tablePageAfterSlidingFresh()
    end

    local function tableCellAtIndex( table, idx )
        local _cell = table:dequeueCell()
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            _cell:setContentSize(_cellSize)
        end
        _cell:setAnchorPoint(0.5, 0.5)
        _cell:removeAllChildren()
        _cell:setLocalZOrder(0)
        local _data = _datas[idx + 1]
       	local _item = zc.createIconByData({
            data = {
                mainType = _data.itemType,
                type = _data.itemId, 
                id = _data.itemId,
            }, 
            pos = cc.p(_cellSize.width*0.5, _cellSize.height*0.5), 
        })
        -- _item:setScale(0.8)
        _item:setScale(self._minScale * self._baseScale)
        _cell:addChild(_item)
        _cell._item = _item
        zc.doFuncForAllChild(_cell, function( child )
    		child:setOpacity(255*0.5)
    	end)
        return _cell
    end
    
    tableView:registerScriptHandler(numberOfCellsInTableView,zctech.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    tableView:registerScriptHandler(cellSizeForTable,zctech.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex,zctech.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(scorllviewScriptScroll,zctech.SCROLLVIEW_SCRIPT_SCROLL)
    tableView:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)

    self._pubLayer = tableView

    self._currentPage = 0
    tableView:reloadData()
    tableView:scrollToCell(self._currentPage, false)
	
    performWithDelay(self, function()
        self._pubLayer:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.CallFunc:create(function()
                self._currentPage = self._currentPage + 1
                self._pubLayer:scrollToCell(self._currentPage, true)
            end),
            cc.DelayTime:create(1.5)
        )))
    end, 0.5)
end

function WeaponBoxLayer:scorllviewScriptScroll( table, isForce ) --这里只对卷轴相对中心位置调整scale
	local currentPage = table:getCurrentPage() + 2
    local _offSet = table:getContentOffset().y
   	if not isForce and self._lastOffSet == _offSet then
   		return
   	end
   	self._lastOffSet = _offSet
    for i = currentPage - 2, currentPage + 3 do
        local _cell = table:cellAtIndex(i)
        if _cell and _cell._item then
            local _posY = _cell:getPositionY() + _offSet + self._pubSize.height*0.2*0.5
            local _part = math.abs(self._pubSize.height*0.5 - _posY)/(self._pubSize.height*0.5)
            local _scale = 1 - _part*self._minScale
            _scale = _scale < self._minScale and self._minScale or _scale
            local _opacity = (1 - _part*0.5)*255
            _cell._item:setScale(_scale * self._baseScale)
            zc.doFuncForAllChild(_cell, function( child )
        		child:setOpacity(_opacity)
        	end)
        	if _scale <= 0.7 then
                _cell:setLocalZOrder(1)
    		elseif _scale < 0.85 then
                _cell:setLocalZOrder(2)
    		else
                _cell:setLocalZOrder(3)
    		end
        end
    end
	local _cell = table:cellAtIndex(currentPage - 3)
    if _cell and _cell._item then
        _cell._item:setScale(self._minScale * self._baseScale)
    end
	local _cell = table:cellAtIndex(currentPage + 4)
    if _cell and _cell._item then
        _cell._item:setScale(self._minScale * self._baseScale)
    end
end

function WeaponBoxLayer:tablePageAfterSlidingFresh( table )
    local table = self._pubLayer

    local currentPage = table:getCurrentPage() + 2
    if currentPage >= self._seatNum + 5 - 3 then
    	self._currentPage = 0
	    table:reloadData()
	    table:scrollToCell(0, false)
	    return
	end
    self:scorllviewScriptScroll(table, true)

    local _cell = table:cellAtIndex(currentPage)
    if _cell and _cell._item then
        if _cell._item:getScale() < 0.9 * self._baseScale then
            currentPage = currentPage + 1
        end
    end

    for i = currentPage - 2, currentPage + 3 do
        local _index = i-1
        local _tmpCell = table:cellAtIndex(i)  
        if _tmpCell then
            if i ~= currentPage then
                local _opacity = 255*0.5
                local _zorder = 1
                if i == currentPage - 1 or i == currentPage + 1 then
                	_opacity = 255*0.8
                	_zorder = 2
                end
                zc.doFuncForAllChild(_tmpCell, function( child )
            		child:setOpacity(_opacity)
            	end)
                _tmpCell:setLocalZOrder(_zorder)
            else
                zc.doFuncForAllChild(_tmpCell, function( child )
            		child:setOpacity(255)
            	end)
                _tmpCell:setLocalZOrder(3)
            end
        end
    end

	local _cell = table:cellAtIndex(currentPage - 3)
    if _cell and _cell._item then
        zc.doFuncForAllChild(_cell, function( child )
    		child:setOpacity(255*0.5)
    	end)
        _cell:setLocalZOrder(0)
        _cell._item:setScale(self._minScale * self._baseScale)
    end
	local _cell = table:cellAtIndex(currentPage + 4)
    if _cell and _cell._item then
        zc.doFuncForAllChild(_cell, function( child )
    		child:setOpacity(255*0.5)
    	end)
        _cell:setLocalZOrder(0)
        _cell._item:setScale(self._minScale * self._baseScale)
    end
end

function WeaponBoxLayer:doBuy( type )
	local _type = tonumber(type) or 1
	zc.sendHttp({
        apiName = "WeaponBox_buy",
        params = {type=_type},
        successCallback = function(backData)
	        if tolua.isnull(self) then
	        	return
	        end
	        backData.noAnimation = false
        	PlayerData:updataData(backData)
        	local _rewards = backData.clientItems
        	self._times = tonumber(backData.times) or 0
            self._times = self._times + 1
        	self:freshCost()
            self:createAnimationShow(backData)
        end
    })
end

function WeaponBoxLayer:createAnimationShow(backData)
    self._boxSpine:setVisible(false)
    self._shadow:setVisible(false)
    local _dialog = ZCDialog:create(255*0.7)
    LayerManager.addNode(_dialog, {isPop = true})

    local _infos = PlayerData:getShowIconDatas(backData)
    local _datas = {}
    for k,v in pairs(_infos) do
        local itemType = tonumber(v.itemType) or 0
        if zc.mainTypeWeapon == v.itemType or v.itemType == zc.mainTypeProp then
            local _db = {}
            if zc.mainTypeWeapon == v.itemType then
                _db = gameData.getDataFromCacheWithPrimaryKey("weapon", v.itemId) 
            else
                _db = gameData.getDataFromCacheWithPrimaryKey("item", v.itemId) 
            end
            v.quality =  tonumber(_db.quality) or 0
            _datas[#_datas + 1] = v
        end
    end
    table.sort(_datas, function( a, b )
        if not a or not b then
            return false
        end
        local itemTypeA = tonumber(a.itemType) or 0
        local itemTypeB = tonumber(b.itemType) or 0
        if itemTypeA ~= itemTypeB then
            return itemTypeA ~= zc.mainTypeWeapon
        end
        local itemIdA = tonumber(a.quality) or 0
        local itemIdB = tonumber(b.quality) or 0
        return itemIdA < itemIdB
    end)

    local _boxSpine = zc.createSpine({
        fileName = "huodong_baoxiang",
        actName = "idle",
        loop = false,
    })
    _boxSpine:setPosition(zc.width*0.5, zc.height*0.5)
    _dialog:addChild(_boxSpine)

    local function _showEnd( ... )
        local tipLab = zc.createLabel({
            text = zc.lang("tips_click_empty_continue"),
            outLine = true,
            fontSize = 22,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(zc.width*0.5, zc.height*0.5 - 200),
        })
        _dialog:addChild(tipLab)
        tipLab:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeOut:create(1.0),cc.FadeIn:create(1.0)) ))

        _dialog:setTouchEndedCallback(function() 
            LayerManager.removeLayout(true)
            self._boxSpine:setVisible(true)
            self._shadow:setVisible(true)
        end)
    end

    local _di = cc.Node:create()
    _di:setPosition(zc.width*0.75 - 30, zc.height*0.5)
    _dialog:addChild(_di, 1)

    local function _createOneItem( idx, callFunc )
        local _idx = tonumber(idx) or 1

        local _itemType = tonumber(_datas[_idx].itemType) or 0
        local _itemId = tonumber(_datas[_idx].itemId) or 0
        local _id = _datas[_idx].model and _datas[_idx].model.id or 0
        local _level
        if _itemType == zc.mainTypeWeapon then
            local __level = tonumber(zc.getWeaponLevel( _id )) or 0
            if __level > 0 then
                _level = zc.getLevelTipShow() .. __level
            end
        end
        local _icon = zc.createIconByData({
            data = {
                mainType = _itemType,
                type = _itemId, 
                id = _itemId,
                num = _datas[_idx].changeNum,
                level = _level,
            }, 
            primaryId = _id,
            showLevel = (_itemType == zc.mainTypeWeapon) and true or false,
            -- showDetailPop = true,
        })
        _icon:setTouchEndedShowTip(true)
        _icon:setScale(0.1)
        _icon:setPosition(-zc.width*0.55, 0)
        local _tarX, _tarY = 0, 0
        if not idx then
            _tarX = 0
            _tarY = 50
        else
            local _ceil = (_idx-1)%5
            _tarX = -200 + _ceil*100
            _tarY = _idx < 6 and 50 or -50
        end
        _di:addChild(_icon)
        _icon:runAction(cc.Sequence:create(
            cc.Spawn:create(
                cc.RotateTo:create(0.3, 720),
                cc.ScaleTo:create(0.3, 0.7),
                cc.MoveTo:create(0.3, cc.p(_tarX, _tarY))
            ),
            cc.CallFunc:create(function()
                local _info = {}
                if _itemType == zc.mainTypeWeapon then
                    _info = PlayerData:getWeaponInfoInfoById(_id) or {}
                end
                local _quality = tonumber(_info.quality) or 0
                if _quality >= 4 then
                    performWithDelay(_icon, function()
                        local _pop = requires("src/pop/makeGodWeaponPop.lua"):create({
                            info = _info,
                            onlyShow = true,
                            isAdd = true,
                            endCallback = callFunc
                        })
                        _dialog:addChild(_pop, 2)
                    end, 0.1)
                else
                    callFunc()
                end
            end)
        ))
    end

    local function _doShow()
        if #_datas > 1 then
            local _idx = 1
            local function _doNext()
                if _idx > #_datas then
                    _showEnd()
                    return
                end 
                _createOneItem(_idx, function()
                    _idx = _idx + 1
                    _doNext()
                end)
            end
            _doNext()
        else
            _createOneItem(nil, _showEnd)
        end
    end

    _boxSpine:registerSpineEventHandler(function( event )
        local name = event.animation
        if name == "open" then
            _boxSpine:playAction("open_idle", true)
        end
    end, sp.EventType.ANIMATION_COMPLETE)

    performWithDelay(_dialog, _doShow, 1.2)

    local _di = cc.Node:create()
    _di:setPosition(zc.width*0.75 - 30, zc.height*0.5 - 20)
    _dialog:addChild(_di)
    local _bg = zc.createSprite("res/Main/copy/copy_sweepbg2.png")
    _bg:setScale(0.7)
    _di:addChild(_bg)
    local _title = zc.createSprite("res/Main/activity/weaponBox/title2.png")
    _title:setPosition(0, 175)
    _di:addChild(_title)
    zc.doFuncForAllChild(_di, function( child )
        child:setOpacity(0)
        child:runAction(cc.FadeIn:create(0.5))
    end)
   
    _boxSpine:runAction(cc.Sequence:create(
        cc.MoveBy:create(0.3, cc.p(-zc.width*0.25, 0)),
        cc.CallFunc:create(function()
            _boxSpine:playAction("open", false)
        end)
    ))
end

function WeaponBoxLayer:createTotolShow()
    local _dialog = ZCPopLayer:create({opacityValue = 255*0.7})
    LayerManager.addNode(_dialog, {isPop = true})
    _dialog:show()

    local _tagNames = LANGUAGE_get_weapon_type_name()
    
    local _size = cc.size(490, #_tagNames*66)
    local _midBg = zc.getScaleNode("res/Main/ornaments/general_tips_s_bg.png", _size)
    _midBg:setPosition(zc.width*0.5, zc.height*0.5)
    _dialog:addContent(_midBg)

    if not self._totleDatas then
        self._totleDatas = {{},{},{},{},{},{},{}}
        local _dbs = gameData.getAllDataWithNoClone("tenEvenPump")
        
        for k,v in pairs(_dbs) do
            if zc.mainTypeWeapon == v.itemType then
                local _db = gameData.getDataFromCacheWithPrimaryKey("weapon", v.itemId)
                local _type = _db.type or 0
                if _type ~= 0 then
                    local _flag = true
                    for _k,_v in pairs(self._totleDatas[_type]) do
                        if v.itemId == _v.itemId then
                            _flag = false
                            break
                        end
                    end
                    if _flag then
                        local _tb = {
                            itemType = v.itemType,
                            itemId = v.itemId,
                            quality = _db.quality,
                        }
                        table.insert(self._totleDatas[_type], _tb)
                    end
                end
            else
                local _db = gameData.getDataFromCacheWithPrimaryKey("item", v.itemId)
                local _flag = true
                for _k,_v in pairs(self._totleDatas[7]) do
                    if v.itemId == _v.itemId then
                        _flag = false
                        break
                    end
                end
                if _flag then
                    local _tb = {
                        itemType = v.itemType,
                        itemId = v.itemId,
                        quality = _db.quality
                    }
                    table.insert(self._totleDatas[7], _tb)
                end
            end

            local _db = gameData
        end
        for k,v in pairs(self._totleDatas) do
            table.sort(v, function( a, b )
                if not a or not b then
                    return false
                end
                local _qA = tonumber(a.quality) or 0
                local _qB = tonumber(b.quality) or 0
                return _qA > _qB
            end)
        end
    end

    local _title = zc.createSprite("res/Main/activity/weaponBox/title2.png")
    _title:setPosition(_size.width*0.5, _size.height)
    _midBg:addChild(_title)

    local _btns = {}
    local _nowIdx = nil

    local _viewSize = cc.size(_size.width*0.95, _size.height*0.9)
    local _scrollView = zc.createScrollview({
        pos = cc.p(_size.width*0.5 - _viewSize.width*0.5, _size.height*0.5 - _viewSize.height*0.5),
        size = _viewSize,
        dir = ccui.ScrollViewDir.vertical,
    })
    _midBg:addChild(_scrollView) 

    local function _freshNow( idx )
        if _nowIdx and _btns[_nowIdx] then
            _btns[_nowIdx]:setSelected(false)
            _btns[_nowIdx]:setEnable(true)
        end
        _nowIdx = idx
        if _nowIdx and _btns[_nowIdx] then
            _btns[_nowIdx]:setSelected(true)
            _btns[_nowIdx]:setEnable(false)
        end

        if not _nowIdx or not self._totleDatas[_nowIdx] then
            return
        end
        local _datas = self._totleDatas[_nowIdx] or {}
        local _num = #_datas
        _scrollView:removeAllChildren()
        if _datas == 0 then
            return
        end

        local _r = math.ceil(_num/5)
        local _innerHeight = _r*90 
        _innerHeight = _innerHeight > _viewSize.height and _innerHeight or _viewSize.height
        _scrollView:setInnerContainerSize(cc.size(_viewSize.width, _innerHeight))
        local _w, _h = 90, 90
        for i=0, _r-1 do
            for j=1, 5 do
                local _index = i*5 + j
                local _data = _datas[_index]
                if _data then
                    local _item = zc.createIconByData({
                        data = {
                            mainType = _data.itemType,
                            type = _data.itemId, 
                            id = _data.itemId,
                        }, 
                        -- showDetailPop = true,
                        pos = cc.p(_viewSize.width*0.5 - (3 - j)*_w, _innerHeight - (0.5 + i)*_h), 
                    })
                    _item:setScale(0.6)
                    _scrollView:addChild(_item)
                    _item:setTouchEndedShowTip()
                end
            end
        end
    end

    for i=1, #_tagNames do
        local _btn = zc.createPushButton({
            text = _tagNames[i],
            normalFile = "res/Main/activity/weaponBox/btn_u.png",
            selectedFile = "res/Main/activity/weaponBox/btn_d.png",
            noScaleAction = true,
            anchor = cc.p(0, 0.5),
            pos = cc.p(_size.width - 7, _size.height - 40 - (i-1)*62),
            endCallback = function()
                _freshNow(i)
            end
        })
        _midBg:addChild(_btn)
        _btns[#_btns + 1] = _btn
    end
    _freshNow(1)
end

return WeaponBoxLayer
