--[[
	演武榜查看信息
	唐实聪
	2016.3.19
]]
local ArenaLookupPop = class("ArenaLookupPop", function()
	return ZCPopLayer:create()
end)

function ArenaLookupPop:create( params )
	return ArenaLookupPop.new( params )
end

function ArenaLookupPop:ctor( params )
	self:show()
	self:initData( params )
	self:initUI()
end

function ArenaLookupPop:initData( params )
	-- dump( data, "ArenaLookupPop" )
	self._data = params.userData
    self._winScore = params.winScore
	self._size = self:getContentSize()
end

function ArenaLookupPop:initUI()
	-- 背景
	local background = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(self._size.width/2, self._size.height/2)
    })
	self:addContent( background )
	self._bg = background
	self._bgSize = background:getContentSize()
	-- 关闭按钮
	local closeBtn = zc.createBackButton({
		pos = cc.p( self._bgSize.width, self._bgSize.height ),
		listener = function ()
			self:hide()
		end
	})
	self._bg:addChild( closeBtn )

	-- 查看信息标题
	local title = zc.getTipPopTitle( "chakanxinxi" )
    title:setPosition( self._bgSize.width/2, self._bgSize.height - 30 )
	self._bg:addChild(title)
	-- 背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(self._bgSize.width*0.5, self._bgSize.height*0.5 + 30)
	self._bg:addChild( middleBg )
   
    local _posX = 70
    local _posY = 125
	-- 头像
	local heroIcon = zc.createPlayerHead({iconId = self._data.iconId})
    heroIcon:setPosition( _posX, _posY )
    heroIcon:setScale( 0.85 )
    middleBg:addChild( heroIcon )
    -- 兵器图标
    local weaponIcon = cc.Sprite:create( "res/Main/hero/hero_type1.png" )
    weaponIcon:setPosition( _posX + 73, _posY + 23 )
    middleBg:addChild( weaponIcon )
	-- 名字
	local name = zc.createLabel({
		text = self._data.userName,
        fontSize = 20,
        outLine = true,
        pixel = 1.5,
        alignment = cc.TEXT_ALIGNMENT_LEFT,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( _posX + 93, _posY + 23 ),
	})
	middleBg:addChild( name )
	-- 国家
	if self._data.countryName and #self._data.countryName > 0 then
		local country = zc.createLabel({
			text = "<"..self._data.countryName..">",
	        fontSize = 20,
	        outLine = true,
	        pixel = 1.5,
	        alignment = cc.TEXT_ALIGNMENT_LEFT,
	        ap = cc.p( 0, 0.5 ),
	        pos = cc.p( name:getPositionX() + name:getContentSize().width + 5, name:getPositionY() ),
		})
		middleBg:addChild( country )
	end
	-- -- 战斗力图片
    local fightingSp = cc.Sprite:create( "res/Main/role/common/fight_bg.png" )
    fightingSp:setAnchorPoint( 0, 0.5 )
    fightingSp:setPosition( _posX + 52, _posY - 20 )
    fightingSp:setScale( 0.8 )
	middleBg:addChild( fightingSp )
	-- -- 战斗力数字
	local fightingNum = zc.createFntLabel({
		text = self._data.fighting,
        fnt = "res/Main/common/fnt/fight_change.fnt",
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 90, fightingSp:getContentSize().height/2 ),
        addwidth = -14,
    })
    fightingNum:setScale( 0.7 )
    fightingSp:addChild( fightingNum )

    -- 战胜可获得积分
    local scoreBg = cc.Sprite:create( "res/Main/arena/lookup/scoreBg.png" )
    scoreBg:setAnchorPoint( 0.5, 0 )
    scoreBg:setPosition( middleBg:getContentSize().width/2, 0 )
    middleBg:addChild( scoreBg )
    -- 文字
    local scoreText = zc.createLabel({
		text = LANGUAGE_ARENA.get_score_when_win..": "..self._winScore,
        fontSize = 20,
        color = display.COLOR_YELLOW,
        outLine = true,
        pixel = 1.5,
        alignment = cc.TEXT_ALIGNMENT_CENTER,
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( scoreBg:getContentSize().width/2, scoreBg:getContentSize().height/2 ),
	})
	middleBg:addChild( scoreText )

    -- 按钮
    local posX = 95
    local posY_top = 100
    local posY_bottom = 46
    local _scale = 0.7
    -- 发邮件
    local emailBtn = zc.createCommomBtn({
    	tag = 3,
        scale = _scale,
        labScale = true,
        text = LANGUAGE_ARENA.send_email,
        pos = cc.p( posX, posY_top ),
        endCallback = function()
            -- self:hide()
            zc.createEmailPop({
                tag=2, 
                name=self._data.userName, 
                needSend=true
            })
        end
	})
	self._bg:addChild( emailBtn )
    -- 屏蔽
    local shieldBtn = zc.createCommomBtn({
    	tag = 3,
        scale = _scale,
        labScale = true,
        text = LANGUAGE_ARENA.ignore,
        pos = cc.p( self._bgSize.width/2, posY_top ),
        endCallback = function()
            zc.maskThePlayer(self._data.userId)
        end
	})
	self._bg:addChild( shieldBtn )
    -- 加好友
    local friendBtn = zc.createCommomBtn({
    	tag = 3,
        scale = _scale,
        labScale = true,
        text = LANGUAGE_ARENA.make_friend,
        pos = cc.p( self._bgSize.width - posX, posY_top ),
        endCallback = function()
            zc.addFriend(self._data.userId)
        end
	})
	self._bg:addChild( friendBtn )
    -- 查看信息
    local lookupBtn = zc.createCommomBtn({
        tag = 3,
        scale = _scale,
        labScale = true,
        text = LANGUAGE_ARENA.lookup,
        pos = cc.p( posX, posY_bottom ),
        endCallback = function()
        	-- self:hide()
        	zc.createOtherPlayerInfoPop( self._data.userName )
        end
	})
	self._bg:addChild( lookupBtn )
    -- 切磋
    local fightBtn = zc.createCommomBtn({
        tag = 3,
        scale = _scale,
        labScale = true,
        text = LANGUAGE_ARENA.fight,
        pos = cc.p( self._bgSize.width/2, posY_bottom ),
        endCallback = function()
        	zc.kahei( self._data.userId )
        end
	})
	self._bg:addChild( fightBtn )
    -- 私聊
    local chatBtn = zc.createCommomBtn({
        tag = 3,
        scale = _scale,
        labScale = true,
        text = LANGUAGE_ARENA.chat_private,
        pos = cc.p( self._bgSize.width - posX, posY_bottom ),
        endCallback = function()
            -- zc.createSourceScene("arena_ChatPanel", "src/layer/chat/ChatPanelPop.lua",{toUserId = self._data.userId, toUserName = self._data.userName, channel = 3, isClose = true})
            zc.createSourceScene("ChatPanel", "src/layer/chat/ChatPanelPop.lua",{toUserId = self._data.userId, toUserName = self._data.userName, channel = 3, isClose = true})
        end
	})
	self._bg:addChild( chatBtn )
end

return ArenaLookupPop