--  Created by zhangchao on 16-03-29.
local caiwenji = class("caiwenji", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function caiwenji:create(params)
	return caiwenji.new(params)
end

local csbs = nil
function caiwenji:ctor(params)
	csbs = {"caiwenji_atk","caiwenji_atk3"}
	self:preloadCsbs(csbs)
end

function caiwenji:getCsbFiles()
	return csbs
end
function caiwenji:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK or skillType == BATTLE_SKILL_TYPE.SUPER then
		local _fileName = "caiwenji_atk"
		local _actName  = "atk"
		if skillType == BATTLE_SKILL_TYPE.SUPER then
			_actName  = "atk3"
		end
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1" or movementID == "atk_1" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				if skillType == BATTLE_SKILL_TYPE.SUPER then
					armature:getAnimation():play("atk3_1")
				elseif skillType == BATTLE_SKILL_TYPE.ATK then
					armature:getAnimation():play("atk_1")
				end
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			print("结束"..tostring(math.random(0,10)))
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function caiwenji:preAttack(params)
	local skillType 	= params.skillType
	-- skillType = 2
	if skillType == BATTLE_SKILL_TYPE.SUPER then--3.士气技能 大招
	    local armature = zc.battle.createBattleEffect({fileName = "caiwenji_atk3" , actName = "atk3"})
	    armature:setPosition(self:getPosition())
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = self:getLocalZOrder() + 1},
		})
    end
end

function caiwenji:isAttackEvent(evt)
	local attackEvt = false
	if string.find(evt,"hit") then
		attackEvt = true
	end
	if string.find(evt,"do_atk3_hit1") or string.find(evt,"do_atk3_hit2") then
		attackEvt = false
	end
	return attackEvt
end



return caiwenji




