--  Created by zhangchao on 16-03-29.
local kongrong = class("kongrong", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function kongrong:create(params)
	return kongrong.new(params)
end

function kongrong:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "kongrong"
		local _actName  = "atk_1"
		-- if skillType == BATTLE_SKILL_TYPE.SUPER then
		-- 	_actName  = "atk3"
		-- end
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				if skillType == BATTLE_SKILL_TYPE.ATK then
					armature:getAnimation():play("atk_2")
				end
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 2},
			})
		end
	else
		self:doHurt(params)
	end
end

function kongrong:showDefenseEffect(params)
	local skillType 	= params.skillType
	local hero 			= params.hero
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene)
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		local armature = zc.battle.createBattleEffect({fileName = "kongrong" , actName = "atk0_1"})
	    armature:setPosition(point)
	    if hero:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * hero:getScaleX())
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 15},
		})
	    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		local armature = zc.battle.createBattleEffect({fileName = "kongrong" , actName = "atk_2"})
	    armature:setPosition(point)
	    if hero:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * hero:getScaleX())
	    end
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 15},
		})
	    hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
	end
end
function kongrong:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end

function kongrong:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 8
	end
	return count
end

return kongrong




