--  Created by wangming on 16-12-14.
local luxun = class("luxun", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function luxun:create(params)
	return luxun.new(params)
end

function luxun:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 3 then
		count = 4
	end
	return count
end

function luxun:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function luxun:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

function luxun:doBuffAnimation( params )
	local buff_type	 			= params.buff_type--buff 类型(对应下面的类型)
	local targetHero       		= params.targetHero
	local armature, topPoint
	if buff_type == 29 then
		armature = zc.battle.createBattleEffect({fileName = "luxun" , actName = "atk0_1", autoRemove = true})
		topPoint = targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, targetHero:getArmature())
	end
	if armature then
		armature:setPosition(topPoint)
		targetHero:getRectBuffNode():addChild(armature)
	end
end


function luxun:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "luxun" , actName = "atk_1", loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_2")
    			self:doHurt(params)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 2},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		if evt == "do_atk3_hit1" then
			for k,hero in pairs(hurtTargets) do
			    local armature = zc.battle.createBattleEffect({fileName = "luxun" , actName = "atk3_1", autoRemove = true})
			    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene))
			    if self:getSide() == BATTLE_SIDE.LEFT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 2},
				})
			end
		end
		self:doHurt(params)
	else
		self:doHurt(params)
	end
end

return luxun




