--  Created by wangming on 16-12-14.
local xiahouyuan = class("xiahouyuan", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function xiahouyuan:create(params)
	return xiahouyuan.new(params)
end

function xiahouyuan:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 5
	elseif skillType == 3 then
		count = 8
	end
	return count
end

function xiahouyuan:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		if evt == "do_atk3_hit" then
			local _fileName = "xiahouyuan"
			local _actName  = "atk3_1"

			for k,hero in pairs(hurtTargets) do
				local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
			    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = false, moveCallback = function (armatureBack,movementType,movementID)
	                if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1" ) then
	                    xpcall(function() armatureBack:removeFromParent() end, function ()
	                            print("armatureBack已被删除")
	                        end)
	                end
	            end})
			    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
			    if hero:getSide() == BATTLE_SIDE.RIGHT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 2},
				})
			end
		end
	end
	self:doHurt(params)
end

function xiahouyuan:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType ~= BATTLE_SKILL_TYPE.SUPER then
		self:showCommonDefenseEffect(params)
	end
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function xiahouyuan:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	local _x = 0
	if skillType == 1 then --1.普通攻击
		-- _x = -50
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = self:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5,6}) then
			_position = 5
		else
			_position = 8
		end
    	y = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}).y
	end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	local pos 				= cc.p(x + _x, y)
	return pos
end

return xiahouyuan




