-- 
local xizhicai = class("xizhicai", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function xizhicai:create(params)
	return xizhicai.new(params)
end

function xizhicai:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 6
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 2
	end
	return count
end

function xizhicai:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.ATK or skillType == BATTLE_SKILL_TYPE.ATK0 or skillType == BATTLE_SKILL_TYPE.SUPER then
		local _playName = "atk_baodian"

		if BATTLE_SKILL_TYPE.ATK0 == skillType then
			_playName = "atk0_baodian"
		elseif skillType == BATTLE_SKILL_TYPE.SUPER then
			_playName = "atk3_baodian3"
		end

		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "xizhicai", actName = "tongyongzidan", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == _playName) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play(_playName)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function xizhicai:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero

	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function xizhicai:shouldMoveAttack(atkName)
	local ret = false
	-- if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
	-- 	ret = false
	-- end
	return ret
end


return xizhicai