--  Created by zhangchao on 16-05-03.
local yuanshao = class("yuanshao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function yuanshao:create(params)
	local _yuanshao = yuanshao.new(params)
	_yuanshao._fit2SkillId = 339
	return _yuanshao
end


local csbs = nil
function yuanshao:ctor(params)
	csbs = {"yuanshao_atk3"}
	self:preloadCsbs(csbs)
end

function yuanshao:getCsbFiles()
	return csbs
end

function yuanshao:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
		-- ret = false
	elseif atkName == BATTLE_ANIMATION_ACTION.FIT_START then
		ret = false
	end
	return ret
end

function yuanshao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 13
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = self._isFit2 and 7 or 9
	end
	return count
end
function yuanshao:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	local fileName = nil
	local actName = nil
	if skillType == 3 then--
		fileName = "yuanshao_atk3"
		actName  = "atk3"
    end

    if fileName and actName then
		local armature = zc.battle.createBattleEffect({fileName = fileName , actName = actName})
	    -- armature:setPosition(self:getPosition())
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		self:getRectEffectNode():addChild(armature)
    end
end
function yuanshao:getFitSkillPos( params )
	local armature = params.armature
	local firstTarget = params.firstTarget
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	local point  	= firstTarget:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
    armature:setPosition(point)
    if self:getSide() == BATTLE_SIDE.RIGHT then
    	armature:setScaleX(-1 * armature:getScaleX())
    end
end
function yuanshao:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "cybejing",
		skeletonActName = "yuanshao",
		name = "yuanshao",
		heroActName = "idle",
		-- 合体技特效
		fileName = "yuanshao_fit",
		actName = "Fit_2",
		--是否需要特殊处理合体技能
		-- specialHandle = true,
	}

	if self._isFit2 then
		fitSrc.fileName = "yuanshao_Fit0_A2"
		fitSrc.actName = "Fit2"
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	end
	return fitSrc
end

function yuanshao:doFitSkillHitEff(params)
	if not self._isFit2 then
		self:_doNormalFitEff(params)
		return
	end
	print("fit_______skill")
	dump(params)

	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			fit_bg:removeFromParent()
		end})

		local _px = 150

		if self._isFit2 then --合体机能2 ，位置跟技能1 区分开。
			_px = -20
		end

	    if self:getSide() == BATTLE_SIDE.RIGHT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    	_px = -_px
	    end
	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_fit_hit") then
				self:doAttack({skillType = skillType, process = process, evt = evt})
			elseif string.find(evt,"back") then
				self:_endFitSkill(all_heroes, _targets_)
	        end
	    end)

		local _position = firstTarget:getBattlePosition()
		if not self._isFit2 then
			if inArray(_position, {1,2,3}) then
				_position = 2
			elseif inArray(_position, {4,5, 6}) then
				_position = 5
			else
				_position = 8
			end
		end
    	local _pos = zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position})
    	_pos.x = _pos.x + _px
	    armature_fit2:setPosition(_pos)

		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	end,0)
end

return yuanshao
