--  Created by zhangchao on 16-03-29.
local yuji = class("yuji", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function yuji:create(params)
	local _yuji = yuji.new(params)
	_yuji._fit2SkillId = 345
	return _yuji
end

function yuji:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _fileName = "yuji"
		local _actName  = "atk_1"
		-- if skillType == BATTLE_SKILL_TYPE.SUPER then
		-- 	_actName  = "atk3"
		-- end
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_1" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 3000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				if skillType == BATTLE_SKILL_TYPE.ATK then
					-- armature:getAnimation():play("eff_sj")
					xpcall(function() armature:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
				end
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	    		if ret and _tmp_ == 1 then
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 2},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		if self._isFit2 then
			for k,hero in pairs(hurtTargets) do
				local _actName = "Fit_2_3"
				local _eventCallback
				if k == 1 then
					_actName = "Fit_2"
					_eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
						zc.battle.doShockAndFlash(evt)
				    	if self:isAttackEvent(evt) then
				        	params.evt = evt
							self:doHurt(params)
						elseif string.find(evt, "back") then
							performWithDelay(self, endFunction, 0.5)
						end
				    end
				end
				local armature_fit = zc.battle.createBattleEffect({fileName = "yuji_fit_A2", actName = _actName, autoRemove = true, eventCallback = _eventCallback})
				if self:getSide() == BATTLE_SIDE.LEFT then
			    	armature_fit:setScaleX(-1 * armature_fit:getScaleX())
			    end
			    armature_fit:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))			
			    zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature_fit , zorder = hero:getLocalZOrder() + 30},
				})
			end
			return
		end
		local _target_ = hurtTargets[1]
		local _events = {}
		for k,hero in pairs(hurtTargets) do
			local runningScene 	= cc.Director:getInstance():getRunningScene()
			local armature_fit = zc.battle.createBattleEffect({fileName = "yuji_Fit", actName = "Fit_2", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
				zc.battle.doShockAndFlash(evt)
		    	if self:isAttackEvent(evt) then
		    		if inArray(evt, _events) then
		    			return
		    		end
		    		table.insert(_events, evt)
		        	params.evt = evt
					self:doHurt(params)
				end
		    end})

			if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature_fit:setScaleX(-1 * armature_fit:getScaleX())
		    end
		    armature_fit:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))			
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature_fit , zorder = hero:getLocalZOrder() + 30},
			})
		end

		local _target_ = hurtTargets[1]
		local armature_fit = zc.battle.createBattleEffect({fileName = "yuji_Fit", actName = "Fit_1", autoRemove = true, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
			if string.find(evt, "back") then
				performWithDelay(self, endFunction, 0.5)
			end
	    end})

		if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit:setScaleX(-1 * armature_fit:getScaleX())
	    end
	    armature_fit:setPosition(_target_:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))			
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit , zorder = self:getLocalZOrder() + 30},
		})

	else
		self:doHurt(params)
	end
end

function yuji:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == BATTLE_SKILL_TYPE.FIT then 
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
		return
	end
    local runningScene 	= cc.Director:getInstance():getRunningScene()
	local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	local armature = zc.battle.createBattleEffect({fileName = "yuji" , actName = "eff_sj"})
    armature:setPosition(point)
    zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		data = {node = armature , zorder = hero:getLocalZOrder() + 1},
	})
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function yuji:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 or atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end

function yuji:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 4
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 7
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = self._isFit2 and 3 or 5
	end
	return count
end

function yuji:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "jxbejing",
		skeletonActName = "yuji",
		name = "yuji",
		heroActName = "idle",
	}

	if self._isFit2 then
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
	end
	return fitSrc
end

function yuji:_doFitSkill(params, fitSrc)
	if self._isFit2 then
		fitSrc.specialHandle = true
		self:doFitNormalSkill(params, fitSrc)
		return
	end
	local data 	= {}
	zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
	local all_heroes 	= data.heroes
	local firstTarget 	= params.firstTarget
	local skillType 	= params.skillType
	local skillId 		= params.skillId
	local _targets_ = {}
	local processInfo 	= params.processInfo
	local process = nil
	local hurtTargets = {}
	if processInfo then
		process 		= processInfo.process
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			if action_type == 5 then
		    	local skill_id 				= process_item[3]
				local skill_level			= process_item[4]--技能的等级
				local skill_type			= process_item[5]--技能类型（ 1 士气技能(大招),2 默认技能 3 组合技能）
				local skill_status			= process_item[6]--技能是否释放成功 1 成功 0  释放失败
				local skill_cover_targets	= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local skill_mix_targets		= process_item[8]--参与辅助组合技能的战斗单元列表(战斗单元id列表)
				if skill_mix_targets ~= nil then
					for k,id in pairs(skill_mix_targets) do
						local data 				= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local hero 			= data.target
						hero:setVisible(true)
						hero:getRectBuffNode():setVisible(false)
						local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" ,fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function()
								hero:setColor(cc.c3b(255,255,255))
								hero:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
								local tmp_side 	= hero:getSide()
							    local pos 		= cc.p(zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7}).x , zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6}).y)

							    local pos_delta = cc.pGetDistance(pos, cc.p(hero:getPositionX(),hero:getPositionY()))
								local dt 		= zc.getDynamicTime(pos_delta, 3000)
								hero:runAction(cc.MoveTo:create(dt, pos ))
							end})
						armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero:getArmature()))
						hero:getRectEffectNode():addChild(armature,1)
						_targets_[#_targets_ + 1] = hero
					end
				end
			elseif action_type == 3 then
				local hp_change_value 		= process_item[3]
				local hp_change_source 		= process_item[4]--血量或者伤害变化来源(对应下面的类型)
				if tonumber(hp_change_value) and tonumber(hp_change_value) < 0 then
					hurtTargets[#hurtTargets + 1] = hero
				end
			end
		end--[[--for end]]
	end
	self.__nowFitAllHeroes = all_heroes
	self.__nowFitType = skillType
	self.__nowFitProgress = process
	self.__nowFitTargets = _targets_

	local _data_ 	= {}
	zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_GET_BG,
		data = _data_,
	})
	local bg = _data_.bg

	local director = cc.Director:getInstance()
    local winSize = director:getWinSize();
    local winWidth = winSize.width;
    local winHeight = winSize.height;

	local runningScene 	= director:getRunningScene()
	--[[自身也需要往上飞起]]
	local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/", fileName = "dazhao_ef", actName = "dazhao", completeCallback = function( )
		local fit_bg
		--合击技1.2的背景不一样。
		if self._isFit2 then
			fit_bg = zc.createSprite("res/image/battle/fit2.jpg")
		else
			fit_bg = zc.createSprite("res/image/battle/fit.jpg")
		end

		zc.setBgSize(fit_bg)
		fit_bg:setPosition(winWidth / 2 , winHeight / 2)
		bg:addChild(fit_bg)
		fit_bg:runAction(cc.FadeIn:create(3.5))
		fit_bg:setName(BATTLE_FIT_BG_NAME)

		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getSide() == self:getSide() then
					hero:setVisible(false)
				else
					hero:setColor(BATTLE_DIM_COLOR)
				end
			end
		end
		for k,hero in pairs(_targets_) do
			hero:setVisible(true)
		end
		self:setVisible(true)

		for k,hero in pairs(hurtTargets) do
			hero:setColor(cc.c3b(255,255,255))
		end

		local tmp_side 	= self:getSide()
	    local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7})

	    local pos_delta = cc.pGetDistance(pos, cc.p(self:getPositionX(),self:getPositionY()))
		local dt = zc.getDynamicTime(pos_delta, 3000)

		self:runAction(cc.Sequence:create(cc.MoveTo:create(dt, pos ), cc.CallFunc:create(function()
			self:playAction(BATTLE_ANIMATION_ACTION.FIT_START)

			local armature = zc.battle.createBattleEffect({fileName = "yuji_Fit", actName = "Fit_3", autoRemove = true})
			armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = self:getLocalZOrder() + 30},
			})

			local armature = zc.battle.createBattleEffect({fileName = "yuji_Fit", actName = "Fit_4", autoRemove = true, completeCallback = function()
				-- [[大闪屏]]
				local node = BattleNodeFitSkill:createWithParams({beijing = fitSrc.beijing,skeletonActName = fitSrc.skeletonActName, heroActName = fitSrc.heroActName,name = fitSrc.name,completeCallback = function( ... )
					self:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					for k,hero in pairs(_targets_) do
						hero:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					end
					--[[攻击特效]]
					performWithDelay(self, function()
						self:doAttack({skillType = skillType, process = process, hurtTargets = hurtTargets, endFunction = function()
							if not tolua.isnull(fit_bg) then
								fit_bg:removeFromParent()
							end
							self:_endFitSkill(all_heroes, _targets_)
						end})
					end, 0.3)
				end})
				runningScene:addChild(node)
			end})
			armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = self:getLocalZOrder() + 30},
			})
			
			for k,hero in pairs(_targets_) do
				local armature = zc.battle.createBattleEffect({fileName = "yuji_Fit", actName = "Fit_3", autoRemove = true})
				armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
			    if self:getSide() == BATTLE_SIDE.LEFT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 30},
				})
				local armature = zc.battle.createBattleEffect({fileName = "yuji_Fit", actName = "Fit_4", autoRemove = true})
				armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
			    if self:getSide() == BATTLE_SIDE.LEFT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 30},
				})
			end
		end) ))
	end})
	armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,self:getArmature()))
	self:getRectEffectNode():addChild(armature,1)
end


return yuji




