--  Created by zhangchao on 16-09-03.
local zhanghong = class("zhanghong", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhanghong:create(params)
	return zhanghong.new(params)
end


function zhanghong:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK then
		ret = false
	end
	return ret
end

function zhanghong:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 3
	elseif skillType == 3 then
		count = 12
	elseif skillType == 4 then
		count = 12
	end
	return count
end

function zhanghong:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			local armature = zc.battle.createBattleEffect({fileName = "zhanghong", actName = "atk_1",autoRemove = false})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)) + 180);
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(
				cc.Sequence:create(
					cc.MoveTo:create(dt,endPos),
					cc.CallFunc:create(function()
			    		if ret and _tmp_ == table.nums( hurtTargets ) then
			    			self:doHurt(params)
			    		end
					end),
					cc.RemoveSelf:create(true)
				)
			)
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function zhanghong:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	local armature = zc.battle.createBattleEffect({fileName = "zhanghong", actName = "atk_2"})
	local runningScene 	= cc.Director:getInstance():getRunningScene()
	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
	if hero:getSide() == BATTLE_SIDE.LEFT then
		armature:setScaleX( armature:getScaleX() * -1 )
	end
	zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		data = {node = armature, zorder = hero:getLocalZOrder() + 1},
	})
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function zhanghong:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	if skillType == 3 then
		-- 大招特殊处理
		local position = targetHero:getBattlePosition()
		position = ( position - 1 )%3 + 1
		denfenser_point = zc.battle.getInitialMatrixPoint({side = targetHero:getSide() , position = position})
	end
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	return pos
end

return zhanghong