--[[
作战页面
wcc 2015-10-15
]]
local EnemyInfoPop = class("EnemyInfoPop",function ()
    return ZCPopLayer:create()
end)

function EnemyInfoPop:create(data)
    return EnemyInfoPop.new(data)
end

function EnemyInfoPop:ctor(params)
    self._enemyData = params.enemyinfo
    self._enemys = params.enemys
    self._guideData = params.guideData
    self._dropData = params.drop --从后端获取的掉落数据
    self._tollgateId = params.tollgateId
    self._dropNeedItem = params.dropInfo --需要特殊显示的扫荡物品
    self._isFirst = params.isFirst
    self._nationId = params.nationId
    self._notBattle = params.notBattle

    self._btnTitle = zc.lang("sweep")
    if APP_REVIEW then
        self._btnTitle = zc.lang("challenge")
    end

    local _tollDb = gameData.getDataFromCacheWithPrimaryKey("tollgate", self._enemyData.tollgateId)
    self._tollDb = _tollDb

	self:initUI()
    self:show(false)
end

function EnemyInfoPop:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/copy/copy_dibian.png")
end

--status 2通关 1手杀 0未开启
function EnemyInfoPop:initUI()
    local _tollDb = self._tollDb
    self.DropItemArray = {}--掉落装备
    -- self.DropResArray = {}--掉落资源

    local _isInFiveLevel = false
    local _myLevel = tonumber(PlayerData.info.level) or 0
    local _dbLevel = tonumber(_tollDb.level) or 0
    if _myLevel - _dbLevel < 5 then
        _isInFiveLevel = true
    end
    local rewardMap = {}
    for i = 1, #self._dropData do
        local _data = self._dropData[i]
        local _itemType = tonumber(_data.type)
        local _itemId = tonumber(_data.id)
        --主角经验掉落：1、首杀，2、关卡等级小于主角等级 5级之内
        if _itemType ~= zc.mainTypePlayerExp 
          or (tonumber(self._enemyData.status) == 1 
          or _isInFiveLevel)
          then 
            if not rewardMap[_itemType] then
                rewardMap[_itemType] = {}
            end
            local typeMap = rewardMap[_itemType]
            if typeMap[_itemId] then
            else
                local _hasGeneral = false
                if _itemType == 2 then --检查是否有武将
                    _hasGeneral = PlayerData:hasSameGeneral(_itemId)
                end
                if not _hasGeneral then
                    local idx = #self.DropItemArray+1
                    self.DropItemArray[idx] = {}
                    self.DropItemArray[idx].itemId = _data.id
                    self.DropItemArray[idx].itemNum = _data.num
                    self.DropItemArray[idx].rate = _data.rate
                    self.DropItemArray[idx].itemType = _data.type
                    self.DropItemArray[idx].weiget = 0
                    if tonumber(_data.type) == 1 then
                        self.DropItemArray[idx].weiget = 10-tonumber(_data.id)
                    elseif tonumber(_data.type) == 2 then
                        self.DropItemArray[idx].weiget = 1000000000
                    elseif tonumber(_data.type) == 3 then
                        self.DropItemArray[idx].weiget = 1000000+tonumber(_data.id)
                    elseif tonumber(_data.type) == 4 then
                        self.DropItemArray[idx].weiget = 1000+tonumber(_data.id)
                    elseif tonumber(_data.type) == 6 then
                        self.DropItemArray[idx].weiget = 10+tonumber(_data.id)
                    elseif tonumber(_data.type) == 9 then--饰品
                        local itemData = gameData.getDataFromCacheWithPrimaryKey("trinket", _data.id) or {}
                        local _quality = tonumber(itemData.color) or 0
                        local _weiget = _quality * 500 + (tonumber(itemData.id) or 0)
                        self.DropItemArray[idx].weiget = _weiget
                        if _quality < 3 then
                            self.DropItemArray[idx] = nil
                        end
                    end
                    if self.DropItemArray[idx] then
                        typeMap[_itemId] = idx
                    end
                end
            end
        end
    end
    local _titleSrc = "res/Main/common/tipTitle/"
    _titleSrc = _titleSrc .. (self._nationId == 1 and "zhuxianfuben.png" or "jingyingfuben.png")
    local bg = zc.createNormalPop({
        tag = 1,
        width = 440,
        height = 480,
        bianZOrder = 0,
        titleSrc = _titleSrc,
    })
    bg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(bg)
    self.bg = bg
    local _bgSize = bg:getContentSize()

    local _itemBg = zc.createGeneralPopScale({
        width = 410,
        height = 150,
    })
    _itemBg:setAnchorPoint(0.5, 1)
    _itemBg:setPosition(_bgSize.width*0.5, _bgSize.height - 50)
    bg:addChild(_itemBg)

    local _itemBgSize = _itemBg:getContentSize()

    local _bgFlower = zc.getSprite({
        src = "res/Main/common/popBg/bgFlower.png",
        pos = cc.p(70, _itemBgSize.height*0.5),
        scale = 0.7,
    })
    _itemBg:addChild(_bgFlower)
    local _bgFlower = zc.getSprite({
        src = "res/Main/weaponCopy/head_bg.png",
        pos = cc.p(_bgFlower:getPosition()),
    })
    _itemBg:addChild(_bgFlower)

    local _headBgPath = "res/Main/hero/hero_item1.png"
    local _headPath = "res/Main/hero/head/hero_head_"..self._enemys.iconId..".png"
    if not zc.checkFileExist(_headPath) then
        _headPath = "res/Main/hero/head/hero_head_1.png"
    end
    local _headIcon = zc.createSprite(_headBgPath)
    _headIcon:setPosition(_bgFlower:getPosition())
    _headIcon:setScale(0.7)
    _itemBg:addChild(_headIcon)
    local head = zc.createSprite(_headPath)
    head:setPosition(cc.p(_headIcon:getContentSize().width/2,_headIcon:getContentSize().height/2))
    _headIcon:addChild(head)
    head:setScale(1.3)
    local _reincarnateImg = zc.createSprite("res/Main/hero/jiao_1.png")
    _reincarnateImg:setAnchorPoint(0, 0)
    _reincarnateImg:setPosition(1, 1)
    _headIcon:addChild(_reincarnateImg)
    local levelLab = zc.createLabel({
        text = zc.getLevelTipShow() .. tostring(_tollDb.level),
        fontSize = 22,
        ap = cc.p(0, 0),
        pos = cc.p(3, 3),
        outLine = true,
    })
    _headIcon:addChild(levelLab)
    local _starDi = zc.getSprite({
        src = "res/Main/chapterMain/starBg.png",
        pos = cc.p(_headIcon:getPositionX(), _headIcon:getPositionY() - 50),
    })
    _itemBg:addChild(_starDi)
    local _starNum = tonumber(self._enemyData.star) or 0
    for starnum = 1, 3 do 
        if starnum <= _starNum then
            local star = zc.getSprite({
                src = "res/Main/common/common_hero_star_1.png",
                pos = cc.p(_starDi:getContentSize().width/4*starnum, _starDi:getContentSize().height*0.5)
            })
            _starDi:addChild(star)
        else
            local starB = zc.getSprite({
                src = "res/Main/common/common_hero_star_2.png",
                pos = cc.p(_starDi:getContentSize().width/4*starnum, _starDi:getContentSize().height*0.5)
            })
            _starDi:addChild(starB)
        end
    end

    local _namePos = cc.p(160, 120)
    local _nameSize = cc.size(120, 30)
    local nameBg = zc.getScaleNode("res/Main/common/popBg/di_properties.png", _nameSize)
    nameBg:setAnchorPoint(0, 0.5)
    nameBg:setPosition(_namePos)
    _itemBg:addChild(nameBg)

    local name = zc.createLabel({
        text = _tollDb.name,
        pos = cc.p(_nameSize.width*0.5, _nameSize.height*0.5),
        fontSize = 24,
    })
    nameBg:addChild(name)
    --消耗物资
    if self._nationId == 1 then
        local costBg = zc.getSprite({
            src = "res/Main/chapterMain/costDi.png",
            ap = cc.p(0, 0.5),
            pos = cc.p(_namePos.x, _namePos.y - 85),
        })
        _itemBg:addChild(costBg)
        local _costSize = costBg:getContentSize()
        local costLabel = zc.createLabel({
            text = zc.lang("cost_tili") .. ":",
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(5, _costSize.height*0.5),
            color = cc.c3b(227, 220, 170),
        })
        costBg:addChild(costLabel)

        local costimg = zc.getSprite({
            src = "res/Main/common/common_icon_energy.png",
            pos = cc.p(_costSize.width - 60, _costSize.height*0.5),
        }) 
        costBg:addChild(costimg)
        local expendNum = _tollDb.expend or 0
        if expendNum == "" then 
            expendNum = 0
        end
        local costNum = zc.createLabel({
            text = "x"..expendNum,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(_costSize.width - 40, _costSize.height*0.5),
        })
        costBg:addChild(costNum)
    else
        nameBg:setPositionY(_namePos.y - 20)
    end

    --次数
    local __py = self._nationId == 1 and 45 or 75
    local numBg = zc.getSprite({
        src = "res/Main/chapterMain/costDi.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(_namePos.x, _namePos.y - __py),
    })
    _itemBg:addChild(numBg)

    local _numBgSize = numBg:getContentSize()

    local _numLabelStr = zc.lang("left_free_times") .. ":"
    local numLimit = tonumber(_tollDb.numLimit)
    local numShowText = numLimit - tonumber(self._enemyData.num)
    if self._nationId == 2 then
        _numLabelStr = zc.lang("left_challenge_times") .. ":"
        local _info = PlayerData:getEliteBuyInfo()
        numShowText = tonumber(_info.challengeTimes)
    end
    local numLabel = zc.createLabel({
        text = _numLabelStr,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(5, _numBgSize.height*0.5),
        color = cc.c3b(227, 220, 170),
    })
    numBg:addChild(numLabel)

    local numLabel = zc.createLabel({
        text = numShowText < 0 and "0" or numShowText,
        fontSize = 22,
        ap = cc.p(1, 0.5),
        pos = cc.p(_numBgSize.width - 5, _numBgSize.height*0.5),
    })
    numBg:addChild(numLabel)

    -- 底部
    local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = 410,
        height = 230,
    })
    _bottomBg:setAnchorPoint(0.5, 0)
    _bottomBg:setPosition(_bgSize.width*0.5, 15)
    bg:addChild(_bottomBg)

    local _bottomBgSize = _bottomBg:getContentSize()
    local _attrBg = zc.createGeneralPopScale({
        tag = 2,
        width = 380,
        height = 130,
    })
    _attrBg:setAnchorPoint(0.5, 1)
    _attrBg:setPosition(_bottomBgSize.width*0.5, _bottomBgSize.height - 10)
    _bottomBg:addChild(_attrBg)
    self._attrBg = _attrBg

    local _attrBgSize = _attrBg:getContentSize()
    --掉落
    local str = "res/Main/chapterMain/tab_1.png"
    if self._isFirst and tonumber(self._isFirst) == 2 then
        str = "res/Main/chapterMain/tab_2.png"
    end
    local drop = zc.getSprite({
        src = str,
        pos = cc.p(_attrBgSize.width*0.5, _attrBgSize.height - 20)
    })
    _attrBg:addChild(drop)

    local _titleLabSize = drop:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "res/Main/common/lace.png",
        ap = cc.p(1, 0.5),
        pos = cc.p(drop:getPositionX() - _titleLabSize.width*0.5 - 10, drop:getPositionY()),
    })
    _attrBg:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "res/Main/common/lace.png",
        ap = cc.p(1, 0.5),
        pos = cc.p(drop:getPositionX() + _titleLabSize.width*0.5 + 10, drop:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _attrBg:addChild(_titleRightSp)
    
    local dropScrollView = zc.createScrollview({
        pos = cc.p(2, 0),
        size = cc.size(_attrBgSize.width - 4, 120),
        innerSize = cc.size(90*(#self.DropItemArray), 120),
        dir = ccui.ScrollViewDir.horizontal,
        bar = false,
        bounceEnable = true,
    })
    _attrBg:addChild(dropScrollView)

    table.sort(self.DropItemArray, function(a,b)
        if not a or not b then
            return false
        end
        return a.weiget > b.weiget
    end)

    local _bei_ = PlayerData:checkActivityOpenState(20) and 2 or 1
    if tonumber(self._isFirst) ~= 2 then
        _bei_ = 1
    end
    for i=1,#self.DropItemArray do 
        local iconcolor = 1
        local goodname = ""
        local itemType = tonumber(self.DropItemArray[i].itemType)
        if itemType == zc.mainTypeSoldierExp then 
            --武将经验
            goodname = LANGUAGE_TOLLGATEHERO.general_exp
        elseif itemType == zc.mainTypeProp then 
            --背包的道具
            local itemDb = PlayerData:getBagDBInfoByID(self.DropItemArray[i]["itemId"])
            if itemDb then
                iconcolor = tonumber(itemDb.color)
                goodname = itemDb.name
            end
        end
        local _showItem = true
        local _showHero = nil
        if tonumber(itemType) == zc.mainTypeSoldier then
            _showItem = false
            _showHero = function() zc.createHeroInfoPop({heroId = self.DropItemArray[i]["itemId"], showHero = true}) end
        end
        local _mainType = tonumber(self.DropItemArray[i]["itemType"]) or 1
        local item = zc.createIconByData({
            data = {
                mainType = _mainType,
                type = self.DropItemArray[i]["itemId"], 
                id = self.DropItemArray[i]["itemId"],
                num = self.DropItemArray[i].itemNum,
            }, 
            showBei = _mainType == zc.mainTypeProp and _bei_ or 1,
            showDetailPop = _showItem,
            listener = _showHero,
            pos = cc.p((i-1/2)*90, 53),
        })
        item:setScale(0.68)
        dropScrollView:addChild(item)

        --加特效(目前只有：武将、金色饰品)
        local showEffect = false 
        if itemType == 2 then
            showEffect = true
        elseif itemType == zc.mainTypeTrinket then
            local trinket = gameData.getDataFromCacheWithPrimaryKey("trinket", self.DropItemArray[i]["itemId"]) or {}
            if trinket and trinket.color and tonumber(trinket.color) > 4 then
                showEffect = true
            end
        end
        if showEffect then
            local renwu_logo = zc.createSpine({
                fileName = "renwu_logo",
                actName = "animation",
                loop = true,
            })
            renwu_logo:setPosition( cc.p(item:getContentSize().width/2, item:getContentSize().height/2) )
            item:addChild(renwu_logo)
            renwu_logo:setScale(1.5)
        end
    end
    
    local _partW = 85
    --扫荡按钮
    local sweepBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_partW, 40),
        text = self._btnTitle,
        endCallback = function()
            --zc.tipInfo("暂未开发")
            local _enemyData = self._enemyData
            local _dropInfo = self._dropData
            local _dropNeedItem = self._dropNeedItem
            local _nationId = self._nationId
            self:hide()
            zc.createSourcePop("Copysweep", "src/layer/chapter/CopysweepPop.lua", {
                enemyData = _enemyData,
                dropInfo = _dropInfo,
                tollDb = _tollDb,
                dropNeedItem = _dropNeedItem,
                nationId = _nationId,
            })
        end,
    })
    _bottomBg:addChild(sweepBtn)
    --三星开启扫荡
    if _starNum >= 3 then 
    else
        sweepBtn:setEnable( false )
    end
    --战斗按钮
    local battleBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_bottomBgSize.width - _partW, sweepBtn:getPositionY()),
        text = zc.lang("challenge_2"),
        touchSize = cc.size(120, 80),
        endCallback = function()
            --新手引导
            local _currentGID = getGuideManager():getCurrentGID()
            if inArray(_currentGID, GuideGroup.BTN_CHU_ZHAN) then
                if tonumber(self._enemyData.tollgateId) == GuideGroupFB_CHUZHAN[tostring(_currentGID)] then
                    getGuideManager():guideOver()
                    getGuideManager():setNextGID(_currentGID)
                end
            end
            --self:goBattle(self._enemyData["id"]) 
            if _tollDb.status == 0 then 
                zc.tipInfo(zc.lang("tips_checkpoint_not_open"))
            else
                local expendNum = tonumber(_tollDb.expend) or 0
                local _myPower = zc.getNumByTypeId( zc.mainTypeResource, zc.dataTypeEnergy )
                if _myPower < expendNum then
                    zc.tipInfo(zc.lang("tips_tili_unenough"))
                    return
                end
                local _params = {
                    battleType = BattleType.PVE, 
                    enemys = self._enemys, 
                    tollgateId = self._tollgateId,
                    fightScene = self._tollDb["scene"] or 1,
                    guideData = self._guideData,
                    isFirstFight = self._isFirst,
                }
                self:hide()
                -- zc.createScene("matrixBattle", _params)
                zc.createMatrixBattle( _params )
            end
        end,
    })
    _bottomBg:addChild(battleBtn)
    if self._notBattle then
        battleBtn:setEnable(false)
    end
    --次数不够
    if numShowText <= 0 then
        battleBtn:setString("")
        local _price = 0
        if self._nationId == 1 then
            local consume_price = gameData.getDataFromCache("consume_price", {type=44} )
            local _beginIndx = tonumber(self._enemyData.num) - tonumber(_tollDb.numLimit)
            local _index = _beginIndx + 1
            if _index > table.nums(consume_price) then
                _index = table.nums(consume_price)
            end
            _price = consume_price[_index].price
        else
            local consume_price = gameData.getDataFromCache("consume_price", {type=37} )
            local _info = PlayerData:getEliteBuyInfo()
            local _index = tonumber(_info.buyTollgateChallenge) + 1
            if _index > #consume_price then
                _index = #consume_price
            end
            _price = consume_price[_index].price
        end
        self:createForceLab(battleBtn, _price or 5, zc.lang("force_attact"), 90)
    end
    --预加载战斗背景(异步)
    local addPath = "res/Main/copy/fightScene/1.jpg"
    if tonumber(self._tollDb["scene"]) == 2 then
        addPath = "res/Main/copy/fightScene/2.jpg"
    elseif tonumber(self._tollDb["scene"]) == 3 then
        addPath = "res/Main/copy/fightScene/3/skeleton.png"
    elseif tonumber(self._tollDb["scene"]) == 4 then
        addPath = "res/Main/copy/fightScene/4/sz.png"
    elseif tonumber(self._tollDb["scene"]) == 5 then
        addPath = "res/Main/copy/fightScene/5/zhandouchangjing_3.png"
    end
    cc.Director:getInstance():getTextureCache():addImageAsync(addPath,function ()
        -- body
    end)

    
    --新手引导
    getGuideManager():guideOver()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_CHU_ZHAN) then
        if tonumber(self._enemyData.tollgateId) == GuideGroupFB_CHUZHAN[tostring(_currentGID)] then
            getGuideManager():setObjTarget(battleBtn)
            getGuideManager():startGuide()
        end
    end
end
--强征按钮内部lab
function EnemyInfoPop:createForceLab(_node, consumeNum, labText, labPosX)
    local gold10 = zc.createSprite(zc.getImgByType(1))
    gold10:setAnchorPoint(0, 0.5)
    gold10:setPosition(18, _node:getContentSize().height/2)
    _node:addChild(gold10)
    local goldNum1 = zc.createLabel({
        text = consumeNum.."",
        fontSize = 18,
        ap = cc.p(0.5, 1),
        pos = cc.p(gold10:getContentSize().width/2, 18),
        color = display.COLOR_GOLD,
        color2 = display.COLOR_BLACK,
        pixel = 1.5,
        outLine = true
    })
    gold10:addChild(goldNum1)
    local froceLevyLab10 = zc.createLabel({
        text = labText,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(labPosX, _node:getContentSize().height/2),
        -- color = cc.c3b(255,241,121),
        color2 = zc.labelWarmColor,
        pixel = 2,
        outLine = true
    })
    _node:addChild(froceLevyLab10)
    return goldNum1
end

function EnemyInfoPop:goBattle(id)
    zc.sendHttp({
        apiName = "Tollgate_challenge",
        params = {id=id},
        successCallback = function (data) 
            --判断战斗结果
            local _result = tonumber(data["data"]["warModel"][5][1])
            --结果类型(1 平局, 2 攻击方完胜, 3 攻击方大胜, 4 攻击方小胜, 5 攻击方完败, 6 攻击方大败, 7 攻击方小败)
            print("战斗状态".._result)
            if _result == 2 or _result == 3 or _result == 4 then 
                --胜利了
                PlayerData:setCurTollGateStatus(id, {status = 2})
            end 
            self:hide()
        end,
    })
end

return EnemyInfoPop