--[[
    FileName: CountryApplyListPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local CountryApplyListPop = class( "CountryApplyListPop", function ()
    return ZCPopLayer:create()
end)
function CountryApplyListPop:create(params)
    return CountryApplyListPop.new(params)
end
function CountryApplyListPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show()
end
function CountryApplyListPop:initData(params)
    self._applyList = params.list
end
function CountryApplyListPop:initUI()
    --通用背景
    local _country_list_bg = zc.getSprite({
        src = "res/Main/country/countryList/list_bg.png",
        ap = cc.p(0.5,0.5),
        pos = cc.p(zc.width/2, zc.height/2) 
    })
    self:addContent(_country_list_bg)
    self._country_list_bg = _country_list_bg
    local popBgSize = _country_list_bg:getContentSize()
    local _bianImg = zc.getScaleNode("res/Main/common/frame.png", cc.size(popBgSize.width, popBgSize.height))
    _bianImg:setPosition(popBgSize.width*0.5, popBgSize.height*0.5)
    _bianImg:setName("bianImg")
    _country_list_bg:addChild(_bianImg, 1)

    self._names = {[1]=zc.lang("country_member_ask_for_member"),[2]=zc.lang("level"),[3]=zc.lang("country_member_ask_for_time")}
    --国家列表标题
    for i=1,#self._names do
        local _text = self._names[i]
        local _label = zc.createLabel({
            text = _text,
            fontSize = 24,
            ap = cc.p(0.5,0.5),
            pos = cc.p(110+160*(i-1), 445),
            color = display.COLOR_BLACK,
            -- color2 = display.COLOR_WHITE,
            -- outLine = true,
        })
        _country_list_bg:addChild(_label)
    end

    --全部同意
    local _all_agree_btn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("all_tongyi"),
        pos = cc.p( 600 ,45 ), 
        endCallback = function ()
            local _ids = self:getAllId()
            if _ids == "" then
                zc.tipInfo(zc.lang("tips_country_member_no_ask_player"))
                return
            end
            zc.sendHttp({
                apiName = "Country_replyApply",
                params = {id=_ids,type=1},
                successCallback = function (net_data)
                    zc.tipInfo(zc.lang("tips_do_success"))
                    self._applyList = {}
                    self._countryTable:reloadData()

                end
            })
        end,
    })
    _country_list_bg:addChild(_all_agree_btn)

    --全部拒绝
    local _all_refuse_btn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("one_key_jujue"),
        pos = cc.p(780  , 45), 
        listener = function ()
            local _ids = self:getAllId()
            if _ids == "" then
                zc.tipInfo(zc.lang("tips_country_member_no_ask_player"))
                return
            end
            zc.sendHttp({
                apiName = "Country_replyApply",
                params = {id=_ids,type=2},
                successCallback = function (net_data)
                    zc.tipInfo(zc.lang("tips_do_success"))
                    self._applyList = {}
                    self._countryTable:reloadData()
                end
            })
        end,
    })
    _country_list_bg:addChild(_all_refuse_btn, 10)

    --关闭按钮
    local _closeButton = zc.createBackButton({
        pos = cc.p(_country_list_bg:getBoundingBox().width-10  , _country_list_bg:getBoundingBox().height), 
        listener = function () 
            self:hide({noAction=true})
        end,
    })
    _country_list_bg:addChild(_closeButton, 10)

    self:initCountryList()

end
function CountryApplyListPop:getAllId()
    local _ids = ""
    for i = 1, #self._applyList do
        local v = self._applyList[i]
        if v and v.id then
            if i == 1 then
                _ids = ""..v.id
            else
                _ids = _ids .. "|" .. v.id
            end
        end
    end
    return _ids
end
function CountryApplyListPop:initCountryList()
    local _tableSize = cc.size(880, 330)
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setPosition(12, 90)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self._country_list_bg:addChild(_tableView)
    self._countryTable = _tableView

    local _cellSize = cc.size(860, 70)

    local function numberOfCellsInTableView( table )
        return #self._applyList
    end
    local function cellSizeForTable( table, index )
        return _cellSize.height , _cellSize.width
    end
    local function tableCellAtIndex( table, index )
        local cell = table:dequeueCell()
        if cell then
            cell:removeAllChildren()
        else
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        end

        local _di = cc.LayerColor:create(cc.c4b(0, 0, 0, 255*0.2), _cellSize.width, _cellSize.height)
        if index%2 == 0 then
            _di = cc.LayerColor:create(cc.c4b(80, 0, 0, 255*0.2), _cellSize.width, _cellSize.height)
        else
            _di = cc.LayerColor:create(cc.c4b(0, 0, 0, 0), _cellSize.width, _cellSize.height)
        end
        cell:addChild(_di)
        self:createOneCell(_di, index)
        return cell
    end
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableView:reloadData()
end

function CountryApplyListPop:createOneCell( cell, index )
    local _country_data = self._applyList[index+1]
    if _country_data then
        local time = tonumber(PlayerData:getTime())-tonumber(_country_data.time)
        local D = math.floor(time/(24*3600))
        local H = math.floor(time/3600-D*24)
        local M = math.floor(time/60 - H*60)
        local S = math.floor(time%60) == 0 and 1 or math.floor(time%60)
        if D > 0 then
            timeStr = D..zc.lang("date_day") .. zc.lang("front")
        elseif H > 0 then
            timeStr = H..zc.lang("date_hours") .. zc.lang("front")
        elseif M > 0 then
            timeStr = M..zc.lang("date_minute") .. zc.lang("front")
        elseif S > 0 then
            timeStr = S..zc.lang("date_seconds") .. zc.lang("front")
        end

        local _textData = {_country_data.userName,_country_data.level,timeStr}
        for i=1,3 do
            local _text = _textData[i]
            local _label = zc.createLabel({
                text = _text,
                fontSize = 20,
                ap = cc.p(0.5,0.5),
                outLine = true,
                pos = cc.p(100+160*(i-1), 30),
                -- color = display.COLOR_BLACK,
            })
            cell:addChild(_label)
        end

        local _agreebutton = zc.createCommomBtn({
            tag = 1,
            scale = 0.8,
            pos = cc.p( 780 - 140, 35 ),
            text = zc.lang("tongyi_2"),
            endCallback = function()
                zc.sendHttp({
                    apiName = "Country_replyApply",
                    params = {id=_country_data.id,type=1},
                    successCallback = function (net_data)
                        self:deletePlayer(_country_data.userId)
                        self._countryTable:reloadData()
                    end
                })
            end,
        })
        cell:addChild(_agreebutton)

        local _refusebutton = zc.createCommomBtn({
            tag = 2,
            scale = 0.8,
            pos = cc.p( 780, 35 ),
            text = zc.lang("jujue_2"),
            endCallback = function()
                zc.sendHttp({
                    apiName = "Country_replyApply",
                    params = {id=_country_data.id,type=2},
                    successCallback = function (net_data)
                        self:deletePlayer(_country_data.userId)
                        self._countryTable:reloadData()
                    end
                })
            end,
        })
        cell:addChild(_refusebutton)

    end
end

function CountryApplyListPop:deletePlayer(_uid)
    for i = 1, #self._applyList do
        local v = self._applyList[i]
        if v and v.userId then
            if tonumber(v.userId) == tonumber(_uid) then
                table.remove(self._applyList,i)
                break
            end
        end
    end
end


return CountryApplyListPop