--[[
-- 国家创建
-- @author lph
-- Creation  2016-4-6
]]
local CountryCreatePop = class("CountryCreatePop",function ()
	return ZCPopLayer:create()
end)
function CountryCreatePop:create(data)
	return CountryCreatePop.new(data)
end

function CountryCreatePop:ctor(data)
    self._data = data
	self:initUI()
end
function CountryCreatePop:initUI()
    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2,zc.height/2) 
    })
    self:addContent(bg)
    local _bgSize = bg:getContentSize()
    --标题
    local _title = zc.getTipPopTitle( "chuangjianguojia" )
    _title:setPosition( _bgSize.width*0.5, _bgSize.height - 30 )
    bg:addChild(_title)

    local _partH = 40
    --国家名字
    local accountName = zc.createLabel({
        text = zc.lang("country_name"),
        fontSize = 22,
        outLine = true,
        anchor = cc.p(0, 0.5),
        pos = cc.p(90, 250 + _partH),
    })
    bg:addChild(accountName)
    local accountBoxSize = cc.size(250, 40)
    local accountBox = ccui.EditBox:create(accountBoxSize, ccui.Scale9Sprite:create("res/Main/email/email_bg_s.png"))
    accountBox:setName("accountBox")
    accountBox:setPlaceholderFontColor(cc.c3b(143,125,91) )
    accountBox:setFontSize(24)
    accountBox:setAnchorPoint(0, 0.5)
    -- accountBox:setText("")
    accountBox:setPlaceHolder(zc.lang("max_enter_tips_7"))
    accountBox:setMaxLength(7)
    accountBox:setInputMode(cc.EDITBOX_INPUT_MODE_ANY)
    accountBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    accountBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    accountBox:setPosition(160, 250 + _partH)
    bg:addChild(accountBox)
    --国家公告
    local noticeName = zc.createLabel({
        text = zc.lang("country_notice"),
        fontSize = 22,
        outLine = true,
        anchor = cc.p(0, 1),
        pos = cc.p(90, 180 + _partH),
    })
    bg:addChild(noticeName)
    local noticeBoxSize = cc.size(250, 120)
    local noticeBox = ccui.EditBox:create(noticeBoxSize, ccui.Scale9Sprite:create("res/Main/email/email_bg_s.png"))
    noticeBox:setName("noticeBox")
    noticeBox:setFontSize(24)
    noticeBox:setAnchorPoint(0, 1)
    noticeBox:setText("")
    noticeBox:setMaxLength(70)
    noticeBox:setInputMode(cc.EDITBOX_INPUT_MODE_ANY)
    noticeBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    noticeBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    noticeBox:setPosition(160, 200 + _partH)
    bg:addChild(noticeBox)

    --创建国家所需元宝
    local _data = gameData.getDataFromCacheWithPrimaryKey("consume_price", 61)
    local _num = 500
    if next(_data) ~= nil then
        _num = _data.price
    end

    local createCountryButton = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("confirm"),
        pos = cc.p(_bgSize.width*0.5, 55), 
        endCallback = function () 
            local name = accountBox:getText()
            local notice = noticeBox:getText()
            if name == "" or name == nil then 
                zc.tipInfo(zc.lang("tips_country_name_empty"))
                return
            end
            if notice == "" or notice == nil then 
                zc.tipInfo(zc.lang("tips_country_notice_empty"))
                return
            end
            zc.sendHttp({
                apiName = "Country_create",
                params = {name=name,announcement=notice},
                successCallback = function (data)
                    zc.tipInfo(zc.lang("tips_country_create_success"))
                    PlayerData:updataData(data)
                    PlayerData:setBaseInfoByTag("countryId",data.id)
                    PlayerData:setBaseInfoByTag("countryName",data.name)
                    LayerManager.removeLayout(true)
                    LayerManager.removeLayout(true)
                    zc.createCountryScene()
                end,
            })
        end,
    })
    bg:addChild(createCountryButton)

    local _goldImg = zc.getSprite({
        src = "res/Main/common/common_icon_gold.png",
        pos = cc.p(createCountryButton:getPositionX()-20, createCountryButton:getPositionY()+45)
    }) 
    bg:addChild(_goldImg)
    local _num_label = zc.createLabel({
        text = tostring(_num),
        fontSize = 20,
        outLine = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(_goldImg:getContentSize().width, _goldImg:getContentSize().height/2),
    })
    _goldImg:addChild(_num_label)

    local _gold = PlayerData:getResourcesInfo().gold
    if tonumber(_gold) < tonumber(_num) then
        createCountryButton:setEnable(false)
        -- createCountryButton:setBright(false)
    end

    --关闭按钮
    local _closeButton = zc.createBackButton({
        pos = cc.p(bg:getBoundingBox().width-10  , bg:getBoundingBox().height), 
        listener = function () 
            LayerManager.removeLayout(true)
        end,
    })
    bg:addChild(_closeButton)
end

return CountryCreatePop