--[[
	押镖接镖弹窗
	唐实聪
	2016.8.5
]]
local CountryDartHelpPop = class("CountryDartHelpPop", function()
	return ZCPopLayer:create({opacityValue = 150})
end)

function CountryDartHelpPop:create( params )
	return CountryDartHelpPop.new( params )
end

function CountryDartHelpPop:ctor( params )
	self:getContainerLayer():setTouchEndedCallback(function() end)
	self:initData( params )
	self:initUI()
	self:refresh( params )

	local function _checkTime()
		self._timer = self._timer - 1
		if self._timer <= 0 then
			-- 镖车到时间了，清理数据
			self:stopActionByTag( 666 )
			zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_UPDATE_MYDART, data = {}})
			-- self:hide()
		else
			self._leftTimeNum:setText( zc.getTimeHMS( self._timer, 1 ) )
		end
	end
	schedule(self, _checkTime, 1, 666)
	_checkTime()

	self:show(true, function()
		-- 设置顶部信息
		local _top = LayerManager.getTopInfoLayer()
		_top:setPopInfo( "CountryDartHelpPop" )
		local _root = LayerManager.getCurRootLayer()
		_root:reorderChild( _top, _top:getLocalZOrder() )
	end)

	-- 同意请求
	zc.addEventListener({
        name = CUSTOM_EVENT.EVENT_DART_AGREE_HELP,
        callback = function( data )
        	local _userData = data.data.data
        	local _helpUserId = tonumber( _userData.userId ) or 0
        	for i, v in ipairs( self._supportList ) do
        		local _userId = tonumber( v.userId ) or 0
        		if _userId == _helpUserId then
        			v.isHelped = 1
        			self:refreshHelper( i )
        			break
        		end
        	end
    	end
	})
end

function CountryDartHelpPop:onCleanup()
	zc.removeEventListener( CUSTOM_EVENT.EVENT_DART_AGREE_HELP )
end

function CountryDartHelpPop:initData( params )
	local _supportData = params.supportData or {}
	-- dump(_supportData,"_supportData")

	self._left = tonumber( _supportData[1] ) or 0
	self._limit = tonumber( _supportData[2] ) or 0
	self._left = self._limit - self._left
	if self._left > 0 then
		self._support = true
	else
		self._left = 0
		self._support = false
	end

	self._timer = tonumber( _supportData[3] ) or 0
	self._timer = self._timer - PlayerData:getTime()

	self._helper = {}
	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function CountryDartHelpPop:initUI()
	local _sp = cc.Sprite:create()
	_sp:setContentSize( self._width, self._height )
	_sp:setPosition( self._width/2, self._height/2 )
	self:addContent( _sp )
	-- 背景
	local _bg = zc.createNormalPop({
        src = "res/Main/country/countryDart/helpBg.png",
        bianZOrder = 0,
        height = 473 + 31,
    })
	_bg:setPosition( self._width/2, self._height/2 )
	_sp:addChild( _bg )
	self._bg = _bg
	local _bgSize = _bg:getContentSize()
	local _bgWidth = _bgSize.width
	local _bgHeight = _bgSize.height
	-- 三个
	for i = 1, 3 do
		local _helper = self:createHelper()
		_helper:setPosition( _bgWidth/2, 454 - 102*i )
		_bg:addChild( _helper )
		self._helper[i] = _helper
	end
	-- 没有玩家
	local _emptyBg = cc.Sprite:create( "res/Main/country/countryDart/emptyBg.png" )
	_emptyBg:setPosition( _bgWidth/2, 250 )
	_bg:addChild( _emptyBg )
	self._emptyBg = _emptyBg
	local _emptyIcon = cc.Sprite:create( "res/Main/country/countryDart/emptyIcon.png" )
	_emptyIcon:setPosition( 30, 24 )
	_emptyBg:addChild( _emptyIcon )
	local _emptyLabel = zc.createLabel({
		text = _text,
		fontSize = 20,
		color = cc.c3b( 76, 18, 18 ),
		ap = cc.p( 0, 0.5 ),
		pos = cc.p( 50, 24 ),
	})
	_emptyBg:addChild( _emptyLabel )
	self._emptyLabel = _emptyLabel
	-- 押镖剩余时间
	local _leftTimeText = zc.createLabel({
		text = zc.lang("country_dart") .. zc.lang("overplus_time") .. ":",
		fontSize = 18,
		color = cc.c3b( 76, 18, 18 ),
		ap = cc.p( 0, 0.5 ),
		pos = cc.p( 35, 95 ),
	})
	_bg:addChild( _leftTimeText )
	local _leftTimeNum = zc.createLabel({
		fontSize = 18,
		color = zc.COLOR_RED,
		ap = cc.p( 0, 0.5 ),
		pos = cc.p( 148, 95 ),
		outLine = true,
	})
	_bg:addChild( _leftTimeNum )
	self._leftTimeNum = _leftTimeNum
	-- 剩余支援次数
	local _leftTimesText = zc.createLabel({
		text = zc.lang("dart_left_help_time") .. ":",
		fontSize = 18,
		color = cc.c3b( 76, 18, 18 ),
		ap = cc.p( 0, 0.5 ),
		pos = cc.p( 218, 95 ),
	})
	_bg:addChild( _leftTimesText )
	local _leftTimesNum = zc.createLabel({
		fontSize = 18,
		ap = cc.p( 0, 0.5 ),
		pos = cc.p( 335, 95 ),
		outLine = true,
	})
	_bg:addChild( _leftTimesNum )
	self._leftTimesNum = _leftTimesNum

	-- 刷新消耗
	local _consumeSp = cc.Sprite:create( zc.getImgByType( 1 ) )
	_consumeSp:setPosition( 55, 50 )
	_bg:addChild( _consumeSp )
	self._consumeSp = _consumeSp
	-- 消耗数字
	local _priceData = gameData.getDataFromCache("consume_price", {type=41})
	local _consumeLabel = zc.createLabel({
		text = _priceData.price,
		outLine = true,
		fontSize = 20,
		color = zc.COLOR_WHITE,
		ap = cc.p( 0, 0.5 ),
		pos = cc.p( 60, 40 ),
	})
	_bg:addChild( _consumeLabel )
	self._consumeLabel = _consumeLabel
	-- 刷新按钮
	local _refreshBtn = zc.createCommomBtn({
		tag = 2,
		pos = cc.p( 160, 50 ),
		text = LANGUAGE_SHOP.refresh,
		endCallback = function()
			if self._timer > 0 then
				zc.sendHttp({
			        apiName = "CountryDart_supportList",
			        params = {type=1},
			        successCallback = function (result)
			        	PlayerData:updataData( result )
			        	self:refresh( result )
			        end,
			    })
			else
				zc.tipInfo(zc.lang("tips_dart_out_of_time"))
			end
		end
	})
	_bg:addChild( _refreshBtn )
	self._refreshBtn = _refreshBtn
	-- 出发按钮
	local _beginBtn = zc.createCommomBtn({
		tag = 1,
		pos = cc.p( _bgWidth - 110, 50 ),
		text = zc.lang("chufa"),
		endCallback = function()
			if self._timer > 0 then
				zc.sendHttp({
			        apiName = "CountryDart_beginDart",
			        successCallback = function (result)
			        	-- dump(result, "CountryDart_beginDart")
			        	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_UPDATE_MYDART, data = result.dartInfo})
			        	LayerManager.getTopInfoLayer():setPopInfo( "" )
			        	self:hide()
			        end,
			    })
			else
				zc.tipInfo(zc.lang("tips_dart_out_of_time"))
			end
		end
	})
	_bg:addChild( _beginBtn )
	-- 标题
	local _title = cc.Sprite:create( "res/Main/country/countryDart/helpTitle.png" )
	_title:setPosition( 63, _bgHeight - 13 )
	_bg:addChild( _title )

end

function CountryDartHelpPop:createHelper()
	-- 背景
	local _helper = cc.Sprite:create( "res/Main/country/countryDart/helpCellBg.png" )
    -- 名字背景
    local _nameBg = cc.Sprite:create( "res/Main/arena/record/nameBg.png" )
    _nameBg:setPosition( 200, 60 )
    _helper:addChild( _nameBg )
	-- 名字
	local _name = zc.createLabel({
        fontSize = 20,
        outLine = true,
        pixel = 1.3,
        alignment = cc.TEXT_ALIGNMENT_CENTER,
        pos = cc.p( _nameBg:getContentSize().width/2, _nameBg:getContentSize().height/2 ),
	})
	_nameBg:addChild( _name )
	_helper._name = _name
	-- 兵器图标
    local _weaponSp = cc.Sprite:create()
    _weaponSp:setPosition( 0, 15 )
    _nameBg:addChild( _weaponSp )
    _helper._weaponSp = _weaponSp
	-- 战斗力图片
    local _fightingSp = cc.Sprite:create( "res/Main/hero/hero_zdl.png" )
    _fightingSp:setAnchorPoint( 0, 0.5 )
    _fightingSp:setPosition( 106, 23 )
	_helper:addChild( _fightingSp )
	-- 战斗力数字
	local _fightingNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 95, _fightingSp:getContentSize().height/2 - 7 ),
        addwidth = -5,
    })
    _fightingSp:addChild( _fightingNum )
    _helper._fightingNum = _fightingNum
    -- 请求
    local _askBtn = zc.createPushButton({
    	normalFile = "res/Main/country/countryDart/ask_u.png",
    	selectedFile = "res/Main/country/countryDart/ask_u.png",
    	disableFile = "res/Main/country/countryDart/ask_g.png",
    	touchScale = 0.95,
    	pos = cc.p( 422, 46 ),
    	endCallback = function()
			if self._timer > 0 then
	    		if _helper.userId then
		    		zc.sendHttp({
				        apiName = "CountryDart_appliedSupport",
				        params = {targetUserId = _helper.userId},
				        successCallback = function (result)
				        	-- dump(result, "CountryDart_appliedSupport")
				        	self._supportList[_helper.index].isHelp = 1
				        	self:refreshHelper( _helper.index )
				        end,
				    })
		    	end
			else
				zc.tipInfo(zc.lang("tips_dart_out_of_time"))
			end
    	end
	})
    _helper:addChild( _askBtn )
    _helper._askBtn = _askBtn
    -- 已请求
    local _asked = cc.Sprite:create( "res/Main/country/countryDart/asked.png" )
    _asked:setPosition( 422, 46 )
    _helper:addChild( _asked )
    _helper._asked = _asked
    -- 已支援
    local _helped = cc.Sprite:create( "res/Main/country/countryDart/helped.png" )
    _helped:setPosition( 422, 46 )
    _helper:addChild( _helped )
    _helper._helped = _helped

    return _helper
end

function CountryDartHelpPop:refreshHelper( index )
	local _data = self._supportList[index]
	local _helper = self._helper[index]
	if not _data then
		_helper:setVisible( false )
		_helper.userId = nil
		_helper.index = nil
		return
	else
		_helper:setVisible( true )
		_helper.userId = _data.userId
		_helper.index = index
	end
	if _helper._head then
		_helper._head:removeFromParent()
		_helper._head = nil
	end
	local _cellHeight = _helper:getContentSize().height
	local _head = zc.createPlayerHead({iconId = _data.iconId, level = _data.level})
	_head:setPosition( 50, _cellHeight/2 )
	_head:setScale( 0.8 )
	_helper:addChild( _head )
	_helper._head = _head
	_helper._name:setText( _data.userName )
	local _weaponData = gameData.getDataFromCacheWithPrimaryKey("weapon", _data.weaponId)
	_helper._weaponSp:setTexture( zc.getHeroTypeImg( _weaponData.type ) )
	_helper._fightingNum:setString( _data.fighting )
	local _isAsk = tonumber( _data.isHelp ) or 0
	local _isHelp = tonumber( _data.isHelped ) or 0
	if _isHelp == 1 then
		-- 已帮助
		_helper._askBtn:setVisible( false )
		_helper._asked:setVisible( false )
		_helper._helped:setVisible( true )
	elseif _isAsk == 1 then
		-- 已请求
		_helper._askBtn:setVisible( false )
		_helper._asked:setVisible( true )
		_helper._helped:setVisible( false )
	else
		_helper._askBtn:setVisible( true )
		_helper._asked:setVisible( false )
		_helper._helped:setVisible( false )
	end
end

function CountryDartHelpPop:refresh( params )
	self._supportList = {}
	if self._support then
		local _supportUserId = tonumber( params.supportUserId ) or 0
		for k, v in pairs( params.supportList ) do
			local _userId = tonumber( v.userId ) or 0
			if _supportUserId ~= 0 and _userId == _supportUserId then
				v.isHelped = 1
			end
			self._supportList[#self._supportList + 1] = v
		end
		-- 刷新玩家
		for i = 1, 3 do
			self:refreshHelper( i )
		end
		self._emptyLabel:setText(zc.lang("dart_now_have_no_can_help_member"))
		if #self._supportList == 0 then
			-- 没有玩家
			self._emptyBg:setVisible( true )
		else
			self._emptyBg:setVisible( false )
		end
		self._leftTimesNum:setColor( zc.COLOR_GREEN )
		self._consumeSp:setVisible( true )
		self._consumeLabel:setVisible( true )
		self._refreshBtn:setEnable( true )
	else
		-- 隐藏玩家
		for i = 1, 3 do
			self:refreshHelper( i )
		end
		self._emptyLabel:setText(zc.lang("dart_today_have_no_help_times"))
		self._emptyBg:setVisible( true )
		self._leftTimesNum:setColor( zc.COLOR_RED )
		self._consumeSp:setVisible( false )
		self._consumeLabel:setVisible( false )
		self._refreshBtn:setEnable( false )
	end
	self._leftTimesNum:setText( self._left.."/"..self._limit )
end

return CountryDartHelpPop