--[[
-- 国家主界面
-- @author lph
-- Creation  2016-4-6
]]


local CountryMainLayer = class("CountryMainLayer", function ()
    return zc.createNormalDialog()
end)

function CountryMainLayer:create( params )
    return CountryMainLayer.new( params )
end

function CountryMainLayer:ctor( params )
    self:initData(params)
    self:initUI()
end

function CountryMainLayer:initData(params)
    PlayerData:setCountryInfo(params)

    self._countryData = params
    self._country_announcement = params.announcement      --公告
    self._country_positionId = params.countryPositionId   --职位
    self._country_name = params.name                      --国家名称
    self._country_level = params.level                    --国家等级
    self._country_exp = params.exp                        --国家经验
    self._country_expLimit = params.expLimit              --下一级升级所需经验
    self._goToTab = params._goToTab         --切换右边tab
    self._gotoFunction = params._gotoFun    --跳转总览功能
    self._memberData = params.memberData
    self._awardStatus = tonumber(params.awardStatus) or 1
    self._award = params.award or {}
    self._endTime = tonumber(params.endTime) or 1
    self._memberList = params.memberList or {}
end

function CountryMainLayer:initUI()
    self._func_names = {zc.lang("country_shop"),zc.lang("country_warehouse"),zc.lang("country_technology")}

    local right_bg = zc.createNormalPop({
        src = "res/Main/country/main/country_pop_right_bg.png",
        srcTag = 2,
        width = 571,
        height = 520+31,
        bianZOrder = 20,
    })
    right_bg:setAnchorPoint(cc.p(1, 0.5))
    right_bg:setPosition(cc.p(zc.width-120, zc.height/2-17))
    self:addChild(right_bg, 11)
    local rightSize = cc.size(571, 520)
    self._rightBg = right_bg

    --title
    local _topBg = cc.Sprite:create( "res/Main/role/common/top_bg.jpg" )
    _topBg:setAnchorPoint( 0.5, 1 )
    _topBg:setPosition( cc.p(right_bg:getContentSize().width/2,right_bg:getContentSize().height-3 ) )
    right_bg:addChild( _topBg )
    _topBg:setScaleX( 563/_topBg:getContentSize().width )
    local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(230,32) )
    nameBg:setPosition(cc.p(_topBg:getPositionX(), _topBg:getPositionY()- _topBg:getContentSize().height/2))
    right_bg:addChild(nameBg)
    local zonglanglab = zc.createLabel({
        fontSize = 23,
        outLine = true,
        pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
    })
    nameBg:addChild(zonglanglab)
    self._tabName = LANGUAGE_get_country_main_tabs()
    self._mainTitle = zonglanglab

    --分割线
    ------------------------------------左侧布局
    local leftSize = cc.size(zc.width-rightSize.width-120, 520)
    -- local _left_bg = zc.getScaleNode("res/Main/setting/scale9_1.png", leftSize)
    local _left_bg = zc.createSprite()
    _left_bg:setContentSize( leftSize )
    _left_bg:setAnchorPoint(cc.p(0, 0.5))
    _left_bg:setPosition(cc.p(0, right_bg:getPositionY() ))
    self:addChild(_left_bg, 10)
    self._left_bg = _left_bg


    self:initLeftUI()
    ------------------------------------右侧布局
    self._right_infoSize = cc.size(565, 464)
    -- local _right_info_bg = zc.getScaleNode("res/Main/setting/scale9_1.png", self._right_infoSize)
    local _right_info_bg = zc.createSprite()
    _right_info_bg:setContentSize( cc.size(565, 464) )
    _right_info_bg:setAnchorPoint(cc.p(0.5, 0))
    _right_info_bg:setPosition(cc.p(rightSize.width/2, 5))
    right_bg:addChild(_right_info_bg, 10)
    self._right_bg = _right_info_bg
        
    --标签按钮
    self:initTagBtn()
end

--左侧ui
function CountryMainLayer:initLeftUI()
    local leftSize = self._left_bg:getContentSize()
    local _tmpH = 50

    --国家名称
    local _country_name_label = zc.createLabel({
        text = self._country_name,
        fontSize = 22,
        pos = cc.p(leftSize.width/2, 440-180 + _tmpH),
        color = cc.c3b(76,18,18),
        -- outLine = true,
    })
    self._left_bg:addChild(_country_name_label, 1)

    local _country_yunbg = zc.createSprite("res/Main/country/main/yun_bg.png")
    _country_yunbg:setPosition(leftSize.width/2+40, 330)
    self._left_bg:addChild(_country_yunbg)

    local _country_flag = zc.createSpine({
        fileName = "cangku_guangqi",
        actName = "animation",
        loop = true,
    })
    -- _country_flag:setAnchorPoint(cc.p(0.5, 1))
    _country_flag:setPosition(leftSize.width/2, 385)
    self._left_bg:addChild(_country_flag)
    _country_flag:setOpacity(255*0.8) 


    local _country_yun1 = zc.createSprite("res/Main/country/main/yun_2.png")
    _country_yun1:setPosition(leftSize.width - 30, 420 + _tmpH)
    self._left_bg:addChild(_country_yun1)

    _country_yun1:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.MoveBy:create(1.0, cc.p(-10,0)),
        cc.MoveBy:create(1.0, cc.p(10,0))
    )))

    local _country_yun2 = zc.createSprite("res/Main/country/main/yun_1.png")
    _country_yun2:setPosition(-30, 284)
    self._left_bg:addChild(_country_yun2)

    _country_yun2:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.MoveBy:create(1.5, cc.p(20,0)),
        cc.MoveBy:create(1.5, cc.p(-20,0))
    )))

    local _country_yun3 = zc.createSprite("res/Main/country/main/yun_3.png")
    _country_yun3:setPosition(317, 230 + _tmpH)
    self._left_bg:addChild(_country_yun3)

    --国家等级bg 
    local _justY = 15 
    local _country_level_bg = zc.getSprite({
        src = "res/Main/country/main/country_level_bg.png",
        ap = cc.p(0,0),
        pos = cc.p(80, 203 - _justY + _tmpH) 
    })
    self._left_bg:addChild(_country_level_bg,1)
    --国家等级
    local _country_level_label = zc.createLabel({
        text = self._country_level,
        fontSize = 22,
        pos = cc.p(23, 23),
        outLine = true,
    })
    _country_level_bg:addChild(_country_level_label)
    self._country_level_label = _country_level_label
    --经验进度
    local _src_1 = "res/Main/drillField/drillField_heroExp_bg_1.png"
    local _src_2 = "res/Main/drillField/drillField_heroExp_1.png"
    self._slider = zc.createProgress(self._left_bg,_src_1,_src_2,cc.p(225,225 - _justY + _tmpH),0.85)
    self._slider:setPercentage(0)
    local _exp = self._country_expLimit
    if _exp ~= 0 then
        self._slider:setPercentage(tonumber(self._country_exp/_exp*100))
    end
    --国家经验/升级经验
    local _country_exp_label = zc.createLabel({
        text = self._country_exp .. "/" .. self._country_expLimit,
        fontSize = 22,
        pos = cc.p(self._slider:getContentSize().width/2-20, 11),
        outLine = true,
    })
    self._slider:addChild(_country_exp_label)
    self._country_exp_label = _country_exp_label


    --国家俸禄
    local _noticeSize = cc.size(leftSize.width-30, 240)
    local _notice_bg_s = ccui.Scale9Sprite:create( cc.rect( 473/2, 0, 1, 236 ), "res/Main/common/attr_bg.png")
    _notice_bg_s:setContentSize(_noticeSize)
    _notice_bg_s:setAnchorPoint(cc.p(0.5, 0))
    _notice_bg_s:setPosition(cc.p(leftSize.width/2, -1))
    self._left_bg:addChild(_notice_bg_s)
    local _b_sideImg = zc.getScaleNode("res/Main/common/popBg/shadow_b.png", cc.size(_noticeSize.width, 31))
    _b_sideImg:setAnchorPoint(0, 1)
    _b_sideImg:setPosition(-2, 3)
    _notice_bg_s:addChild(_b_sideImg, -1)
    local _r_sideImg = ccui.Scale9Sprite:create( cc.rect( 16, 50, 1, 539-160 ), "res/Main/common/popBg/shadow_r.png")
    _r_sideImg:setContentSize(cc.size(32,193))
    _r_sideImg:setAnchorPoint(0, 0)
    _r_sideImg:setPosition(_noticeSize.width-12, _b_sideImg:getPositionY()-31)
    _notice_bg_s:addChild(_r_sideImg, -1)

    local _descBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        pos = cc.p(_noticeSize.width - 35, _noticeSize.height - 35),
        endCallback = function()
            -----玩法说明
            zc.createRulePop(7)
        end
    })
    _notice_bg_s:addChild(_descBtn, 1)

    -- 国家储备
    do 
        local drop = zc.getSprite({
            src = "res/Main/country/main/guojiachubei.png",
            pos = cc.p(_noticeSize.width*0.5, _noticeSize.height - 30)
        })
        _notice_bg_s:addChild(drop)

        local _titleLabSize = drop:getContentSize()
        local _titleLeftSp = zc.getSprite({
            src = "res/Main/common/lace.png",
            ap = cc.p(1, 0.5),
            pos = cc.p(drop:getPositionX() - _titleLabSize.width*0.5 - 10, drop:getPositionY()),
        })
        _notice_bg_s:addChild(_titleLeftSp)

        local _titleRightSp = zc.getSprite({
            src = "res/Main/common/lace.png",
            ap = cc.p(1, 0.5),
            pos = cc.p(drop:getPositionX() + _titleLabSize.width*0.5 + 10, drop:getPositionY()),
        })
        _titleRightSp:setScaleX(-1)
        _notice_bg_s:addChild(_titleRightSp)

        local _w = 160
        local _h = 30
        local _moneyDi = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        _moneyDi:setPosition(40, drop:getPositionY() - 40)
        _moneyDi:setContentSize(_w, _h)
        _moneyDi:setAnchorPoint(0, 0.5)
        _notice_bg_s:addChild(_moneyDi)

        local _sp = zc.createSprite(zc.getImgByType(zc.dataTypeMoney))
        _sp:setPosition(20, _h*0.5)
        _moneyDi:addChild(_sp)

        local _label = zc.createLabel({
            text = zc.getWan(self._countryData.money),
            fontSize = 20,
            color = display.COLOR_GREEN,
            ap = cc.p(1, 0.5),
            pos = cc.p(_w - 10, _h*0.5)
        })
        _moneyDi:addChild(_label)
    end

    -- 我的俸禄
    do 
        local drop = zc.getSprite({
            src = "res/Main/country/main/wodefenglu.png",
            pos = cc.p(_noticeSize.width*0.5, _noticeSize.height - 115)
        })
        _notice_bg_s:addChild(drop)

        local _titleLabSize = drop:getContentSize()
        local _titleLeftSp = zc.getSprite({
            src = "res/Main/common/lace.png",
            ap = cc.p(1, 0.5),
            pos = cc.p(drop:getPositionX() - _titleLabSize.width*0.5 - 10, drop:getPositionY()),
        })
        _notice_bg_s:addChild(_titleLeftSp)

        local _titleRightSp = zc.getSprite({
            src = "res/Main/common/lace.png",
            ap = cc.p(1, 0.5),
            pos = cc.p(drop:getPositionX() + _titleLabSize.width*0.5 + 10, drop:getPositionY()),
        })
        _titleRightSp:setScaleX(-1)
        _notice_bg_s:addChild(_titleRightSp)

        local _w = 160
        local _h = 30

        local _taxDi = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        _taxDi:setPosition(40, drop:getPositionY() - 45)
        _taxDi:setContentSize(_w, _h)
        _taxDi:setAnchorPoint(0, 0.5)
        _notice_bg_s:addChild(_taxDi)

        local _sp = zc.createSprite(zc.getImgByType(zc.dataTypeTax))
        _sp:setPosition(20, _h*0.5)
        _taxDi:addChild(_sp)

        local _label1 = zc.createLabel({
            fontSize = 20,
            color = display.COLOR_GREEN,
            ap = cc.p(1, 0.5),
            pos = cc.p(_w - 10, _h*0.5)
        })
        _taxDi:addChild(_label1)

        local _moneyDi = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        _moneyDi:setPosition(40, _taxDi:getPositionY() - 40)
        _moneyDi:setContentSize(_w, _h)
        _moneyDi:setAnchorPoint(0, 0.5)
        _notice_bg_s:addChild(_moneyDi)

        local _sp = zc.createSprite(zc.getImgByType(zc.dataTypeMoney))
        _sp:setPosition(20, _h*0.5)
        _moneyDi:addChild(_sp)

        local _label2 = zc.createLabel({
            fontSize = 20,
            color = display.COLOR_GREEN,
            ap = cc.p(1, 0.5),
            pos = cc.p(_w - 10, _h*0.5)
        })
        _moneyDi:addChild(_label2)


        local function _freshNum()
            local _num1, _num2
            if #self._award > 0 then
                for k,v in pairs(self._award) do
                    if tonumber(v.type) == zc.mainTypeResource then
                        if tonumber(v.id) == zc.dataTypeMoney then
                            _num2 = tonumber(v.num) or 0
                        elseif tonumber(v.id) == zc.dataTypeTax then
                            _num1 = tonumber(v.num) or 0
                        end
                    end
                end
            end
            if not _num1 then
                local _levelDb = gameData.getDataFromCacheWithPrimaryKey("country_level", self._country_level)
                local _salary = tonumber(_levelDb.salary) or 0
                local _positionDb = gameData.getDataFromCacheWithPrimaryKey("country_position", self._country_positionId)
                local _salaryPercent = tonumber(_positionDb.salaryPercent) or 0
                _num1 = _salary*_salaryPercent
            end
            _label1:setString(zc.getWan(_num1))

            if not _num2 then
                local _totalResNum = tonumber(self._countryData.money) or 0
                local _data = gameData.getDataFromCacheWithPrimaryKey("country_position", self._country_positionId)
                local _rate = 1
                if next(_data) ~= nil then
                    _rate = _data.salary
                end
                local _rate_sum = 0
                local _allDb = gameData.getAllDataWithNoClone("country_position")
                for k,v in pairs(_allDb) do
                    local __rate = tonumber(v.salary) or 0
                    _rate_sum = _rate_sum + __rate
                end
                local _my_num = _rate/_rate_sum*_totalResNum
                _num2 = math.floor(_my_num)
            end
            _label2:setString(zc.getWan(_num2))
        end
        _freshNum()

        local function _doCan()
            self._countNum:stopAllActions()
            self._getBtn:setEnable(true)
            self._countLabel:setVisible(false)
            self._countNum:setVisible(false)
        end

        local function _freshTime()
            if self._awardStatus == 1 then
                _doCan()
                return
            else
                self._getBtn:setEnable(false)
                self._countLabel:setVisible(true)
                self._countNum:setVisible(true)
            end
            local _lifeTime = tonumber(self._endTime) or 0
            local _nowTime = _lifeTime - PlayerData:getTime()
            if _nowTime <= 0 then
                _doCan()
            else
                local _hour = math.modf(_nowTime/(60*60))
                local _leftTime = _nowTime%(60*60)
                local _minute = math.modf(_leftTime/60)
                local _seconds = _leftTime%60
                _hour = _hour >= 10 and _hour or ("0" .. _hour)
                _minute = _minute >= 10 and _minute or ("0" .. _minute)
                _seconds = _seconds >= 10 and _seconds or ("0" .. _seconds)
                self._countNum:setString(_hour .. ":" .. _minute .. ":" .. _seconds)
            end
        end

        local _getBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("fetch_2"),
            pos = cc.p(_noticeSize.width*0.5 + 110, 50),
            endCallback = function()
                if self._awardStatus ~= 1 then
                    zc.tipInfo(LANGUAGE_TOLLGATEHERO.can_not_fetch)
                    return
                end
                zc.sendHttp({
                    apiName = "Country_getDayReawrd",
                    successCallback = function(backData)
                        PlayerData:updataData(backData)
                        self._awardStatus = tonumber(backData.awardStatus) or 1
                        self._award = backData.award or {}
                        self._endTime = tonumber(backData.endTime) or 1
                        schedule(self._countNum, _freshTime, 1)
                        _freshTime()
                        _freshNum()
                    end
                })
            end
        })
        _notice_bg_s:addChild(_getBtn)
        self._getBtn = _getBtn

        local _countLabel = zc.createLabel({
            text = zc.lang("time_count_down") .. "：",
            ap = cc.p(1, 0.5),
            fontSize = 20,
            pos = cc.p(_getBtn:getPositionX(), _getBtn:getPositionY() + 45),
            color = cc.c3b(238, 236, 165),
            outLine = true,
        })
        _notice_bg_s:addChild(_countLabel)
        self._countLabel = _countLabel

        local _countNum = zc.createLabel({
            text = "00:00:00",
            ap = cc.p(0, 0.5),
            fontSize = 20,
            pos = cc.p(_countLabel:getPositionX(), _countLabel:getPositionY()),
            color = display.COLOR_RED,
            outLine = true,
        })
        _notice_bg_s:addChild(_countNum)
        self._countNum = _countNum

        schedule(_countNum, _freshTime, 1)
        _freshTime()
    end


    --国家公告
    local _noticeNode = cc.Node:create()
    local _noticeSize = cc.size(290, 160)
    _noticeNode:setAnchorPoint(0.5, 0)
    _noticeNode:setContentSize(_noticeSize)
    _noticeNode:setPosition(leftSize.width/2, 300 + _tmpH)
    self._left_bg:addChild(_noticeNode)

    local _country_notice_name = zc.createSprite("res/Main/country/main/noticeTitle.png")
    _country_notice_name:setPosition( cc.p(_noticeSize.width/2, _noticeSize.height - 25) )
    _noticeNode:addChild(_country_notice_name, 1)

    local _noticeInfoSize = cc.size(_noticeSize.width - 35, 105)
    self._noticeInfoSize = _noticeInfoSize
    local _noticeInfoBg = cc.Node:create()
    _noticeInfoBg:setContentSize( _noticeInfoSize )
    _noticeInfoBg:setAnchorPoint( 0.5, 0 )
    _noticeInfoBg:setPosition( _noticeSize.width/2, 8 )
    _noticeNode:addChild( _noticeInfoBg )

    local _scrollView = cc.ScrollView:create()
    _scrollView:setViewSize( cc.size(_noticeInfoSize.width, 115) )
    _scrollView:setContentSize( _noticeInfoSize )
    _scrollView:setPosition(cc.p(0, 0))
    _scrollView:ignoreAnchorPointForPosition(true)
    _scrollView:updateInset()
    _scrollView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    _scrollView:setClippingToBounds(true)
    _scrollView:setBounceable(false)   
    _noticeInfoBg:addChild(_scrollView)
    self._noticeScrollview = _scrollView

    --公告内容
    self._notice_content_label = zc.createRichLabel({
        text = "",
        fontSize = 20,
        pos = cc.p(10, 0),
        anchor = cc.p(0,1),
        color = cc.c3b(76,18,18),
    })
    self._notice_content_label:enableStroke(display.COLOR_BLACK, 0.2)
    self._notice_content_label:setDimensions(cc.size(_noticeInfoSize.width - 20, 0))
    _scrollView:addChild(self._notice_content_label)


    --test
    -- self._country_announcement = "您捐献的过于热情，请稍后在捐献，您也可以花费一些金币直接清除冷却时间！您捐献的过于热情，请稍后在捐献，您也可以花费一些金币直接清除冷却时间！您捐献的过于热情，请稍后在捐献，您也可以花费一些金币直接清除冷却时间！"

    --设置国家公告
    self:setCountryNotice(self._country_announcement)

    --国家成员数量
    local _memberNum = self._countryData.memberNum
    local _memberLimit = self._countryData.memberLimit
    local _member_label = zc.createLabel({
        text = zc.lang("country_member") .. ":" .. _memberNum .. "/" .. _memberLimit,
        fontSize = 18,
        ap = cc.p(1,0.5),
        pos = cc.p(240, -10),
        color = cc.c3b(76,18,18),
    })
    _noticeInfoBg:addChild(_member_label)
    self._member_label = _member_label
end

--设置国家公告
function CountryMainLayer:setCountryNotice(_str)
    self._notice_content_label:setString(_str or "")
    -- local labSize = self._notice_content_label:getContentSize()
    -- dump(labSize, "-----------dump----labSize----ad-------------" )
    self._noticeScrollview:setContentSize( cc.size(self._noticeInfoSize.width, self._notice_content_label:getContentSize().height + 5) )
    self._noticeScrollview:setContentOffset(self._noticeScrollview:minContainerOffset())
    self._notice_content_label:setPosition(cc.p(10, self._noticeScrollview:getContentSize().height - 5))
end

--右侧UI -- 总览
function CountryMainLayer:initRightUI()
    --五个按钮
    local rightBgSize = self._right_infoSize
    local rightBgNode = zc.getScaleNode("res/Main/country/main/country_rightNode_bg.png", rightBgSize)
    -- local rightBgNode = zc.getScaleNode("res/Main/setting/scale9_1.png", rightBgSize)
    rightBgNode:setPosition( rightBgSize.width/2, rightBgSize.height/2 )
    self._right_bg:addChild(rightBgNode)

    
    local buttonInfoList = {
        [1] = {
            img="res/Main/country/main/country_button_1.png",
            tag=2,
            name = zc.lang("country_warehouse"),
            pos=cc.p(139, 360),
            -- pos=cc.p(428 + 289, 360),
            tableIndex = 2,
        },
        [2] = {
            img="res/Main/country/main/country_button_2.png",
            tag=3,
            name = zc.lang("country_technology"),
            pos=cc.p(428, 360),
            tableIndex = 1,
        },
        [3] = {
            img="res/Main/country/main/country_button_3.png",
            tag=1,
            name = zc.lang("country_shop"),
            pos=cc.p(139, 133),
            tableIndex = 1,
        },
        [4] = {
            img="res/Main/country/main/country_button_4.png",
            tag=5,
            name = zc.lang("country_dart"),
            pos=cc.p(428, 133),
            tableIndex = 1,
        },
        [5] = {
            img="res/Main/country/main/country_button_5.png",
            tag=4,
            name = zc.lang("country_worldboss"),
            pos=cc.p(285, 249),
            tableIndex = 1,
        },
        [6] = {
            img="res/Main/country/main/country_button_6.png",
            tag=6,
            name = zc.lang("country_nightWuchao"),
            -- pos=cc.p(428 + 289, 360),
            pos=cc.p(139, 360),
            tableIndex = 1,
        },
    }   
    self._buttonInfoList = buttonInfoList

    local _dotList = {}
    for i = 1, 2 do
        if i == 1 then
            _path = "res/Main/country/main/dot_gray.png"
        else
            _path = "res/Main/country/main/dot_black.png"
        end
        local dot = zc.createSprite(_path)
        dot:setAnchorPoint(0.5, 0.5)
        dot:setPosition(rightBgSize.width/2+(i==1 and -1 or 1)*15, 26)
        rightBgNode:addChild(dot)
        _dotList[#_dotList+1] = dot
    end

    local tableSize = cc.size(rightBgSize.width-4,rightBgSize.height-4)
    local myTableBg = rightBgNode
    local myTable = zc.ZCTableView:create( tableSize )
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(false)
    myTable:setAutoAlign(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    rightBgNode:addChild(myTable)

    self._buttonTable = myTable

    local function cellSizeForTable(table,idx)
        return tableSize.height, tableSize.width
    end
    local function numberOfCellsInTableView(table)
        return 1
    end
    local function tablePageAfterSliding(table, cell)
        local currentPage = table:getCurrentPage()
        for i = 1, #_dotList do
            local dot = _dotList[i]
            local _path = ""
            if currentPage+1 == i then
                _path = "res/Main/country/main/dot_gray.png"
            else
                _path = "res/Main/country/main/dot_black.png"
            end
            if not tolua.isnull(dot) then
                dot:setTexture(_path)
            end
        end
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width, tableSize.height))
        else
            cell:removeAllChildren()
        end
        self:updateButtonListCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(tableCelTouched,cc.TABLECELL_TOUCHED)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)

    myTable:reloadData()
end

function CountryMainLayer:updateButtonListCell(cell, index)
    for i = 1, #self._buttonInfoList do
        local v = self._buttonInfoList[i]
        if v.tableIndex and v.tableIndex == index then
            local touchBtn = zc.createPushButton({
                normalFile = v["img"],
                needSwallow = true,
                touchScale = 0.9,
                touchSize = cc.size(90, 90),
                pos = v["pos"],
                endCallback = function()
                    self:toFuncView(v["tag"])
                end,
            })
            cell:addChild(touchBtn)

            local buttonNameBg = zc.createSprite("res/Main/country/main/country_button_nameBg.png") 
            buttonNameBg:setPosition(touchBtn:getContentSize().width/2+10, 40)
            touchBtn:addChild(buttonNameBg)

            local buttonName = zc.createLabel({
                text = v["name"],
                stroke = false,
                fontSize = 26,
                pos = cc.p(buttonNameBg:getContentSize().width/2-10, buttonNameBg:getContentSize().height/2-8),
                color = cc.c3b(229,223,170),
                color2 = display.COLOR_BLACK,
            })
            buttonNameBg:addChild(buttonName)

            if self._gotoFunction and self._gotoFunction == i then
                self._gotoFunction = nil
                self:toFuncView(v["tag"])
            end
        end
    end
end

function CountryMainLayer:toFuncView(index)
    if index == 1 then
        --国家商店
        zc.sendHttp({
            apiName = "Country_goods_list",
            params = {type="1|2|3"},
            successCallback = function (data) 
                zc.createSourceScene("CountryShop", "src/layer/country/CountryShopLayer.lua", data)
            end,
        })
    elseif index == 2 then
        --国家仓库
        zc.sendHttp({
            apiName = "Country_memberList",
            params = {id=self._countryData.id},
            successCallback = function (data)
                local _data = {countryData = PlayerData:getCountryInfo(),memberData = data}
                zc.createSourcePop("CountryWarehouse", "src/layer/country/CountryWarehousePop.lua",_data)
            end,
        })
    elseif index == 3 then
        --国家科技
        zc.sendHttp({
            apiName = "Country_techList",
            successCallback = function (data)
                local function _callBack()
                    self:updateCountryView()
                end 
                local _data = { techData = data,countryData = self._countryData,callback = _callBack}
                zc.createSourcePop( "CountryTechInfo", "src/layer/country/CountryTechInfoPop.lua", _data)
            end,
        })
    elseif index == 4 then
        -- 世界boss
        zc.createWorldBossLayer()
    elseif index == 5 then
        -- 押镖
        zc.createCountryDartMainLayer()
    elseif index == 6 then
        zc.createGrabMineMain()
    end
end

function CountryMainLayer:updateCell(cell,index)
    local _cityData = self._countryCitysData[index]
    local _m = math.floor((index-0.1)/3 )
    local _n = index
    _n = _n - 3*_m
    local _src = string.format("res/Main/country/main/country_city_bg_%s.png",_n)
    local _di = zc.getSprite({
        src = _src,
        ap = cc.p(0.5,0.5),
        pos = cc.p(100, 140),
    })
    cell:addChild(_di)
    local _src_city = string.format("res/Main/copy/%s.png",index)
    local _cityImg = zc.getSprite({
        src = _src_city,
        ap = cc.p(0.5,0),
        pos = cc.p(103, 50),
        scale = 0.65,
    })
    _di:addChild(_cityImg)

    zc.setGray( _di:getVirtualRenderer() )
    zc.setGray( _cityImg:getVirtualRenderer() )


    local _cityName = ""
    if _cityData then
        _cityName = _cityData.cityId
    end
    local _name_label = zc.createLabel({
        text = _cityName,
        fontSize = 24,
        ap = cc.p(0.5,0.5),
        stroke = true,
        pos = cc.p(123, 250),
    })
    _di:addChild(_name_label)


    _di:setTouchEnabled(true)
    _di:setSwallowTouches(false)
    local _flag = false
    _di:addTouchEventListener(function ( sender, eventType )
        if eventType == ccui.TouchEventType.began then 
            _flag = false
            _di:setScale(0.95)
        elseif eventType == ccui.TouchEventType.moved then 
            _flag = true
        elseif eventType == ccui.TouchEventType.ended then
            _di:setScale(1.0)  
        else
            _flag = false
            _di:setScale(1.0)
        end
    end)
end

function CountryMainLayer:toCitysView(index)
    local _cityData = self._countryCitysData[index]
    zc.sendHttp({
        apiName = "Country_cityInfo",
        params = {cityId=_cityData.id},
    })
end

--国家职位权限
function CountryMainLayer:getCountryPrivileges(_positionId)
    local _data = gameData.getDataFromCacheWithPrimaryKey("country_position", _positionId)
    local _privileges = ""
    if next(_data) ~= nil then
        _privileges = _data.privileges
    end
    local _data = {}
    if tonumber(_str) ~= 0 then 
        _data = string.split(_privileges,",")
    else
        _data = nil
    end
    return _data
end

--标签按钮
function CountryMainLayer:initTagBtn()
    self._tagNames = {
        zc.lang("country_overview"), 
        zc.lang("country_member_1"),
        zc.lang("country_rank"),
        zc.lang("country_help"),
        zc.lang("country_log"),
    }
    --查看特权，只有特权1、2能显示国家设置
    local privileges = self:getCountryPrivileges(self._country_positionId)
    if privileges then
        for i = 1, #privileges do
            local pri = tonumber(privileges[i])
            if pri == 1 or pri == 2 then
                self._tagNames[#self._tagNames+1] = zc.lang("country_setting")
                break
            end
        end
    end

    self._tag = self._goToTab or 1--默认是全部

    self._tabButtonList = {}
    local initPosY = 480-70/2
    for i=1,#self._tagNames do
        local tabBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/tab_btn_noraml.png",
            needSwallow = true,
            touchScale = 0.9,
            anchor = cc.p(0, 0.5),
            touchSize = cc.size(110, 75),
            pos = cc.p(self._rightBg:getContentSize().width, initPosY-(i-1)*75),
            endCallback = function() end,
        })
        tabBtn:setTag(i)
        self._rightBg:addChild(tabBtn, 11)
        self._tabButtonList[i] = tabBtn
        local normalLab = zc.createLabel({
            text = self._tagNames[i],
            fontSize = 22,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(48, 36),
            outLine = true,
            color = zc.tabLabNormalColor1,
            -- color2 = zc.tabLabNormalColor2,
            color2 = display.COLOR_WHITE,
            pixel = 0.5,
        })
        tabBtn:addChild(normalLab, 2)
        local selectedLab = zc.createLabel({
            text = self._tagNames[i],
            fontSize = 22,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(48, 36),
            outLine = true,
            color = display.COLOR_WHITE,
            color2 = zc.tabLabselectColor2 ,
            pixel = 1,
        })
        tabBtn:addChild(selectedLab, 2)
        selectedLab:setVisible(false)
        tabBtn._normalLab = normalLab
        tabBtn._selectLab = selectedLab

        tabBtn:setTouchEndedCall(function()
            self:changeTab(tabBtn)
        end)
        if self._tag == i then 
            self:changeTab(tabBtn)
        end
    end

end

--标签切换
function CountryMainLayer:changeTab(_node)
    local function getNormal()
        return zc.createSprite("res/Main/common/button/tab_btn_noraml.png")
    end
    local function getSelect()
        return zc.createSprite("res/Main/common/button/tab_btn_select.png")
    end
    if not self._selectedBtn or self._selectedBtn ~= _node then
        local tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        else
            self._selectedBtn:setStateNormal( getNormal() )
            self._selectedBtn._normalLab:setVisible(true)
            self._selectedBtn._selectLab:setVisible(false)
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        end

        self._tag = tag
        self:cleanRightUI()
        if self._quitCountryButton then
            self._quitCountryButton:setVisible(false)
        end
        if tag == 1 then  -- 总览
            self:initRightUI()
        elseif tag == 2 then -- 国家成员
            self:countryMemberUI()
        elseif tag == 3 then -- 国家排名
            self:countryRankUI()
        elseif tag == 4 then -- 国家帮助
            self:countryHelpUI()
        elseif tag == 5 then -- 国家日志
            self:countryLogUI()
        elseif tag == 6 then -- 国家设置  
            self:countrySettingUI()
        elseif tag == 7 then -- 国家战争
        end
        self._mainTitle:setString(self._tabName[tag])
    end
end

--UI界面切换--国家成员
function CountryMainLayer:countryMemberUI()
    if self._quitCountryButton then
        self._quitCountryButton:setVisible(true)
    end
    zc.sendHttp({
        apiName = "Country_memberList",
        params = {id=self._countryData.id},
        successCallback = function (data)
            local _layer = requires("src/layer/country/CountryMemberListLayer.lua"):create(data)
            self._right_bg:addChild(_layer) 
        end,
    })
end

--国家排行
function CountryMainLayer:countryRankUI()
    zc.sendHttp({
        apiName = "Country_rank",
        successCallback = function (data)
            local _layer = requires("src/layer/country/CountryRankLayer.lua"):create(data)
            self._right_bg:addChild(_layer) 
        end,
    })
end

--国家帮助
function CountryMainLayer:countryHelpUI()
    zc.sendHttp({
        apiName = "Country_helpList",
        successCallback = function (data)
            local _layer = requires("src/layer/country/CountryHelpLayer.lua"):create(data)
            self._right_bg:addChild(_layer) 
        end,
    })
end

--国家日志
function CountryMainLayer:countryLogUI()
    zc.sendHttp({
        apiName = "Country_recordList",
        successCallback = function (data) 
            local _layer = requires("src/layer/country/CountryLogLayer.lua"):create(data)
            self._right_bg:addChild(_layer)
        end,
    })
end

--国家设置
function CountryMainLayer:countrySettingUI()
    local _layer = requires("src/layer/country/CountrySettingPop.lua"):create(self._countryData)
    _layer:setPosition(cc.p(-1,-12))
    self._right_bg:addChild(_layer) 
end

function CountryMainLayer:cleanRightUI()
    self._right_bg:removeAllChildren()
end

--创建scollView
function CountryMainLayer:createTabButScrollView()
    local _tabButScrollView = cc.ScrollView:create()
    _tabButScrollView:setViewSize(cc.size(190, 500))
    _tabButScrollView:setContentSize(cc.size(190, 500))
    _tabButScrollView:setPosition(cc.p(943,0))
    _tabButScrollView:ignoreAnchorPointForPosition(true)
    _tabButScrollView:updateInset()
    _tabButScrollView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL) 
    _tabButScrollView:setClippingToBounds(true)
    _tabButScrollView:setBounceable(false)
    _tabButScrollView:setContentOffset(_tabButScrollView:minContainerOffset()) 
    return  _tabButScrollView
end

--刷新国家数据
function CountryMainLayer:updateCountryView()
    self._countryData = PlayerData:getCountryInfo()
    -- dump(self._countryData, "-----_countryData----")

    self._country_level_label:setString(self._countryData.level)
    local _exp = self._countryData.expLimit
    if _exp ~= 0 then
        self._slider:setPercentage(tonumber(self._countryData.exp /_exp*100))
    else
        self._slider:setPercentage(0)
    end
    self._country_exp_label:setString(self._countryData.exp  .. "/" .. self._countryData.expLimit)
    local _memberNum = self._countryData.memberNum
    local _memberLimit = self._countryData.memberLimit
    self._member_label:setString(zc.lang("country_member") .. ":" .. _memberNum .. "/" .. _memberLimit)
end

return CountryMainLayer