--[[
	世界boss信息弹窗
	唐实聪
	2016.6.13
]]
local WorldBossInfoPop = class("WorldBossInfoPop", function()
	return ZCPopLayer:create()
end)

function WorldBossInfoPop:create( params )
	return WorldBossInfoPop.new( params )
end

function WorldBossInfoPop:ctor( params )
	self:initData( params )
	self:initUI()
    self:startTimer()
	self:show()
end

function WorldBossInfoPop:initData( params )
    self._index = params.index
	self._bossData = params.data
    self._cd = params.cd
    self._hp = params.hp
    self._status = params.status
    self._unlock = params.unlock

    local _myTimes = params.times
    local _data = gameData.getDataFromCache("consume_price", {type=24})
    if _data.price then
        _data = {_data}
    end
    local _priceIndex = (tonumber(_myTimes) or 0) + 1
    if _priceIndex > table.nums(_data) then
        _priceIndex = table.nums(_data)
    end
    local priceInfo = _data[_priceIndex] or {}
    self._price = priceInfo.price or 0

    self._timeInfo = params.timeInfo

    self._attackCallback = params.attackCallback

	self._size = self:getContentSize()
end

function WorldBossInfoPop:initUI()
	-- 背景
    local background = cc.Sprite:create( "res/Main/common/popBg/popup_Bg_blue.png" )
    background:setPosition( self._size.width/2, self._size.height/2 )
    self:addContent( background )
    local bgWidth = background:getContentSize().width
    local bgHeight = background:getContentSize().height
    -- 关闭
    local close = zc.createBackButton({
        pos = cc.p( bgWidth - 20, bgHeight - 20), 
        listener = function()
            self:hide()
        end,
    })
    background:addChild( close )
    -- 标题
    local title =  zc.getTipPopTitle( "chengchixinxi" )
    title:setPosition( bgWidth/2, bgHeight - 30 )
    background:addChild(title)

    -- 中间背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(bgWidth*0.5, bgHeight*0.5 + 30)
    background:addChild(middleBg)
    local middleWidth = middleBg:getContentSize().width
    local middleHeight = middleBg:getContentSize().height

	-- 城市
    local _path = "res/Main/country/worldBoss/city_sp_"..self._bossData.iconId..".png"
    if self._index == 2 then
        _path = "res/Main/copy/11.png"
    end
	local city = cc.Sprite:create( _path )
	city:setAnchorPoint( 1, 0.5 )
	city:setPosition( 180, middleHeight/2 )
    middleBg:addChild( city )
    local _cityWidth = city:getContentSize().width
    local _cityHeight = city:getContentSize().height
	local name = cc.Sprite:create( "res/Main/country/worldBoss/city_name_"..self._bossData.iconId..".png" )
	name:setAnchorPoint( 0, 1 )
	name:setPosition( _cityWidth - 20, _cityHeight )
	city:addChild( name )
    -- 未解锁
    local lock = cc.Sprite:create( "res/Main/country/worldBoss/unlock.png" )
    lock:setPosition( _cityWidth/2, _cityHeight/2 )
    city:addChild( lock )
    -- 破
    local pass = cc.Sprite:create( "res/Main/country/worldBoss/pass.png" )
    pass:setPosition( _cityWidth/2, _cityHeight/2 )
    city:addChild( pass )

	local _height = middleHeight - 28
	-- 解锁条件
	local unlockText = zc.createLabel({
        text = zc.lang("unlock_condition") .. ":",
        fontSize = 18,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 200, _height),
        outLine = true,
    })
    middleBg:addChild( unlockText )
    local _unlock = false
    for i, v in ipairs( string.split( tostring( self._bossData.activateId ), "," ) ) do
    	local _data = gameData.getDataFromCacheWithPrimaryKey("bossPve_npcGroup", v)
    	if next(_data) then
    		_unlock = true
			local unlockNum = zc.createLabel({
		        text = _data.name..zc.getLevelTipShow().._data.level,
		        fontSize = 18,
		        color = zc.COLOR_YELLOW,
		        ap = cc.p( 0, 0.5 ),
		        pos = cc.p( 290, _height ),
		        outLine = true,
		    })
		    middleBg:addChild( unlockNum )
		    _height = _height - 30
		end
    end
    if not _unlock then
    	-- 如果没有解锁条件
		local unlockNum = zc.createLabel({
	        text = zc.lang("no"),
	        fontSize = 18,
	        color = zc.COLOR_YELLOW,
	        ap = cc.p( 0, 0.5 ),
	        pos = cc.p( 290, _height ),
	        outLine = true,
	    })
	    middleBg:addChild( unlockNum )
	    _height = _height - 30
    end
    _height = _height - 10
    -- 当前等级
    local crtLevelText = zc.createLabel({
        text = LANGUAGE_RECHARGE.current_level .. ":",
        fontSize = 18,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 200, _height),
        outLine = true,
    })
    middleBg:addChild( crtLevelText )
    local crtLevelNum = zc.createLabel({
        text = zc.getLevelTipShow()..self._bossData.level,
        fontSize = 18,
        color = zc.COLOR_YELLOW,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 290, _height),
        outLine = true,
    })
    middleBg:addChild( crtLevelNum )
    _height = _height - 40
    -- 推荐战力
    local fightText = zc.createLabel({
        text = zc.lang("recommend") .. zc.lang("fighting") .. ":",
        fontSize = 18,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 200, _height),
        outLine = true,
    })
    middleBg:addChild( fightText )
    local fightSp = zc.createImageView({
        src = "res/Main/home/home_fight.png",
        ap = cc.p( 0, 0.5 ),
        pos = cc.p(280, _height)
    })
    middleBg:addChild( fightSp )
    local fightNum = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        text = self._bossData.fight,
        ap = cc.p(0, 0.5),
        pos = cc.p(fightSp:getPositionX() + fightSp:getContentSize().width - 10, _height - 7),
        addwidth = -5,
    })
    fightNum:setScale( 1.2 )
    middleBg:addChild( fightNum )

    -- 放弃
    local giveup = zc.createCommomBtn({
    	tag = 2,
    	btnText = zc.lang("give_up"),
    	pos = cc.p( 130, 70 ),
    	endCallback = function()
    		self:hide()
    	end
	})
	background:addChild( giveup )

	-- 进攻
    local attack = zc.createCommomBtn({
    	tag = 1,
    	btnText = LANGUAGE_ARENA.attack,
    	pos = cc.p( bgWidth - 130,  70),
    	endCallback = function()
            local _startTime = tonumber( self._timeInfo.startTime ) or 0
            local _endTime = tonumber( self._timeInfo.endTime ) or 0
            local _myTime = PlayerData:getTime()
            if _startTime <= _myTime and _myTime <= _endTime then
                if self._hp == 0 then
                    zc.tipInfo(tostring(self._bossData.name) .. zc.lang("already_be_defeated") .. "!")
                    return
                end
                if self._cd > 0 then
                    -- -- 强攻
                    self:goMatrix(true)
                else
                    self:goMatrix(false)
                end
            else
                zc.tipInfo(zc.lang("tips_worldboss_unopen"))
            end
    	end
	})
	background:addChild( attack )
    self._attack = attack

    -- 强攻花费
    local consumeSp = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
    background:addChild( consumeSp )
    self._consumeSp = consumeSp
    local consumeNum = zc.createLabel({
        text = self._price,
        color = zc.COLOR_YELLOW,
        outLine = true,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( consumeSp:getContentSize().width + 10, consumeSp:getContentSize().height/2 ),
    })
    consumeSp:addChild( consumeNum )
    self._consumeNum = consumeNum
    consumeSp:setPosition( attack:getPositionX() - consumeNum:getContentSize().width/2, attack:getPositionY() + 40 )
    -- 倒计时
    local stormTimer = zc.createLabel({
        color = zc.COLOR_RED,
        fontSize = 18,
        pos = cc.p( attack:getPositionX(), attack:getPositionY() - 40 ),
        outLine = true,
        pixel = 2,
    })
    background:addChild( stormTimer )
    self._stormTimer = stormTimer

    -- 状态
    if self._status then
        -- 已突破
        pass:setVisible( true )
        lock:setVisible( false )
        attack:setEnable( false )
    elseif self._unlock then
        -- 已解锁
        pass:setVisible(  self._hp == 0 )
        lock:setVisible( false )
        attack:setEnable( true )
    else
        -- 未解锁
        pass:setVisible( false )
        lock:setVisible( true )
        attack:setEnable( false )
    end
end

-- 倒计时相关
function WorldBossInfoPop:startTimer()
    self:stopTimer()
    self._timer = scheduler.scheduleGlobal(function()
        self:tick()
    end, 1)
    self:tick()
end
function WorldBossInfoPop:tick()
    if self._cd <= 0 then
        self:stopTimer()
        self._consumeSp:setVisible( false )
        self._attack:setText( LANGUAGE_ARENA.attack )
        self._stormTimer:setVisible( false )
    else
        self._cd = self._cd - 1
        self._attack:setText( zc.lang("force_attact") )
        self._stormTimer:setText( zc.getTimeHMS( self._cd ) )
    end
end
function WorldBossInfoPop:stopTimer()
    if self._timer then
        scheduler.unscheduleGlobal( self._timer )
        self._timer = nil
    end
end

function WorldBossInfoPop:onCleanup()
    self:stopTimer()
end

function WorldBossInfoPop:goMatrix(_isForce) --_isForce 是否强攻
    local enemyData = {}
    enemyData.enemys = {}
    for i = 1, 9 do 
        local enemyId = tonumber(self._bossData["location"..i])
        if enemyId ~= 0 then
            enemyData["enemys"][i] = gameData.getDataFromCacheWithPrimaryKey("bossPve_npc", enemyId)
        else
            enemyData["enemys"][i] = {}
        end
    end
    local dataInfo = {
        battleType = BattleType.WorldBoss,
        enemys = enemyData,
        tollgateId = self._bossData.tollgateId,
        isForce = _isForce,
    }
    self:hide()
    zc.createMatrixBattle( dataInfo )
end

return WorldBossInfoPop