--[[
    FileName: CreateRoleLayer.lua
    Author: andong
    Date: 2016-05-04
    Purpose: 创建角色界面
]]
local CreateRoleLayer = class( "CreateRoleLayer", function ()
    return ZCDialog:create()
end)

function CreateRoleLayer:create(parmas)
    return CreateRoleLayer.new(parmas)
end

function CreateRoleLayer:onEnter()
    zc.preloadMainCity(self)
end

function CreateRoleLayer:ctor(parmas)
    -- dump(parmas, "parmas=====")

    self:initData(parmas)
    self:initUI()
end

function CreateRoleLayer:initData(parmas)
    math.randomseed(os.time())
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self._parmas = parmas
    self._ACTIONS = {"atk","atk0","atk3"}
    self._weapName = LANGUAGE_get_weapon_type_name()
    self.actionIndex = 1
    self._role = 1--人物 1男 2女
    --主角开启状态 
    self._openRole = {
        [1] = {[1]=true,[2]=true,[3]=false},
        [2] = {[1]=true,[2]=true,[3]=false},
    }
    self._openState = {[1]=1,[2]=1}
    --主角大图
    self._roleInfo = {
        [1] = {[1]="101",[2]="103",[3]="101"}, -- 1男
        [2] = {[1]="104",[2]="102",[3]="102"}, -- 2女
    }
    --动作
    self._roleConfig = {
        [1]={
            [1]="nanzhu",[2]="nanzhu_shan",[3]="",
        },
        [2]={
            [1]="nvzhuqiang",[2]="nvzhujue",[3]="",
        }
    }
    -- for i = 1, 2 dof
    --     zc.battle.createHeroArmatureWithResId(config[i])
    -- end
end
function CreateRoleLayer:initUI()
    local background = cc.Sprite:create("res/Main/selectrole/select_bg.jpg")
    background:setPosition(cc.p(zc.width/2, zc.height/2))
    self:addChild(background)
    zc.setBgSize(background)

    local scaleSize = cc.size(zc.width, 700)
    -- local bgSp = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
    local bgSp = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
    -- local bgSp = zc.createSprite()
    -- bgSp:setContentSize(cc.size(zc.width, 700))
    bgSp:setPosition(zc.width/2, zc.height/2)
    self:addChild(bgSp, 1)
    self._bgSp = bgSp
    self._bgSize = cc.size(zc.width, 700)

    --
    --用户名  
    local accountBg = zc.createImageView({
        src = "res/Main/selectrole/edit_box.png",
        pos = cc.p(scaleSize.width/2, 80), 
    })
    bgSp:addChild(accountBg, 11)
    local accountMore = zc.createImageView({
        src = "res/Main/selectrole/selectrole_random.png",
        pos = cc.p(accountBg:getContentSize().width, accountBg:getContentSize().height/2),
        touchScale = 0.9,
        listener = function () 
            self._accountBox:setText("")
            self._accountBox:setText(self:getRandomName())
        end
    })
    accountBg:addChild(accountMore)
    local accountBoxSize = cc.size(accountBg:getContentSize().width * 0.7, accountBg:getContentSize().height/4*3)
    local accountBox = ccui.EditBox:create(accountBoxSize, ccui.Scale9Sprite:create("res/Main/common/img_empty.png"))
    accountBox:setFontSize(35)
    accountBox:setAnchorPoint(0, 0.5)
    accountBox:setText(self:getRandomName())
    accountBox:setMaxLength(7) --最多7个字
    accountBox:setPosition(0, accountBg:getContentSize().height/2+3)
    accountBox:setFontColor(display.COLOR_WHITE)
    accountBox:setPlaceholderFont(zc.getFont(1), 22 )
    accountBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE ) 
    accountBox:setInputMode(cc.EDITBOX_INPUT_MODE_ANY)
    accountBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)

    accountBg:addChild(accountBox)
    self._accountBox = accountBox

    self:createBaseInfo()

    self:createFirstTab()

end
function CreateRoleLayer:createFirstTab()
    local bgSp = self._bgSp
    local bgSize = self._bgSize
    local tabBg = zc.createSprite("res/Main/selectrole/gender_bg.png")
    tabBg:setAnchorPoint(0.5, 0.5)
    tabBg:setPosition(170, 107)
    bgSp:addChild(tabBg, 1)
    self._buttonPath = {
        [1] = {
            u = "res/Main/selectrole/boy_up.png",
            d = "res/Main/selectrole/boy_down.png",
        },
        [2] = {
            u = "res/Main/selectrole/girl_up.png",
            d = "res/Main/selectrole/girl_down.png",
        }
    } 
    for i = 1, 2 do
        local touchBtn = zc.createPushButton({
            normalFile = self._buttonPath[i].u,
            selectedFile = self._buttonPath[i].u,
            needSwallow = false,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(92+(i-1)*81, 53),
            endCallback = function() end,
        })
        touchBtn:setCascadeOpacityEnabled(true)
        tabBg:addChild(touchBtn)
        touchBtn:setTag(i)
        touchBtn:setTouchEndedCall(function()
            self:changeFirstTab(touchBtn)
        end)
        touchBtn:setOpacity(255*0.6)
        if i == self._role then
            self:changeFirstTab(touchBtn)
        end
    end
end
function CreateRoleLayer:changeFirstTab(_node)
    local btnPath = self._buttonPath
    local function getNormal(_tag)
        return zc.createSprite(btnPath[_tag].u)
    end
    local function getSelected(_tag)
        return zc.createSprite(btnPath[_tag].d)
    end
    if not self._firstBtn or self._firstBtn ~= _node then
        local _tag = _node:getTag()
        print("_tag -----> ", _tag)
        if not self._firstBtn then
            self._firstBtn = _node
            self._firstBtn:setStateNormal(getSelected(_tag))
            self._firstBtn:setStateSelected(getSelected(_tag))
            self._firstBtn:setOpacity(255)

        else
            self._firstBtn:setStateNormal(getNormal(self._role))
            self._firstBtn:setStateSelected(getNormal(self._role))
            self._firstBtn:setOpacity(255*0.6)
            self._firstBtn = _node
            self._firstBtn:setStateNormal(getSelected(_tag))
            self._firstBtn:setStateSelected(getSelected(_tag))
            self._firstBtn:setOpacity(255)
        end
        self._role = _tag

        self._secondBtn = nil
        self._buttonList = {}
        --createSecondTab
        self:createSecondTab(_tag)

        self:playOpenAnimate()
    end
end
--展开动画
function CreateRoleLayer:playOpenAnimate()
    self._icon_scale = 1.0
    local idx = 0
    for k,v in pairs(self._buttonList) do
        v:setEnable(false)
        local op = v.biankuang:getOpacity()
        local vis      = cc.CallFunc:create(function() 
            v:setVisible(true)
            v:setScale(0.1)
            v.biankuang:setOpacity(0)
            if v.biankuang.content then
                v.biankuang.content:setOpacity(0)
            end
        end )
        local fade     = cc.Spawn:create(
            cc.CallFunc:create(function() v.biankuang:runAction(cc.Sequence:create(cc.FadeTo:create(0.2, op))) end),
            cc.CallFunc:create(function() 
                if v.biankuang.content then
                    v.biankuang.content:runAction(cc.Sequence:create(cc.FadeTo:create(0.2, op)))
                end 
            end)
        )
        local _scale_1 = cc.ScaleTo:create(0.1, 0.8*self._icon_scale)
        local _scale_2 = cc.ScaleTo:create(0.06, 1.2*self._icon_scale)
        local _scale_3 = cc.ScaleTo:create(0.06, 1.0*self._icon_scale)
        local _enable = cc.CallFunc:create(function() v:setEnable(true) end)
        local deTime = 0
        if idx == 2 then
            deTime = 0.13
        elseif idx == 3 then
            deTime = 0.15
        end
        -- deTime = deTime + idx * 1.5
        local _delayTime = cc.DelayTime:create(deTime)
        idx = idx + 1
        v:runAction(cc.Sequence:create(_delayTime, vis,cc.Spawn:create(fade, cc.Sequence:create(_scale_1,_scale_2,_scale_3,_enable))))
    end
end
function CreateRoleLayer:createSecondTab(_role)
    if not self._selectRoleBg then
        local scaleSize = cc.size(389, 488)
        -- local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
        local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
        myScale9:setAnchorPoint(cc.p(0, 0))
        myScale9:setPosition(cc.p(0, 150))
        self._bgSp:addChild(myScale9, 10)
        self._selectRoleBg = myScale9
    else
        self._selectRoleBg:removeAllChildren()
    end
    local srBg = self._selectRoleBg
    local srSize = self._selectRoleBg:getContentSize()

    local weapon = {
        [1] = "res/Main/selectrole/w_qiang.png",
        [2] = "res/Main/selectrole/w_shan.png",
        [3] = "res/Main/selectrole/w_jian.png",
    }
    -- local weaponPos = {
    --     [1] = cc.p(),
    --     [2] = cc.p(),
    --     [3] = cc.p(),
    -- }
    local qidaiPath = {
        [1] = "res/Main/selectrole/qidai_boy.png",
        [2] = "res/Main/selectrole/qidai_girl.png",
    }
    local no_heroPath = {
        [1] = "res/Main/selectrole/no_hero_boy.png",
        [2] = "res/Main/selectrole/no_hero_girl.png",
    }
    local biankuangPath = {
        [1] = "res/Main/selectrole/xuan_boy.png",
        [2] = "res/Main/selectrole/xuan_girl.png"
    }
    local roleImgTa = self._roleInfo[tonumber(_role)]
    for i = 1, 3 do
        local rolePath = "res/Main/hero/body/"..roleImgTa[i]..".png"
        local posX = i == 2 and 271 or 145
        local posY = srSize.height - (203/2) - (i-1)*135
        
        local biankuang = zc.createSprite(biankuangPath[_role])

        local arrow = zc.createSprite("res/Main/selectrole/word_bg.png")
        arrow:setAnchorPoint(0.5, 0.5)
        arrow:setPosition(biankuang:getContentSize().width/2, 35)
        biankuang:addChild(arrow, 10)

        local w_normal = zc.createSprite(weapon[i])
        w_normal:setAnchorPoint(0.5, 0.5)
        w_normal:setPosition(biankuang:getContentSize().width/2, 51)
        biankuang:addChild(w_normal, 10)

        if i == 2 then
            arrow:setRotation(90)
            arrow:setPosition(45, biankuang:getContentSize().height/2)
            w_normal:setPosition(55, biankuang:getContentSize().height/2)
        elseif i == 3 then
            arrow:setRotation(180)
            arrow:setPosition(biankuang:getContentSize().width/2, biankuang:getContentSize().height-35)
            w_normal:setPosition(biankuang:getContentSize().width/2, biankuang:getContentSize().height-35)
        end

        if self._openRole[_role][i] then
            local pic = cc.ClippingNode:create()
            pic:setInverted(false)
            pic:setAlphaThreshold(0.5)
            local template = zc.createSprite("res/Main/selectrole/role_bg.png")--模板
            -- local template = zc.createSprite("res/Main/common/img_empty.png")--模板
            -- local template = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(190, 190))
            template:setScale(223/245)
            pic:setStencil(template)
            local content = zc.createSprite(rolePath)--底板
            content:setScale(0.5)
            content:setPositionY(content:getPositionY()-30)
            pic:addChild(content)
            pic:setPosition(biankuang:getContentSize().width/2, biankuang:getContentSize().height/2-2)
            biankuang:addChild(pic)
            biankuang.content = content
            
        else
            local qidai = zc.createSprite(qidaiPath[_role])
            qidai:setAnchorPoint(0.5, 0.5)
            qidai:setPosition(biankuang:getContentSize().width/2, biankuang:getContentSize().height/2)
            biankuang:addChild(qidai)
            local no_hero = zc.createSprite( no_heroPath[_role] )
            no_hero:setAnchorPoint(0.5, 0.5)
            no_hero:setPosition(biankuang:getContentSize().width/2, biankuang:getContentSize().height/2)
            biankuang:addChild(no_hero)

        end

        local heroBtn = zc.createPushButton({
            normalNode = biankuang,
            needSwallow = false,
            anchor = cc.p(0.5, 0.5),
            pos = cc.p(posX, posY),
            touchSize = cc.size(120, 120),
            endCallback = function() end,
        })
        srBg:addChild(heroBtn)
        biankuang:setCascadeOpacityEnabled(true)
        biankuang:setOpacity(255*0.5)
        heroBtn.biankuang = biankuang

        heroBtn:setTouchEndedCall(function()
            if self._openRole[_role][i] then 
                self:changeSecondTab(heroBtn, _role, i)
            else
                zc.tipInfo(zc.lang("tips_unopen_fornow"))
            end
        end)

        -- if self._openRole[_role][i] then 
        --     self:changeSecondTab(heroBtn, _role, i)
        -- end
        if i == self._openState[tonumber(_role)] then
            self:changeSecondTab(heroBtn, _role, i)
        end
        heroBtn:setVisible(false)
        table.insert(self._buttonList,heroBtn)
    end
end
function CreateRoleLayer:changeSecondTab(_node, _role, tag)
    local biankuangPath = {
        [1] = "res/Main/selectrole/xuan_boy.png",
        [2] = "res/Main/selectrole/xuan_girl.png"
    }
    if not self._secondBtn or self._secondBtn ~= _node then
        if not self._secondBtn then
            self._secondBtn = _node
            self._secondBtn.biankuang:setTexture("res/Main/selectrole/selected.png")
            self._secondBtn.biankuang:setOpacity(255)
            self._secondBtn.biankuang.content:setOpacity(255)
        else
            self._secondBtn.biankuang:setTexture(biankuangPath[_role])
            self._secondBtn.biankuang:setOpacity(255*0.5)
            self._secondBtn.biankuang.content:setOpacity(255*0.5)
            self._secondBtn = _node
            self._secondBtn.biankuang:setTexture("res/Main/selectrole/selected.png")
            self._secondBtn.biankuang:setOpacity(255)
            self._secondBtn.biankuang.content:setOpacity(255)
        end
        local roleName = self._roleInfo[_role][tag]
        self:createHeroInfo(_role, roleName, tag)

    end
end

--创建英雄信息
function CreateRoleLayer:createHeroInfo(_role, roleName, tag)
    --英雄图片
    local bodyPath = "res/Main/hero/body/"..roleName..".png"
    if not zc.checkFileExist(bodyPath) then
        bodyPath = "res/Main/hero/body/101.png"
    end

    local bgSp = self._bgSp
    local bgSize = self._bgSize
    
    if not self._roleImg then
        local roleImg = zc.createSprite(bodyPath)
        roleImg:setAnchorPoint(0.5, 0.5)
        roleImg:setPosition(bgSize.width/2-30, bgSize.height/2 + 20)
        bgSp:addChild(roleImg)
        roleImg:setOpacity(0)
        roleImg:runAction(cc.Sequence:create(cc.FadeIn:create(0.5)))
        self._roleImg = roleImg
    else
        self._roleImg:runAction(cc.Sequence:create(
            cc.FadeOut:create(0.3),
            cc.CallFunc:create(function() 
                self._roleImg:setTexture(bodyPath)
                if tonumber(roleName) == 104 then
                    self._roleImg:setPositionY(bgSize.height/2 - 10)
                else
                    self._roleImg:setPositionY(bgSize.height/2 + 20)
                end
            end ),
            cc.FadeIn:create(0.5)
        ))
    end

    --技能信息
    if not self._infoBg then
        local infoBg = zc.createSprite("res/Main/selectrole/infoBg.png")
        infoBg:setAnchorPoint(0.5, 0.5)
        infoBg:setPosition(bgSize.width - 13 - 135, bgSize.height/2)
        bgSp:addChild(infoBg)
        self._infoBg = infoBg

        local heightTa = {[1]=123, [2]=126, [3]=197}
        for i = 1,3 do
            local scaleSize = cc.size(infoBg:getContentSize().width-15, heightTa[i])
            local myScale9 = zc.getScaleNode("res/Main/selectrole/info_bg2.png", scaleSize)
            myScale9:setAnchorPoint(cc.p(0.5, 1))
            local posY = infoBg:getContentSize().height-10 
            if i == 2 then
                posY = posY - heightTa[1]-2
            elseif i == 3 then
                posY = posY - heightTa[2] - heightTa[1] - 4
            end
            myScale9:setPosition(cc.p(infoBg:getContentSize().width/2, posY ))
            infoBg:addChild(myScale9)
            myScale9:setOpacity(100)
            myScale9:setName("myScale9"..i)
        end
    end

    local function createNameAndF(_node, path)
        local f_name = zc.createSprite(path)
        f_name:setPosition(_node:getContentSize().width/2, _node:getContentSize().height-21)
        _node:addChild(f_name)
        local f_l = zc.createSprite("res/Main/selectrole/w_name_f_l.png")
        f_l:setAnchorPoint(1, 0.5)
        f_l:setPosition(0, f_name:getContentSize().height/2)
        f_name:addChild(f_l)
        local f_r = zc.createSprite("res/Main/selectrole/w_name_f_r.png")
        f_r:setAnchorPoint(0, 0.5)
        f_r:setPosition(f_name:getContentSize().width, f_name:getContentSize().height/2)
        f_name:addChild(f_r)
        f_r:setFlippedY(true)
    end

    for i = 1, 3 do
        
        local infoScale = self._infoBg:getChildByName("myScale9"..i)
        infoScale:removeAllChildren()
        local userData = gameData.getDataFromCacheWithPrimaryKey("user", _role)

        if i == 1 then
            createNameAndF(infoScale, "res/Main/selectrole/w_name_wuqi.png")
            
            local weapId = userData["weaponId"..tag]
            local weapInfo = gameData.getDataFromCacheWithPrimaryKey("weapon", weapId)
            
            local wuqiType = zc.createLabel({
                text = zc.lang("weapon_type") .. "：" .. self._weapName[weapInfo["type"] or 1],
                outLine = true,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(13, infoScale:getContentSize().height/2),
                color = display.COLOR_BTNFONTYELLOW,
                color2 = display.COLOR_BLACK,
                align = kCCTextAlignmentCenter,
                pixel = 1.3
            })
            infoScale:addChild(wuqiType)

            local attackType = "" 
            if weapInfo and tonumber(weapInfo.heroType) == 1 then 
                attackType = zc.lang("physics_attack_1")
            else
                attackType = zc.lang("strategy_attack_1")
            end
            local attackTeyp = zc.createLabel({
                text = zc.lang("attack_type") .. "：" .. attackType,
                outLine = true,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(13, infoScale:getContentSize().height/2 - 35),
                color = display.COLOR_BTNFONTYELLOW,
                color2 = display.COLOR_BLACK,
                align = kCCTextAlignmentCenter,
                pixel = 1.3
            })
            infoScale:addChild(attackTeyp)
        elseif i == 2 then
            createNameAndF(infoScale, "res/Main/selectrole/w_name_jineng.png")
            local userData = gameData.getDataFromCacheWithPrimaryKey("user", _role)
             --随机技能
            local weapon_skillDB = gameData.getDataFromCache("weapon_skill", {weaponId = userData["weaponId"..tag]})
            if weapon_skillDB and weapon_skillDB["skillId"] then
                local skillcontent = ""
                local _weapon_skill = nil
                if weapon_skillDB.skillId then
                    _weapon_skill = weapon_skillDB.skillId
                else
                    _weapon_skill = weapon_skillDB[1]["skillId"]
                end
                local skillitem = zc.createIconByData({
                    data = {
                        mainType = zc.mainTypeSkill,
                        type = 1, 
                        id = _weapon_skill,
                    },
                    sexId = _role,
                    pos = cc.p(infoScale:getContentSize().width/2, 40), 
                    listener = function ()
                        zc.createSkillInfoPop({id=_weapon_skill,sexId=_role})
                    end
                })
                infoScale:addChild(skillitem)
                skillitem:setScale(0.7)
            end
        else
            local smallBg = zc.createSprite("res/Main/selectrole/smallRole_bg.png")
            smallBg:setPosition(infoScale:getContentSize().width/2, infoScale:getContentSize().height/2)
            infoScale:addChild(smallBg)
            -- 动画
            local armature = zc.createArmature({
                -- fileName = roleName == "101" and "nanzhu" or "nvzhujue",
                fileName = self._roleConfig[tonumber(_role)][tag],
                autoRemove = false,
                actName = "idle",
                loop = true,
                eventCallback = function() end,
            })
            -- armature:setAnchorPoint( 0.5, 0.5 )
            armature:setPosition( cc.p(smallBg:getPositionX(), smallBg:getPositionY()-50) )
            infoScale:addChild(armature)
            zc.soldierChangeWeapon(armature, userData["weaponId"..tag])
            -- if _role == 1 then
            --     armature:setPositionY(smallBg:getPositionY() - 20)
            -- end
            -- 按钮
            local heroBtn = zc.createPushButton({
                touchSize = cc.size( 200, 190 ),
                pos = cc.p(  smallBg:getPositionX(), smallBg:getPositionY() ),
                endCallback = function()
                    local _action = zc.random(1, 3)
                    if self._action and self._action == _action then
                        if _action < 3 then
                            _action = _action + 1
                        else 
                           _action = 1 
                        end
                    end
                    self._action = _action
                    local _actions = {"atk3", "atk", "atk0"}
                    armature:getAnimation():play( _actions[_action], -1, 0 )
                    armature:getAnimation():setMovementEventCallFunc(function(armature, movementType, movementID)
                        if 1 == tonumber(movementType) then
                            armature:getAnimation():play("idle", -1, 1)
                        end
                    end)
                end
            })
            infoScale:addChild( heroBtn )
        end
    end

    if not self._createBtn then
        local createBtn = zc.createPushButton({
            normalFile = "res/Main/selectrole/create_up.png",
            selectedFile = "res/Main/selectrole/create_down.png",
            needSwallow = false,
            pos = cc.p(self._infoBg:getPositionX(), 100),
            endCallback = function() end,
        })
        bgSp:addChild(createBtn)
        self._createBtn = createBtn
    end
    self._createBtn:setTouchEndedCall(function()
        --创建
        self:regFunc(_role, tag)
    end)


end

function CreateRoleLayer:createBaseInfo()
    local arrow_up = zc.createSprite("res/Main/selectrole/bg_up.png")
    arrow_up:setAnchorPoint(0, 1)
    arrow_up:setPosition(0, zc.height)
    self:addChild(arrow_up)

    local arrow_down = zc.createSprite("res/Main/selectrole/bg_down.png")
    arrow_down:setAnchorPoint(1, 0)
    arrow_down:setPosition(zc.width, 0)
    self:addChild(arrow_down)

end
function CreateRoleLayer:regFunc(_role,_weaponIndex)
    -- print("_role        --------> ", _role)
    -- print("_weaponIndex --------> ", _weaponIndex)
    -- do return end
    local _weaponIndex = tonumber(_weaponIndex) or 1
    self._selectRole = _role
    self._selectWeapon = _weaponIndex
    zc.sendHttp({
        apiName = "User_createCharacter",
        params = {
            name = self._accountBox:getText(),
            seigniorId = _role,
            passportId = self._parmas.portId,
            passportName = "",
            weaponIndex = _weaponIndex
        },
        successCallback = function (data) 
            -- dump(data, "desciption, nesting")
            zc.doActionStatisticsEvent(StatisticsEvent.EVENT_REGISTER)
            local _createTime = data.createTime
            GAMETOKEN = data.key
            GAMEUID = data.userId
            -- zc.getScene("login"):goHome()

            zc.sendHttp({
                apiName = "User_main",
                successCallback = function (data)
                    -- local xxx = os.clock()
                    -- self:addDBConfig()--加载静态表
                    -- print("消耗的时间："..tostring(os.clock() - xxx))
                    PlayerData:setAllInfo(data)
                    PlayerData:setCreateTime(_createTime)
                    GAMEUID = PlayerData:getBaseInfo()["userId"]
                    --http 平台验证后进入游戏（与socket是否连接成功没有关系）
                    zc.createScene(LAYER_NAME_TAG.LAYER_MAINCITY ,{data = PlayerData:getHouseInfo(), newScene = true})
                    --进行socket连接--
                    -- SOCKET_LOGIN_SERVER = SOCKET_LOGIN_SERVER_EX
                    -- CHAT_SERVER_PORT = CHAT_SERVER_PORT_EX
                    initConnectNet(SOCKET_LOGIN_SERVER, CHAT_SERVER_PORT)

                    xpcall(function ( ... )
                        local args = {}
                        local sigs = nil
                        local _param_ = {
                            userid = tostring(GAMEUID)
                        }
                        local platform = cc.Application:getInstance():getTargetPlatform()
                        --此处的代码为热云sdk准备
                        if GAME_SDK == GAMESDK.SDK_ZHANYOU then
                            if (cc.PLATFORM_OS_ANDROID == platform) then
                                local param = json.encode(_param_)
                                args = {param}
                                sigs = "(Ljava/lang/String;)V"
                            elseif (cc.PLATFORM_OS_IPHONE == platform or platform == cc.PLATFORM_OS_IPAD) then
                                args = _param_
                            end
                            zc.luaBridgeCall(LUA_BRIDGE_CLASS,"createRoleCallback",args,sigs)
                        end
                    end, function ( msg )
                        print("----------------------------------------热云sdk error")
                        print("LUA ERROR: " .. tostring(msg) .. "\n")
                        print(debug.traceback())
                        print("----------------------------------------")
                    end)
                    
                end,
            })
        end,
    })
end
----------------------------------------------------------------------------------------获取随机名字

function CreateRoleLayer:getRandomName()
    local _namesInfo = LANGUAGE_get_randomNames()

    local r = math.random(1, os.time()) 
    local r1 = (r + #_namesInfo[1] - 1) % (#_namesInfo[1])+1
    local r2 = (r + #_namesInfo[2] - 1) % (#_namesInfo[2])+1
    local r3 = (r + #_namesInfo[3] - 1) % (#_namesInfo[3])+1
    
    return _namesInfo[1][r1] .. _namesInfo[2][r2] .. _namesInfo[3][r3]
end
function CreateRoleLayer:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/selectrole/select_bg.jpg")
    textureCache:removeTextureForKey("res/Main/selectrole/edit_box.png")
    textureCache:removeTextureForKey("res/Main/selectrole/selectrole_random.png")
    textureCache:removeTextureForKey("res/Main/selectrole/gender_bg.png")
    textureCache:removeTextureForKey("res/Main/selectrole/boy_up.png")
    textureCache:removeTextureForKey("res/Main/selectrole/boy_down.png")
    textureCache:removeTextureForKey("res/Main/selectrole/girl_up.png")
    textureCache:removeTextureForKey("res/Main/selectrole/girl_down.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_qiang.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_shan.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_jian.png")
    textureCache:removeTextureForKey("res/Main/selectrole/qidai_boy.png")
    textureCache:removeTextureForKey("res/Main/selectrole/qidai_girl.png")
    textureCache:removeTextureForKey("res/Main/selectrole/no_hero_boy.png")
    textureCache:removeTextureForKey("res/Main/selectrole/no_hero_girl.png")
    textureCache:removeTextureForKey("res/Main/selectrole/xuan_boy.png")
    textureCache:removeTextureForKey("res/Main/selectrole/xuan_girl.png")
    textureCache:removeTextureForKey("res/Main/selectrole/xuan_girl.png")
    textureCache:removeTextureForKey("res/Main/selectrole/word_bg.png")
    textureCache:removeTextureForKey("res/Main/selectrole/role_bg.png")
    textureCache:removeTextureForKey("res/Main/selectrole/selected.png")
    textureCache:removeTextureForKey("res/Main/selectrole/infoBg.png")
    textureCache:removeTextureForKey("res/Main/selectrole/info_bg2.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_name_f_l.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_name_f_r.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_name_wuqi.png")
    textureCache:removeTextureForKey("res/Main/selectrole/w_name_jineng.png")
    textureCache:removeTextureForKey("res/Main/selectrole/smallRole_bg.png")
    textureCache:removeTextureForKey("res/Main/selectrole/create_up.png")
    textureCache:removeTextureForKey("res/Main/selectrole/create_down.png")
    textureCache:removeTextureForKey("res/Main/selectrole/bg_up.png")
    textureCache:removeTextureForKey("res/Main/selectrole/bg_down.png")
    
    local selectrole = self._roleConfig[self._selectRole][self._selectWeapon]
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nanzhu.csb", true)
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nanzhu_shan.csb", true)
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nvzhujue.csb", true)
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo("res/image/battle/hero/nvzhuqiang.csb", true)
    
    local _callback = self._callback
    self:removeAllChildren()
    helper.collectMemory(true)
    local hero = zc.createArmature({fileName = selectrole , async = true, asyncCallback = function() end}) 
    if _callback and type(_callback) == "function" then
        _callback()
    end
end

return CreateRoleLayer