--[[
    FileName: LevyPop.lua
    Author: andong
    Date: 2016-04-27
    Purpose: 征收弹窗
]]
local LevyPop = class( "LevyPop", function ()
    return zc.createNormalDialog()
end)
function LevyPop:create(params)
    return LevyPop.new(params)
end
function LevyPop:ctor(params)
    self:initData(params)
    self:initUI()
end

function LevyPop:initData(params)
    self._houseInfo = params.houseInfo
    self._freeTimes = tonumber(params.freeTimes) or 0  --剩余免费次数
    self._startFreeTimes = self._freeTimes
    self._levyTimes = tonumber(params.arLeyvTimes) or 0 --强征总次数

    -- self._totalFree = 12 --总免费次数
    self._totalFree = tonumber(params.todayFreeTimes)
    self._profitType = 2 --收益类型（暂时为2）
    -- self._totalTimes = self._levyTimes + self._totalFree - self._freeTimes
    self._totalTimes = tonumber(params.todayLevyTimes)
    self._canLevyTimes = 0 --可征收最大次数

    self._unitPrice = tonumber(params.price) or 1--强征单价

    --收益
    self._profit = gameData.getDataFromCacheWithPrimaryKey("houseEffect_leyv", self._houseInfo["level"]) --等级与收益

    self._canLevyTimes = tonumber(self._profit["numLimit"]) --此等级的集市可征收的次数
    
    self._treasureStaus = {}
    if params.treasureStaus then
        for k,v in pairs(params.treasureStaus) do
            self._treasureStaus[tonumber(v)] = "got"
        end
    end
    self._case = {} --宝箱
    self._maxRewardLevel = 0
    local case = gameData.getAllDataWithNoClone("leyv_awards")
    local _nums = table.nums(case)
    for i = 1, _nums do
        local _caseData = case[tostring(i)]
        local idx = #self._case + 1
        self._case[idx] = {}
        self._case[idx].award = {}
        for j = 1, 10 do
            local reId = _caseData["treasureId"..j]
            if reId then
                local reward = gameData.getDataFromCacheWithPrimaryKey("treasure", reId) --宝箱1的奖励要乘建筑等级(展示用)
                self._case[idx].award[j] = reward
                self._case[idx].xiangziId = reward["iconId"]
            else
                break
            end
        end
        self._case[idx].id = _caseData["id"]
        self._case[idx].times = _caseData["times"]
        self._case[idx].status = 0 --0不可领取 1可领取 2已经领取 
        if self._treasureStaus[tonumber(_caseData["id"])] then --已经领取
            self._case[idx].status = 2
        else
            if self._totalTimes >= tonumber(_caseData["times"]) then
                self._case[idx].status = 1
            end
        end
        if tonumber(_caseData["times"]) > self._maxRewardLevel then
            self._maxRewardLevel = tonumber(_caseData["times"])
        end
    end
end

function LevyPop:getprite()
    --征收次数花费列表
    if not self._timesPrice then
        self._timesPrice = gameData.getDataFromCache("consume_price", {["type"]=33} )
    end
    local price1 = 0
    local price10 = 0
    for i = 1, 10 do
        local v = self._timesPrice[self._levyTimes+i]
        if not v or not v.price then
            v = self._timesPrice[#self._timesPrice]
        end
        if i == 1 then
            price1 = v["price"]
        end
        price10 = price10 + v["price"]
    end
    return price1, price10
end
function LevyPop:initUI()
    local bg_up = zc.createSprite("res/Main/levy/bg_up_1.jpg")
    bg_up:setAnchorPoint(0.5, 0)
    -- bg_up:setPosition(zc.width/2, zc.height/2+649/2-462/2)
    self._justY = 50
    bg_up:setPosition(zc.width/2, 187-self._justY)
    self:addChild(bg_up, -1)
    self._baseScale = (zc.height-100)/502
    bg_up:setScale(self._baseScale)
    self._bg_up = bg_up
    local bg_down = zc.createSprite("res/Main/levy/bg_down.jpg")
    bg_down:setAnchorPoint(0.5, 0)
    -- bg_down:setPosition(zc.width/2, zc.height/2 - 649/2+187/2)
    bg_down:setPosition(zc.width/2, 0)
    self:addChild(bg_down, 2)

    local popSize = cc.size(zc.width, 649)
    local popBg = zc.createSprite()
    popBg:setContentSize( popSize )
    popBg:setAnchorPoint(0.5, 0)
    popBg:setPosition(zc.width/2, 0)
    self:addChild(popBg, 5)

    local popSize = popBg:getContentSize()
    self._popBg = popBg
    self._popSize = popSize
    self._closeBtn:setTouchEndedCall(function()
        local _currentGID = getGuideManager():getCurrentGID()
        if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then
            zc.setGuideFuncNextStep(_currentGID)
        end
        LayerManager.removeLayout()
    end)

    self:createButton()
    self:createBaseInfo()
end
function LevyPop:createButton()
    local popBg = self._popBg
    local popSize = self._popSize

    local icon_path = {
        [1] = {src_up="res/Main/levy/icon_money_up.png",src_down="res/Main/levy/icon_money_down.png",name=LANGUAGE_getReousrceNameById(zc.dataTypeMoney)},
        [2] = {src_up="res/Main/levy/icon_wood_up.png",src_down="res/Main/levy/icon_wood_down.png",name=LANGUAGE_getReousrceNameById(zc.dataTypeWood)},
        [3] = {src_up="res/Main/levy/icon_orn_up.png",src_down="res/Main/levy/icon_orn_down.png",name=LANGUAGE_getReousrceNameById(zc.dataMineral)},
    }
    for i = 1, #icon_path do
        local _normal = zc.createSprite(icon_path[i].src_up)
        local _select = zc.createSprite(icon_path[i].src_down)
        local icon_button
        icon_button = zc.createPushButton({
            normalNode = _normal,
            selectedNode = _select,
            needSwallow = true,
            endCallback = function()
                self:changeButton(icon_button)
            end,
            pos =cc.p(popSize.width - 340 + (i-1)*125, 184)
        })
        popBg:addChild(icon_button)
        icon_button:setTag(i)
        if i == 1 then
            icon_button:setSelected(true)
            self._selectedBtn = icon_button
            self:createLiziSpine(icon_button)
        end

        local icon_name_bg = zc.createSprite("res/Main/levy/icon_name_bg.png")
        icon_name_bg:setAnchorPoint(0.5, 0.5)
        icon_name_bg:setPosition(150/2+15, 20)
        icon_button:addChild(icon_name_bg, 1)
        local myLab = zc.createLabel({
            text = icon_path[i].name,
            fontSize = 22,
            outLine = true,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(icon_name_bg:getContentSize().width/2-20, icon_name_bg:getContentSize().height/2),
            color = cc.c3b(230,224,163),
        })
        icon_name_bg:addChild(myLab)
    end
end

function LevyPop:changeButton(_node)
    if not self._selectedBtn or self._selectedBtn ~= _node then
        -- LayerManager.addShieldLayout(nil, 0.5)
        if not self._selectedBtn then

        else
            self._selectedBtn:setSelected(false)
            self._selectedBtn = _node
            self._selectedBtn:setSelected(true)
        end
        local _tag = _node:getTag()
        local _path = "res/Main/levy/bg_up_".._tag..".jpg"
        self._bg_up:stopAllActions()
        self._bg_up:setPosition(zc.width/2, 187-self._justY)
        
        if not tolua.isnull(self._actionSp) then
            self._actionSp:setVisible(false)
        end
        if _tag == 1 or _tag == 3 then
            self._bg_up:setTexture(_path)

            local _actionSp = zc.createSprite(_path)
            _actionSp:setAnchorPoint(0.5,0)
            _actionSp:setPosition(zc.width/2, 187 - self._justY)
            self:addChild(_actionSp, -1)
            _actionSp:setOpacity(255*0.8)
            _actionSp:setScale(self._baseScale+0.6)
            _actionSp:runAction(cc.Sequence:create(
                cc.Spawn:create(
                    cc.FadeOut:create(0.2),
                    cc.ScaleTo:create(0.2,self._baseScale)),
                cc.CallFunc:create(function()
                    self._bg_up:runAction(CCShake:create(0.3, 30))
                end),
                cc.RemoveSelf:create(true)))
            self._actionSp = _actionSp
        elseif _tag == 2 then
            local _actionSp = zc.createSprite(_path)
            _actionSp:setAnchorPoint(0.5,0)
            _actionSp:setPosition(zc.width/2, 187 - self._justY + zc.height)
            self:addChild(_actionSp, -1)
            _actionSp:setOpacity(255*1)
            _actionSp:setScale(self._baseScale)

            _actionSp:runAction(cc.Sequence:create(
                cc.MoveBy:create(0.08,cc.p(0,-zc.height-40)),
                cc.MoveBy:create(0.08,cc.p(0,80)),
                cc.MoveBy:create(0.08,cc.p(0,-60)),
                cc.MoveBy:create(0.09,cc.p(0,30)),
                cc.MoveBy:create(0.09,cc.p(0,-10)),
                cc.CallFunc:create(function() 
                    self._bg_up:setTexture(_path)
                end),
                cc.RemoveSelf:create(true)
            ))
            self._actionSp = _actionSp
        end
        

        self:createLiziSpine(_node)
        self._tag = _tag
        self:refreshState()
    end
end
function LevyPop:createLiziSpine(_node)
    if self._liziSpine then
        self._liziSpine:removeFromParent()
    end
    local _liziSpine = zc.createSpine({
        fileName = "speedsudu",
        actName = "animation",
        loop = true,
        needInit = false,
    })
    _liziSpine:setPosition(_node:getPositionX(),_node:getPositionY())
    _liziSpine:setScale(0.65)
    self._popBg:addChild(_liziSpine, -1)
    self._liziSpine = _liziSpine
end
function LevyPop:refreshState()

    local consumeIcon = self._consumeIcon
    local starNumLab = self._starNumLab

    starNumLab:setString("+"..(self._profit["awards"..self._tag] or 0 ))

    local _type = {[1]=2,[2]=9,[3]=10}
    consumeIcon:setTexture(zc.getImgByType(_type[self._tag]))
    consumeIcon:setPositionX(starNumLab:getPositionX()-starNumLab:getContentSize().width - 40)
end
function LevyPop:createBaseInfo()
    local popBg = self._popBg
    local popSize = self._popSize

    local infoBg = popBg
    local infoSize = infoBg:getContentSize()
    local duihua = zc.createSprite("res/Main/levy/kuang.png")
    duihua:setPosition(743, 538)
    self:addChild(duihua)
    local totalLab = zc.createLabel({
        text = zc.lang("today_have_levy"),
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(duihua:getContentSize().width/2, duihua:getContentSize().height/2+15),
        color = display.COLOR_BLACK,
    })
    duihua:addChild(totalLab)
    local totalNum = zc.createLabel({
        text = self._totalTimes.. zc.lang("ci"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(duihua:getContentSize().width/2, duihua:getContentSize().height/2-15),
        color = display.COLOR_GREEN,
    })
    duihua:addChild(totalNum)
    self._totalNum = totalNum
    

    local progressBg = cc.Sprite:create("res/Main/levy/timebarBg.png")
    progressBg:setAnchorPoint(cc.p(0.5,0.5))
    progressBg:setPosition(cc.p(379+50-50, 34))
    infoBg:addChild(progressBg)
    local progressBar = cc.ProgressTimer:create(cc.Sprite:create("res/Main/levy/timebar.png"))
    progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    progressBar:setMidpoint(cc.p(0, 1))
    progressBar:setBarChangeRate(cc.p(1, 0))
    progressBar:setAnchorPoint(cc.p(0.5,0.5))
    progressBar:setPosition(cc.p(progressBg:getContentSize().width/2,progressBg:getContentSize().height/2))
    progressBg:addChild(progressBar)
    --
    --test
    -- self._maxRewardLevel = 70
    
    progressBar:setPercentage(tonumber(self._totalTimes)/tonumber(self._maxRewardLevel) * 100)
    -- progressBar:setPercentage(20)
    
    self._progressBar = progressBar
    local timesColor = {[1]=display.COLOR_WHITE,[2]=display.COLOR_WHITE,[3]=display.COLOR_GOLD}
    -- local dis = 608/#self._case
    local dis = 608/(self._maxRewardLevel/10)
    for i = 1, #self._case do

        local boxbg = zc.createSprite("res/Main/levy/box_bg.png")
        boxbg:setAnchorPoint(0.5, 0.5)
        boxbg:setPosition(121-50+dis+dis*((tonumber(self._case[i]["times"])/10)-1) - (i==#self._case and 6 or 0), 103)
        infoBg:addChild(boxbg)
        boxbg:setScale(0.9)
        
        local boxBtn = zc.createPushButton({
            touchSize = cc.size(100, 100),
            needSwallow = false,
            endCallback = function()
            end,
            pos =cc.p(boxbg:getContentSize().width/2, boxbg:getContentSize().height/2)
        })
        boxbg:addChild(boxBtn)

        local armature = zc.createSpine({
            fileName = "missionbox",
            needInit = false,
        })
        armature:setPosition(boxBtn:getContentSize().width/2, boxBtn:getContentSize().height/2)
        boxBtn:addChild(armature)
        self._case[i]["armature"] = armature

        boxBtn:setTouchEndedCall(function()
            local function refresh(net_data)
                -- dump(net_data, "net_data ==== ")
                --更新已领取列表
                self._treasureStaus[tonumber(self._case[i].id)] = "got"
                self._case[i].status = 2
                -- self:showReward(2,net_data, "领取获得：")
                zc.createShowReward( net_data )
                net_data.noAnimation = true
                PlayerData:updataData( net_data )
                local amId = self._case[i]["xiangziId"]
                if amId > 4 then
                    amId = 4
                end
                armature:playAction("box"..amId.."_open", true) --已经领取
            end
            local params = {callback=refresh,info=self._case[i]}
            zc.createSourcePop("LevyReward", "src/layer/levy/LevyRewardPop.lua", params)
        end)
        
        local timesBg = zc.createSprite("res/Main/levy/times_bg.png")
        timesBg:setAnchorPoint(0.5, 0.5)
        timesBg:setPosition(boxBtn:getContentSize().width/2, -22)
        boxBtn:addChild(timesBg)
        local timesBgSize = timesBg:getContentSize()
        local _color = cc.c3b(244,180,41)
        local timesLab = zc.createLabel({
            text = self._case[i].times.. zc.lang("ci"),
            outLine = true,
            fontSize = 22,
            pos = cc.p(timesBgSize.width/2, timesBgSize.height/2),
            color = _color,
        })
        timesBg:addChild(timesLab)
    end
    self:refreshCase()

    for i = 1, 2 do
        local info_bg = zc.getScaleNode("res/Main/levy/info_bg.png", cc.size(306, 30))
        info_bg:setAnchorPoint(0, 0.5)
        info_bg:setPosition(12, 245 - (i-1)*33)
        self:addChild(info_bg, 0)
        if i == 1 then
            local danci = zc.createLabel({
                text = zc.lang("single_levy") .. "：",
                fontSize = 18,
                ap = cc.p(0, 0.5),
                pos = cc.p(8, info_bg:getContentSize().height/2),
                color = cc.c3b(222, 176, 93),
            })
            info_bg:addChild(danci)
            local starNumLab = zc.createLabel({
                text = "+"..(self._profit["awards1"]),
                outLine = true,
                fontSize = 18,
                ap = cc.p(1, 0.5),
                pos = cc.p(info_bg:getContentSize().width-10, danci:getPositionY()),
            })
            info_bg:addChild(starNumLab)
            local consumeIcon = zc.createSprite(zc.getImgByType(self._profitType))
            consumeIcon:setAnchorPoint(0, 0.5)
            consumeIcon:setPosition(starNumLab:getPositionX()-starNumLab:getContentSize().width-40, danci:getPositionY())
            info_bg:addChild(consumeIcon)
            consumeIcon:setScale(0.9)

            self._consumeIcon = consumeIcon
            self._starNumLab = starNumLab
        else
            -- (222, 176, 93)、(255, 0, 0)、(222, 176, 93)
            local tipLab = zc.createRichLabel({
                text = LANGUAGE_get_levy_tip(),
                pos = cc.p(8, info_bg:getContentSize().height/2),
                anchor = cc.p(0,0.5),
            })
            tipLab:enableStroke(display.COLOR_BLACK, 0.2)
            info_bg:addChild(tipLab)
        end
    end
    
    local freeTip = zc.createLabel({
        text = zc.lang("free") .. "：",
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(695+65, 60),
    })
    infoBg:addChild(freeTip)
    local freeNum = zc.createLabel({
        text = ""..self._freeTimes.."/"..self._totalFree,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(freeTip:getPositionX()+freeTip:getContentSize().width, freeTip:getPositionY()),
        color = display.COLOR_GREEN,
    })
    infoBg:addChild(freeNum)
    freeTip:setVisible(false)
    freeNum:setVisible(false)
    self._freeNum = freeNum
    --免费征收按钮
    -- local freePos = myScale9:convertToWorldSpace(cc.p(diSize.width-84, diSize.height/2))
    local freePos = cc.p(zc.width-191+20, freeTip:getPositionY())
    local freeLevyBtn = zc.createCommomBtn({
        tag = 1,
        needSwallow = false,
        anchor = cc.p(0.5, 0.5),
        text = zc.lang("levy_2"),
        pos = cc.p(freePos.x, freePos.y),
        endCallback = function() end,
    })
    infoBg:addChild(freeLevyBtn)

    self._freeLevyBtn = freeLevyBtn
    freeLevyBtn:setVisible(false)
    --强征按钮
    --1次
    local forcePos1 = cc.p(zc.width-266, freeTip:getPositionY())
    local forceLevyBtn1 = zc.createCommomBtn({
        tag = 1,
        needSwallow = false,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(forcePos1.x, forcePos1.y),
        endCallback = function() end,
    })
    infoBg:addChild(forceLevyBtn1)

    local price1, price10 = self:getprite()
    local onePrice = self:createForceLab(forceLevyBtn1,price1, zc.lang("force_levy_1"), 74)
    self._onePrice = onePrice
    --10次
    local forcePos10 = cc.p(zc.width-100, freeTip:getPositionY())
    local forceLevyBtn10 = zc.createCommomBtn({
        tag = 1,
        needSwallow = false,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(forcePos10.x, forcePos10.y),
        endCallback = function() end,
    })
    infoBg:addChild(forceLevyBtn10)

    local tenPrice = self:createForceLab(forceLevyBtn10,price10, zc.lang("force_levy_10"), 96)
    self._tenPrice = tenPrice
    --
    local overLab = zc.createLabel({
        text = zc.lang("tips_free_levy_times_have_over"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(1, 0.5),
        pos = cc.p(700, freeTip:getPositionY()),
    })
    infoBg:addChild(overLab)
    overLab:setVisible(false)
    
    --
    local function overTimes() --刷新总次数用完
    end
    forceLevyBtn1:setTouchEndedCall(function()
        self:levyCallback(1, overTimes)
    end)
    forceLevyBtn10:setTouchEndedCall(function()
        self:levyCallback(2, overTimes)
    end)

    forceLevyBtn1:setVisible(false)
    forceLevyBtn10:setVisible(false)
    
    --设置按钮状态
    if tonumber(self._freeTimes) > 0 then
        freeTip:setVisible(true)
        freeNum:setVisible(true)
        freeLevyBtn:setVisible(true)
        freeLevyBtn:setTouchEndedCall(function()
            local function refresh() --刷新按钮状态
                freeNum:setText(self._freeTimes.."/"..self._totalFree)
                if self._freeTimes <= 0 then
                    forceLevyBtn1:setVisible(true)
                    forceLevyBtn10:setVisible(true) 
                    LayerManager.addShieldLayout(nil, 0.3)
                    freeTip:setVisible(false)
                    freeNum:setVisible(false)
                    freeLevyBtn:setVisible(false)
                end
            end
            self:levyCallback(1, refresh)
        end)
    else
        forceLevyBtn1:setVisible(true)
        forceLevyBtn10:setVisible(true)
    end

end
--征收
function LevyPop:levyCallback( _times , callback)
    -- body
    LayerManager.addShieldLayout(nil, 0.3)

    local addNum = _times == 1 and 1 or 10
    local _id = self._tag and self._tag or 1
    print("_times -==> ", _times)
    zc.sendHttp({
        apiName = "Levy_goods",
        params = {type=_times, id = _id},
        successCallback = function(net_data)
            musicManager.playEffect(zc.effect["effLevy".._id])
            self:showReward(1, net_data, zc.lang("levy_gain") .. "：", addNum)
            if self._freeTimes then
                self._freeTimes = self._freeTimes - 1
            end
            self._totalTimes = self._totalTimes + addNum
            self._progressBar:setPercentage(tonumber(self._totalTimes)/tonumber(self._maxRewardLevel) * 100)
            self._totalNum:setText(self._totalTimes.."次")

            self._levyTimes = tonumber(net_data.arLeyvTimes)
            local price1, price10 = self:getprite()
            self._onePrice:setText( price1 )
            self._tenPrice:setText( price10 )

            if callback then
                callback()
            end
            self:refreshCase()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_6009 
              or _currentGID == GuideKey.KEY_6024
              or _currentGID == GuideKey.KEY_6025 then
                self:addGuide()
            end
        end,
    })
end
function LevyPop:refreshCase()
    --刷新箱子状态
    for i = 1, #self._case do
        local status = 0 --0不可领取 1可领取 2已经领取 
        if self._treasureStaus[tonumber(self._case[i]["id"])] then --已经领取
            status = 2
        else
            if self._totalTimes >= tonumber(self._case[i]["times"]) then
                status = 1
            end
        end
        self._case[i].status = status
        if self._case[i].armature then
            local armature = self._case[i].armature
            local amId = self._case[i]["xiangziId"]
            if amId > 4 then
                amId = 4
            end
            if status == 0 then
                armature:playAction("box"..(amId).."_lock", true) --没奖励
            elseif status == 2 then
                armature:playAction("box"..(amId).."_open", true) --已经领取
            elseif status == 1 then
                armature:playAction("box"..(amId).."_closer", true) --有可领取奖励
            end 
        end
    end
end
function LevyPop:showReward(_type, data, title, times) --_type表示征收奖励还是宝箱奖励
    if _type == 1 then
        local _showData = table.copy(data)
        local oldData = table.copy(PlayerData.resourcesInfo)
        
        -- dump(oldData, "oldData =1 ")  
        --
        data.noAnimation = true
        PlayerData:updataData( data )
        -- dump(oldData, "oldData =2 ")  

        -- local pos1 = {}
        -- local pos2 = {}
        local _fileName = "yb"
        local _action = "Animation1"
        if self._tag and self._tag ~= 1 then
            _fileName = "diaoluo"
            if self._tag == 2 then
                _action = "mucai"
            elseif self._tag == 3 then
                _action = "kuangshi"
            end
        end 
        local function showac(_t)
            local showItem = {}
            for i = 1, _t do
                local delay = math.random(1,3)*0.15
                performWithDelay(self, function()
                    local armature = zc.createAnimationArmature({
                        fileName = _fileName,
                        autoRelease = true
                    })
                    showItem[#showItem+1] = armature
                    armature:getAnimation():play(_action,-1, 0)
                    armature:setPosition( cc.p(zc.width/2-30+(i-(_t+1)/2)*220, 640/2 + 187) )
                    self:addChild( armature , 1)
                    if i == _t then
                        armature:getAnimation():setMovementEventCallFunc(function(armature, movementType, movementID)
                            print("movementType --> ", movementType)
                            if 1 == tonumber(movementType) then
                                for i=1,#showItem do
                                    showItem[i]:runAction(cc.Sequence:create(
                                        cc.FadeOut:create(0.2),
                                        cc.RemoveSelf:create(true)
                                    ))
                                end
                            end
                        end)
                    end
                end,delay)
            end
        end
        
        if times and tonumber(times) == 10 then
            showac(8)
        else
            showac(4)
        end



        ----
        local totalReward = PlayerData:getShowIconDatas(_showData)
        local reward = {}
        local ownRes = {} --已经拥有的资源
        local ownItems = {} --已经拥有的物品
        for i = 1, table.nums(totalReward) do
            local v = totalReward[i]
            local _main = tonumber(v["itemType"])
            local _itemid = tonumber(v["itemId"])
            local _target
            if _main == 1 then
                _target = ownRes
            elseif _main == 4 then
                _target = ownItems
            end
            if _target[_itemid] then --如果已经有了
                local _idx = _target[_itemid]
                if reward[_idx] and reward[_idx]["changeNum"] then
                    reward[_idx]["changeNum"] = tonumber(reward[_idx]["changeNum"]) + tonumber(v["changeNum"])
                end
            else --如果还没有
                local idx = #reward + 1
                reward[idx] = v
                _target[_itemid] = idx
            end
        end

        local bg = zc.createSprite( "res/Main/common/tipResource/bg.png" )
        bg:setCascadeOpacityEnabled( true )
        bg:setPosition( -1000, -1000 )
        self:addChild(bg, 1000)

        local myLab = zc.createLabel({
            text = zc.lang("levy_gain") .. "：",
            outLine = true,
            fontSize = 30,
            ap = cc.p(0, 0.5),
            pos = cc.p(170, bg:getContentSize().height/2),
            color = display.COLOR_GOLD,
            color2 = display.COLOR_BLACK,
            align = kCCTextAlignmentCenter,
            pixel = 1.3
        })
        bg:addChild(myLab)

        for i = 1, #reward do
            local _type = tonumber(reward[i].itemId)
            local item = zc.createSprite(zc.getImgBigByType(_type))
            item:setScale(0.8)
            item:setPosition(cc.p(350+(i-1)*300, myLab:getPositionY() ))
            bg:addChild(item)

            local numLab = zc.createLabel({
                text = "x"..reward[i].changeNum,
                outLine = true,
                fontSize = 30,
                ap = cc.p(0, 0.5),
                pos = cc.p(item:getPositionX()+item:getContentSize().width/2-20, item:getPositionY() ),
                color = display.COLOR_WHITE,
                color2 = display.COLOR_BLACK,
                align = kCCTextAlignmentCenter,
                pixel = 1.3
            })
            bg:addChild(numLab)

            if reward[i].itemType == 1 then
                local str = "(100%" .. zc.lang("earnings") .. ")"
                local strColor = display.COLOR_GOLD
                if tonumber(data["buffs"]) > 1 then
                    str = "("..(tonumber(data["buffs"])*100).."%" .. zc.lang("earnings") .. ")"
                    strColor = display.COLOR_RED
                end
                local shouyi = zc.createLabel({
                    text = str,
                    outLine = true,
                    fontSize = 24,
                    ap = cc.p(0, 0.5),
                    pos = cc.p(numLab:getPositionX()+numLab:getContentSize().width, item:getPositionY()),
                    color = strColor,
                    color2 = display.COLOR_BLACK,
                    align = kCCTextAlignmentCenter,
                    pixel = 1.3
                })
                bg:addChild(shouyi)
            end
        end
        bg:runAction(
            cc.Sequence:create(
                cc.CallFunc:create(
                    function()
                        bg:setOpacity( 255 )
                        bg:setPosition( zc.width/2, zc.height/2 )
                    end
                ),
                cc.EaseIn:create(
                    cc.MoveBy:create(0.264, cc.p(0, 45)),
                    0.264),
                cc.DelayTime:create(1.760),
                cc.Spawn:create(
                    cc.FadeOut:create(0.176),
                    cc.MoveBy:create(0.176, cc.p(0, 35))
                ),
                cc.RemoveSelf:create(true)
            )
        )
    else
        -- 刷新资源
        PlayerData:updataData( data )
    end
end


--强征按钮内部lab
function LevyPop:createForceLab(_node, consumeNum, labText, labPosX)
    local gold10 = zc.createSprite(zc.getImgByType(1))
    gold10:setAnchorPoint(0, 0.5)
    gold10:setPosition(5, _node:getContentSize().height/2)
    _node:addChild(gold10)
    local goldNum1 = zc.createLabel({
        text = consumeNum.."",
        -- shadow = true,
        -- stroke = true,
        fontSize = 18,
        ap = cc.p(0.5, 1),
        pos = cc.p(gold10:getContentSize().width/2, 18),
        color = display.COLOR_GOLD,
        color2 = display.COLOR_BLACK,
        pixel = 2,
        outLine = true
    })
    gold10:addChild(goldNum1)
    local froceLevyLab10 = zc.createLabel({
        text = labText,
        -- stroke = true,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(labPosX, _node:getContentSize().height/2),
        color = cc.c3b(255,241,121),
        color2 = cc.c3b(98,17,17),
        pixel = 2,
        outLine = true
    })
    _node:addChild(froceLevyLab10)
    return goldNum1
end

--创建背景、lab、img
function LevyPop:createBgStarAndLab(bgSrc, labPosX, labText, typeId, _num)
    local itemBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(335, 38))
    local tipLab = zc.createLabel({
        text = labText,
        fontSize = 20,
        outLine = true,
        color = cc.c3b(238, 197, 117),
        ap = cc.p(0, 0.5),
        pos = cc.p(labPosX, itemBg:getContentSize().height/2),
    })
    itemBg:addChild(tipLab)
    local consumeIcon = cc.Sprite:create(zc.getImgByType(typeId))
    consumeIcon:setAnchorPoint(0, 0.5)
    consumeIcon:setPosition(tipLab:getPositionX()+tipLab:getContentSize().width+100, tipLab:getPositionY())
    itemBg:addChild(consumeIcon)
    consumeIcon:setScale(0.9)
    local starNumLab = zc.createLabel({
        text = "+"..(_num),
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(consumeIcon:getPositionX()+consumeIcon:getContentSize().width, tipLab:getPositionY()),
    })
    itemBg:addChild(starNumLab)
    return itemBg
end

function LevyPop:onCleanup()
    PlayerData:setFreeLeyv(self._freeTimes)
    if (self._startFreeTimes > 0 and self._freeTimes <= 0)
      or (self._startFreeTimes <= 0 and self._freeTimes > 0)
      then
        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 16}})
    end
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( "res/animation/yb/yb.csb", true)
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( "res/animation/diaoluo/diaoluo.csb", true)
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/levy/infoBg.png")
    textureCache:removeTextureForKey("res/Main/levy/kuang.png")
    textureCache:removeTextureForKey("res/Main/levy/timebar.png")
    textureCache:removeTextureForKey("res/Main/levy/timebarBg.png")
end

function LevyPop:onEnter()
    if not getGuideManager():guideIsOver() then
        getGuideManager():addMaskLayer()
        performWithDelay(self, function()
            getGuideManager():removeMaskLayer()
            self:addGuide()
        end, 0.1)
    end
end

function LevyPop:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_6009
     or _currentGID == GuideKey.KEY_6024 
     or _currentGID == GuideKey.KEY_6025 then
        local _num = tonumber(self._totalTimes) or 0 
        if _num == 0 then
            getGuideManager():setCurrentGID(GuideKey.KEY_6009)
        elseif _num == 1 then
            getGuideManager():setCurrentGID(GuideKey.KEY_6024)
        elseif _num == 2 then
            getGuideManager():setCurrentGID(GuideKey.KEY_6025)
        else
            zc.setGuideFuncNextStep(GuideKey.KEY_6025)
            self:addGuide()
            return
        end
        getGuideManager():setObjTarget(self._freeLevyBtn)
        getGuideManager():startGuide()
    elseif inArray(_currentGID, GuideGroup.DUI_HUA) then
        getGuideManager():setHeroFuncCallBack(function()
            self:addGuide()
        end)
        getGuideManager():startGuide()
    elseif inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then
        getGuideManager():setObjTarget(self._closeBtn)
        getGuideManager():startGuide()
    end
end



return LevyPop