--[[
	购买体力弹窗
	唐实聪
	2016.6.13
]]
local BuyEnergyPop = class("BuyEnergyPop", function()
	return ZCPopLayer:create()
end)

function BuyEnergyPop:create( params )
	return BuyEnergyPop.new(params)
end

function BuyEnergyPop:ctor(params)
    self._buyType = tonumber(params.type) or zc.dataTypeEnergy
	self:initUI()
    self:refresh()
	self:show()
end

function BuyEnergyPop:initData()
end

function BuyEnergyPop:initUI()
	-- 背景
    local background = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
    })
    background:setPosition( zc.width/2, zc.height/2 )
    self:addContent( background )
    self._bg = background
    local bgSize = background:getContentSize()
    -- 关闭
    local close = zc.createBackButton({
        pos = cc.p( bgSize.width - 20, bgSize.height - 20), 
        listener = function()
            self:hide()
        end,
    })
    background:addChild( close )


    local _titleFile = "goumaitili"
    local _iconFile = "res/Main/home/buy_energy.png"
    if self._buyType == zc.dataWeaponTollgateTimes then
        _titleFile = "goumaitiaozhanling"
        _iconFile = "res/Main/weaponCopy/buy_times.png"
    end

    -- 标题
    local title =  zc.getTipPopTitle(_titleFile)
    title:setPosition( bgSize.width/2, bgSize.height - 30 )
    background:addChild(title)

    -- 中间背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(bgSize.width*0.5, bgSize.height*0.5 + 30)
    background:addChild( middleBg )
    -- 图标
    local energyBuySp = zc.createSprite(_iconFile)
    energyBuySp:setPosition(middleBg:getContentSize().width/2, middleBg:getContentSize().height/2 + 17 )
    middleBg:addChild(energyBuySp)
    -- +120
    local _addNumString = "+120"
    if self._buyType == zc.dataWeaponTollgateTimes then
        _addNumString = "+6"
    end
    local energyAddNum = zc.createLabel({
        text = _addNumString,
        fontSize = 25,
        color = zc.COLOR_GREEN,
        ap = cc.p( 0, 0 ),
        pos = cc.p( 50, 3),
        outLine = true,
        pixel = 1.5,
    })
    energyBuySp:addChild(energyAddNum)
    -- 今日剩余购买次数
    local leftBuyTimeLabel = zc.createLabel({
        text = zc.lang("today_left_buy_times") .. ":",
        fontSize = 20,
        ap = cc.p( 1, 0.5 ),
        pos = cc.p( 295, 25),
        outLine = true,
        pixel = 1.5,
    })
    middleBg:addChild(leftBuyTimeLabel)
    self._leftBuyTimeLabel = leftBuyTimeLabel
    -- 次数数字
    local leftBuyTimeNum = zc.createLabel({
        fontSize = 25,
        color = zc.COLOR_YELLOW,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 300, 25),
        outLine = true,
        pixel = 1.5,
    })
    middleBg:addChild(leftBuyTimeNum)
    self._leftBuyTimeNum = leftBuyTimeNum

    -- 购买花费
    local consumeIcon = cc.Sprite:create( "res/Main/common/common_icon_gold.png" )
    consumeIcon:setPosition( 120, 70 )
    background:addChild( consumeIcon )
    self._consumeIcon = consumeIcon
    local consumeNum = zc.createLabel({
        fontSize = 22,
        ap = cc.p( 0, 0 ),
        pos = cc.p( 25, 0),
        outLine = true,
        pixel = 1.5,
    })
    consumeIcon:addChild(consumeNum)
    self._consumeNum = consumeNum

    -- 购买按钮
    local buyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p( bgSize.width*0.5, 70), 
        btnText = LANGUAGE_SHOP.buy,
        endCallback = function()
            if self._limit then
                zc.tipInfo(zc.lang("tips_buy_times_limit"))
                return
            end

            if self._buyType == zc.dataWeaponTollgateTimes then
                zc.sendHttp({
                    apiName = "WeaponCopy_buyTimes",
                    params = {nums=1},
                    successCallback = function( backData )
                        PlayerData:updataData( backData )
                        PlayerData.limitInfo.weaponTollgateItemBuy = backData.weaponTollgateItemBuy
                        self:refresh()
                    end,
                })
            else
                zc.sendHttp({
                    apiName = "User_buyEnergy",
                    successCallback = function( backData )
                        PlayerData:updataData( backData )
                        PlayerData.limitInfo.buyEnergy = backData.bugTimes
                        self:refresh()
                    end,
                })
            end
        end
    })
    background:addChild( buyBtn )
    self._buyBtn = buyBtn

    if self._buyType == zc.dataWeaponTollgateTimes then 
        buyBtn:setPositionY(buyBtn:getPositionY() + 20)
        consumeIcon:setPositionY(consumeIcon:getPositionY() + 20)

        local _rechTips = zc.createRichLabel({
            text = zc.lang("buy_energy_tips"),
            fontSize = 20,
            color = display.COLOR_BLACK,
            pos = cc.p(buyBtn:getPositionX(), buyBtn:getPositionY() - 50)
        })
        background:addChild( _rechTips )
    end
end

function BuyEnergyPop:refresh()
    local _numBuyed, _numLimit, priceInfo
    if self._buyType == zc.dataWeaponTollgateTimes then
        _numBuyed = tonumber(PlayerData.limitInfo.weaponTollgateItemBuy) or 0
        _numLimit = -1
        self._leftBuyTimeLabel:setString(zc.lang("today_already_buy_times") .. "：")
        self._leftBuyTimeNum:setString(_numBuyed)
        priceInfo = zc.getConsumePriceData(58, _numBuyed + 1)
    else
        _numBuyed = tonumber( PlayerData.limitInfo.buyEnergy ) or 0
        _numLimit = tonumber( gameData.getDataFromCacheWithPrimaryKey("vip", 6)["vip"..PlayerData.info.vip] ) or 0
        self._leftBuyTimeNum:setText( ( _numLimit - _numBuyed ).."/".._numLimit)
        priceInfo = zc.getConsumePriceData(28, _numBuyed + 1)
    end
    if _numLimit > _numBuyed or _numLimit == -1 then
        -- 可以继续购买
        self._limit = false
        local _numConsume = priceInfo.price or 1
        self._consumeNum:setText(_numConsume)
        self._consumeIcon:setVisible( true )
    else
        self._limit = true
        self._consumeNum:setText( "" )
        self._consumeIcon:setVisible( false )
    end
end

return BuyEnergyPop