--[[
FileName 		MainBottomBtnsLayer.lua
ProjectName		HJ2

Created by wangming on 16-07-12
    
]]

local MainBottomBtnsLayer = class("MainBottomBtnsLayer", function()
	local _node = cc.Node:create()
	_node:setContentSize(winSize)
	return _node
end)

function MainBottomBtnsLayer:create( params )
	return MainBottomBtnsLayer.new(params)
end
-- jiaose,beibao,guojia,bingqi,buzhen,shiping,zhenzhan,renwu
function MainBottomBtnsLayer:ctor(params)
    local _params = params or {}
    self._needToDefault = _params.needToDefault
    self._bottomButtonList = {}    -- 下方按钮
    self._bottomButtonList_1 = {}  -- 上方按钮
    self._showButtonList = _params.showList --需要显示的按钮
    self._btnScale = 0.9
    self._height = 60*self._btnScale
    local _height = self._height
    self._click = 1

    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
    --icon 遮罩 home_icon_mask
    self.home_icon_mask = zc.getSprite({
        src = "res/Main/home/home_icon_mask.png",
        pos = cc.p(zc.width ,0),
        ap = cc.p(1,0),
    })
    self:addChild(self.home_icon_mask)
    --收起展开按钮
    local retractAndOpen_btn = zc.createPushButton({
        normalNode = zc.createSpriteWithFrameName("bottonBtn.png"),
        pos = cc.p(zc.width-50, _height), 
        touchScale = 0.95,
        needEnableWhenMoving = true,
        endCallback = function () 
            if self._click == 1 then
                self:playRetractAnimate()
                self._click = 2
            elseif self._click == 2 then
                self:playOpenAnimate()
                self._click = 1
            end 
        end,
    })
    self:addChild(retractAndOpen_btn)
    self.retractAndOpen_btn = retractAndOpen_btn
    
    --copy界面
    local _file = "res/Main/common/common_icon_zhandou.png"
    local _nameText = zc.lang("main_line")
    local _btnEff = zc.effect.btnFight
    self._isBack = _params.isBack
    if _params.isBack then
        _file = "res/Main/common/common_icon_huicheng.png"
        _nameText = zc.lang("back_to_city")
        self._click = 2
        _btnEff = nil
    end
    self._fubenButton = self:createBottonBtn({
        src = _file,
        pos = cc.p(zc.width-50, _height + 95),
        text = _nameText,
        btnEff = _btnEff,
        tag = 1,
        listener = function () 
            --新手引导
            if _params.isBack then
                local _currentGID = getGuideManager():getCurrentGID()
                if inArray(_currentGID, GuideGroup.BTN_BACK_MAINCITY) then  -- 返回主城
                    zc.setGuideFuncNextStep(_currentGID)
                end
                LayerManager.backToMainCity()
            else
                local _currentGID = getGuideManager():getCurrentGID()
                if inArray(_currentGID, GuideGroup.BTN_FUBEN) then
                    getGuideManager():guideOver()
                    getGuideManager():setNextGID(_currentGID)
                end
                zc.createChapter({nationId=1})
            end
        end,
    }) 
    if not _params.isBack then
        local _btn = self._fubenButton._btn
        local _node = cc.Node:create()
        _node:setContentSize(_btn:getContentSize())
        local _spine = zc.createSpine({
            fileName = "zhandou_tubiao",
            actName = "animation",
        })
        _node:addChild(_spine)
        _btn:setStateNormal(_node)
    end

    self:initBottom()
end

function MainBottomBtnsLayer:initBottom()
    self._idx = 0
    local _startX = 140
    local _part = 90*self._btnScale
    local _height = self._height
    for k,v in pairs(self._bottomButtonList) do
        v:removeFromParent()
    end
    self._bottomButtonList = {}

    --布阵界面
    local function _createBuzhen()
        if self._showButtonList and not self._showButtonList["buzhen"] then
            return
        end
        self._buzhenButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_buzhen.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("lineup"),
            listener = function () 
                local _currentGID = getGuideManager():getCurrentGID()
                if inArray(_currentGID, GuideGroup.BTN_BUZHEN) then
                    getGuideManager():guideOver()
                    getGuideManager():setNextGID(_currentGID)
                end
                zc.createBuzhenLayer()
            end,
        })
        self._idx = self._idx + 1
    end
    --角色
    local function _createSolider()
        if self._showButtonList and not self._showButtonList["jiaose"] then
            return
        end
        self._soliderButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_wujiang.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("role"),
            listener = function () 
                self:checkBack()
                --新手引导
                local _currentGID = getGuideManager():getCurrentGID()
                if inArray(_currentGID, GuideGroup.BTN_ROLE)
                  or _currentGID == GuideKey.KEY_11401
                  then
                    zc.setGuideFuncNextStep(_currentGID, false)
                end
                zc.createHeroListLayer()
            end,
        })
        self:createRedPoint(self._soliderButton)
        self._idx = self._idx + 1
    end
    --背包
    local function _createBag()
        if self._showButtonList and not self._showButtonList["beibao"] then
            return
        end
        self._bagButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_bag.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("bag"),
            listener = function () 
                self:checkBack()
                zc.createSourceScene("bag", "src/layer/bag/BagLayer.lua", {} )
            end,
        })
        self._idx = self._idx + 1
        self:createRedPoint(self._bagButton)
    end
    --国家
    local function _createCountry()
        if self._showButtonList and not self._showButtonList["guojia"] then
            return
        end
        if not zc.getFunctionStatus(24) then
            return
        end
        self._countryButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_guojia.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("country"),
            listener = function ()
                if not self:checkIsInCounry() then --检查是否在抢矿跳转到国家
                    zc.createCountryScene()
                end
            end,
        })
        self:createRedPoint(self._countryButton)
        self._idx = self._idx + 1
    end
    -- 养成
    local function _createRole()
        -- if self._showButtonList and not self._showButtonList["zhanfa"] then
        --     return
        -- end
        if not zc.getFunctionStatus(48) then
            return
        end
        self._roleButton = self:createBottonBtn({
            src = "res/Main/common/yangcheng.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("yangcheng"),
            listener = function ()  

                --新手引导
                getGuideManager():guideOver()

                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_11509 then
                    getGuideManager():setNextGID(GuideKey.KEY_11509)
                end

                if _currentGID == GuideKey.KEY_14801 then
                    zc.setGuideFuncNextStep(_currentGID, true)
                end

                self:addSmityDialog(true)

            end,
        })
        self:createRedPoint(self._roleButton)
        self._idx = self._idx + 1
    end

    --兵器谱
    local function _createSmithy()
        if self._showButtonList and not self._showButtonList["bingqi"] then
            return
        end
        self._smithyButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_bingqipu.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("smithy"),
            listener = function () 
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_12902
                  or _currentGID == GuideKey.KEY_13505
                  or _currentGID == GuideKey.KEY_14202 then
                    zc.setGuideFuncNextStep(_currentGID, false)
                    getGuideManager():addMaskLayer()
                end
                -- zc.createSmithLayer({layertype = 2})
                self:addSmityDialog()
            end,
        })
        self:createRedPoint(self._smithyButton)
        self._idx = self._idx + 1
    end

    --征战
    local function _createFightEnter()
        if self._showButtonList and not self._showButtonList["zhenzhan"] then
            return
        end
        self._fightEnterButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_zhenzhan.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("fightEnter"),
            spineEffFile = "zhengzhan",
            listener = function () 
                zc.createFightEnter()
            end,
        })
        self:createRedPoint(self._fightEnterButton)
        self._idx = self._idx + 1
    end

    --任务
    local function _createTask()
        if self._showButtonList and not self._showButtonList["renwu"] then
            return
        end
        self._taskButton = self:createBottonBtn({
            src = "res/Main/common/common_icon_renwu.png",
            pos = cc.p(zc.width - (_startX + _part*self._idx), _height), 
            text = zc.lang("task"),
            listener = function () 
                zc.createTaskView()
            end,
        })
        self:createRedPoint(self._taskButton)
        self._idx = self._idx + 1
    end

    if not APP_REVIEW then
        _createFightEnter()
    end
    _createBuzhen()
    _createBag()
    _createCountry()
    _createRole()
    _createSmithy()
    _createSolider()
    _createTask()

    if self._click == 2 then
        for k,v in pairs(self._bottomButtonList) do
            v:setScale(0)
            v:setVisible(false)
        end
        for k,v in pairs(self._bottomButtonList_1) do
            v:setScale(0)
            v:setVisible(false)
        end
        self.home_icon_mask:setOpacity(0)
        self.retractAndOpen_btn:setRotation(90)
        self.home_icon_mask:setVisible(false)
    end
end

function MainBottomBtnsLayer:checkIsInCounry()
    local _isInCountry = false
    if zc.getScene("GrabMineMapSecondLayer") then
        if zc.getScene("tollgate") then
            self._needToDefault = true
            self:checkBack()
            return false
        else
            _isInCountry = true
            LayerManager.removeLayout()
        end
    end
    if zc.getScene("GrabMineMapFirstLayer") then
        if zc.getScene("tollgate") then
            self._needToDefault = true
            self:checkBack()
            return false
        else
            _isInCountry = true
            LayerManager.removeLayout()
        end
    end
    return _isInCountry
end
function MainBottomBtnsLayer:checkBack()
    if self._needToDefault then
        LayerManager.backToMainCity(false)
    end
end

function MainBottomBtnsLayer:checkOpen()
    local _flag = false
    if not self._countryButton and zc.getFunctionStatus(24) then
        _flag = true
    elseif not self._roleButton and zc.getFunctionStatus(48) then
        _flag = true
    end
    if _flag then
        self:initBottom()
    end
end

function MainBottomBtnsLayer:createBottonBtn( params )    
    local _scale1 = 0.5
    local _scale2 = 0.6
    local _needAdd = params.needAdd == nil and true or params.needAdd
    local _btn, _icon 
    _btn = zc.getSprite({
        src = "bottomDi.png",
        plist = true,
        pos = params.pos, 
        scale = 0.9,
        -- params.listener()
    })
    local _di = zc.getSprite({
        src = "btnNameDi.png",
        plist = true,
        pos = cc.p(_btn:getContentSize().width*0.5, 10),
    })
    _btn:addChild(_di)

    local _label = zc.createLabel({
        text = params.text,
        fontSize = 22,
        stroke = true,
        pixel = 2,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_di:getContentSize().width*0.5, _di:getContentSize().height*0.5),
    })
    _di:addChild(_label)
    if _needAdd then
        self:addChild(_btn, 1)
    end

    _icon = zc.createPushButton({
        normalFile = params.src,
        touchScale = _scale2/_scale1,
        scale = _scale1,
        touchSize = cc.size(95, 95),
        btnEff = params.btnEff == nil and zc.effect.btnOpen or params.btnEff,
        needEnableWhenMoving = true,
        pos = cc.p(_btn:getContentSize().width*0.5, _btn:getContentSize().height*0.5 + 10),
        endCallback = params.listener,
        noScaleAction = true,
    })
    _btn:addChild(_icon)

    if params.spineEffFile then
        _icon:getStateNormal():setVisible(false)
        local _spine = zc.getSpine(params.spineEffFile)
        _spine:playAction(params.spineEffAct or "animation", true)
        _spine:setPosition(_icon:getContentSize().width*0.5, _icon:getContentSize().height*0.5)
        _icon:addChild(_spine)
    end
    _btn._btn = _icon
    if _needAdd then
        if params.tag == 1 then
            table.insert(self._bottomButtonList_1, _btn)
        else
            table.insert(self._bottomButtonList, _btn)
        end
    end
    return _btn
end

function MainBottomBtnsLayer:resetStatus(toDoOpen)
    self.retractAndOpen_btn:stopAllActions()
    self.retractAndOpen_btn:setEnable(true)
    self.retractAndOpen_btn:setRotation(toDoOpen and 90 or 0)
    for k,v in pairs(self._bottomButtonList) do
        v._btn:setEnable(true)
        v:setVisible(toDoOpen and false or true)
        v:setScale(toDoOpen and 0 or self._btnScale)
    end
    for k,v in pairs(self._bottomButtonList_1) do
        v._btn:setEnable(true)
        v:setVisible(toDoOpen and false or true)
        v:setScale(toDoOpen and 0 or self._btnScale)
    end
    self.home_icon_mask:stopAllActions()
    self.home_icon_mask:setOpacity(toDoOpen and 0 or 255)
    self.home_icon_mask:setVisible(toDoOpen and false or true)

    if self._isBack then
        return
    end
    local _mainCity = zc.getScene(LAYER_NAME_TAG.LAYER_MAINCITY)
    if not _mainCity then
        return
    end
    if not tolua.isnull(self._maskLayer) then
        self._maskLayer:removeFromParent()
        self._maskLayer = nil
    end

    if _mainCity.chatLayer then
        if self._chatAction then
            _mainCity.chatLayer:stopAction(self._chatAction)
        end
        self._chatAction = nil
        _mainCity.chatLayer:setPositionX(toDoOpen and -zc.width or 0)
    end

    if _mainCity._hammerNode then
        _mainCity._hammerNode:stopAllActions()
        _mainCity._hammerNode:setPositionX(toDoOpen and -zc.width or 0)
    end

    if _mainCity._activityNode then
        _mainCity._activityNode:stopAllActions()
        _mainCity._activityNode:setPositionX(toDoOpen and zc.width*2 - 65 or zc.width - 65)
    end
end

 --功能按钮收起动画
function MainBottomBtnsLayer:playRetractAnimate()
    self:resetStatus(false)
    local _timeScale = 1.5

    self.retractAndOpen_btn:setEnable(false)
    
    local num = #self._bottomButtonList + 1
    for k,v in pairs(self._bottomButtonList) do
        v._btn:setEnable(false)
        local _scale_1 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.3)
        local _scale_3 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.0)
        local _scale_4 = cc.ScaleTo:create(0.1/_timeScale, 0.0)
        local _callFunc = cc.CallFunc:create(function()
            v:setVisible(false)
        end)
        local _delayTime = cc.DelayTime:create((num-k)/20/_timeScale)
        v:runAction(cc.Sequence:create(
            _delayTime,
            _scale_1,
            _scale_3,
            _scale_4,
            _callFunc
        ))
    end
    local num_1 = #self._bottomButtonList_1 + 1
    for k,v in pairs(self._bottomButtonList_1) do
        v._btn:setEnable(false)
        local _scale_1 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.3)
        local _scale_3 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.0)
        local _scale_4 = cc.ScaleTo:create(0.1/_timeScale, 0.0)
        local _callFunc = cc.CallFunc:create(function()
            v:setVisible(false)
        end)
        local _delayTime = cc.DelayTime:create((num_1-k)/20/_timeScale)
        v:runAction(cc.Sequence:create(
            _delayTime,
            _scale_1,
            _scale_3,
            _scale_4,
            _callFunc
        ))
    end
    --icon遮罩--
    local _seq = cc.Sequence:create(
        cc.FadeOut:create(0.8/_timeScale), 
        cc.CallFunc:create(function()
            self.home_icon_mask:setVisible(false)
            self.retractAndOpen_btn:setEnable(true)
        end))
    self.home_icon_mask:runAction(_seq)
    self.retractAndOpen_btn:runAction(cc.RotateBy:create(0.5, 90))

    if self._isBack then
        return
    end
    local _mainCity = zc.getScene(LAYER_NAME_TAG.LAYER_MAINCITY)
    if not _mainCity then
        return
    end
    local _maskLayer = getGuideManager():getMaskLayer()
    local _topInfo = LayerManager.getTopInfoLayer()
    _topInfo:addChild(_maskLayer, 100)
    self._maskLayer = _maskLayer
    performWithDelay(_maskLayer, function()
        _maskLayer:removeFromParent()
        self._maskLayer = nil
    end, 0.5/_timeScale)

    if _mainCity.chatLayer then
        self._chatAction = cc.Sequence:create(
            cc.MoveBy:create(0.5/_timeScale, cc.p(-zc.width, 0)),
            cc.CallFunc:create(function() self._chatAction = nil end)
        )
        _mainCity.chatLayer:runAction(self._chatAction)
    end
    if _mainCity._hammerNode then
        _mainCity._hammerNode:runAction(cc.MoveBy:create(0.5/_timeScale, cc.p(-zc.width, 0)))
    end

    if _mainCity._activityNode then
        _mainCity._activityNode:runAction(cc.MoveBy:create(0.5/_timeScale, cc.p(zc.width, 0)))
    end
end

--展开动画
function MainBottomBtnsLayer:playOpenAnimate()
    self:resetStatus(true)
    local _timeScale = 1.5
    self.retractAndOpen_btn:setEnable(false)
    
    for k,v in pairs(self._bottomButtonList) do
        v._btn:setEnable(true)
        v:setVisible(true)
        local _scale_1 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.3)
        local _scale_2 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*0.8)
        local _scale_3 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.0)
        local _delayTime = cc.DelayTime:create(k/20/_timeScale)
        v:runAction(cc.Sequence:create(
            _delayTime,
            _scale_1,
            _scale_2,
            _scale_3
        ))
    end
    for k,v in pairs(self._bottomButtonList_1) do
        v._btn:setEnable(true)
        v:setVisible(true)
        local _scale_1 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.3)
        local _scale_2 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*0.8)
        local _scale_3 = cc.ScaleTo:create(0.1/_timeScale, self._btnScale*1.0)
        local _delayTime = cc.DelayTime:create(k/20/_timeScale)
        v:runAction(cc.Sequence:create(
            _delayTime,
            _scale_1,
            _scale_2,
            _scale_3
        ))
    end
    --icon遮罩--
    local _seq = cc.Sequence:create(
        cc.FadeIn:create(0.8/_timeScale),
        cc.CallFunc:create(function()
            self.retractAndOpen_btn:setEnable(true)
        end)
    )
    self.home_icon_mask:setVisible(true)
    self.home_icon_mask:runAction(_seq)
    self.retractAndOpen_btn:runAction(cc.RotateBy:create(0.5, -90))

    if self._isBack then
        return
    end
    local _mainCity = zc.getScene(LAYER_NAME_TAG.LAYER_MAINCITY)
    if not _mainCity then
        return
    end
    local _maskLayer = getGuideManager():getMaskLayer()
    local _topInfo = LayerManager.getTopInfoLayer()
    _topInfo:addChild(_maskLayer, 100)
    self._maskLayer = _maskLayer
    performWithDelay(_maskLayer, function()
        _maskLayer:removeFromParent()
        self._maskLayer = nil
    end, 0.5/_timeScale)

    if _mainCity.chatLayer then
        self._chatAction = cc.Sequence:create(
            cc.MoveBy:create(0.5/_timeScale, cc.p(zc.width, 0)),
            cc.CallFunc:create(function() self._chatAction = nil end)
        )
        _mainCity.chatLayer:runAction(self._chatAction)
    end
    if _mainCity._hammerNode then
        _mainCity._hammerNode:runAction(cc.MoveBy:create(0.5/_timeScale, cc.p(zc.width, 0)))
    end

    if _mainCity._activityNode then
        _mainCity._activityNode:runAction(cc.MoveBy:create(0.5/_timeScale, cc.p(-zc.width, 0)))
    end    
end

function MainBottomBtnsLayer:createRedPoint( btn )
    --添加红点
    local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
    _redPoint:setVisible(false)
    btn:addChild(_redPoint)
    btn._redPoint = _redPoint
	_redPoint:setAnchorPoint(1, 1)
	_redPoint:setPosition(btn:getContentSize().width*self._btnScale, btn:getContentSize().height*self._btnScale)
end

-------------------------


function MainBottomBtnsLayer:checkRedAndBubble() 
    -- 主角红点
    self:freshRoleRed()
    -- 武将红点
    self:freshSoliderRed()
    -- 国家红点
    self:freshCountryRed()
    -- 任务红点
    self:freshTaskRed()
    --兵器谱红点
    self:freshSmithyRed()
    --背包
    self:freshBagRed()
end
--背包
function MainBottomBtnsLayer:freshBagRed()
    if not self._bagButton then
        return
    end
    local flag = PlayerData:checkBagRedState()
    self._bagButton._redPoint:setVisible( flag )
end
-- 主角红点
function MainBottomBtnsLayer:freshRoleRed()
    if not self._roleButton then
        return
    end
    if zc.getTrinketRedDotStatus() then
        self._roleButton._redPoint:setVisible( true )
    else
        self._roleButton._redPoint:setVisible( false )
    end
end

-- 武将红点
function MainBottomBtnsLayer:freshSoliderRed()
    if not self._soliderButton then
        return
    end
    local _heroData = PlayerData:getGeneralInfo()
    if #_heroData == 0 then
        -- 没有武将
        self._soliderButton._redPoint:setVisible( false )
    elseif PlayerData:getGodWeaponRedDotState() then
        -- 可升级强化进阶神兵
        self._soliderButton._redPoint:setVisible( true )
    elseif zc.getEquipRedDotStatus( _heroData ) then
        -- 可升级进阶装备
        self._soliderButton._redPoint:setVisible( true )
    elseif zc.getChangeWeaponRedDotStatus( _heroData ) then
        -- 能换武器
        self._soliderButton._redPoint:setVisible( true )
    elseif zc.getStarupRedDotStatus( _heroData ) then
        -- 能升星
        self._soliderButton._redPoint:setVisible( true )
    elseif zc.getFetterRedDotStatus( _heroData ) then
        -- 能羁绊
        self._soliderButton._redPoint:setVisible( true )
    elseif PlayerData:checkCanClearWeapons() then
        -- 可洗练武器
        self._soliderButton._redPoint:setVisible( true )
    elseif zc.getGemSetRedDotStatusByHero( _heroData ) then
        -- 宝石镶嵌
        self._soliderButton._redPoint:setVisible( true )
    else
        self._soliderButton._redPoint:setVisible( false )
    end
end

-- 国家红点
function MainBottomBtnsLayer:freshCountryRed()    
    if not self._countryButton then
        return
    end
end

-- 任务红点
function MainBottomBtnsLayer:freshTaskRed() 
    local _mainCity = zc.getScene("mainCity")
    local _flag = false
    if _mainCity and _mainCity.taskLayer then
        _flag = _mainCity.taskLayer:getTaskRed()
    end
    self._taskButton._redPoint:setVisible(_flag)
end

--兵器谱红点
function MainBottomBtnsLayer:freshSmithyRed()
    if not self._smithyButton then
        return
    end
    local smithyRedState = false
    
    -- 洗练
    smithyRedState = PlayerData:checkCanClearWeapons() --有可洗练的兵器
    if smithyRedState then
        self._smithyButton._redPoint:setVisible(true)
        return
    end
    -- 熟练度
    smithyRedState = PlayerData:getSmithPracticeRedDotState()
    if smithyRedState then
        self._smithyButton._redPoint:setVisible(true)
        return
    end
    --兵器谱
    smithyRedState = PlayerData:getSmithBookRedDotState() --成就铺有可激活或者升级
    if smithyRedState then
        self._smithyButton._redPoint:setVisible(true)
        return
    end
    smithyRedState = PlayerData:getGodWeaponRedDotState()
    self._smithyButton._redPoint:setVisible(smithyRedState)
end

function MainBottomBtnsLayer:addSmityDialog(index)
    local _topLay = LayerManager.getTopInfoLayer()
    if not _topLay then
        return
    end
    local _lay = ZCDialog:create(0)
    _topLay:addChild(_lay)

    local function _endCall()
        _lay:removeFromParent()
    end
    local _pos
    if index then
        _pos = cc.p(self._roleButton:getPosition())
    else
        _pos = cc.p(self._smithyButton:getPosition())
    end
    local _node = cc.Node:create()
    _lay:addChild(_node)

    local _funcs
    if index then
        _funcs = {
            {
                id = 9,
                name = zc.lang("leading_trinket"),
                callFunc = function()
                    _endCall()
                    zc.createRoleTrinket()
                end,
                checkRed = function()
                    return PlayerData:checkCanClearWeapons()
                end,
            },
            {
                id = 47,
                name = zc.lang("soulfete"),
                callFunc = function()
                    _endCall()
                    zc.createHeroSoulRand()
                end,
                checkRed = function()
                    return PlayerData:checkCanClearWeapons()
                end,
            },
            {
                id = 48,
                name = zc.lang("zhanfa"),
                callFunc = function()
                    _endCall()
                    getGuideManager():guideOver()
                    local layer = 
                    zc.createSourceScene("ZhanFaLayer", "src/layer/role/ZhanFaLayer", {})
                end,
                checkRed = function()
                    return PlayerData:checkCanClearWeapons()
                end,
            }
        }
    else
        _funcs = {
            {
                id = 29,
                name = zc.lang("smithy_clear"),
                callFunc = function()
                    _endCall()
                    zc.createSmithClearLayer()
                end,
                checkRed = function()
                    return PlayerData:checkCanClearWeapons()
                end,
            },
            {
                id = 35,
                callFunc = function()
                    _endCall()
                    zc.createSmithPracticeLayer()
                end,
                checkRed = function()
                    return PlayerData:getSmithPracticeRedDotState()
                end,
            },
            {
                id = 12,
                callFunc = function()
                    _endCall()
                    zc.createSmithBookLayer()
                end,
                checkRed = function()
                    return PlayerData:getSmithBookRedDotState()
                end,
            },
            {
                id = 7,
                name = zc.lang("god_weapon"),
                callFunc = function()
                    _endCall()
                    self:checkBack()
                    zc.createSmithGodWeaponLayer()
                end,
                checkRed = function()
                    return PlayerData:getGodWeaponRedDotState()
                end,
            },
            {
                id = 42,
                name = zc.lang("weapon_cast"),
                callFunc = function()
                    _endCall()
                    self:checkBack()
                    zc.createWeaponCastLayer()
                end,
                checkRed = function()

                end,
            }
        }
    end

    _size = cc.size(400, 116)
    local _btns = {}
    local _lists = {}
    local _num = 0
    for i=1, #_funcs do
        if zc.getFunctionStatus(_funcs[i].id) then
            _num = table.nums(_lists)
            local _data = gameData.getDataFromCacheWithPrimaryKey("functions", _funcs[i].id)
            local tipIcon = self:createBottonBtn({
                src = "res/Main/common/common_icon_".._data.icon..".png",
                pos = cc.p( 50 + _num*98, _size.height*0.5 + 3),
                text = _funcs[i].name or _data.content,
                listener = _funcs[i].callFunc,
                needAdd = false,
            })
            _lists[i] = tipIcon
            _btns[tostring(_funcs[i].id)] = tipIcon
            tipIcon._btn:setEnable(false)
            _node:addChild(tipIcon)
            self:createRedPoint(tipIcon)
            if _funcs[i].checkRed() then
                tipIcon._redPoint:setVisible(true)
            end
        end
    end
    _num = table.nums(_lists)
    _size.width = _num*100
    _node:setContentSize(_size)
    _node:setAnchorPoint(0.5, 0)
    _node:setPosition(_pos.x, _pos.y + 50)

    local _di = ccui.Scale9Sprite:create(cc.rect(2, 30, 5, 16 ), "res/Main/home/bingqiDi.png")
    _di:setContentSize(_size.width*0.5, _size.height)
    _di:setAnchorPoint(1, 0)
    _di:setPosition(_size.width*0.5, 0)
    _node:addChild(_di, -1)
    local _di2 = ccui.Scale9Sprite:create(cc.rect(2, 30, 5, 16 ), "res/Main/home/bingqiDi.png")
    _di2:setContentSize(_size.width*0.5, _size.height)
    _di2:setAnchorPoint(1, 0)
    _di2:setPosition(_size.width*0.5, 0)
    _di2:setScaleX(-1)
    _node:addChild(_di2, -1)

    _node:setScaleX(0.1)
    _node:runAction(cc.Sequence:create(
        cc.CallFunc:create(function() 
            getGuideManager():addMaskLayer()
        end),
        cc.ScaleTo:create(0.15, 1, 1),
        cc.CallFunc:create(function()
            getGuideManager():removeMaskLayer()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12903 then
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(_btns["29"], 0.5)
                getGuideManager():startGuide()
            elseif _currentGID == GuideKey.KEY_13502 then
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(_btns["35"], 0.5)
                getGuideManager():startGuide()
            elseif _currentGID == GuideKey.KEY_14203 then
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(_btns["42"], 0.5)
                getGuideManager():startGuide()
            elseif _currentGID == GuideKey.KEY_14802 then
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(_btns["48"], 0.5)
                getGuideManager():startGuide()
            elseif _currentGID == GuideKey.KEY_11510 then
                getGuideManager():setNextGID(GuideKey.KEY_11510)
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(_btns["9"], 0.5)
                getGuideManager():startGuide()
            end
        end),
        cc.CallFunc:create(function()
            _lay:setTouchEndedCallback(_endCall)
            for k,v in pairs(_lists) do
                v._btn:setEnable(true)
            end
        end)
    ))
end

return MainBottomBtnsLayer