--[[
    FileName: ResearchQunXiongLayer.lua
    Author: andong
    Date: 2016-04-07
    Purpose: 研究院群雄界面
]]
local ResearchQunXiongLayer = class( "ResearchQunXiongLayer", function ()
    return ZCDialog:create()
end)
function ResearchQunXiongLayer:create(parmas)
    return ResearchQunXiongLayer.new(parmas)
end
function ResearchQunXiongLayer:ctor(parmas)
    self:initData(parmas)
    self:initUI()
end

function ResearchQunXiongLayer:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end
    self._parmas = parmas
    self._openInfo = {}
    for i = 1, #parmas.captains do
        if parmas.captains[i] then
            self._openInfo[tonumber(parmas.captains[i].captainId)] = "open"
        end
    end
    --判断开启个数(当前加2)
    self._seatNum = 0
    local _datas = gameData.getAllDataWithNoClone("captain")
    local _tmpNums = table.nums(_datas)
    for i = 1, _tmpNums do
        local tollId = tonumber(gameData.getDataFromCacheWithPrimaryKey("captain", i)["id"]) or 0
        if self._openInfo[tollId] then
            self._seatNum = i
        else
            self._seatNum = self._seatNum + 2
            break
        end
    end
    if self._seatNum >= _tmpNums then
        self._seatNum = _tmpNums
    end

    self._totalAct = {}
    for i = 1, self._seatNum do
        local groupData = gameData.getDataFromCache("captain_combine", {["captainId"]=i}) --组合
        self._totalAct[i] = {}
        self._totalAct[i].totalGroup = #groupData
        self._totalAct[i].activitied = 0
    end
    self._activitied = {}
    local openInfo = parmas.captains
    for i = 1, #openInfo do
        local activitiedNum = 0
        for j = 1, #openInfo[i]["combineIds"] do
            local idx = tonumber(openInfo[i]["combineIds"][j])
            self._activitied[idx] = "open"
            activitiedNum = activitiedNum + 1
        end
        if self._totalAct[i] and self._totalAct[i].activitied then
            self._totalAct[i].activitied = activitiedNum
        end      
    end
end
function ResearchQunXiongLayer:initUI()
    local background = cc.Sprite:create("res/Main/research/qunxiong/qunxiong.jpg")
    background:setPosition(cc.p(zc.width/2, zc.height/2))
    self:addChild(background)
    zc.setBgSize(background) --放大
    
    local backButton = zc.createTopBackButton({
        pos = cc.p(zc.width - 60, zc.height - 40), 
        listener = function () 
            LayerManager.removeLayout()
        end,
    })
    self:addChild(backButton, 10)

    --界面信息
    self:createInfo()
    --选择信息
    self:createSelectInfo()
end

function ResearchQunXiongLayer:createSelectInfo()
    local selectNum = self._seatNum
    local itemWidth = 370
    local innerWidth = itemWidth * selectNum
    local ifBunce = selectNum > 2 and true or false
    local myscrollview = zc.createScrollview({
        pos = cc.p(0, 40),
        size = cc.size(zc.width,zc.height-80),
        innerSize = cc.size(innerWidth, zc.height-80),
        dir = ccui.ScrollViewDir.horizontal,
        bounceEnable = false,
    })
    self:addChild(myscrollview, 9)

    local pos = zc.sortFromMiddle(cc.p(zc.width/2, zc.height/2), selectNum, zc.width/selectNum)
    local peopleImg = {[1]="8",[2]="15",[3]="2",[4]="102",[5]="11",[6]="9"}
    self._actNumLab = {}
    for i = 1, selectNum do
        local selectBg = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(itemWidth, 427))
        local selectBtn = zc.createPushButton({
            normalNode = selectBg,
            needSwallow = false,
            needEnableWhenMoving = true,
            anchor = cc.p(0.5, 0.5),
            noScaleAction = true,
            touchScale = 0.9,
            pos = cc.p(itemWidth/2+(i-1)*itemWidth, myscrollview:getContentSize().height/2-15),
            endCallback = function() end,
        })
        myscrollview:addChild(selectBtn)
        selectBtn:setTouchEndedCall(function()
            if self._openInfo[i] then
                zc.sendHttp({
                    apiName = "Captain_captainInfo", 
                    successCallback = function (net_data)
                        net_data["openState"] = self._openInfo
                        net_data["openNum"] = self._seatNum
                        net_data["tag"] = i
                        net_data["totalAct"] = self._totalAct
                        net_data["activitied"] = self._activitied
                        net_data["callback"] = function(act, total)
                            if act and total then
                                self._activitied = act
                                self._totalAct = total
                                for j = 1, #self._actNumLab do
                                    local numStr = self._totalAct[j].activitied.."/"..self._totalAct[j].totalGroup
                                    self._actNumLab[j]:setText(numStr)
                                end
                            end
                            local starNumStr = PlayerData:getResourcesInfo().captainEnergy
                            self._fightNumsLab:setText(starNumStr)
                        end
                        --功能引导
                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_12507 then
                            zc.setGuideFuncNextStep(_currentGID)
                        end
                        zc.createSourceScene("QunXiongMain", "src/layer/research/QunXiongMainLayer.lua", net_data)
                    end,
                })
            else
                zc.tipInfo(zc.lang("tips_qunxiong_unopen"))
            end
        end)

        local diId = math.floor((i-1)/2)+1
        local di_bg = zc.createSprite("res/Main/research/qunxiong/di_bg_"..diId..".png")
        di_bg:setAnchorPoint(0.5, 0.5)
        di_bg:setPosition(selectBg:getContentSize().width/2-30, selectBg:getContentSize().height/2+25)
        selectBg:addChild(di_bg)

        local di_f = zc.createSprite("res/Main/research/qunxiong/di_f"..diId..".png")
        di_bg:addChild(di_f)
        if i == 1 or i == 2 then
            di_f:setAnchorPoint(1, 0)
            di_f:setPosition(12, 20)
        else
            di_f:setAnchorPoint(0, 1)
            di_f:setPosition(-18, di_bg:getContentSize().height+10)
        end
        
        local people = zc.createSprite("res/Main/hero/body/"..peopleImg[i]..".png")
        people:setAnchorPoint(1, 0)
        people:setPosition(selectBg:getContentSize().width+90, 0)
        selectBg:addChild(people)
        people:setScale(0.6)

        local nameImg = zc.createSprite("res/Main/research/qunxiong/di_word_"..i..".png")
        nameImg:setAnchorPoint(0.5, 1)
        nameImg:setPosition(di_bg:getPositionX(), selectBg:getContentSize().height-20)
        selectBg:addChild(nameImg)


        local timesBg = zc.getScaleNode("res/Main/research/qunxiong/word_bg.png", cc.size(74, 25))
        timesBg:setAnchorPoint(cc.p(0.5, 0.5))
        timesBg:setPosition(di_bg:getPositionX(), 85)
        selectBg:addChild(timesBg)

        local numStr = self._totalAct[i].activitied.."/"..self._totalAct[i].totalGroup
        local times = zc.createLabel({
            text = numStr,
            outLine = true,
            fontSize = 20,
            ap = cc.p(0.5, 0.5),
            pos = cc.p(timesBg:getContentSize().width/2, timesBg:getContentSize().height/2),
            pixel = 1.3
        })
        timesBg:addChild(times)
        self._actNumLab[i] = times
        
        local yun = zc.createSprite("res/Main/research/qunxiong/yun_left.png")
        yun:setAnchorPoint(0, 0)
        yun:setPosition(0, -25)
        selectBg:addChild(yun)

        if not self._openInfo[i] then --如果没有开启
            zc.setGray(di_bg)
            zc.setGray(di_f)
            zc.setGray(people)
            zc.setGray(nameImg)
            zc.setGray(timesBg)
            zc.setGray(yun)
            times:setColor(display.COLOR_DEEPGRAY)

            local static = gameData.getDataFromCache("houseEffect_captain", {["captainId"]=i})
            if static and static["id"] or next(static) then
                local openToll = gameData.getDataFromCacheWithPrimaryKey("captain", i).tollgateId
                local tollInfo = PlayerData:getEnemyInfoByEnemyId(openToll)
                local openTollLab = zc.createLabel({
                    text = zc.lang("finish_tollgate") .. zc.lang("num_di") .. tollInfo.chapterId.. zc.lang("num_zhang") ..":"..tollInfo.name,
                    outLine = true,
                    fontSize = 18,
                    ap = cc.p(0.5, 0),
                    pos = cc.p(selectBg:getContentSize().width/2+15, 20),
                    pixel = 1.3
                })
                selectBg:addChild(openTollLab)

                local level 
                if static.id then
                    level = static.id
                elseif static[1] then
                    level = static[1].id
                end
                local levelStr = zc.lang("and_yanjiuyaun_achieve_level")..level..zc.lang("level_unlock")
                local openLevelLab = zc.createLabel({
                    text = levelStr,
                    outLine = true,
                    fontSize = 18,
                    ap = cc.p(0.5, 0),
                    pos = cc.p(selectBg:getContentSize().width/2+15, 0),
                    pixel = 1.3
                })
                selectBg:addChild(openLevelLab)
            else
                local tipLab = zc.createLabel({
                    text = zc.lang("tips_unopen_fornow") .. "!",
                    outLine = true,
                    fontSize = 22,
                    ap = cc.p(0.5, 0),
                    pos = cc.p(selectBg:getContentSize().width/2+15, 20),
                    color = display.COLOR_DEEPGRAY,
                    pixel = 1.3
                })
                selectBg:addChild(tipLab)
            end
        end

        ---功能引导
        if self._openInfo[1] and i == 1 then
            self._guide_btn = selectBtn
        end
    end
end
function ResearchQunXiongLayer:createInfo()
    local title = zc.createSprite("res/Main/research/qunxiong/title.png")
    title:setAnchorPoint(0, 1)
    title:setPosition(0, zc.height)
    self:addChild(title, 10)

    local itemBg = cc.Sprite:create("res/Main/copy/leftTimesBg.png")
    itemBg:setAnchorPoint(0, 0)
    itemBg:setPosition(65, 17)
    self:addChild(itemBg, 10)

    local tipLab = zc.createLabel({
        text = zc.lang("attack_times"),
        stroke = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(36, itemBg:getContentSize().height/2),
        pixel = 1.3
    })
    itemBg:addChild(tipLab)

    local starNumStr = PlayerData:getResourcesInfo().captainEnergy
    local starNumLab = zc.createLabel({
        text = starNumStr,
        stroke = true,
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(tipLab:getPositionX()+tipLab:getContentSize().width, tipLab:getPositionY()),
        color = display.COLOR_GREEN,
        pixel = 1.3
    })
    itemBg:addChild(starNumLab)
    self._fightNumsLab = starNumLab

    --添加云动画
    zc.getYunDongTai(nil,2,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp )
            self:addChild( armDown )
        end
    end)

    local exclamationBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            zc.createRulePop(3)
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(280, itemBg:getPositionY()+15)
    })
    self:addChild(exclamationBtn)
end
function ResearchQunXiongLayer:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end
function ResearchQunXiongLayer:onEnter()
    self:addGuide()
end

--新手引导--功能引导
function ResearchQunXiongLayer:addGuide()
    --功能引导
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12505 then
        zc.setGuideFuncNextStep(_currentGID)
        self:addGuide()
    elseif inArray(_currentGID, GuideGroup.DUI_HUA) then 
        local function  _callBack()
            getGuideManager():addMaskLayer()
            performWithDelay(self, function ()
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(self._guide_btn)
                getGuideManager():startGuide()
            end, 0.3) 
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end  
end

return ResearchQunXiongLayer