--[[
    武将升星界面
    唐实聪
    2016.4.6
    2016.8.18重做
]]
local RoleStarupLayer = class("RoleStarupLayer", function()
    local layer = cc.Sprite:create()
    layer:setContentSize( 629, 539 )
    return layer
end)

function RoleStarupLayer:create( params )
    return RoleStarupLayer.new( params )
end

function RoleStarupLayer:ctor( params )
    self:initData()
    self:initUI()
    self:refreshHero( params )

    local function onNodeEvent(event)
        if "enter" == event then
            self:onEnter()
        elseif "cleanup" == event then
            self:onCleanup()
        elseif "exit" == event then
            -- self:onExit()
        end
    end
    self:registerScriptHandler(onNodeEvent)
    
    zc.addEventListener({name = CUSTOM_EVENT.EVENT_REFRESH_FORM_SWEEP, callback = function()
        self:buildStatusData()
        self:refreshStatusUI()
    end})
end

function RoleStarupLayer:onEnter()
    -- 顶部信息栏
    LayerManager.getTopInfoLayer():setPopInfo( "RoleStarupLayer" )
    -- 副本刷新
    if self._init then
        self:buildStatusData()
        self:judgeData()
    else
        self._init = true
        performWithDelay(self, function()
            self:guideFunc_1()
        end, 0.01)
    end

end

function RoleStarupLayer:onCleanup()
    self._exist = false

    zc.removeEventListener( CUSTOM_EVENT.EVENT_REFRESH_FORM_SWEEP )
end

function RoleStarupLayer:initData()
    self._armatureX = 232
    self._armatureY = 64

    local _size = self:getContentSize()
    self._width = _size.width
    self._height = _size.height
end

function RoleStarupLayer:initUI()
    -- 背景
    local _bg = cc.Sprite:create( "res/Main/role/common/role_bg.png" )
    _bg:setPosition( self._width/2, self._height/2 )
    self:addChild( _bg )
    self._bg = _bg

    local _middleX = 307

    -- 顶部
    local _topBg = cc.Sprite:create( "res/Main/role/common/top_bg.jpg" )
    _topBg:setAnchorPoint( 0.5, 1 )
    _topBg:setPosition( _middleX, self._height - 5 )
    _bg:addChild( _topBg )
    local _topBgSize = _topBg:getContentSize()
    local _topBgWidth = _topBgSize.width
    local _topBgHeight = _topBgSize.height
    _topBg:setScaleX( 594/_topBgWidth )

    -- 名字
    local _nameBg = ccui.Scale9Sprite:create( cc.rect( 12, 11, 14, 10 ), "res/Main/role/common/name_bg.png" )
    _nameBg:setContentSize( 408, 30 )
    _nameBg:setPosition( _topBgWidth/2, _topBgHeight/2 )
    _topBg:addChild( _nameBg )
    local _name = zc.createRichLabel({
        fontSize = 23,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 245, 163 ),
    })
    _name:setPosition( _topBgWidth/2, _topBgHeight/2 )
    _topBg:addChild( _name )
    self._name = _name

    -- 武器图标
    local _weaponIconBg = cc.Sprite:create( "res/Main/role/common/weapon_icon_bg.png" )
    _weaponIconBg:setAnchorPoint( 0, 0 )
    _weaponIconBg:setPosition( 0, 0 )
    _topBg:addChild( _weaponIconBg )
    local _weaponIcon = cc.Sprite:create()
    _weaponIcon:setPosition( _weaponIconBg:getContentSize().width/2 + 2, -10 )
    _weaponIconBg:addChild( _weaponIcon )
    self._weaponIcon = _weaponIcon

    -- 属性
    local _attrBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        needSwallow = false,
        touchScale = 0.9,
        pos = cc.p( _topBgWidth - 23, _topBgHeight/2 ),
        endCallback = function()
            zc.createRulePop( 2 )
        end,
    })
    _topBg:addChild( _attrBtn )

    -- 称号
    local _selectTitle = zc.createPushButton({
        normalFile = "res/Main/role/attribute/title_u.png",
        selectedFile = "res/Main/role/attribute/title_d.png",
        touchSize = cc.size(100,100),
        needSwallow = false,
        touchScale = 0.9,
        pos = cc.p( 390, _nameBg:getContentSize().height/2 ),
        endCallback = function()
            zc.sendHttp({
                apiName = "Chenghao_get",
                successCallback = function (net_data)
                    local function refresh()
                        local _nameText = zc.getLevelTipShow()..self._heroData.level.." "..PlayerData.info.userName
                        local _newAdvance = tonumber(self._heroData.newAdvance) or 0
                        if _newAdvance > 0 then
                            _nameText = _nameText .. "+" .. _newAdvance
                        end
                        self._name:setString( _nameText.."  [color=ffe400ff]< "..zc.getGodNameById( PlayerData:getBaseInfoByTag( "godName" ) ).." >[/color]" )
                    end
                    net_data.callback = refresh
                    zc.createSourcePop("RoleTitlePop", "src/layer/role/RoleTitlePop.lua", net_data)
                end
            })
        end,
    })
    _nameBg:addChild( _selectTitle )
    self._selectTitle = _selectTitle

    -- 法阵背景
    local _starupBg = cc.Sprite:create( "res/Main/role/starup/bg.png" )
    _starupBg:setPosition( _middleX, self._height - 265 )
    _bg:addChild( _starupBg )
    self._starupBg = _starupBg
    local _starupBgSize = _starupBg:getContentSize()
    local _starupBgWidth = _starupBgSize.width
    self._starupBgWidth = _starupBgWidth
    local _starupBgHeight = _starupBgSize.height
    self._starupBgHeight = _starupBgHeight
    -- 创建图标
    self._iconBg = {}
    local _radius = 160
    for i = 1, 6 do
        -- 角度
        local _degree = math.rad( 360*( i - 1 )/6 )
        -- 图标背景
        local _iconBgWidth = 99
        local _iconBgHeight = 109
        local _iconBg = cc.Sprite:create()
        _iconBg:setContentSize( _iconBgWidth, _iconBgHeight )
        _iconBg:setPosition( _starupBgWidth/2 + _radius*math.sin( _degree ), _starupBgHeight/2 + _radius*math.cos( _degree ) )
        _starupBg:addChild( _iconBg )
        self._iconBg[i] = _iconBg
        -- 图标
        local _icon = cc.Sprite:create()
        _icon:setScale( 0.8 )
        _icon:setPosition( _iconBgWidth/2, _iconBgHeight/2 )
        _iconBg:addChild( _icon )
        _iconBg._icon = _icon
        -- 加号
        local _plus = cc.Sprite:create( "res/Main/multyCopy/plus.png" )
        _plus:setPosition( _iconBgWidth/2 + 15, _iconBgHeight/2 + 15 )
        _plus:setScale( 0.8 )
        _iconBg:addChild( _plus )
        _iconBg._plus = _plus
        local _btn = zc.createPushButton({
            touchSize = cc.size( _iconBgWidth, _iconBgHeight ),
            pos = cc.p( _iconBgWidth/2, _iconBgHeight/2 ),
            endCallback = function()
                --功能引导
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_11404 then
                    zc.setGuideFuncNextStep(_currentGID)
                end
                local info = {
                    data = self._activateList[i],
                    status = self._starupStatus[i],
                    key = self:getStarKey( self._starupLevel ),
                    heroId = self._id,
                    starId = self._starupList.id,
                    index = i,
                    callback = function( grid )
                        if grid then
                            self._gridData = tostring( grid or 0 )
                            -- 升星材料数据
                            self:buildStatusData()
                            self:showAttr( i )
                            self:showSpine( i )
                        end
                        self:guideFunc_1()
                    end
                }
                zc.createSourcePop("RoleStarupInfo", "src/layer/role/RoleStarupInfoPop.lua", info)
            end
        })
        _iconBg:addChild( _btn )
        _iconBg._btn = _btn
        _btn:setContentSize( _iconBgWidth, _iconBgHeight )
    end
    -- 技能图标

    local _skillBtn = zc.createIconByData({
        data = {
            mainType=zc.mainTypeSkill,
            type=1,
            id=1,
        },
        pos = cc.p( _starupBgWidth/2, _starupBgHeight/2 ),
    })
    _starupBg:addChild( _skillBtn)
    self._skillBtn = _skillBtn

    self.tbn = ZCSprite:create("res/Main/hero/skill/265.jpg")
    self.tbn:setPosition(_starupBgWidth/2,_starupBgWidth/2)
    _starupBg:addChild(self.tbn)
    self.tbn:setVisible(false)

    local _skillTop = cc.Sprite:create( "res/Main/role/starup/skillTop.png" )
    _skillTop:setPosition( _skillBtn:getPosition() )
    _starupBg:addChild( _skillTop )
    
    -- 一键装备
    local _oneKeyBtn = zc.createCommomBtn({
        tag = 2,
        text = LANGUAGE_ROLE.one_key_activate,
        pos = cc.p( 15, 25 ),
        endCallback = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_11406 then
                zc.setGuideFuncNextStep(_currentGID, false)
                self:guideFunc_1()
            end
            local index = nil
            local oneKeyFlag = false
            for i, v in ipairs( self._starupStatus ) do
                if not v.activated and v.activatable then
                    oneKeyFlag = true
                    index = index and index.."|"..i or i
                end
            end
            if oneKeyFlag then
                zc.sendHttp({
                    apiName = "Hero_activeGrid",
                    params = {heroId = self._id, starId = self._starupList.id, indexs = index},
                    successCallback = function( data )
                        PlayerData:updataData( data )
                        PlayerData:setGeneralInfoById( self._id, data.hero )
                        self._gridData = tostring( data.hero.grid or 0 )
                        -- 升星材料数据
                        self:buildStatusData()
                        self:showAttr( index )
                        self:showSpine( index )
                        -- 刷新升星红点
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 4}})
                    end,
                })
            else
                zc.tipInfo( LANGUAGE_ROLE.no_equip )
            end
        end
    })
    _starupBg:addChild( _oneKeyBtn )
    self._guide_oneKey = _oneKeyBtn
    -- 升星
    local _starupBtn = zc.createCommomBtn({
        tag = 1,
        text = LANGUAGE_ROLE.starup,
        pos = cc.p( _starupBgWidth - 15, 25 ),
        endCallback = function ()
            -- 判断是否全都镶嵌
            local starupFlag = true
            for i, v in ipairs( self._starupStatus ) do
                if not v.activated then
                    starupFlag = false
                    break
                end
            end
            if not starupFlag then
                -- 有没有镶嵌的
                zc.tipInfo( LANGUAGE_ROLE.activate_all_to_starup )
                return
            end
            -- 判断升星材料是否充足
            for i, v in ipairs( self._starupData.consume ) do
                if zc.getNumByTypeId( v.itemType, v.itemId ) < tonumber( v.itemNum or 0 ) then
                    starupFlag = false
                    break
                end
            end
            if starupFlag then
                zc.sendHttp({
                    apiName = "Hero_upgradeStar",
                    params = {heroId = self._id, starId = self._starupList.id},
                    successCallback = function( data )
                        getGuideManager():addMaskLayer()
                        PlayerData:updataData( data )
                        PlayerData:setGeneralInfoById( self._id, data.hero )
                        musicManager.playEffect( zc.effect.heroStarup )
                        self._starupLevel = tonumber( data.hero.star or 0 )
                        self._gridData = tostring( data.hero.grid or 0 )
                        local _armature = zc.createArmature({
                            parentPath = "res/animation/shengxing/",
                            fileName = "shengxing",
                            autoRemove = true,
                            actName = "idle",
                            eventCallback = function() end,
                            completeCallback = function()
                                zc.createSourcePop("RoleStarupSuccessPop", "src/layer/role/RoleStarupSuccessPop", {heroData = self._heroData, skillData = self._skillData, record = self._record})
                                -- 升星数据
                                self:buildStarupData()
                                -- 升星材料数据
                                self:buildStatusData()
                                self:showSpine( "1|2|3|4|5|6" )
                                getGuideManager():removeMaskLayer()
                            end
                        })
                        _armature:setPosition( self._starupBgWidth/2 + 3, self._starupBgHeight/2 )
                        self._starupBg:addChild( _armature )
                        -- 刷新升星红点
                        zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLELAYER_CHANGE, data = {id = 4}})
                    end,
                })
            else
                zc.tipInfo( LANGUAGE_ROLE.consume_not_enough )
            end
        end
    })
    _starupBg:addChild( _starupBtn )
    self._starupBtn = _starupBtn

    local _frame = ccui.Scale9Sprite:create( cc.rect( 16, 0, 32, 511 ), "res/Main/common/frame.png" )
    _frame:setContentSize( 611, 513 )
    _frame:setAnchorPoint( 0, 1 )
    _frame:setPosition( 2, self._height )
    _bg:addChild( _frame )
end
-- 战斗力变化响应
function RoleStarupLayer:onFightChange( data )
    zc.numChangeAnimation({
        label = self._fightNum,
        pos = cc.p( self._fightNum:getContentSize().width/2, 20 ),
        callback = function()
            self._fightNum:setString( data.fighting )
        end
    })
end

-- 更换武将刷新
function RoleStarupLayer:refreshHero( params )
    self:refreshHeroData( params )

    self:refreshHeroUI()
end
function RoleStarupLayer:refreshHeroData( params )
    -- 数据
    self._id = tonumber( params.id ) or 1

    -- 武将数据
    self._heroData = PlayerData:getGeneralInfoById( self._id )

    -- 武将信息，静态表，用来显示资质和阵营和兵器图标
    self._heroList = gameData.getDataFromCacheWithPrimaryKey("hero", self._heroData.heroId)

    -- 兵器数据
    self._weaponData = PlayerData:getWeaponsInfoById( self._id )

    self._starupLevel = tonumber( self._heroData.star ) or 0
    self._gridData = tostring( self._heroData.grid )

    -- 升星数据
    self:buildStarupData()

    -- 升星材料数据
    self:buildStatusData()

    -- 是否是主角
    local _mainRoleId = tonumber( PlayerData.info.heroId ) or 0
    self._isMainRole = _mainRoleId == self._id

    self._record = params.record
end
function RoleStarupLayer:refreshHeroUI()
    -- 名字
    local _nameText = zc.getLevelTipShow()..self._heroData.level.." "..( self._isMainRole and PlayerData.info.userName or  self._heroData.name )
    local _reincarnate = tonumber( self._heroData.reincarnate ) or 0
    if _reincarnate > 0 then
        _nameText = _reincarnate .. zc.lang("turn") .. _nameText
    end
    local _newAdvance = tonumber(self._heroData.newAdvance) or 0
    if _newAdvance > 0 then
        _nameText = _nameText .. "+" .. _newAdvance
    end
    local _titleText = self._heroData.title
    self._name:setString( _nameText.."  [color=ffe400ff]< ".._titleText.." >[/color]" )
    if self._isMainRole then
        self._selectTitle:setVisible( true )
    else
        self._selectTitle:setVisible( false )
    end
    -- 兵器图标
    local _weaponType = 1
    if self._isMainRole then
        -- 主角
        _weaponType = tonumber( self._weaponData.type ) or 1
    else
        _weaponType = tonumber( self._heroList.weaponType ) or 1
    end
    self._weaponIcon:setTexture( zc.getHeroTypeBigImg( _weaponType ) )

    self:judgeData()
end
-- 升星静态数据
function RoleStarupLayer:buildStarupData()
    local _heroId = tonumber( self._heroData.heroId ) or 1
    local _starupLevel = self._starupLevel
    
    -- 下一等级的升星数据
    local _starupList = gameData.getDataFromCache("hero_star_level", {heroId = _heroId, level = _starupLevel + 1})
    self._starupList = _starupList
    -- 激活数据
    do
        self._activateList = {}
        local _itemIdTable = string.split( _starupList.itemId or "", "," )
        for i = 1, 6 do
            if _starupList["gridType"..i] and _starupList["gridStuffs"..i] and _starupList["gridEffects"..i] then
                local _key = tonumber( _starupList["gridType"..i] ) or 1
                local _consume = {}
                for j, v in ipairs( string.split( _starupList["gridStuffs"..i], "," ) ) do
                    local __consume = string.split( v, "|" )
                    _consume[#_consume + 1] = {
                        itemType = __consume[1],
                        itemId = __consume[2],
                        itemNum = __consume[3],
                    }
                end
                local _effect = {}
                for j, v in ipairs( string.split( _starupList["gridEffects"..i], "," ) ) do
                    local __effect = string.split( v, "|" )
                    _effect[#_effect + 1] = {
                        attr = LANGUAGE_getAttributeTextById( __effect[1] ),
                        value = zc.getAttributeNumById( __effect[1], __effect[2] ),
                    }
                end
                self._activateList[#self._activateList + 1] = {
                    -- 激活消耗
                    consume = _consume,
                    -- 激活效果
                    effect = _effect,
                    -- 激活物品
                    itemId = _itemIdTable[i] or 0,
                }
            end
        end
    end
    -- 升星数据
    do
        self._starupData = {}
        local _consume = {}
        for i, v in ipairs( string.split( self._starupList["stuffs"] or "", "," ) ) do
            local __consume = string.split( v, "|" )
            _consume[#_consume + 1] = {
                itemType = __consume[1],
                itemId = __consume[2],
                itemNum = __consume[3],
            }
        end
        local _effect = {}
        for i, v in ipairs( string.split( self._starupList["effects"] or "", "," ) ) do
            local __effect = string.split( v, "|" )
            _effect[#_effect + 1] = {
                attr = LANGUAGE_getAttributeTextById( __effect[1] ),
                value = zc.getAttributeNumById( __effect[1], __effect[2] ),
            }
        end
        self._starupData = {
            consume = _consume,
            effect = _effect,
        }
    end

    -- 技能信息，可能再升一星没有技能，接着向下找
    do
        local _nxtStarLevel = _starupLevel + 1
        local skillData = {}
        while true do
            skillData = gameData.getDataFromCache( "hero_star_level", { heroId = _heroId, level = _nxtStarLevel } )
            if next( skillData ) then
                if skillData.skills then
                    local _skillData = string.split( skillData.skills, "|" )
                    local _skillId = tonumber( _skillData[1] ) or 0
                    if _skillId ~= 0 then
                        -- 有技能
                        break
                    end
                end
            else
                skillData = nil
                break
            end
            _nxtStarLevel = _nxtStarLevel + 1
        end
        if skillData then
            -- 还有技能可以解锁
            local _skillData = string.split( skillData.skills, "|" )
            local _skillId = tonumber( _skillData[1] ) or 0
            if _skillId > 10000 then
                -- 升星技能
                self._skillData = {
                    id = _skillData[1],
                    desc = skillData.desc or "",
                    name = skillData.name or "",
                    starLevel = _nxtStarLevel,
                    skillLevel = tonumber( _skillData[2] ),
                }
            else
                -- 其他技能
                skillData = gameData.getDataFromCacheWithPrimaryKey( "skill", _skillData[1])
                self._skillData = {
                    id = _skillData[1],
                    desc = skillData.desc1 or "",
                    name = skillData.name or "",
                    starLevel = _nxtStarLevel,
                    skillLevel = tonumber( _skillData[2] ),
                }
            end
        else
            -- 没有可以解锁的技能了
            self._skillData = nil
        end
    end
end
-- 升星状态数据
function RoleStarupLayer:buildStatusData()
    self._starupStatus = {}
    
    for i, v in ipairs( self._activateList ) do
        local consumeFlag = true
        for j, u in ipairs( v.consume ) do
            if zc.getNumByTypeId( u.itemType, u.itemId ) < tonumber( u.itemNum or 0 ) then
                consumeFlag = false
                break
            end
        end
        self._starupStatus[i] = {activatable = consumeFlag, activated = false}
    end

    -- 是否已经激活
    if #self._gridData == 7 then
        for i, v in ipairs( self._starupStatus ) do
            local flag = tonumber( string.sub( self._gridData, i + 1, i + 1 ) ) == 1
            v.activated = flag
        end
    end
end
-- 刷新升星装备
function RoleStarupLayer:refreshStatusUI()
    -- 获取资源key
    local _key = self:getStarKey( self._starupLevel )
    for i, v in ipairs( self._iconBg ) do
        local _itemId = self._activateList[i].itemId
        local _iconData = zc._getIconInfo({
            data = {
                mainType=zc.mainTypeProp,
                type=_itemId,
                id=_itemId,
            }
        })
        v._icon:setTexture( _iconData.img )
        if self._starupStatus[i].activated then
            -- 已激活
            v:setTexture( "res/Main/role/starup/fullBg_".._key..".png" )
            zc.setGray( v, false )
            zc.setGray( v._icon, false )
            v._plus:setVisible( false )
        else
            -- 未激活
            v:setTexture( "res/Main/role/starup/emptyBg_".._key..".png" )
            zc.setGray( v )
            zc.setGray( v._icon )
            -- 材料是否充足
            if self._starupStatus[i].activatable then
                -- 材料充足
                v._plus:setVisible( true )
                if not self._guide_btn then
                    self._guide_btn = v
                end
            else
                -- 材料不充足
                v._plus:setVisible( false )
            end
        end
    end
end
-- 星级改变刷新
function RoleStarupLayer:refreshStarupUI()
    -- 星级
    zc.createHeroStar( self._bg, self._heroData.star, cc.p( 56, self._height - 96 ) )
    self:refreshConsume()

    local _newAdvance = tonumber(self._heroData.newAdvance) or 0
    local _params = {
        heroId = self._heroData.heroId,
        star = self._heroData.star, 
        newAdvance = newAdvance,
    }
    if self._heroData.id == tonumber(PlayerData.info.heroId) then
        _params.heroData = self._heroData
    end
    local _skillData = zc.getHeroSkillData(_params)
    local flag = false
    local aoyi_list = {}
    for k,v in pairs(_skillData) do
        if v.skillType == 4 then
            if v.id == tonumber(self._skillData.id) then
                flag = true
            end
            table.insert(aoyi_list,v)
        end
    end
    -- 奥义走通用统一图标
    if flag then
        self._skillBtn:setVisible(false)
        self.tbn:setVisible(true)
        dump(self._heroData,"self._heroData")
        dump(self._skillData,"test")
        self.tbn:setTouchEndedCallback(function ()
            zc.createSourcePop( "RoleStarupSkill", "src/layer/role/RoleStarupSkillPop.lua", {
                skillData = self._skillData,
                -- aoyiData = aoyi_list,
                heroData = self._heroData,
            })
        end)
        
    else
        if self.tbn then self.tbn:setVisible(false) end
        self._skillBtn:setVisible(true)
        zc.updateIconByData(self._skillBtn, {
            data = {
                mainType=zc.mainTypeSkill,
                type=self._skillData.id,
                id=self._skillData.id,
            },
            listener=function()
                zc.createSourcePop( "RoleStarupSkill", "src/layer/role/RoleStarupSkillPop.lua", {skillData = self._skillData} )
            end
        })
    end
end
-- 刷新升星消耗
function RoleStarupLayer:refreshConsume()
    -- 升星消耗
    for i, v in ipairs( self._starupConsume or {} ) do
        v.icon:removeFromParent()
        v.num:removeFromParent()
    end
    self._starupConsume = {}
    local _consumeWidth = 0
    for i, v in ipairs( self._starupData.consume ) do
        local _info = zc._getIconInfo({data={mainType=v.itemType,type=v.itemId,id=v.itemId}})
        local _icon = cc.Sprite:create( _info.img )
        _icon:setScale( 40/_icon:getContentSize().width )
        self._starupBg:addChild( _icon )
        local _num = zc.createLabel({
            text = v.itemNum,
            fontSize = 18,
            color = zc.getNumByTypeId( v.itemType, v.itemId ) < tonumber( v.itemNum or 0 ) and display.COLOR_RED or display.GREEN,
            ttf = zc.getFont( 1 ),
            ap = cc.p( 0, 0.5 ),
            outLine = true,
        })
        self._starupBg:addChild( _num )
        self._starupConsume[#self._starupConsume + 1] = {icon = _icon, num = _num, pos = _consumeWidth}
        _consumeWidth = _consumeWidth + 35 + _num:getContentSize().width
    end
    local _beginX = self._starupBtn:getPositionX() - _consumeWidth/2
    for i, v in ipairs( self._starupConsume ) do
        local _posY = self._starupBtn:getPositionY() + 45
        v.icon:setPosition( _beginX + v.pos + 15, _posY )
        v.num:setPosition( _beginX + v.pos + 35, _posY )
    end
end
-- 通过星级获取资源的key
function RoleStarupLayer:getStarKey( starLevel )
    local _starLevel = tonumber( starLevel ) or 0
    if _starLevel <= 5 then
        return "green"
    elseif _starLevel <= 10 then
        return "blue"
    elseif _starLevel <= 15 then
        return "purple"
    end
end


--功能引导
function RoleStarupLayer:guideFunc_1()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_11404 then
        getGuideManager():setObjTarget(self._iconBg[1])
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_11406 then
        getGuideManager():setObjTarget(self._guide_oneKey)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_11407 then
        local function _callBack()
            getGuideManager():setFuncGuideOver()
            local _heroList = zc.getScene("HeroListLayer")
            if _heroList then
                _heroList._guideHandFlag = true
            end
            local _roleLayer = zc.getScene("RoleAttributeLayer")
            if _roleLayer and _roleLayer._back then
                local _guideHand = zc.createSpine({
                    fileName = "shou",
                    actName = "shou",
                    scale = 0.8
                })
                _guideHand:setPosition(cc.pMul(cc.pFromSize(_roleLayer._back:getContentSize()), 0.5))
                _roleLayer._back:addChild(_guideHand, 10)
                performWithDelay(_guideHand, function()
                    _guideHand:removeFromParent()
                    _guideHand = nil
                end, 4)
            end
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

-- 飘属性动画
function RoleStarupLayer:showAttr( index )
    local _index = string.split( tostring(index), "|" )
    local _attr = {}
    for i, v in ipairs( _index ) do
        for j, u in ipairs( self._activateList[tonumber(v)].effect ) do
            _attr[#_attr + 1] = u.attr.." +"..u.value
        end
    end
    -- dump( _attr )
    for i, v in ipairs( _attr ) do
        local _attrLabel = zc.createLabel({
            text = v,
            outLine = true,
            fontSize = 30,
            fontName = zc.getFont(1),
            ap = cc.p(0.5, 0.5),
            pos = cc.p( self._starupBgWidth/2, self._starupBgHeight/2 ),
            color = display.COLOR_GREEN,
            color2 = display.COLOR_BLACK,
            align = kCCTextAlignmentCenter,
            pixel = 1.3
        })
        self._starupBg:addChild(_attrLabel, 100)
        _attrLabel:setScale(0.01)
        _attrLabel:runAction(
            cc.Sequence:create(
                cc.DelayTime:create((i-1)*0.4),
                cc.Spawn:create(
                    cc.ScaleTo:create(0.3, 1.2),
                    cc.MoveBy:create(0.3, cc.p(0, 15))
                ),
                cc.Spawn:create(
                    cc.MoveBy:create(0.4, cc.p(0, 20)),
                    cc.ScaleTo:create(0.2, 1.0)   
                ),
                cc.Spawn:create(
                    cc.MoveBy:create(0.5, cc.p(0, 50)),
                    cc.FadeOut:create(0.4)
                ),
                cc.RemoveSelf:create(true)
            )
        )
    end
end

-- 道具爆动画
function RoleStarupLayer:showSpine( index )
    local _index = string.split( tostring(index), "|" )
    for i, v in ipairs( _index ) do
        local _icon = self._iconBg[tonumber(v)]
        local _spine = zc.createSpine({
            fileName = "shilianchou",
            actName = "start_4",
            loop = false,
            needInit = false
        })
        _spine:setPosition( _icon:getContentSize().width/2, _icon:getContentSize().height/2 )
        _icon:addChild( _spine )
        _spine:registerSpineEventHandler(function( event )
            if event.eventData.name == "hit" then
                self:judgeData()
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ROLE_REFRESHSKILL})
            end
        end, sp.EventType.ANIMATION_EVENT)
    end
end

function RoleStarupLayer:judgeData()
    if not next( self._starupList ) then
        -- 没有升星
        self._starupBg:setVisible( false )
        for i = 1, 5 do
        local star = self._bg:getChildByName( "star_"..i )
        if star then
            star:removeFromParent()
        end
    end
        zc.tipInfo(zc.lang("already_up_to_max_star"))
    else
        self._starupBg:setVisible( true )
        -- 刷新升星装备
        self:refreshStatusUI()
        -- 刷新升星
        self:refreshStarupUI()
    end
end


return RoleStarupLayer