--[[
-- 饰品洗炼属性弹窗
-- @author lph
-- Creation  2015-12-13
]]

local TrinketReplaceAttrLayer = class("TrinketReplaceAttrLayer",function ()
	return ZCPopLayer:create()
end)

function TrinketReplaceAttrLayer:create(data)
    local layer = TrinketReplaceAttrLayer.new(data)
    return layer
end
function TrinketReplaceAttrLayer:onCleanup()
    zc.saveFightingChange()
end
function TrinketReplaceAttrLayer:ctor(data)
    self._type = data._type  -- 1 洗练 2 转移
    self._item = data.item
    self._curItem = data.curItem
    self._itemTemp = gameData.getDataFromCacheWithPrimaryKey("trinket", data.item.trinketId)
    self._curItemTemp = gameData.getDataFromCacheWithPrimaryKey("trinket", data.curItem.trinketId)
    self._replaceAttrFunc = data.replaceAttrFunc or nil
    self._transferAttrFunc = data.transferAttrFunc or nil 
    self._leftFunc = data.leftFunc
    self._rightFunc = data.rightFunc
    self._fightCallback = data.fightCallback
    --左侧饰品主属性
    self._left_main_attr = zc.getEquipAttriNameByEffectType(self._curItemTemp.effectId,true)..":".. self._curItemTemp.effectValue
    --右侧饰品主属性
    self._right_main_attr = zc.getEquipAttriNameByEffectType(self._itemTemp.effectId,true)..":".. self._itemTemp.effectValue

    self:getContainerLayer():setTouchEndedCallback(function() end)
    self:initUI()

end

function TrinketReplaceAttrLayer:initUI()
    local _colorbg = ZCDialog:create(160)
    self:addChild(_colorbg)
    --背景1
    local _bg_1 = cc.Sprite:create("res/Main/ornaments/replaceAttr_bg.png")
    _bg_1:setAnchorPoint(cc.p(0.5,0.5))
    _bg_1:setPosition(zc.width/2, zc.height/2-10)
    self:addChild(_bg_1)
    self._bg_1 = _bg_1
    --背景--
    local _bg = zc.createImageView({
        src = "res/Main/ornaments/replaceAttr_bg_1.png",
        ap = cc.p(0.5,1),
        pos = cc.p(zc.width/2, _bg_1:getContentSize().height-20)
    })
    _bg_1:addChild(_bg)
    self._bg = _bg

    -- 关闭按钮
    local closeBtn = zc.createBackButton({
        pos = cc.p( _bg_1:getContentSize().width-40, _bg_1:getContentSize().height ),
        listener = function ()
            if self._rightFunc then
                if self._replaceData then
                    self._rightFunc(self._replaceData)
                end
            end
            self:hide()
        end
    })
    _bg_1:addChild( closeBtn )
    self._closeBtn = closeBtn

    --左侧
    local _left_bg_s = cc.Sprite:create()
    _left_bg_s:setContentSize(cc.size(324,407))
    _left_bg_s:setPosition(50, _bg:getContentSize().height-10)
    _left_bg_s:setAnchorPoint(cc.p(0,1))
    _bg:addChild(_left_bg_s)
    --左侧icon
    --统一创建饰品
    local _trinket_icon_left = zc.createIconByData({
        data = {
            type = 1, 
            id = self._curItemTemp.id,
            hideCount = true,
            mainType = zc.mainTypeTrinket,
            quality = self._curItemTemp.color,
            plistType = true,
        }, 
        pos = cc.p(10, _left_bg_s:getBoundingBox().height-5),
    })
    _trinket_icon_left:setScale(0.65)
    _trinket_icon_left:setAnchorPoint(cc.p(0,1))
    _left_bg_s:addChild(_trinket_icon_left)
    
    --饰品名称
    local _trinketName = zc.createLabel({
        text = self._curItemTemp.name,
        fontSize = 24,
        ttf = zc.getFont(1),
        ap = cc.p(0, 1),
        pos = cc.p(100, _left_bg_s:getBoundingBox().height-10),
        color = zc.getColorByQuality(self._curItemTemp.color),
        outLine = true,
    })
    _left_bg_s:addChild(_trinketName)
    local equipedLab = zc.createLabel({
        text = "(" .. zc.lang("equiped") .. ")",
        outLine = true,
        fontSize = 24,
        fontName = zc.getFont(1),
        ap = cc.p(0, 1),
        pos = cc.p(_trinketName:getPositionX()+_trinketName:getContentSize().width, _trinketName:getPositionY() ),
        pixel = 1.3
    })
    _left_bg_s:addChild(equipedLab)
    
    --左侧饰品主属性
    local _left_main_attr = zc.createLabel({
        text = self._left_main_attr,
        fontSize = 24,
        outLine = true,
        ttf = zc.getFont(1),
        ap = cc.p(0, 1),
        pos = cc.p(100, _left_bg_s:getBoundingBox().height-50),
        --color = display.COLOR_BROWN,
    })
    _left_bg_s:addChild(_left_main_attr)
    --属性背景
    self._left_bg_s_1 = _left_bg_s
    --创建左侧饰品附加属性
    self:initLeftTrinketExtAttr()

    --右侧
    local _right_bg_s = cc.Sprite:create()
    _right_bg_s:setContentSize(cc.size(324,407))
    _right_bg_s:setPosition(_bg:getContentSize().width-20, _bg:getContentSize().height-10)
    _right_bg_s:setAnchorPoint(cc.p(1,1))
    _bg:addChild(_right_bg_s)
    --属性背景
    self._right_bg_s_1 = _right_bg_s

     --右侧icon
     --统一创建饰品
    local _trinket_icon_right = zc.createIconByData({
        data = {
            type = 1, 
            id = self._itemTemp.id,
            hideCount = true,
            mainType = zc.mainTypeTrinket,
            quality = self._itemTemp.color,
            plistType = true,
        }, 
        pos = cc.p(10, _right_bg_s:getBoundingBox().height-5),
    })
    _trinket_icon_right:setScale(0.65)
    _trinket_icon_right:setAnchorPoint(cc.p(0,1))
    _right_bg_s:addChild(_trinket_icon_right)

    --饰品名称
    local _trinketName = zc.createLabel({
        text = self._itemTemp.name,
        fontSize = 24,
        ttf = zc.getFont(1),
        outLine = true,
        ap = cc.p(0, 1),
        pos = cc.p(100, _right_bg_s:getBoundingBox().height-10),
        color = zc.getColorByQuality(self._itemTemp.color),
    })
    _right_bg_s:addChild(_trinketName)
    --右侧饰品主属性
    local _right_main_attr = zc.createLabel({
        text = self._right_main_attr,
        fontSize = 24,
        ttf = zc.getFont(1),
        ap = cc.p(0, 1),
        pos = cc.p(100, _left_bg_s:getBoundingBox().height-50),
        outLine = true,
        --color = display.COLOR_BROWN,
    })
    _right_bg_s:addChild(_right_main_attr)

    --创建右侧饰品附加属性
    self:initRightTrinketExtAttr()

    --消耗金币背景
    local _gold_bg = zc.createImageView({
        src = "res/Main/copy/copy_di.png",
        pos = cc.p(_bg_1:getBoundingBox().width-250, 45)
    })
    _bg_1:addChild(_gold_bg)
    
    --金币icon
    local _gold_icon = zc.createImageView({
        src = "res/Main/common/common_icon_money.png",
        pos = cc.p(20, 10)
    })
    _gold_bg:addChild(_gold_icon)
    --洗炼所需金币
    self._replaceEnable = tonumber(PlayerData:getResourcesInfo()["money"]) >= tonumber(self._curItemTemp.replacePrice)
    local _color = display.COLOR_WHITE
    if not self._replaceEnable then
        _color = display.COLOR_RED
    end
    local _need_gold = zc.createLabel({
        text = self._curItemTemp.replacePrice,
        fontSize = 20,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(40, 10),
        color = _color,
        outLine = true
    })
    _gold_bg:addChild(_need_gold)
    self._gold_bg = _gold_bg
    

    --中间标题 
    local _strPath = "res/Main/ornaments/trinket_title_zy.png"
    if self._type == 1 then 
        _strPath = "res/Main/ornaments/trinket_title_xl.png" 
        --洗练按钮
        local _replaceAttrBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("xilian_2"),
            pos = cc.p(_bg_1:getBoundingBox().width-110, 45), 
            endCallback = function ()
                local targetIndx = self.index
                local _data = {id = self._curItem.id,stuffId = self._item.id,index = targetIndx}
                self._isWashing = true
                zc.sendHttp({
                    apiName = "Trinket_replaceAttribute",
                    params = _data,
                    successCallback = function (data)
                        self._closeBtn:setEnable(false)
                        self._replaceAttrBtn:setEnable(false)
                        --新手引导
                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_11515 then
                            getGuideManager():guideOver()
                            getGuideManager():setNextGID(_currentGID)
                        end
                        data["targetIndx"] = targetIndx --目标顺序
                        self:replaceAttrSuccess(data)
                    end,
                })
            end,
        })
        _bg_1:addChild(_replaceAttrBtn)
        self._replaceAttrBtn = _replaceAttrBtn
        self._replaceAttrBtn:setEnable(self._replaceEnable)
        --左侧提示
        local _left_text_bg = cc.Sprite:create("res/Main/ornaments/trinket_text_bg.png")
        _left_text_bg:setPosition(50, 19)
        _left_text_bg:setAnchorPoint(cc.p(0,0.5))
        _bg:addChild(_left_text_bg)

        local _left_tips = zc.createLabel({
            text = zc.lang("please_select_property_xilian"),
            fontSize = 22,
            ttf = zc.getFont(1),
            ap = cc.p(0, 0.5),
            pos = cc.p(80, 15),
            color = cc.c3b( 217, 202, 169 ),
            outLine = true
        })
        _left_text_bg:addChild(_left_tips)
        

        --右侧提示
        local _right_text_bg = cc.Sprite:create("res/Main/ornaments/trinket_text_bg.png")
        _right_text_bg:setPosition(_bg:getBoundingBox().width/2, 19)
        _right_text_bg:setAnchorPoint(cc.p(0,0.5))
        _bg:addChild(_right_text_bg)
        local _right_tips = zc.createLabel({
            text = zc.lang("xilian_cover_origin_property"),
            fontSize = 22,
            ttf = zc.getFont(1),
            ap = cc.p(0, 0.5),
            pos = cc.p(180, 15),
            color = cc.c3b( 217, 202, 169 ),
            outLine = true
        })
        _right_text_bg:addChild(_right_tips)
    else
        _need_gold:setString(tostring(self._itemTemp.transferPrice))

        self._transferEnable = tonumber(PlayerData:getResourcesInfo()["money"]) >= tonumber(self._curItemTemp.transferPrice)

        --确定按钮
        local _sureAttrBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("finish_2"),
            pos = cc.p(_bg_1:getBoundingBox().width-110, 45), 
            endCallback = function () 
                self:hide()
                -- self:removeSelf()
            end,
        })
        _bg_1:addChild(_sureAttrBtn)
        _sureAttrBtn:setVisible(false)
        self._sureAttrBtn = _sureAttrBtn

        --转移按钮
        local _transferAttrBtn = zc.createCommomBtn({
            tag = 1,
            text = zc.lang("transfer_2"),
            pos = cc.p(_bg_1:getBoundingBox().width-110, 45), 
            endCallback = function () 
                local _data = {leftId = self._curItem.id,rightId = self._item.id}
                zc.sendHttp({
                    apiName = "Trinket_transfer",
                    params = _data,
                    successCallback = function (data)
                       self:updateView(data)
                    end,
                })
            end,
        })
        _bg_1:addChild(_transferAttrBtn)
        self._transferAttrBtn = _transferAttrBtn
        self._transferAttrBtn:setEnable(self._transferEnable)
    end
    --洗炼或者转移中间标题 
    local _title_xl = zc.createImageView({
        src = _strPath,
        pos = cc.p(_bg:getBoundingBox().width/2+50, _bg:getBoundingBox().height/2-40),
    })
    _bg:addChild(_title_xl,9)
    if self._type == 1 then 
        self:registerTouchScriptHandler()
    else
        local _arrow_bg = cc.Sprite:create()
        _arrow_bg:setContentSize(_title_xl:getContentSize())
        _arrow_bg:setPosition(_title_xl:getContentSize().width/2, _title_xl:getContentSize().height/2)
        _title_xl:addChild(_arrow_bg)
        self._arrow_bg = _arrow_bg

        local _arrow_1 = cc.Sprite:create("res/Main/ornaments/trinket_arrow_1.png")
        _arrow_1:setPosition(85, 173)
        _arrow_bg:addChild(_arrow_1)
        _arrow_1:setOpacity(100)
        self._arrow_1 = _arrow_1
        local _arrow_2 = cc.Sprite:create("res/Main/ornaments/trinket_arrow_1.png")
        _arrow_2:setScale(-1)
        _arrow_2:setPosition(120, 10)
        _arrow_bg:addChild(_arrow_2)
        _arrow_2:setOpacity(100)
        self._arrow_2 = _arrow_2
    end
    -- self:setCloseContent(_bg)
end
--注册点击
function TrinketReplaceAttrLayer:registerTouchScriptHandler()
    --开始注册点击事件
    local listener = cc.EventListenerTouchOneByOne:create()
    listener:setSwallowTouches(false)
    --触摸开始
    listener:registerScriptHandler(function(touch, event) 
        return true
    end, cc.Handler.EVENT_TOUCH_BEGAN)
    --触摸滑动
    listener:registerScriptHandler(function(touch, event)

    end, cc.Handler.EVENT_TOUCH_MOVED)
    --触摸结束
    listener:registerScriptHandler(function(touch, event)
        local point = self._left_bg_s_1:convertToNodeSpace(touch:getLocation())
        if self._isWashing then --如果点击了洗练就不让点击
            return
        end
        for k,v in pairs(self._left_extAttr_bg_list) do
            if cc.rectContainsPoint(v.left_extAttr_bg:getBoundingBox(), point ) then
                v.left_arrow:setVisible(true)
                v.left_choosedBox:setVisible(true)
                self.index = v.id
            end
        end
        for k,v in pairs(self._left_extAttr_bg_list) do
            if v.id ~= self.index then
                v.left_arrow:setVisible(false)
                v.left_choosedBox:setVisible(false)
            end
        end
    end, cc.Handler.EVENT_TOUCH_ENDED)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    --给精灵添加点击事件
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self._bg)
end

--创建左侧饰品附加属性
function TrinketReplaceAttrLayer:initLeftTrinketExtAttr()
    self._left_extAttr_bg_list = {}
    self._left_extAttr_flag = false
    self.index = 6
    for i=1,6 do
        self:createLeftTrinketExtAttr(i)
    end  
end 
 --创建左侧附加属性
function TrinketReplaceAttrLayer:createLeftTrinketExtAttr(_id)
    if self._left_extAttr_flag then return end
    local _str_effectId = "effectId" .. _id
    local _str_effectValue = "effectValue" .. _id
    local _str_effectColor = "effectColor" .. _id
    if tonumber(self._curItem[_str_effectId]) == 0 then 
        -- if _id >= 4 then return end
        _left_extAttr_text_1 = zc.lang("empty") 
        self._left_extAttr_flag = true
        self.index = _id
    else
        _left_extAttr_text_1 = zc.getEquipAttriNameByEffectType(self._curItem[_str_effectId])..":".. self._curItem[_str_effectValue]
    end
     --属性背景
    local _str = "res/Main/ornaments/trinket_attr_bg_1.png"
    if _id % 2 == 0 then
        _str = "res/Main/ornaments/trinket_attr_bg_2.png"
    end
    local _left_extAttr_bg_s_1 = cc.Sprite:create(_str)
    _left_extAttr_bg_s_1:setPosition(0, self._left_bg_s_1:getBoundingBox().height-99 - (tonumber(_id)-1)*48)
    _left_extAttr_bg_s_1:setAnchorPoint(cc.p(0,1))
    self._left_bg_s_1:addChild(_left_extAttr_bg_s_1,2)
    --选中框
    local _sprite_box = cc.Sprite:create("res/Main/common/check_bg2.png")
    _sprite_box:setPosition(10, 25)
    _sprite_box:setAnchorPoint(cc.p(0, 0.5))
    _left_extAttr_bg_s_1:addChild(_sprite_box)
    
    --属性1
    local _left_extAttr_1 = zc.createLabel({
        text = _left_extAttr_text_1,
        fontSize = 24,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(80, 25),
        color = zc.getColorByQuality(self._curItem[_str_effectColor]),
        outLine = true
    })
    _left_extAttr_bg_s_1:addChild(_left_extAttr_1,2)
    
    _left_extAttr_1:setString(_left_extAttr_text_1)
    --小箭头1
    local _left_arrow_1 = zc.createImageView({
        src = "res/Main/common/check.png",
        pos = cc.p(10, 25),
        ap = cc.p(0, 0.5),
    })
    _left_arrow_1:setScale( 0.6 )
    _left_extAttr_bg_s_1:addChild(_left_arrow_1,2)
    _left_arrow_1:setVisible(self._left_extAttr_flag)
    --选中框1
    local _left_choosedBox_1 = zc.createImageView({
        src = "res/Main/ornaments/trinket_choosedBox.png",
        pos = cc.p(0, 25),
        ap = cc.p(0, 0.5),
    })

    _left_extAttr_bg_s_1:addChild(_left_choosedBox_1)
    _left_choosedBox_1:setVisible(self._left_extAttr_flag)
    if self._type == 2 then
        _sprite_box:setVisible(false)
        if tonumber(_id) == 1 then
            _left_choosedBox_1:setPosition(cc.p(-5,-100))
            _left_choosedBox_1:loadTexture("res/Main/ornaments/trinket_choosedBox_big_left.png") 
            _left_choosedBox_1:setVisible(true) 
            local _seq = cc.Sequence:create(cc.FadeTo:create(1.0,50),cc.FadeTo:create(1.0,255))
            _left_choosedBox_1:runAction(cc.RepeatForever:create(_seq))
            self._left_choosedBox_1 = _left_choosedBox_1
        else
            _left_choosedBox_1:setVisible(false)
            _left_arrow_1:setVisible(false)
            if self._left_extAttr_flag then
                _left_extAttr_1:setVisible(false)
            end
        end
    else
        if tonumber(_id) == 6 then
            _left_choosedBox_1:setVisible(true)
            _left_arrow_1:setVisible(true)
        end
    end
    local data = {_left_attr=_left_extAttr_1,left_extAttr_bg = _left_extAttr_bg_s_1,left_arrow = _left_arrow_1,left_choosedBox = _left_choosedBox_1,id = _id}
    table.insert(self._left_extAttr_bg_list,data) 
end

--创建右侧饰品附加属性
function TrinketReplaceAttrLayer:initRightTrinketExtAttr()
    self._right_extAttr_bg_list = {}
    for i=1,6 do
        self:createRightTrinketExtAttr(i)
    end
    
end 
 --创建右侧附加属性
function TrinketReplaceAttrLayer:createRightTrinketExtAttr(_id)
    local _str_effectId = "effectId" .. _id
    local _str_effectValue = "effectValue" .. _id
    local _str_effectColor = "effectColor" .. _id
    if tonumber(self._item[_str_effectId]) == 0 then 
        _right_extAttr_text_1 = zc.lang("empty") 
        return
    else
        _right_extAttr_text_1 = zc.getEquipAttriNameByEffectType(self._item[_str_effectId])..":".. self._item[_str_effectValue]
    end
     --属性背景
    local _right_extAttr_bg_s_1 = zc.createScale9Sprite({
        size = cc.size(280, 47),
        file = "res/Main/common/img_empty.png",
        pos = cc.p(0, self._right_bg_s_1:getBoundingBox().height-99 - (tonumber(_id)-1)*48),
    })
    _right_extAttr_bg_s_1:setAnchorPoint(cc.p(0,1))
    self._right_bg_s_1:addChild(_right_extAttr_bg_s_1,2)
     local _str = "res/Main/ornaments/trinket_attr_bg_1.png"
    if _id % 2 == 0 then
        _str = "res/Main/ornaments/trinket_attr_bg_2.png"
    end
    local _right_extAttr_ = cc.Sprite:create(_str)
    _right_extAttr_:setAnchorPoint(cc.p(0.5,0.5))
    _right_extAttr_:setPosition(_right_extAttr_bg_s_1:getContentSize().width/2, _right_extAttr_bg_s_1:getContentSize().height/2)
    _right_extAttr_bg_s_1:addChild(_right_extAttr_)
    _right_extAttr_:setScaleX(-1)
    
    --属性1
    local _right_extAttr_1 = zc.createLabel({
        text = _right_extAttr_text_1,
        fontSize = 24,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(80, 25),
        color = zc.getColorByQuality(self._item[_str_effectColor]),
        outLine = true
    })
    _right_extAttr_bg_s_1:addChild(_right_extAttr_1,2)
    
    _right_extAttr_1:setString(_right_extAttr_text_1)

    --选中框1
    local _right_choosedBox_1 = zc.createImageView({
        src = "res/Main/ornaments/trinket_choosedBox.png",
        pos = cc.p(380, 25),
        ap = cc.p(0, 0.5),
    })
    _right_choosedBox_1:setScaleX(-1)
    _right_extAttr_bg_s_1:addChild(_right_choosedBox_1)
    
    if _id == 1 then 
        _right_choosedBox_1:setVisible(true)
        if self._type == 2 then
            _right_choosedBox_1:setScaleX(1)
            _right_choosedBox_1:setPosition(cc.p(-75,-100))
            _right_choosedBox_1:loadTexture("res/Main/ornaments/trinket_choosedBox_big_right.png")  
            local _seq = cc.Sequence:create(cc.FadeTo:create(1.0,50),cc.FadeTo:create(1.0,255))
            _right_choosedBox_1:runAction(cc.RepeatForever:create(_seq))
            self._right_choosedBox_1 = _right_choosedBox_1
        end
    else
        _right_choosedBox_1:setVisible(false) 
    end
    local _attrData = {effectId = self._item[_str_effectId],effectValue = self._item[_str_effectValue]}
    local data = {_right_attr=_right_extAttr_1,right_extAttr_bg = _right_extAttr_bg_s_1,right_choosedBox = _right_choosedBox_1,id = _id,attrData = _attrData}
    table.insert(self._right_extAttr_bg_list,data)

end
--转移成功更新界面
function TrinketReplaceAttrLayer:updateView(data)
    self._arrow_1:setOpacity(255)
    self._arrow_2:setOpacity(255)
    self._left_choosedBox_1:stopAllActions()
    self._right_choosedBox_1:stopAllActions()
    self._arrow_bg:runAction(cc.RotateBy:create(0.5,-30))

    self._transferAttrFunc(data.costMoney)
    self._transferAttrBtn:setVisible(false)
    self._gold_bg:setVisible(false)
    self._sureAttrBtn:setVisible(true)
    for k,v in pairs(self._left_extAttr_bg_list) do
        v.left_extAttr_bg:removeSelf()
    end
    for k,v in pairs(self._right_extAttr_bg_list) do
        v.right_extAttr_bg:removeSelf()
    end
    self:initLeftTrinketExtAttr()
    self:initRightTrinketExtAttr()
end

--洗练成功
function TrinketReplaceAttrLayer:replaceAttrSuccess(data)
    self._replaceAttrBtn:setEnable(false)
    self._play_num_max = 3
    self._play_num = 1
    self._nums = 1
    self._attrNum = #self._right_extAttr_bg_list
    self._numMax_1 = self._attrNum + 1
    self._numMax = self._attrNum 
    self._index = 1
    self._curr_num = 1
    if self._attrNum < 5 then self._play_num_max = 4 end

    self._numMax = self._numMax + tonumber(data["index"]) --index被洗练的属性顺序idx
    self._curr_num = tonumber(data["index"])
    self:_animateCallBack_1(data)
end
--洗练动画
function TrinketReplaceAttrLayer:_animateCallBack_1(data)
    if self._nums <= self._numMax_1 then
        if self._nums <= self._attrNum then
            self._right_extAttr_bg_list[self._nums].right_choosedBox:setVisible(false)
        else
            if self._nums - self._attrNum <= self._attrNum then
                self._right_extAttr_bg_list[self._nums - self._attrNum].right_choosedBox:setVisible(false)
            else
                if self._right_extAttr_bg_list[self._nums - self._attrNum *2] then
                    self._right_extAttr_bg_list[self._nums - self._attrNum *2].right_choosedBox:setVisible(false)  
                end
            end
        end
        self._nums = self._nums + 1
        performWithDelay(self, function ()
            self:_animateCallBack_2(data)
        end,0.05)
    else
        performWithDelay(self, function ()
            self:animationFinish(data)
        end,0.05)
    end
end

function TrinketReplaceAttrLayer:_animateCallBack_2(data)
    if self._nums <= self._numMax_1 then
        if self._nums <= self._attrNum then
            self._right_extAttr_bg_list[self._nums].right_choosedBox:setVisible(true)
        else
            if self._nums - self._attrNum <= self._attrNum then
                self._right_extAttr_bg_list[self._nums - self._attrNum].right_choosedBox:setVisible(true)
            else
                if self._right_extAttr_bg_list[self._nums - self._attrNum *2] then
                    self._right_extAttr_bg_list[self._nums - self._attrNum *2].right_choosedBox:setVisible(true)  
                end
            end
        end
        if self._nums == self._numMax_1 then
            if self._play_num <= self._play_num_max then
                self._nums = 1
                self._play_num = self._play_num + 1
                performWithDelay(self, function ()
                    self:_animateCallBack_1(data)
                end,0.05)
            else
                performWithDelay(self, function ()
                    self:_animateCallBack_1_1(data)
                end,0.2)
            end
        else
            performWithDelay(self, function ()
                self:_animateCallBack_1(data)
            end,0.05)
        end
    else
        performWithDelay(self, function ()
            self:animationFinish(data)
        end,0.05)
    end  
end

function TrinketReplaceAttrLayer:_animateCallBack_1_1(data)
    if self._nums <= self._numMax then
        if self._nums <= self._attrNum then
            self._right_extAttr_bg_list[self._nums].right_choosedBox:setVisible(false)
        else
            if self._nums - self._attrNum <= self._attrNum then
                self._right_extAttr_bg_list[self._nums - self._attrNum].right_choosedBox:setVisible(false)
            else
                if self._right_extAttr_bg_list[self._nums - self._attrNum *2] then
                    self._right_extAttr_bg_list[self._nums - self._attrNum *2].right_choosedBox:setVisible(false)  
                end
            end
        end
        self._nums = self._nums + 1
        performWithDelay(self, function ()
            self:_animateCallBack_2_2(data)
        end,0.1)
    else
        performWithDelay(self, function ()
            self:animationFinish(data)
        end,0.05)
    end
end

function TrinketReplaceAttrLayer:_animateCallBack_2_2(data)
    print("---self._nums self._numMax---",self._nums, self._numMax,self._attrNum) 
    if self._nums <= self._numMax then
        if self._nums <= self._attrNum then
            self._right_extAttr_bg_list[self._nums].right_choosedBox:setVisible(true)
        else
            if self._nums - self._attrNum <= self._attrNum then
                self._right_extAttr_bg_list[self._nums - self._attrNum].right_choosedBox:setVisible(true)
            else
                if self._right_extAttr_bg_list[self._nums - self._attrNum *2] then
                    self._right_extAttr_bg_list[self._nums - self._attrNum *2].right_choosedBox:setVisible(true)  
                end
            end
        end
        if self._nums >= self._numMax then
            self:animationFinish(data)
        else
            performWithDelay(self, function ()
                self:_animateCallBack_1_1(data)
            end,0.1)
        end
    else
        self._right_extAttr_bg_list[self._curr_num].right_choosedBox:setVisible(true)
        self:animationFinish(data)
    end 
end

--动画结束
function TrinketReplaceAttrLayer:animationFinish(_data)
    self._replaceData = _data
    self._closeBtn:setEnable(true)
    self._replaceAttrBtn:setVisible(false)
    self._gold_bg:setVisible(false)

    --交换
    local rightItem = self._right_extAttr_bg_list[self._curr_num]._right_attr
    local rightItemParent = rightItem:getParent()
    local leftItem = self._left_extAttr_bg_list[self.index]._left_attr
    local leftItemParent  = leftItem:getParent()
    local targetPos = leftItemParent:convertToWorldSpace(cc.p(leftItem:getPositionX(),leftItem:getPositionY()))
    local nowPos = rightItemParent:convertToWorldSpace(cc.p(rightItem:getPositionX(),rightItem:getPositionY()))
    local exchangeLab = zc.createLabel({
        text = rightItem:getString(),
        outLine = true,
        fontSize = 24,
        fontName = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(nowPos.x,nowPos.y),
        color = rightItem:getColor(),
        pixel = 1.3,
    })
    self:addChild(exchangeLab)
    exchangeLab:runAction(
        cc.Sequence:create(
        cc.DelayTime:create(0.15),
        cc.Spawn:create(
            cc.MoveBy:create(0.8,cc.p(targetPos.x-nowPos.x,targetPos.y-nowPos.y)),
            cc.Sequence:create(cc.ScaleTo:create(0.4,1.5),cc.ScaleTo:create(0.4,1))
        ),
        cc.CallFunc:create(function() leftItem:setVisible(false) end),
        cc.CallFunc:create(function()
                zc.numChangeAnimation({
                    label = exchangeLab,
                    pos = cc.p( exchangeLab:getContentSize().width/2, 20 ),
                    callback = function()
                    end
                })
                zc.autoShowFightingChange()
        end)))

    --确定按钮
    local _sureAttrBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("finish_2"),
        pos = cc.p(self._replaceAttrBtn:getPosition()), 
        endCallback = function () 
            --新手引导
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_11516 then
                getGuideManager():setFuncGuideOver()
            end
            if self._rightFunc then
                self._rightFunc(_data)
            end
            self:hide()
        end,
    })
    self._bg_1:addChild(_sureAttrBtn)


    --撤销
    --撤销消耗元宝背景
    local _revoke_replaceAttr_price = "20" 
    local _data = gameData.getDataFromCache("consume_price", {type = 10})
    if next(_data) ~= nil then
        _revoke_replaceAttr_price = _data.price
    end
    local _gold_bg = zc.createImageView({
        src = "res/Main/copy/copy_di.png",
        pos = cc.p(330, self._replaceAttrBtn:getPositionY())
    })
    self._bg_1:addChild(_gold_bg)
    
    --元宝icon
    local _gold_icon = zc.createImageView({
        src = "res/Main/common/common_icon_gold.png",
        pos = cc.p(20, 10)
    })
    _gold_bg:addChild(_gold_icon)
    --洗炼撤销所需元宝
    local _need_gold = zc.createLabel({
        text = tostring(_revoke_replaceAttr_price),
        fontSize = 20,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(60, 10),
        outLine = true,
    })
    _gold_bg:addChild(_need_gold)

    local _revokeEnable = tonumber(PlayerData:getResourcesInfo()["gold"]) >= tonumber(_revoke_replaceAttr_price)
    local _revokeBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("revoke_2"),
        pos = cc.p(200,self._replaceAttrBtn:getPositionY()), 
        listener = function () 
            if self._leftFunc then
                self._leftFunc()
            end
            --去掉保存数据
            zc.saveFightingChange()
            self:hide()
        end,
    })
    self._bg_1:addChild(_revokeBtn)
    _revokeBtn:setEnable(_revokeEnable)

    --新手引导
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_11516 then
        getGuideManager():setObjTarget(_sureAttrBtn)
        getGuideManager():startGuide()
    end
end

function TrinketReplaceAttrLayer:onEnter()
    LayerManager.getTopInfoLayer():setPopInfo("trinketReplaceAttr")
    self:getParent():reorderChild(LayerManager.getTopInfoLayer(),LayerManager.getTopInfoLayer():getLocalZOrder())
    --新手引导
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_11515 then
        getGuideManager():addMaskLayer()
        performWithDelay(self, function ()
            getGuideManager():removeMaskLayer()
            getGuideManager():setObjTarget(self._replaceAttrBtn)
            getGuideManager():startGuide()
        end, 0.3) 
    end
end

function TrinketReplaceAttrLayer:onExit()
    LayerManager.getTopInfoLayer():setPopInfo("RoleTrinket")
    if self._fightCallback then
        self._fightCallback()
    end
end


return TrinketReplaceAttrLayer