local ZhanFaAoYI = class("ZhanFaAoYI", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(720,463)
	return layer
end)

function ZhanFaAoYI:create( params )
	return ZhanFaAoYI.new( params )
end

function ZhanFaAoYI:ctor( params )
    self._activityType = params.activityType
	self._size = self:getContentSize()
	self:initData( params )
	self:initUI(params)
	self:refresUI()
end

function ZhanFaAoYI:initData(params)
    -- dump(params,"ZhanFaAoYI:initData(params)")
    --武将镶嵌信息
    self.heroData = params.heroData

    self.equip_info = params.heroData.tactics

    self.isEquip = params.isEquip

    self.newEquipIndex = params.select_index or 0

    self.curSelectSkill = params.index

    self.skillData = params.skillData

    --特效配置
    self.allTime = 5
    self.effectConfig = {}
    self.effectConfig[1] = { actionTime = allTime, posX = 0, scaleStart = 0, scaleEnd = 0.33, rotate = 0, scale = 3.5, pos = ccp(252, 399)}
    self.effectConfig[2] = { actionTime = allTime, posX = 95, scaleStart = 0, scaleEnd = 0.35, rotate = 150, scale = 3.5, pos = ccp(253, 299)}
    self.effectConfig[3] = { actionTime = allTime, posX = 125, scaleStart = 0, scaleEnd = -0.36, rotate = 180, scale = 3.5, pos = ccp(253, 500)}
    self.effectConfig[4] = { actionTime = allTime, posX = -10, scaleStart = 0.36, scaleEnd = 0.49}
    self.effectConfig[5] = { actionTime = allTime, posX = -10, scaleStart = 0.49, scaleEnd = 0.47*2}
    self.effectConfig[6] = { actionTime = allTime, posX = -10, scaleStart = 0.47*2, scaleEnd = 0.45*3}
    self.effectConfig[7] = { actionTime = allTime, posX = -10, scaleStart = 0.45*3, scaleEnd = 0.43*4}

    --解锁个数
    self.unlockCount = self:getUnLockCount(params.heroData.newAdvance)
	-- role数组
    self.role_list = {}
    -- 加号
    self.plus_list = {}
    -- 封
    self.feng_list = {}
    -- 等级bg
    self.lvbg_list = {}
	-- 等级label
    self.label_list = {}
    -- 武器icon
    self.weaponIcon_list = {}

    --特效
    self.effect_list = {}
    self.zhanfaLimitData = gameData.getDataFromCache("tactics")
end

function ZhanFaAoYI:refresUI(flag)
    for i=1,8 do
        self.role_list[tostring(i)]:setVisible(tonumber(self.equip_info["tplace2" .. i]) ~= 0)
        self.plus_list[tostring(i)]:setVisible( self:isVisiblePlus(i) )
        self.feng_list[tostring(i)]:setVisible( i > self.unlockCount )
        self.lvbg_list[tostring(i)]:setVisible( self.role_list[tostring(i)]:isVisible() )

        if self.lvbg_list[tostring(i)]:isVisible() then
            self.label_list[tostring(i)]:setText("LV." .. self.equip_info["tlevel" .. 2 .. i])
        end

        if tonumber(self.equip_info["tplace2" .. i]) ~= 0 then
            local heroData = PlayerData:getSignGeneralById(self.equip_info["tplace2" .. i])
            zc.updateIconByData(self.role_list[tostring(i)], {
                    data = {
                        mainType = zc.mainTypeSoldier,
                        type = 1, 
                        id = heroData.heroId,
                        level = zc.getLevelTipShow() .. heroData.level,
                        reincarnate = heroData.reincarnate,
                    }, 
                    quality = heroData.quality,
                    showQuality = true,
                })
            local weaponType = self.role_list[tostring(i)]:getChildByName("weaponType")
            weaponType:setTexture("res/Main/role/common/weapon_icon_" .. heroData.weaponType .. ".png")

        end
        if i < 7 then 
            self.weaponIcon_list[i]:setVisible(false)
        end

        --判断特效
        local itemBg = self:getChildByName("itemBg" .. i)
        local effectBox = itemBg:getChildByName("effectBox")
        if tonumber(self.equip_info["tplace2" .. i]) ~= 0 and effectBox then
            effectBox:removeFromParent()
        end
    end

    local info = self:getEquipType()

    local count = 0
    for k,v in pairs(info) do
        count = count + 1

        self.weaponIcon_list[count]:setVisible(true)
        self.weaponIcon_list[count]:setTexture("res/Main/role/common/weapon_icon_" .. k .. ".png")

        local str = ""
        if v > 1 then
            str = v
        end

        self.weaponIcon_list[count]:getChildByName("weaponCountLabel"):setText(str)
    end

    self:getChildByName("weaponIcon_bg"):setVisible(count > 0)
    self:getChildByName("weaponIcon_bg"):setContentSize(count * 40, 30)

    --技能的选中状态
    local effecFlag = false
    local id = tonumber(self.skillData.id)
    local combineSkillId = tonumber(self.skillData.combineSkillId)
    -- print("id:",id,"combineSkillId:",combineSkillId,"self.equip_info.isUseCombine:",self.equip_info.isUseCombine)
    if id == combineSkillId then
        if tonumber(self.equip_info.isUseCombine) <= 1 then
            effecFlag = true
        end
        self.ID = 1
    else
        if tonumber(self.equip_info.isUseCombine) == 2 then
            effecFlag = true
        end
        self.ID = 2
    end

    local usingBtn = self:getChildByName("usingBtn")
    if usingBtn then
        usingBtn:removeFromParent()
    end

    local bgx = self.bg:getPositionX()
    local bgy = self.bg:getPositionY()
    local bgsize = self.bg:getContentSize()
    if effecFlag then
       if flag then
            local _spine = zc.createSpine({
                fileName = "qianghua_jinjie",
                actName = "animation2",
                loop = false,
                needInit = false,
                autoRemove = true,
                removeCallback = function()
                    local circleEffect = zc.createSpine({
                        fileName = "jiban",
                        actName = "unlock",
                        loop = true,
                    })
                    circleEffect:setPosition(ccp(40, 40))
                    self.skill_icon:addChild(circleEffect)
                end
            })
            _spine:setScale(3)
            _spine:setPosition(ccp(40, 40))
            self.skill_icon:addChild(_spine)
        else
            local circleEffect = zc.createSpine({
                fileName = "jiban",
                actName = "unlock",
                loop = true,
            })
            circleEffect:setPosition(ccp(40, 40))
            self.skill_icon:addChild(circleEffect)
        end

        local normal_ = zc.createSprite("res/Main/role/using_btn.png")
        local select_ = zc.createSprite("res/Main/role/using_btn.png")

        local usingBtn = zc.createPushButton({
            normalNode = normal_,
            selectedNode = select_,
            -- text = zc.lang("xiaoguoyulan"),
            pos = ccp(bgx,bgy - bgsize.height/2 - 50),
            scale = 1,
            fontSize = 28,
            outLine = true,
            endCallback = function ( )

            end
        })
        usingBtn:setName("usingBtn")
        self:addChild(usingBtn) 
    else
        local normal_ = zc.createSprite("res/Main/role/useBtn.png")
        local select_ = zc.createSprite("res/Main/role/useBtn.png")

        local usingBtn = zc.createPushButton({
            normalNode = normal_,
            selectedNode = select_,
            pos = ccp(bgx,bgy - bgsize.height/2 - 60),
            scale = 1,
            fontSize = 28,
            outLine = true,
            endCallback = function ( )
                local usingBtn = self:getChildByName("usingBtn")
                local effect = usingBtn:getChildByName("effect")
                effect:playAction("idle3", false)

                effect:registerSpineEventHandler( function ( event )
                    if event.animation == "idle3" then
                        effect:playAction("idle2", true)
                    end
                end, sp.EventType.ANIMATION_COMPLETE)

                local comfirm = ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    msg = zc.lang("isUseThisSKill"),
                    showDi = true,
                    rightCallback = function()
                        zc.sendHttp({
                            apiName = "Role_Open",
                            params = {heroId = self.heroData.id,id = self.ID},
                            successCallback = function(data)
                                PlayerData:updataData(data)
                                for k,v in pairs(PlayerData:getGeneralInfo()) do
                                    if tonumber(self.heroData.id) == tonumber(v.id) then
                                        dump(v,"到底是什么？")
                                    end
                                end
                                -- 默认的1
                                if self.ID == 1 then 
                                    self.equip_info.isUseCombine = 1    
                                else
                                    self.equip_info.isUseCombine = 2
                                end
                                self:refresUI(true)
                            end,
                        })
                    end
                })
                comfirm:setPosition(ccp(-70, 78))
                self:addChild(comfirm,11)
            end
        })
        usingBtn:setName("usingBtn")
        self:addChild(usingBtn) 
        local effect = zc.createSpine({scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"})
        effect:setName("effect")
        effect:setPosition(ccp(70, 42))
        effect:playAction("idle2", true)
        usingBtn:addChild(effect)
    end
end

--获取装备的个数
function ZhanFaAoYI:getEquipCount()
    local count = 0
    for i=1,8 do
        if tonumber(self.equip_info["tplace2" .. i]) ~= 0 then
            count = count + 1
        end
    end

    return count
end

--获取上下装备个数。1，上。 2下
function ZhanFaAoYI:getHeroEquipCountByType(equipType)
    local upCount = 0
    local downCount = 0
    for i=1,8 do
        if tonumber(self.equip_info["tplace2" .. i]) ~= 0 then
            if i%2 == 0 then
                downCount = downCount + 1
            else
                upCount = upCount + 1
            end
        end
    end

    if equipType == 1 then

        return upCount
    else

        return downCount
    end 

end

--获取装备的将的武器类型及个数
function ZhanFaAoYI:getEquipType()
    local list = {}
    for i=1,8 do
        if tonumber(self.equip_info["tplace2" .. i]) ~= 0 then
            local data = PlayerData:getSignGeneralById(self.equip_info["tplace2" .. i])

            if not list[tostring(tonumber(data.weaponType))] then
                list[tostring(tonumber(data.weaponType))] = 0
            end
            list[tostring(tonumber(data.weaponType))] = list[tostring(tonumber(data.weaponType))] + 1
        end
    end
    return list
end

--播放动作。
function ZhanFaAoYI:playAllAction()
    local upCount = self:getHeroEquipCountByType(1)
    local downCount = self:getHeroEquipCountByType(2)
    
    local effect1 = self.effect_list[1]
    local effect2 = self.effect_list[2]
    local effect3 = self.effect_list[3]
    local effect4 = self.effect_list[4]
    local effect5 = self.effect_list[5]

    print("self.newEquipIndex : " .. self.newEquipIndex) 

    if upCount >= 1 then
        self:setLineState(effect1, 1)
        self:setLineState(effect3, 3)

        if upCount == 1 then
            self:setLineState(effect4, 4)
        elseif upCount == 2 then
            self:setLineState(effect4, 5)
        elseif upCount == 3 then
            self:setLineState(effect4, 6)
        elseif upCount == 4 then
            self:setLineState(effect4, 7)
        end

        local count = 0

        for i=1,upCount do
            local itemBg = self:getChildByName("itemBg" .. (i*2 - 1))
            local effectBox = itemBg:getChildByName("effectBox")
            if not effectBox then
                effectBox = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"} )
                effectBox:playAction("idle1", true)
                effectBox:setPosition(ccp(61, 58))
                itemBg:addChild(effectBox)
            end
        end
        

    else
        effect3:setScaleX(0)
        effect4:setScaleX(0)
    end

    if downCount >= 1 then
        self:setLineState(effect1, 1)
        self:setLineState(effect2, 2)

        if downCount == 1 then
            self:setLineState(effect5, 4)
        elseif downCount == 2 then
            self:setLineState(effect5, 5)
        elseif downCount == 3 then
            self:setLineState(effect5, 6)
        elseif downCount == 4 then
             self:setLineState(effect5, 7)
        end

        for i=1,downCount do
            local itemBg = self:getChildByName("itemBg" .. (i*2))
            local effectBox = itemBg:getChildByName("effectBox")
            if not effectBox then
                effectBox = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"} )
                effectBox:playAction("idle1", true)
                effectBox:setPosition(ccp(61, 58))
                itemBg:addChild(effectBox)
            end
        end

    else
        effect2:setScaleX(0)
        effect5:setScaleX(0)
    end

    if downCount == 0 and upCount == 0 then
        effect1:setScaleX(0)
    end
    -- end

    --线的走动特效,判断有点恶心，,暂时先不搞了

    -- if self.isEquip then
    --     if self.newEquipIndex == 1 or self.newEquipIndex == 2 then
    --         local action2Tag = 0
    --         local action3Tag = 4
    --         local itemTag = self.newEquipIndex
    --         local effect1 = 1
    --         local effect2 = 0
    --         local effect3 = 0

    --         if self.newEquipIndex == 1 then
    --             action2Tag = 3
    --             effect2 = 3
    --             effect3 = 4

    --         elseif self.newEquipIndex == 2 then
    --             action2Tag = 2
    --             effect2 = 2
    --             effect3 = 5
    --         end
    --         local action1 = self:getLineAction(1)
    --         local action2 = self:getLineAction(action2Tag)
    --         local action3 = self:getLineAction(action3Tag)
    --         local action4 = cc.CallFunc:create(function()
    --                 local itemBg = self:getChildByName("itemBg" .. itemTag)
    --                 local effectBox = itemBg:getChildByName("effectBox")
    --                 if not effectBox then
    --                     effectBox = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"} )
    --                     effectBox:playAction("idle1", true)
    --                     effectBox:setPosition(ccp(61, 58))
    --                     itemBg:addChild(effectBox)
    --                 end
    --             end)

    --         local sEffect1 = self.effect_list[effect1]
    --         sEffect1:runAction(cc.Sequence:create(
    --                 action1,
    --                 cc.CallFunc:create(function()
    --                     local sEffect2 = self.effect_list[effect2]
    --                     sEffect2:runAction(cc.Sequence:create(
    --                         action2,
    --                         cc.CallFunc:create(function()
    --                             local sEffect3 = self.effect_list[effect3]
    --                             sEffect3:runAction(cc.Sequence:create(
    --                                 action3,
    --                                 action4
    --                             ))
    --                         end)
    --                     ))
    --                 end)
    --             )
    --         )
           
    --     else
    --         local itemTag = self.newEquipIndex
    --         local effectTag = 0
    --         local actionTag = 0

    --         if self.newEquipIndex%2 == 1 then
    --             effectTag = 4
    --         else
    --             effectTag = 5
    --         end

    --         if math.ceil(self.newEquipIndex/2) == 2 then
    --             actionTag = 5
    --         elseif math.ceil(self.newEquipIndex/2) == 3 then
    --             actionTag = 6
    --         elseif math.ceil(self.newEquipIndex/2) == 4 then
    --             actionTag = 7
    --         end

    --         local effect = self.effect_list[effectTag]
    --         local action1 = self:getLineAction(actionTag)
    --         local action2 = cc.CallFunc:create(function()
    --                 local itemBg = self:getChildByName("itemBg" .. itemTag)
    --                 local effectBox = itemBg:getChildByName("effectBox")
    --                 if not effectBox then
    --                     effectBox = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"} )
    --                     effectBox:playAction("idle1", true)
    --                     effectBox:setPosition(ccp(61, 58))
    --                     itemBg:addChild(effectBox)
    --                 end
    --             end)

    --         effect:runAction(cc.Sequence:create(
    --                 action1,
    --                 action2
    --             ))
    --     end
    -- end

end

--直接设置线的缩放，不走动作
function ZhanFaAoYI:setLineState(target, idx)
    target:setScaleX(self.effectConfig[idx].scaleEnd)
    target:setPositionX(150*(self.effectConfig[idx].scaleEnd - 0) + self.effectConfig[idx].posX)
    if idx <= 3 then
        for i=1,3 do
            local blf = cc.blendFunc()
            blf.src = GL_DST_COLOR
            blf.dst = GL_ONE

            local light = zc.createSprite("res/Main/role/light.png")    
            -- light:setOpacity(255)
            self:addChild(light)
            light:setRotation(self.effectConfig[idx].rotate)
            -- light:setPosition(self.effectConfig[idx].pos)
            light:setPosition(self.effectConfig[idx].pos)
            -- light:setScale(self.effectConfig[idx].scale)
            light:setBlendFunc(blf)
        end
    end
end

--设置线的缩放，走动作
function ZhanFaAoYI:getLineAction(i)
    print("i .. : " .. i)
    local action = cc.Spawn:create(
                cc.ScaleTo:create(self.allTime, self.effectConfig[i].scaleEnd, 0.3),
                cc.MoveTo:create(self.allTime, cc.p(150*(self.effectConfig[i].scaleEnd - 0) + self.effectConfig[i].posX, 8))
            )
    
    return action
end

--获取解锁个数
function ZhanFaAoYI:getUnLockCount(advanceLv)

    for k,v in pairs(gameData.getDataFromCache("tactics")) do
        if tonumber(v.condition) == tonumber(advanceLv) then
            return tonumber(v.id)
        end
    end

    return 8
end

--加号的显示与隐藏
function ZhanFaAoYI:isVisiblePlus(idx)
    local upCount = self:getHeroEquipCountByType(1)
    local downCount = self:getHeroEquipCountByType(2)

    if idx %2 == 1 then
        return math.ceil(idx/2) == (upCount + 1) and math.ceil(idx/2) <= math.ceil(self.unlockCount/2)
    else
        if self.unlockCount < 2 then
            return false
        end
        return math.ceil(idx/2) == (downCount + 1) and math.ceil(idx/2) <= math.floor(self.unlockCount/2)
    end
end

--判断该位置是否解锁。
function ZhanFaAoYI:isUnLock(idx)
    local pos_config = {1,5,2,6,3,7,4,8}
    for i=1,8 do
        if pos_config[i] == idx then
            if i <= self.unlockCount then
                return i
            end
        end
    end
    return nil
end

function ZhanFaAoYI:initUI(params)
	local _data = params.skillData

	self.bg = zc.createSprite("res/Main/role/fetter/heroBg.png")
	self.bg:setPosition(130,400)
	self.bg:setScale(0.9)
	self:addChild(self.bg)

	local bgsize = self.bg:getContentSize()
	local bgx = self.bg:getPositionX()
	local bgy = self.bg:getPositionY()

	local normal_ = zc.createSprite("res/Main/common/button/btn_blue_u.png")
	normal_:setRotation(90)
	local select_ = zc.createSprite("res/Main/common/button/btn_blue_d.png")
	select_:setRotation(90)

	local efftBtn = zc.createPushButton({
		normalNode = normal_,
        selectedNode = select_,
		text = zc.lang("xiaoguoyulan"),
		pos = cc.p(bgx - bgsize.width/2 - 15,bgy),
		scale = 0.6,
		fontSize = 28,
		outLine = true,
		endCallback = function ( )
            local params = {
                skillData =  self.skillData, -- 技能数据
                heroData =  self.heroData, -- 吃武将数据
                index = self.curSelectSkill 
            }
            zc.createSourcePop("ZhanFaSkillPreviewPop", "src/layer/role/ZhanFaSkillPreviewPop.lua", params)
		end
	})
	self:addChild(efftBtn)
    
	local sign = zc.createSprite("res/Main/role/aoyi_" .. self.skillData.hitType .. ".png")
    sign:setPosition(bgx + 3,bgsize.height/4 + bgy + 5)
    self:addChild(sign,1)

    local rotation = {0,90,0,0}
    local tiao_width = {100,214,592,592}

    local tiao_posX = {
        bgx + bgsize.width/2 - 10,
        bgx + bgsize.width/2 + 40,
        bgx + bgsize.width/2 + 335,
        bgx + bgsize.width/2 + 335,
    }
    local tiao_posY = {
        bgy,
        bgy,
        bgy + bgsize.height/1.65 ,
        bgy - bgsize.height/1.65,
    }

    for i=1,4 do
        local tiao = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10),"res/Main/role/waypoint.png")
        tiao:setName("tiao" .. i)
        tiao:setContentSize(tiao_width[i],16)
        tiao:setRotation(rotation[i])
        tiao:setPosition(tiao_posX[i],tiao_posY[i])
        if i == 1 then
            self:addChild(tiao)
        elseif i == 2 then
            self:addChild(tiao,-1)
        else
           self:addChild(tiao,-2)
        end
    end

    for i=1,5 do
        local tiao
        if i == 1 then
            tiao = self:getChildByName("tiao" .. i)
        elseif i == 2 or i == 3 then
            tiao = self:getChildByName("tiao" .. 2)
        else
            tiao = self:getChildByName("tiao" .. (i - 1))
        end

        local lineEffect = zc.getSpine("gz_1")
        lineEffect:setScaleY(0.3)
        lineEffect:setScaleX(self.effectConfig[i].scaleStart)
        lineEffect:playAction("idle2", true)
        lineEffect:setPosition(ccp(self.effectConfig[i].posX, 8))
        tiao:addChild(lineEffect)
        table.insert(self.effect_list, lineEffect)
    end

	local skillbg = ZCSprite:create("res/Main/role/fetter/fetterItemBg.png")
    skillbg:setName("skillbg")
    skillbg:setScale(0.9)
    skillbg:setPosition(bgx,bgy - 2)
    self:addChild(skillbg)

    -- 技能icon底图
    local img = ZCSprite:create("res/Main/hero/hero_item1.png")
    img:setPosition(cc.p(bgsize.width * 0.5, bgsize.height*0.5 - 2))
    img:setScale(0.8)
    self.bg:addChild(img)

    local _info = zc._getIconInfo({
        data = {
           mainType=zc.mainTypeSkill,
            type=_data.id, 
            id=_data.id,
        }
    })

    -- 技能icon
    self.skill_icon = zc.createSprite(_info.img)
    -- self.skill_icon:setScale(0.9)
    self.skill_icon:setPosition(bgx,bgy)
    self:addChild(self.skill_icon)

    local weaponIcon_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    weaponIcon_bg:setName("weaponIcon_bg")
    weaponIcon_bg:setContentSize(236,30)
    weaponIcon_bg:setPosition(bgx, bgy - bgsize.height/2 - 3)
    self:addChild(weaponIcon_bg)

    --解锁是竖着来的，做个映射
    local pos_config = {1,3,5,7,2,4,6,8}
    local function RemoveLayer( ... )
        self:removeChildByTag(100000)
    end
    local fontSizes = {18,26,26,18}
    local colors = {cc.c3b(255,219,97),cc.c3b(255,0,30),cc.c3b(255,0,30),cc.c3b(255,219,97)}
    local outLines = {false,true,true,false}
    local pos_Y = {-30,-27,-29,-30}
    local distance = {20,20,20,20}
	for i = 1, 8 do
		local bg = ZCSprite:create("res/Main/role/fetter/fetterItemBg.png")

        bg:setName("itemBg" .. pos_config[i])
		bg:setScale(0.8)
		local bgsize = bg:getContentSize()
		if i <= 4 then
			bg:setPosition(370 + (i - 1) * (bgsize.width + 30),500)
		else
			bg:setPosition(370 + (i - 5) * (bgsize.width + 30),300)
		end
        
        local params = {
            skillData = _data, -- 技能数据
            heroData = params.heroData, -- 要吃武将的武将
            removeLayer = RemoveLayer,
            index = pos_config[i], -- 装备武将位置
            type = 2,
            list_weapType = self:getEquipType() or {},
            select_index = params.select_index,
            seletToCell = params.seletToCell
        }

        bg:setTouchEndedCallback(function ()

            local equipPos = self:isUnLock(i)
            if equipPos then
                if self.plus_list[tostring(pos_config[i])]:isVisible() then
                    zc.createSourceScene("ZhanFaRoleList", "src/layer/role/ZhanFaRoleList.lua", params or {})
                elseif self.role_list[tostring(pos_config[i])]:isVisible() then
                    params.activityType = 0
                    params.roleData = PlayerData:getSignGeneralById(self.equip_info["tplace2" .. equipPos]) or {}
                    local layer_ = requires("src/layer/role/ZhanFaZhaungBei.lua"):create(params or {})
                    layer_:setTag(100000)
                    self:addChild(layer_)
                end
            else
                local heroData = params.heroData or {}
                local level = 0
                local zhanfaLimitData = gameData.getDataFromCache("tactics")
                for k,v in pairs(zhanfaLimitData) do
                    if tonumber(v.id) == pos_config[i] then
                        level = v.condition
                    end
                end
                zc.tipInfo(zc.lang("tupoLimit")..level..zc.lang("jiefeng"))
            end
        end)
		self:addChild(bg)
        local locationX = bg:getPositionX()
        local locationY = bg:getPositionY()

		-- 武将icon
        local role_icon = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldier,
                type = 1, 
                id = 1,
            }, 
            scale = 0.8,
            pos = cc.p(bgsize.width * 0.5, bgsize.height*0.5 + 3), 
            listener = function ( ... )
            end
        })
        local weaponType = zc.createSprite("res/Main/role/common/weapon_icon_1.png" )
        weaponType:setScale(0.7)
        weaponType:setPosition(ccp(role_icon:getContentSize().width - 20, role_icon:getContentSize().height - 20))
        weaponType:setName("weaponType")
        role_icon:addChild(weaponType)
        bg:addChild(role_icon)
        self.role_list[tostring(pos_config[i])] = role_icon
        -- table.insert(self.role_list,role_icon)

		local plus = zc.createSprite("res/Main/multyCopy/plus.png")
		plus:setPosition(bgsize.width/2,bgsize.height/2 + 3)
		bg:addChild(plus)
        plus:setScale(1.3)
        self.plus_list[tostring(pos_config[i])] = plus
		-- table.insert(self.plus_list,plus)

		local feng = zc.createSprite("res/Main/role/feng.png")
		feng:setPosition(bgsize.width/2,bgsize.height/2)
        feng:setScale(1.2)
		bg:addChild(feng)
        local heroData = self.heroData or {}
        local level = 0
        for k,v in pairs(self.zhanfaLimitData) do
            if tonumber(v.id) == pos_config[i] then
                level = v.condition
            end
        end

        local texts = {zc.lang("tupoLimit"),"+",level,zc.lang("jiefeng")}
        local jianju = {feng:getContentSize().width/2 + 10,feng:getContentSize().width/4,feng:getContentSize().width/4,feng:getContentSize().width/2.8}
        for i = 1,4 do
            if i == 2 and texts[i] == "+" then
                distance[i] = 23
            end
            local label = zc.createLabel({
                text = texts[i],
                fontSize = fontSizes[i],
                outLine = outLines[i],
                color = colors[i],
                ap = cc.p(1,0.5),
                pos = cc.p((i -1)*jianju[i] + distance[i],pos_Y[i])
            })
            feng:addChild(label)
        end

        self.feng_list[tostring(pos_config[i])] = feng
		-- table.insert(self.feng_list,feng)

		local lvbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
		lvbg:setContentSize(95,30)
		local posx = bg:getPositionX()
		local posy = bg:getPositionY()
		lvbg:setPosition(posx,posy - bgsize.height/2 - 10)
		self:addChild(lvbg)
        self.lvbg_list[tostring(pos_config[i])] = lvbg
		-- table.insert(self.lvbg_list,lvbg)

		local lvbgSize = lvbg:getContentSize()
		local levelLabel = zc.createLabel({
                text = "LV.2",
                fontSize = 22,
                pos = cc.p(lvbgSize.width/2, lvbgSize.height/2),
                outLine = true,
            })
        lvbg:addChild(levelLabel)
        self.label_list[tostring(pos_config[i])] = levelLabel
        -- table.insert(self.label_list,levelLabel)
        if i < 7 then
	        local weaponIcon_ = zc.createSprite("res/Main/role/common/weapon_icon_1.png" )
	        weaponIcon_:setScale(0.5)
	        local weaponIcon_Size = weaponIcon_:getContentSize()
	        weaponIcon_:setPosition((i - 1)*weaponIcon_Size.width/1.9 + 20,14)
	        weaponIcon_bg:addChild(weaponIcon_)

            weaponIcon_:addChild(zc.createLabel({ text = "0", fontSize = 30, pos = ccp(60, 20), name = "weaponCountLabel" }))

	        table.insert(self.weaponIcon_list,weaponIcon_)
    	end
	end
    self:playAllAction()
end

return ZhanFaAoYI