local ZhanFaZhaungBei = class("ZhanFaZhaungBei", function()
	return ZCPopLayer:create({
		isRemoveLayout = true
	})
end)

function ZhanFaZhaungBei:create( params )
	return ZhanFaZhaungBei.new( params )
end

function ZhanFaZhaungBei:ctor( params )
    self._activityType = params.activityType
	self:initData( params )
	self:initUI(params)

	local data = {
			index = self.Type,
			isUpgrade = true,
			select_index = self.select_index,
			seletToCell = self.seletToCell,
		}
	print("self.Type:",self.Type,"self.select_index ",self.select_index,"self.selectCellTo.",self.seletToCell)
	local function hideCallBack( )
		print("hideCallBack( ):::")
		zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = data})
	end
	self:setHideCallback(hideCallBack)
end

function ZhanFaZhaungBei:initData(params)
	local eateed_data = params.roleData or {}
	local skillData = params.skillData or {}
	if skillData.skillType == 3 then -- 必杀
		self.Type = 1
	elseif skillData.skillType == 4 then -- 奥义
		self.Type = 2
	end
	self.select_index = params.index or 1
	self.heroData = params.heroData or {}
	self.removeLayer = params.removeLayer
	self.roleData = params.roleData
	self.type = params.type
	self.seletToCell = params.seletToCell

	self.skillData = skillData
	self.zhanfaData = {}
	if self.skillData.hitType == 1 then  -- 攻击
		self.tag = 1
	else
		self.tag = 2
	end
	local zhanfa_data = gameData.getDataFromCache("tactics_hero")
	local zhanfa_upgrade = gameData.getDataFromCache("tactics_levelup")
    local _mainRoleId = tonumber( PlayerData.info.heroId ) or 0
    if eateed_data.id == _mainRoleId  then
    	local mainData = PlayerData:getWeaponsInfoById(_mainRoleId)
    	self.weaponType_ = mainData.type
    else
    	self.weaponType_ = eateed_data.weaponType
    end

    local _qualifications = eateed_data.qualifications
    self.qualifications = _qualifications
    local hitType = skillData.hitType

    print("_qualifications:",_qualifications,"weaponType_:",self.weaponType_,"hitType:",hitType)
    for k,v in pairs(zhanfa_data) do
    	if self.weaponType_ == v.weaponType and v.qualifications == tonumber(_qualifications)  then
    		print("v.weaponType:",v.weaponType,"v.qualifications:",v.qualifications,"v.skillType  ",v.skillType)
    		self.zhanfaData[v.skillType] = v
    	end
    end
    self.zhanfaUpgrade = {}
    self.zhanfaUpgradeCount = 0
    for k,v in pairs(zhanfa_upgrade) do
    	if _qualifications == v.qualifications then
    		dump(v)
    		self.zhanfaUpgrade[v.level] = v
    		self.zhanfaUpgradeCount = self.zhanfaUpgradeCount + 1
    	end
    end

	self.weaponType_Data = {
		[1] = {
			name = zc.lang("long_handle"),
			weaponType = 1,
		},
		[2] = {
			name = zc.lang("single_hand"),
			weaponType = 2,
		},
		[3] = {
			name = zc.lang("staff"),
			weaponType = 3,
		},
		[4] = {
			name = zc.lang("sword"),
			weaponType = 4,
		},
		[5] = {
			name = zc.lang("fan"),
			weaponType = 5,
		},
		[6] = {
			name = zc.lang("magic_ball"),
			weaponType = 6,
		}
	}
end

function ZhanFaZhaungBei:initUI(params)
	local _data = params.roleData or {}
	dump(_data,"------------------------ZhanFaZhaungBei 镶嵌的武将数据------")
	-- dump(_data)
	local _bgWidth
	local _bgHeight
	local _x
	local _y
	if self._activityType == 1 then
		_bgWidth = 680
		_bgHeight = 445
		_x = 530
		_y = 360
	else
		_bgWidth = 680
		_bgHeight = 445
		_x = 530
		_y = 400
	end
	local background = cc.Sprite:create( "res/Main/battle/battleresult/battle_bg.png" )
	background:setScale(2)
	background:setPosition(_x,_y)
	self:addChild(background,-1)

    local _bg = zc.createNormalPop({
        tag = 1,
        titleTag = 4,
        height = _bgHeight,
        width = _bgWidth,
        showSide = false,
    })
	_bg:setPosition(_x,_y)
	-- 可视范围内点击不消失
	self:addContent(_bg)
	local bgSize = _bg:getContentSize()

	local _b_sideImg = zc.getScaleNode("res/Main/common/popBg/shadow_b.png", cc.size(_bgWidth, 25))
    _b_sideImg:setAnchorPoint(0, 1)
    _b_sideImg:setPosition(0, 0)
    _bg:addChild(_b_sideImg)

    local _r_sideImg = zc.getScaleNode("res/Main/common/popBg/shadow_r.png", cc.size(25, _bgHeight))
    _r_sideImg:setAnchorPoint(0, 1)
    _r_sideImg:setPosition(_bgWidth, _bgHeight - 25)
    _bg:addChild(_r_sideImg)

    
    local str 
	if self.Type == 1 then
		str = "tlevel1"..self.select_index
	else
		str = "tlevel2"..self.select_index
	end
	local zhanfa_level = 0
	print("_data[str]:",self.heroData.tactics[str],"str:",str)
	if tonumber(self.heroData.tactics[str]) == 0 then
		zhanfa_level = 1
	else
		zhanfa_level = tonumber(self.heroData.tactics[str])
	end
	print("zhanfa_level:",zhanfa_level)
	self.oldLevel = zhanfa_level

	local normal_ = zc.createSprite("res/Main/common/button/common_close_btn_u.png")
    local select_ = zc.createSprite("res/Main/common/button/common_close_btn_d.png")
    -- self.zhanfa_level 
    local data = {
		index = self.Type,
		isUpgrade = true,
		select_index = self.select_index,
		seletToCell = self.seletToCell,
	}
    local _btn = zc.createPushButton({
        normalNode = normal_,
        selectedNode = select_,
        pos = cc.p(bgSize.width, bgSize.height - 10),
        endCallback = function ()
	            if self.removeLayer then
					self.removeLayer()
					zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = {
						index = self.Type,
						isUpgrade = true,
						select_index = self.select_index,
						seletToCell = self.seletToCell,
					}})
				end
        end
    })
    _bg:addChild(_btn,5)

	local bg_black = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/common/popBg/di_4.png")
    bg_black:setContentSize(650,270)
	bg_black:setPosition(bgSize.width/2,bgSize.height/2 + 25)
	_bg:addChild(bg_black)

	local yellow_bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/trinket/sellDi.png")
	yellow_bg:setContentSize(674,100)
	yellow_bg:setPosition(bgSize.width/2,45)
	_bg:addChild(yellow_bg)

	local _spine = zc.getSpine( "jsxxyxg" )
    _spine:setPosition( 90,180 )
    _spine:setScale(0.8)
    _spine:playAction( "animation", true )
    bg_black:addChild( _spine )

    local skillbg = ZCSprite:create("res/Main/role/fetter/fetterItemBg.png")
    skillbg:setPosition(_spine:getContentSize().width/2+3,_spine:getContentSize().height/2 -2)
    _spine:addChild(skillbg)

	local _headIcon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeSoldier,
            type = 1, 
            id = _data.heroId,
            level = zc.getLevelTipShow() .. _data.level,
            reincarnate = _data.reincarnate,
        }, 
        quality = _data.quality,
        showQuality = true,
        scale = 0.8,
        pos = cc.p(_spine:getContentSize().width/2 + 3,_spine:getContentSize().height/2),
    })
	_spine:addChild(_headIcon)

	local bg_tiao1 = zc.createSprite("res/Main/common/popBg/di_properties.png")
	bg_tiao1:setPosition(_spine:getPositionX() + 10,70)
	bg_black:addChild(bg_tiao1)

	local bg_tiao1_size = bg_tiao1:getContentSize()

	local curr_level = zc.createLabel({
		text = zc.lang("curr_level")..":",
        fontSize = 20,
        pos = cc.p( 50,bg_tiao1_size.height/2 ),
        color = cc.c3b(200,182,127),
    })
	bg_tiao1:addChild(curr_level)

	local level_str = "LV."..(zhanfa_level)
	local level_num = zc.createLabel({
		text = level_str,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p( curr_level:getPositionX() + curr_level:getContentSize().width/2 + 15,bg_tiao1_size.height/2 ),
        outLine = true,
    })
	bg_tiao1:addChild(level_num)

	local bg_tiao2 = zc.createSprite("res/Main/common/popBg/di_properties.png")
	bg_tiao2:setPosition(bg_tiao1:getPositionX(),bg_tiao1:getPositionY() - 40)
	bg_black:addChild(bg_tiao2)

	local weapType = zc.createLabel({
		text = zc.lang("weaponType")..":",
        fontSize = 20,
        pos = cc.p( 50,bg_tiao1_size.height/2 ),
        color = cc.c3b(200,182,127),
    })
    bg_tiao2:addChild(weapType)

    local weapType_name = zc.createLabel({
		text = self:getWeaponName(self.weaponType_),
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p( weapType:getPositionX() + weapType:getContentSize().width/2 + 15,bg_tiao1_size.height/2 ),
        outLine = true,
    })
    bg_tiao2:addChild(weapType_name)

    local weaponIcon_ = zc.createSprite("res/Main/role/common/weapon_icon_"..self.weaponType_..".png" )
    weaponIcon_:setScale(0.5)
    weaponIcon_:setPosition(weapType_name:getPositionX()+ weapType_name:getContentSize().width + 20,bg_tiao1_size.height/2)
    bg_tiao2:addChild(weaponIcon_)
    local distanceY = 157
    local height_ = 315
    local distanceY_Gray = 0
    local height_Gray = 248
    local width_ = 380

	local bg_gray = ccui.Scale9Sprite:create(cc.rect(25, 25, 3, 3),"res/Main/common/popBg/di_3.png")
	bg_gray:setContentSize(width_,height_Gray)
	bg_gray:setPosition( bg_black:getPositionX() + 75,bg_black:getPositionY() + distanceY_Gray)
	_bg:addChild(bg_gray)

	local selet_list = {}
	local selet_list_label = {}
	local texts = {zc.lang("gongji"),zc.lang("fuzhu")}
	local fontcolors = {cc.c3b(255, 207, 91), cc.c3b(187, 157, 144)}
	
	local function Buildesc(level)
		local desc_list = {}
		local str 
		if self.Type == 1 then
			str = "tlevel1"..self.select_index
		else
			str = "tlevel2"..self.select_index
		end
		local zhanfa_level = 0
		if tonumber(self.heroData.tactics[str]) == 0 then
			zhanfa_level = 1
		else
			zhanfa_level = tonumber(self.heroData.tactics[str])
		end
		if level then
			zhanfa_level = level
		end
		for i=1,2 do
			zhanfa_level = zhanfa_level + (i - 1)
			if zhanfa_level > self.zhanfaUpgradeCount + 1 then
				local _desc = "[color=ffffff00]"..zc.lang("manji").."[/color]"
				table.insert(desc_list,_desc)
			else
			    local str_list = {}
		    	local tab_ = string.split(self.zhanfaData[self.tag].desc,"$")
			    for k,v in pairs(tab_) do
			    	local n,m = string.find(v,"|")
			    	if n then
			    		local gongshi = string.split(v,"|")
			    		local func = loadstring("return "..string.gsub(gongshi[2],"lv",zhanfa_level))
			    		local str2 = func()
			    		local baifenhao = string.split(v,"%")
			    		if baifenhao[2] == "" then
			    			str2 = str2.."%"
						end
			    		table.insert(str_list,str2)
			    	else
			    		table.insert(str_list,v)
			    	end
			    end
			    local _desc = ""
			    for i = 1,#str_list do
			    	local str = str_list[i]
			    	if i%2 == 0 then
			    		_desc = _desc.."[color=ff00FF00]"..str.."[/color]"
			    	else
			    		_desc = _desc.."[color=ff2d180b]"..str.."[/color]"
			    	end
			    end
			    print("self.tag:",self.tag,"ldesc:",self.zhanfaData[self.tag].desc,"_desc:",_desc)
			    table.insert(desc_list,_desc)
			end
		end
		return desc_list
	end
	-- 富文本语言
	local desc_list = Buildesc()
	local label_list = {}
	local btn_list = {}
	local function selectFunc()
    	for j=1,2 do
    		if self.tag == j then
    			selet_list[j]:setTexture("res/Main/role/select.png")
    			selet_list[j]:setLocalZOrder(0)
    			selet_list_label[j]:setColor(fontcolors[1])
    		else
    			selet_list[j]:setTexture("res/Main/role/unselect.png")
    			selet_list[j]:setLocalZOrder(-1)
    			selet_list_label[j]:setColor(fontcolors[2])
    		end
    	end
    end
    -- 描述
	for i = 1,2 do
		local _baseAttrTitle = cc.Sprite:create( "res/Main/role/level"..i..".png" )
    	_baseAttrTitle:setPosition( bg_gray:getContentSize().width/2, bg_gray:getContentSize().height - ((i - 1)*105 + 35) )
	    bg_gray:addChild( _baseAttrTitle )

	    local _baseAttrTitleLeft = cc.Sprite:create( "res/Main/common/lace.png" )
	    _baseAttrTitleLeft:setAnchorPoint( 1, 0.5 )
	    _baseAttrTitleLeft:setPosition( 0, _baseAttrTitle:getContentSize().height/2 )
	    _baseAttrTitle:addChild( _baseAttrTitleLeft )
	    local _baseAttrTitleRight = cc.Sprite:create( "res/Main/common/lace.png" )
	    _baseAttrTitleRight:setAnchorPoint( 0, 0.5 )
	    _baseAttrTitleRight:setPosition( _baseAttrTitle:getContentSize().width, _baseAttrTitle:getContentSize().height/2 )
	    _baseAttrTitleRight:setFlippedX( true )
	    _baseAttrTitle:addChild( _baseAttrTitleRight )

	    -- 实际应该有一个战法的等级，
	    local desc = zc.createRichLabel({
	        -- text = desc_list[i].."测试文本是否换行，测试文本是否换行，测试文本是否换行，测试文本是否换行",
	        text = desc_list[i],
	        height = 0,
	        width =320,
	        fontSize = 20,
	        ap = cc.p(0.5, 1 ),
	        pos = cc.p(bg_gray:getContentSize().width/2, _baseAttrTitle:getPositionY() - _baseAttrTitle:getContentSize().height - 21),
	        -- outLine = true,
	    })
	    if desc:getContentSize().width > 350 then
	        desc:setDimensions(cc.size(350, 66))
	    end
	    bg_gray:addChild(desc)
	    label_list[i] = desc

    	local touch_sprite = ZCSprite:create("res/Main/role/unselect.png")
	    touch_sprite:setPosition(cc.p(bg_gray:getContentSize().width + 15, (i - 1) * 120 + 63))
	    touch_sprite:setTouchEndedCallback(function ()
	    	self.tag = i
	    	selectFunc()
	    	local des = Buildesc()
	    	for i=1,2 do
	    		label_list[i]:setString(des[i])
	    		if label_list[i]:getContentSize().width > 350 then
	    			label_list[i]:setDimensions(cc.size(350, 66))
	    		end
	    	end
        end)
        local label = zc.createLabel({
        	text = texts[i],
        	pos = ccp(touch_sprite:getContentSize().width/2,touch_sprite:getContentSize().height/2),
        	outLine = true,
        	color = fontcolors[i],
        	fontSize = 24
        	})

        touch_sprite:addChild(label)
        if i == 1 then
        	bg_gray:addChild(touch_sprite,-1)
    	else
    		bg_gray:addChild(touch_sprite)
    	end
        selet_list[i] = touch_sprite
        selet_list_label[i] = label
	end
	selectFunc()
	self.zhuangbeiBtn = zc.createCommomBtn({
		tag = 1,
		text = LANGUAGE_ROLE.activate_space,
		pos = cc.p(yellow_bg:getContentSize().width/2, yellow_bg:getContentSize().height/2),
		outLine = true,
		endCallback = function()
			if self._activityType == 0 then -- 强化
				zc.sendHttp({
					apiName = "Role_Upgrade",
					params = {
						heroId = self.heroData.id,
						type = self.Type,
						index = self.select_index,
					},
					successCallback = function(backData)
						PlayerData:updataData(backData)
						zc.tipInfo(zc.lang("strength")..zc.lang("success"))
						zhanfa_level = zhanfa_level + 1
						level_num:setString("LV."..zhanfa_level)

						self.newLevel = zhanfa_level

						local des = Buildesc(zhanfa_level)
				    	for i=1,2 do
				    		label_list[i]:setString(des[i])
				    		if label_list[i]:getContentSize().width > 350 then
				    			label_list[i]:setDimensions(cc.size(350, 66))
				    		end
				    	end
				    	print("#self.list_bg ",#self.list_bg)
				    	for i = 1,#self.list_bg do
				    		self.list_bg[i]:setVisible(false)
				    	end
				    	self:initReward(zhanfa_level,yellow_bg)
					end,
				})
			else
				zc.sendHttp({
					apiName = "Role_XiangQian",-- 装备
					params = {
						heroId = self.heroData.id,
						targetHeroId = _data.id,
						type = self.Type,
						index = self.select_index,
					},
					successCallback = function(backData)
						PlayerData:updataData(backData)
						for k,v in pairs(PlayerData:getGeneralInfo()) do
                            if tonumber(self.heroData.id) == tonumber(v.id) then
                                dump(v,"装备后到底是什么？")
                            end
                        end

						local isEquip = true
						zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_ZHANFA_CHANGE, data = {
							index = self.Type,
							isEquip = isEquip,
							select_index = self.select_index,
							seletToCell = self.seletToCell,
							id = self.heroData.id,
							}
						})
						if self.removeLayer then
							self.removeLayer()
							zc.tipInfo(zc.lang("equip")..zc.lang("success"))
						end
						LayerManager.removeLayout()
					end,
				})
			end
		end
	})
	yellow_bg:addChild(self.zhuangbeiBtn)
	self:initReward(zhanfa_level,yellow_bg)
end

function ZhanFaZhaungBei:initReward(zhanfa_level,yellow_bg)
	local _fragmentNum
	local _costNum
	self.list_bg = {}
	if self._activityType == 0 then
		local Y = yellow_bg:getPositionY() + 8
		if self.xiaohao_tiao == nil then
			self.xiaohao_tiao = zc.createSprite("res/Main/role/breakthrough/costTips.png")
			self.xiaohao_tiao:setScale(0.8)
			self.xiaohao_tiao:setPosition(35,Y)
			yellow_bg:addChild(self.xiaohao_tiao)
		end
		-- 满级
		print("#self.zhanfaUpgrade:",self.zhanfaUpgradeCount +1,"zhanfa_level:",zhanfa_level,"TEST")
		if zhanfa_level >= self.zhanfaUpgradeCount + 1 then
			self.xiaohao_tiao:setVisible(false)
			for k = 1,#self.list_bg do
				self.list_bg[k]:setVisible(false)
			end
			self.manjiLabel = zc.createSprite("res/Main/role/zhanfa_max.png")
			self.manjiLabel:setScale(1.2)
			self.manjiLabel:setPosition(130,yellow_bg:getContentSize().height/2)
			yellow_bg:addChild(self.manjiLabel)
			self.manjiLabel:setVisible(true)
			self.zhuangbeiBtn:setEnable(false)
		else
			self.xiaohao_tiao:setVisible(true)
			for k = 1,#self.list_bg do
				self.list_bg[k]:setVisible(true)
			end

			self.zhuangbeiBtn:setEnable(true)
			if self.manjiLabel then
				self.manjiLabel:setVisible(false)
			end
			local xiaohao_tiao_size = self.xiaohao_tiao:getContentSize()
			local index_ = zhanfa_level 
			dump(self.zhanfaUpgrade[index_],"test")

			_costNum = self.zhanfaUpgrade[index_].sameCardNum
			local _info = PlayerData:getFragmentInfoByHeroId(self.roleData.heroId) or {}
			_fragmentNum = tonumber(_info.num) or 0
			local reward_ = {self.zhanfaUpgrade[index_].needStuff1,self.zhanfaUpgrade[index_].needStuff2,self.zhanfaUpgrade[index_].needStuff3}
			
			if _costNum ~= 0 then
				local bg_item = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
				bg_item:setContentSize(80,80)
				bg_item:setScale(0.8)
				bg_item:setPosition(self.xiaohao_tiao:getPositionX()+ xiaohao_tiao_size.width + 20,Y)
				yellow_bg:addChild(bg_item)
				table.insert(self.list_bg,bg_item)

				local _item = zc.createIconByData({
			        data = {
			            mainType = zc.mainTypeSoldierFragment,
			            type = self.roleData.heroId, 
			            id = self.roleData.heroId,
			        }, 
			        quality = self.roleData.quality,
			        scale = 0.6,
		        	pos = cc.p(40,40), 
		    	})
		    	_item:setTouchEndedShowTip()
				bg_item:addChild(_item)
				local numLabel = zc.createLabel({
					text = ""..zc.getWan(_costNum),
			        fontSize = 20,
			        scale = 0.9,
			        ap = cc.p(1,0.5),
			        pos = cc.p(bg_item:getContentSize().width - 5,18),
			        outLine = true,
				})
				bg_item:addChild(numLabel)
				numLabel:setColor(_costNum <= _fragmentNum and display.COLOR_WHITE or display.COLOR_RED)
			end
			local num = 0
			for k,v in pairs(reward_) do
				if v ~= 0 then
					num = num + 1
				end
			end
			for i = 1,num do
				local data = reward_[i]
				if data ~= 0 then
					local bg_item = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
					bg_item:setContentSize(80,80)
					bg_item:setScale(0.8)
					local X =  #self.list_bg >= 1 and (self.list_bg[#self.list_bg]:getPositionX() + self.list_bg[#self.list_bg]:getContentSize().width - 8) or (self.xiaohao_tiao:getPositionX()+ xiaohao_tiao_size.width + 20)
					bg_item:setPosition(X,Y)
					table.insert(self.list_bg,bg_item)
					yellow_bg:addChild(bg_item)

					local _tb_ = string.split(data, "|")
					local item_icon = zc.createIconByData({
							 data = {
					            mainType = _tb_[1],
					            type = _tb_[2], 
					            id = _tb_[2],
					        },
					        scale = 0.61,
					        pos = cc.p(40,40)
						})
					item_icon:setTouchEndedShowTip()
					bg_item:addChild(item_icon)

					local str = ""..(zc.getWan(_tb_[3])or 1)
					local label = zc.createLabel({
						text = str,
						fontSize = 20,
						ap = cc.p(1,0.5),
						pos = cc.p(bg_item:getContentSize().width - 5,18),
						scale = 0.9,
						})
					bg_item:addChild(label)
					local _cost = tonumber(zc.getNumByTypeId(_tb_[1],_tb_[2])) or 1
					print("_cost:",_cost,"_tb_[3] ",_tb_[3],"_fragmentNum:",_fragmentNum,"_costNum:",_costNum)
					label:setColor( _cost < tonumber(_tb_[3]) and display.COLOR_RED or display.COLOR_WHITE)
				end
			end
		end
		
		-- 卸下按钮
		local distance 
		local y 

		if #self.list_bg == 1 then
			distance = 200
			y = 150
		elseif #self.list_bg == 2 then
			distance = 160
			y = 120
		elseif #self.list_bg == 3 then
			distance = 140
			y = 100
		elseif #self.list_bg == 4 then
			distance = 115
			y = 90
		else
			distance = 230
			y = 170
		end
		print("#self.list_bg:",#self.list_bg)
		local x_ = #self.list_bg >= 1 and self.list_bg[#self.list_bg]:getPositionX() + distance or distance + 80
		self.zhuangbeiBtn:setString(zc.lang("strength"))
		self.zhuangbeiBtn:setPositionX(yellow_bg:getContentSize().width - y)
		if self.xiexiaBtn == nil then
			self.xiexiaBtn = zc.createCommomBtn({
				tag = 2,
				text = zc.lang("unload"),
				pos = cc.p(x_ , yellow_bg:getContentSize().height/2),
				outLine = true,
				endCallback = function()
					local function RemoveLayer( ... )
						self:removeChildByTag(200000)
					end
					local params= {
						skillData = self.skillData,
						index = self.select_index,
						heroData = self.heroData,
						roleData = self.roleData,
						removeLayer = RemoveLayer,
						seletToCell = self.seletToCell,
					}
	        		local layer_ = requires("src/layer/role/ZhanFaUnLoad.lua"):create(params or {})
	                layer_:setTag(200000)
	                self:addChild(layer_)
				end
			})
			yellow_bg:addChild(self.xiexiaBtn)
		else
			self.xiexiaBtn:setPosition(cc.p(x_, yellow_bg:getContentSize().height/2))
		end
	end
end

function ZhanFaZhaungBei:getWeaponName(weaponType)
	for i,v in ipairs(self.weaponType_Data) do
		if weaponType == v.weaponType then
			return v.name
		end
	end
end

return ZhanFaZhaungBei