--[[
FileName 		TaskTipsPop.lua
ProjectName		HJ2
Created by wangming on 16-11-01 ---需求变更了，重写  
]]
local TaskTipsPop = class("TaskTipsPop",function ()
	local _file = zc.createPushButton({
        normalFile = "taskBar.png",
        plist = true,
        anchor = cc.p(0, 0),
        endCallback = function() end,
    })
	return _file
end)

function TaskTipsPop:create()
    return TaskTipsPop.new()
end

function TaskTipsPop:ctor()
	local _label = zc.createRichLabel({
		anchor = cc.p(0, 0.5),
		fontSize = 18,
		pos = cc.p(57, self:getContentSize().height*0.5),
		color = cc.c3b(86, 32, 2),
	})
	self:addChild(_label)
	self._showLab = _label

	self:setTouchEndedCallback(function ()
    	local _taskData = self._taskData
		if tonumber(_taskData.status) == 1 then
    		zc.toReceiveRewardsView(_taskData.conditions or "")
        elseif tonumber(_taskData.status) == 2 then
            zc.createTaskView({tag = _taskData.type, taskId = _taskData.id})
        end
	end)
	self:refresh()
end

function TaskTipsPop:refresh()
	local function _getTb( data, dbData, _type )
		local _tb = {}
		_tb.id = dbData.id
		_tb.status = data.status
		_tb.progress = dbData.progress
		_tb.arg1 = tonumber(data.arg) or 0
		_tb.arg2 = tonumber(data.conditions) or 1
		if type(_tb.arg2) ~= "number" then
			_tb.arg2 = 1
		end
		_tb.arg1 = _tb.arg1 > _tb.arg2 and _tb.arg2 or _tb.arg1
		_tb.name = dbData.name
		_tb.desc = dbData.desc
		_tb.type = _type
		_tb.conditions = dbData.conditions
		return _tb
	end

	local _allDatas = PlayerData:getTaskData()[1] or {}
	local _taskData = _allDatas[1]
	if _taskData then
		local _dbData = gameData.getDataFromCacheWithPrimaryKey("task", _taskData.taskId)
		_taskData = _getTb(_taskData, _dbData, 1)
		local _progress = ""
		if tonumber(_taskData.progress) ~= 0 then 
			local _color = "ffff0000"
			if _taskData.arg1 == _taskData.arg2 then
				_color = "ff00ff00"
			end
			_progress = "[color=" .. _color .. "](" .. _taskData.arg1 .. "/" .. _taskData.arg2 .. ")[/color]"
		end
		local _text = _taskData.desc .. _progress
		self._showLab:setString(_text)
		self._taskData = _taskData
		if _taskData.arg1 == _taskData.arg2 then
			if not self._overEff then
			    local _eff = zc.createSpine({
			        fileName = "renwutexiao",
			        actName = "renwuwancheng",
			    })
			    _eff:setPosition(self:getContentSize().width*0.5, self:getContentSize().height*0.5)
			    self:addChild(_eff, 2)
			    self._overEff = _eff
			end
		else
			if self._overEff then
				self._overEff:removeFromParent()
				self._overEff = nil
			end
		end
	else
		self._taskData = {}
		self._showLab:setString(zc.lang("tips_now_main_task_all_finish"))
		if self._overEff then
			self._overEff:removeFromParent()
			self._overEff = nil
		end
	end

	if self._taskData.id == GuideTask33Key and tonumber(_taskData.status) == 2 then
		if not self._guideHand then
			local _guideHand = zc.createSpine({
		        fileName = "shou",
		        actName = "shou",
		    })
		    _guideHand:setRotation(-45)
		    _guideHand:setScale(0.5)
		    _guideHand:setPosition(self:getContentSize().width*0.8, self:getContentSize().height*0.5)
		    self:addChild( _guideHand, 10)
			self._guideHand = _guideHand
		end
		local _mainCity = zc.getScene("mainCity")
		if _mainCity and _mainCity._guideHand then
			_mainCity._guideHand:setVisible(false)
		end
	elseif self._guideHand then
		self._guideHand:removeFromParent()
		self._guideHand = nil
	end
end

function TaskTipsPop:getTaskRed()
	for i=1, 3 do
		if self:getFlag(i) then
			if i == 1 then
				self:refresh()
			end
			return true
		end
	end
	return false
end

--获取是否有任务可领取
function TaskTipsPop:getFlag( idx )
    local _num = zc.getAchieveTaskLevel()
	local _datas = PlayerData:getTaskData()[idx] or {}
	if _datas and #_datas > 0 then
		for k,v in pairs(_datas) do
			if tonumber(v.status) == 2 then
				if idx == 2 then
					local _taskTemplate = gameData.getDataFromCacheWithPrimaryKey("task", v.taskId)
		            if _taskTemplate.level <= _num then
						return true
		            end
		        else
					return true
				end
			end
		end
	end
	return false
end

function TaskTipsPop:checkGuideHand(flag)
	if tolua.isnull(self._guideHand) then
		self._guideHand = nil
		return
	end
	self._guideHand:setVisible(flag)
end

return TaskTipsPop