--[[
	名将副本奖励箱子弹窗
	唐实聪
	2016.4.7
]]
local TollgateHeroRewardPop = class("TollgateHeroRewardPop", function()
	return ZCPopLayer:create()
end)

function TollgateHeroRewardPop:create( params )
	return self.new( params )
end

function TollgateHeroRewardPop:ctor( params )
	self:show()
	self:initData( params )
	self:initUI()
end

function TollgateHeroRewardPop:initData( params )
	-- dump( params, "params" )
	self._reward = {}
    -- 
    local chapterId = params.chapterId
    local awards = gameData.getDataFromCacheWithPrimaryKey("hero_chapter", chapterId).awards
    self._reward[#self._reward + 1] = gameData.getDataFromCacheWithPrimaryKey("drop_award", awards)
	-- 是否可以领取
	self._fetchable = params.fetchable or false
	-- 是否已经领取
	if tonumber( params.drawPass ) == 1 then
		self._fetched = true
	else
		self._fetched = false
	end
	self._callback = params.callback

	self._size = self:getContentSize()
end

function TollgateHeroRewardPop:initUI()
	-- 背景
	local background = cc.Sprite:create( "res/Main/battle/battleresult/battle_bg.png" )
	background:setPosition( self._size.width/2, self._size.height/2 - 30 )
	self:addContent( background )
	self._bg = background
	self._bgSize = background:getContentSize()
	-- 奖励
    local armature = zc.createArmature({
        parentPath = "res/Main/battle/battleresult/win/",
        fileName = "win",
        actName = "SWL_star_3",
        eventCallback = function() end,
        completeCallback = function(armatureBack,movementType,movementID)
            self._armature:getAnimation():play("SWL_idle_3", -1, 0)
        end
    })
    armature:setPosition(self._bgSize.width/2, self._bgSize.height)
    background:addChild(armature)
    self._armature = armature
    -- 标题
    local titleBg = cc.Sprite:create( "res/Main/wushenTower/common_title_bg.png" )
    titleBg:setPosition( self._bgSize.width/2, self._bgSize.width/2 + 105 )
    background:addChild( titleBg )
    local title = zc.createLabel({
        text = "",
        stroke = true,
        fontSize = 22,
        fontName = zc.getFont(1),
        ap = cc.p( 0.5, 0.5 ),
        pos = cc.p( titleBg:getContentSize().width/2, titleBg:getContentSize().height/2 ),
        color = display.COLOR_GOLD,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    titleBg:addChild( title )
   	-- 说明
   	local desc = zc.createLabel({
        text = "",
        stroke = true,
        fontSize = 22,
        fontName = zc.getFont(1),
        ap = cc.p( 0.5, 1 ),
        pos = cc.p( titleBg:getContentSize().width/2, -15 ),
        color = display.COLOR_GOLD,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    titleBg:addChild( desc )
    -- 奖励
    local rewardPos = zc.sortFromMiddle( cc.p( self._bgSize.width/2, self._bgSize.height/2 - 20), #self._reward, 146 )
    for i, v in ipairs( self._reward ) do
    	local item = zc.createIconByData({
            data = {
                mainType = v.itemType,
                type = v.itemId, 
                id = v.itemId,
                num = v.itemNum,
            }, 
            showDetailPop = true,
            pos = rewardPos[i], 
            color = iconColor
        })
        -- item:setScale( 0.68 )
        background:addChild( item )
    end
    -- 领取奖励
    local fetchBtn = zc.createCommomBtn({
        tag = 1,
    	pos = cc.p( self._bgSize.width/2, 10 ),
    	text = LANGUAGE_TOLLGATEHERO.fetch_reward,
    	endCallback = function ()
    		if self._callback then
    			self._callback()
    		end
            self:hide()
        end
    })
    background:addChild( fetchBtn )
    if self._fetched then
    	-- 已领取
    	fetchBtn:setText( LANGUAGE_TOLLGATEHERO.fetched )
    	fetchBtn:setEnable( false )
    elseif not self._fetchable then
    	-- 不可领取
    	fetchBtn:setText( LANGUAGE_TOLLGATEHERO.can_not_fetch )
    	fetchBtn:setEnable( false )
    end
end

return TollgateHeroRewardPop