--[[
wcc
打造神器
makeGodWeaponPop
]]

local makeGodWeaponPop = class("makeGodWeaponPop",function()
    return ZCPopLayer:create({opacityValue=100})
end);

function makeGodWeaponPop:create(data)

    self._onlyShow = data.onlyShow --只显示一下，状态值已经是0，不用改变
    self._isAdd = data.isAdd
    self._endCallback = data.endCallback
    if not self._onlyShow then
        local thisWeapon = PlayerData:getWeaponInfoInfoById(data.info["id"])
        if thisWeapon["status"] and tonumber(thisWeapon["status"]) == 0 then
            return
        end
        --如果在这三个界面，就不再叠加弹出
        if zc.getScene("SmithyClear") or zc.getScene("SmithyBook") then
            return
        end
        if zc.getScene("SmithyGodWeapon") then
            if thisWeapon and thisWeapon["isUser"] ~= 1 then
                return
            end
        end
    end
    self._refreshState = data.refreshState
    return makeGodWeaponPop.new(data.info)
end

function makeGodWeaponPop:ctor(info)
    self:getContainerLayer():setTouchEndedCallback(function() end)
    -- dump(info, "---info--")
    self:initUI(info)
    self:show(false)
end

function makeGodWeaponPop:initUI(info)
    --打造成功，展示兵器同时改变领取状态值
    if not self._onlyShow then
        PlayerData:updateWeaponsInfoById({id=info.id,createTime = PlayerData:getTime(),status=0})
        zc.sendHttp({
            apiName = "Weapon_changeState",
            params = {weaponId = info.id},
            successCallback = function()
                if self._refreshState then
                    self._refreshState()
                end
            end,
        })
    end
        

    local closeBtn = zc.createPushButton({
        needSwallow = true,
        touchSize = cc.size(10000, 10000),
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(zc.width/2, zc.height/2),
    })
    self:addContent(closeBtn)
    closeBtn:setContentSize(cc.size(zc.width,zc.height))
    closeBtn:setEnable(false)
    performWithDelay(self, function()
        closeBtn:setEnable(true)
    end, 0.8)
    
    local mask = cc.LayerColor:create(cc.c4b(0,0,0,250))
    mask:setContentSize(cc.size(zc.width+100,zc.height+100))
    mask:setPosition(cc.p(-50,-50))
    closeBtn:addChild(mask, -1)

    --添加动画
    local bgSprite = zc.createSprite("res/Main/smithy/make/makeSuccess/successBg.jpg")
    bgSprite:setPosition(zc.width/2, zc.height/2)
    zc.setBgSize(bgSprite)
    closeBtn:addChild(bgSprite)

    local _sp = zc.createSprite()
    _sp:setPosition(zc.width/2,zc.height/2)
    closeBtn:addChild(_sp, 100)
    _sp:setScale(4)
    local _action = zc.getAnimationBySpriteFrame({
        path = "res/Main/smithy/make/makeSuccess/daz/daz",
        preFix = "daz_",
        perUnit = 1/10,
        startIndex = 1,
        endIndex = 8,
    })
    _sp:runAction(cc.Sequence:create(
        cc.DelayTime:create(0.1),
        _action,
        cc.CallFunc:create(
            function()
                local dzcg = zc.getSpine("dzcg")
                dzcg:setPosition(zc.width/2+35, zc.height/2-10)
                closeBtn:addChild(dzcg)
                dzcg:playAction("idle", false)
                closeBtn:runAction(cc.Sequence:create(cc.DelayTime:create(0.3),CCShake:create(0.3, 30)))
            end)
    ))


    local bg_top = zc.createSprite("res/Main/smithy/make/makeSuccess/titleBg_1.png")
    bg_top:setAnchorPoint(0, 1)
    bg_top:setPosition(0, zc.height)
    closeBtn:addChild(bg_top)

    local bg_down = zc.createSprite("res/Main/smithy/make/makeSuccess/titleBg_2.png")
    bg_down:setAnchorPoint(1, 0)
    bg_down:setPosition(zc.width, 0)
    closeBtn:addChild(bg_down)
    

    local taizi = zc.createSprite("res/Main/smithy/make/makeSuccess/taizi.png")
    taizi:setAnchorPoint(0.5, 0)
    taizi:setPosition(zc.width/2, zc.height/2 - 210)
    closeBtn:addChild(taizi)
    local huo = zc.getSpine("kaishiyouxi")
    huo:playAction("burn", true)
    huo:setPosition(cc.p(taizi:getContentSize().width/2, taizi:getContentSize().height/2+110))
    taizi:addChild(huo)
    
    local bgSize = cc.size(734, 384)
    -- local _bg = zc.getScaleNode("res/Main/setting/scale9_1.png", bgSize)
    local _bg = zc.getScaleNode("res/Main/common/img_empty.png", bgSize)
    _bg:setAnchorPoint(cc.p(0.5, 0.5))
    _bg:setPosition(cc.p(zc.width/2, zc.height/2-60))
    closeBtn:addChild(_bg, 1)
    
    local _click_empty = zc.createImageView({
        src = "res/Main/common/click_empty.png",
        pos = cc.p(_bg:getContentSize().width/2, -30)
    })
    -- _bg:addChild(_click_empty,4)
    local _click_emptyLab = zc.createLabel({
        text = zc.lang("tips_click_empty_continue"),
        outLine = true,
        fontSize = 18,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_bg:getContentSize().width/2, -30),
        color = cc.c3b(198,88,91),
        pixel = 1.3
    })
    _bg:addChild(_click_emptyLab)
    local left = zc.createSprite("res/Main/smithy/make/makeSuccess/left_bg.png")
    left:setAnchorPoint(1, 0.5)
    left:setPosition(0, _click_emptyLab:getContentSize().height/2)
    _click_emptyLab:addChild(left)
    left:setFlipX(true)
    
    local right = zc.createSprite("res/Main/smithy/make/makeSuccess/left_bg.png")
    right:setAnchorPoint(0, 0.5)
    right:setPosition(_click_emptyLab:getContentSize().width, _click_emptyLab:getContentSize().height/2)
    _click_emptyLab:addChild(right)
    
    --
    local _title_bg = zc.createImageView({
        src = "res/Main/smithy/make/make_title_bg.png",
        pos = cc.p(_bg:getContentSize().width/2, _bg:getContentSize().height),
    })
    -- _bg:addChild(_title_bg)
    local title  = zc.createImageView({
        src = "res/Main/smithy/make/make_success.png",
        pos = cc.p(130, 139),
    })
    -- _title_bg:addChild(title)
    local _isUser = false
    if tonumber(info.weaponId) == 1001 or tonumber(info.weaponId) == 2001 then
        _isUser = true
        local weaponToPath = {
            [1001]="qiang_1",[1002]="qiang_1",[1003]="qiang_2",[1004]="qiang_2",[1005]="qiang_3",[1006]="qiang_3",
            [2001]="shanzi_1",[2002]="shanzi_1",[2003]="shanzi_2",[2004]="shanzi_2",[2005]="shanzi_3",[2006]="shanzi_3",
        }
        local weaponPath = weaponToPath[tonumber(info.iconId)]
        local skeletonNode = zc.createSpine({
            path = "res/Main/smithy/shenbing/show/",
            fileName = weaponPath,
            actName = info.iconId,
        })
        skeletonNode:setPosition(_bg:getContentSize().width/2, 270)
        _bg:addChild(skeletonNode)
        skeletonNode:setScale(0.7)
        skeletonNode:runAction(cc.RepeatForever:create(cc.Spawn:create(
            cc.Sequence:create(
                cc.MoveBy:create(1.2, cc.p(0, 10)),
                cc.MoveBy:create(1.2, cc.p(0, -10))
            )
        )))
    else
        local weapon = zc.createImageView({
            src = "res/Main/weapon/weaponImage/".. info.iconId ..".png",
            pos = cc.p(_bg:getContentSize().width/2, 270),
        })
        _bg:addChild(weapon)
        weapon:setScale(1.5)
        weapon:runAction(cc.RepeatForever:create(cc.Spawn:create(
            cc.Sequence:create(
                cc.MoveBy:create(1.2, cc.p(0, 10)),
                cc.MoveBy:create(1.2, cc.p(0, -10))
            )
        )))
        local weapon_bg = zc.createImageView({
            src = "res/Main/smithy/make/make_weapon_bg.png",
            pos = cc.p(_bg:getContentSize().width/2, _bg:getContentSize().height-215),
        })
        -- _bg:addChild(weapon_bg)
        --兵器特效展示
        zc.showWeaponEffect(weapon,info.weaponId)
        if info["type"] and tonumber(info["type"]) == 3 then
            weapon:setPositionY(weapon:getPositionY()+60)
        end
    end

    local nameLab = zc.createLabel({
        text = info["name"] or "",
        outLine = true,
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(_bg:getContentSize().width/2, 180),
        color = zc.getColorByQuality(info["color"]),
        pixel = 1.3
    })
    _bg:addChild(nameLab)
    if not _isUser then
        local _level = zc.getWeaponLevel( info["id"] )

        local showNameBg = zc.createSprite("res/Main/pub/showNameBg.png")
        showNameBg:setAnchorPoint(0, 0.5)
        showNameBg:setPosition(50-zc.width, zc.height/2 - zc.width*(math.sin(math.rad(26))))
        closeBtn:addChild(showNameBg,10)
        showNameBg:setRotation( -17 )

        local nameBg = zc.createSprite()
        nameBg:setContentSize(300,50)
        nameBg:setAnchorPoint(0.5, 0.5)
        nameBg:setPosition(showNameBg:getContentSize().width/2, 73)
        showNameBg:addChild(nameBg)
        local name = zc.createLabel({
            text = zc.lang("weapon_quality") .. " ",
            outLine = true,
            fontSize = 30,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, 25),
            color = display.COLOR_YELLOW,
            pixel = 1.3
        })
        nameBg:addChild(name)
        local chenghao = zc.createLabel({
            text = _level,
            outLine = true,
            fontSize = 50,
            ap = cc.p(0, 0.5),
            pos = cc.p(name:getPositionX()+name:getContentSize().width+5, name:getPositionY()),
            color = display.COLOR_WHITE,
            color = cc.c3b(233,150,3),
            pixel = 1.3
        })
        nameBg:addChild(chenghao)
        nameBg:setRotation( -9.5 )
        showNameBg:runAction(cc.Sequence:create(cc.DelayTime:create(0.9),cc.MoveBy:create(0.4,cc.p(zc.width,zc.width*(math.sin(math.rad(26))) ))))
        self._showNameBg = showNameBg
    end

    --组织数据
    local effectInfoList = {}
    local teffectInfoList = {}
    for i = 1, 6 do
        local effectInfo = info["effectInfo"..i]
        if effectInfo and  effectInfo["effectId"] then
            local idx = #effectInfoList + 1
            effectInfoList[idx] = {}
            effectInfoList[idx].effectId    = effectInfo["effectId"]
            effectInfoList[idx].effectValue = info["effectValue"..i]
        end
    end
    for i = 1, 4 do
        local teffectId = info["teffectId"..i]
        if teffectId and tonumber(teffectId) > 0 then
            local idx = #teffectInfoList + 1
            teffectInfoList[idx] = {}
            teffectInfoList[idx].teffectId    = info["teffectId"..i]
            teffectInfoList[idx].teffectValue = info["teffectValue"..i]
            teffectInfoList[idx].teffectColor = info["teffectColor"..i]
        end
    end
    table.sort( teffectInfoList, function( a,b )
        local _aColor = tonumber(a.teffectColor)
        local _bColor = tonumber(b.teffectColor)
        if  _aColor ~= _bColor then
            return _aColor > _bColor
        else
            return tonumber(a.teffectId) < tonumber(b.teffectId)
        end
    end)

    local widthNum = #effectInfoList > #teffectInfoList and #effectInfoList or #teffectInfoList
    if widthNum > 3 then
        widthNum = 3
    end
    local lineNum = math.floor((#effectInfoList-1)/3) + 1 + math.floor((#teffectInfoList-1)/3) + 1
    if info["isUser"] and tonumber(info["isUser"]) == 1 then
        lineNum = math.floor((#effectInfoList-1)/3) + 1 + 2
    end
    local contentWidth = 150 + widthNum * 150
    local contentHeight = lineNum * 50
    local contentbg = zc.getScaleNode("res/Main/smithy/make/makeSuccess/info_bg.png", cc.size(contentWidth, contentHeight))
    contentbg:setAnchorPoint(cc.p(0.5, 1))
    contentbg:setPosition(cc.p(_bg:getContentSize().width/2, 155))
    _bg:addChild(contentbg)
    contentbg:setPositionY(contentbg:getPositionY() - zc.height)

    closeBtn:setTouchEndedCallback(function()
        if self._showNameBg then
            self._showNameBg:stopAllActions()
            self._showNameBg:setPosition(cc.p(50 , zc.height/2))
        end
        contentbg:stopAllActions()
        contentbg:setPosition(cc.p(_bg:getContentSize().width/2, 155))
        performWithDelay(self,function()
            closeBtn:setTouchEndedCallback(function() 
                if self._isAdd then
                    self:removeFromParent()
                else
                    self:hide()
                end 
            end)
        end,0.1)
    end)

    contentbg:runAction(cc.Sequence:create(
        cc.DelayTime:create(1.3),
        cc.MoveBy:create(0.5,cc.p(0,zc.height)),
        cc.CallFunc:create(function() closeBtn:setTouchEndedCallback(
            function() 
                if self._isAdd then
                    self:removeFromParent()
                else
                    self:hide()
                end 
            end) 
        end)
    ))
        


    local posH = contentHeight - 30
    local curAtt =  zc.createLabel({
        text = zc.lang("base_attribute"),
        fontSize = 23,
        ap = cc.p(0, 0.5),
        pos = cc.p(30, posH),
        outLine = true,
        color = display.COLOR_WHITE
    })
    contentbg:addChild(curAtt)

    for i = 1, #effectInfoList do
        local posX = (i - math.floor((i-1)/3)*3) * 150
        if i == 4 then
            posH = posH-30
        end
        local effectInfo = effectInfoList[i]
        local effectId = effectInfo["effectId"]
        local effectValue = effectInfo["effectValue"] or 0
        local effectStr = LANGUAGE_getAttributeTextById(effectId)
        local effectNum = zc.getAttributeNumById(effectId,effectValue)
        local effectLab = zc.createLabel({
            text = effectStr.."：",
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(posX, posH),
            -- color = display.COLOR_WHITE,
            color = cc.c3b(238,98,3),
            pixel = 1.3
        })
        contentbg:addChild(effectLab)
        local effectNumLab = zc.createLabel({
            text = "+"..effectNum,
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(effectLab:getPositionX()+effectLab:getContentSize().width, effectLab:getPositionY()),
            -- color = display.COLOR_GREEN,
            color = cc.c3b(238,98,3),
            pixel = 1.3
        })
        contentbg:addChild(effectNumLab)
    end

    --test
    -- info["isUser"] = 1
    --如果是主角
    if info["isUser"] and tonumber(info["isUser"]) == 1 then
        --检查是否有解锁新的技能
        local newSkill = {}
        for i = 1,4 do
            local skillName = ""
            local skillLevelName = ""
            if i < 4 then
                skillName = "commonSkillId"..i
                skillLevelName = "commonSkillLevel"..i
            else
                skillName = "moraleSkillId"
                skillLevelName = "moraleSkillLevel"
            end

            if info[skillName] and tonumber(info[skillName]) > 0 then
                local static = gameData.getDataFromCacheWithPrimaryKey("skill", info[skillName])
                if static["subType"] and tonumber(static["subType"]) ~= 1 then
                    local idx = #newSkill + 1
                    newSkill[idx] = {}
                    newSkill[idx].skillid = info[skillName]
                    newSkill[idx].skillLevel = info[skillLevelName]
                    newSkill[idx].isBisha = false
                    if i == 4 then
                        newSkill[idx].isBisha = true
                    end
                end
            end
        end

        if next(newSkill) then
            local skillTip = zc.createLabel({
                text =  LANGUAGE_ROLE.unlock .. zc.lang("skill"),
                outLine = true,
                fontSize = 23,
                ap = cc.p(0, 0.5),
                pos = cc.p(30, posH - 55),
                pixel = 1.3
            })
            contentbg:addChild(skillTip)
            
            for i = 1, #newSkill do
                local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(100, 100))
                local orangeBtn = zc.createPushButton({
                    normalNode = myScale9,
                    needSwallow = true,
                    endCallback = function()
                    end,
                    pos = cc.p(skillTip:getPositionX()+160+(i-1)*110,skillTip:getPositionY())
                })
                contentbg:addChild(orangeBtn, 10)
                local item = zc.createIconByData({
                    data = {
                        mainType = zc.mainTypeSkill,
                        type = 1, 
                        id = newSkill[i].skillid,
                    }, 
                    pos = cc.p(orangeBtn:getContentSize().width/2, orangeBtn:getContentSize().height/2 ), 
                    listener = function ()
                        zc.createSkillInfoPop({id = newSkill[i].skillid, level=newSkill[i].skillLevel})
                    end
                })
                orangeBtn:addChild(item)

                item:setScale(0.8)

                if newSkill[i].isBisha then
                    local bisha = zc.createSprite("res/Main/pub/critical.png")
                    bisha:setAnchorPoint(0.5, 1)
                    bisha:setPosition( item:getContentSize().width/2 , 10 )
                    item:addChild(bisha)
                end
                item:setVisible(false)
                self:runAction(cc.Sequence:create(
                    cc.DelayTime:create(1.3+(i-1)*0.3), 
                    cc.CallFunc:create(function()  
                        local _spine = zc.getSpine( "shilianchou" )
                        _spine:setScale( 0.9 )
                        _spine:playAction( "start_4", false )
                        _spine:setPosition( item:getPosition() )
                        orangeBtn:addChild( _spine )
                    end),
                    cc.CallFunc:create(function()
                        item:setVisible(true)
                    end) 
                ))
            end
        end
    else
        if #teffectInfoList == 0 then
            return
        end
        local newAtt =  zc.createLabel({
            text = zc.lang("append_attribute"),
            fontSize = 23,
            ap = cc.p(0, 0.5),
            pos = cc.p(30, posH - 35),
            outLine = true,
            color = display.COLOR_WHITE
        })
        contentbg:addChild(newAtt)

        local posH = newAtt:getPositionY()
        for i = 1, #teffectInfoList do
            local posX = (i - math.floor((i-1)/3)*3) * 150
            if i == 4 then
                posH = posH-30
            end
            local teffectInfo = teffectInfoList[i]
            local teffectId     = teffectInfo["teffectId"]
            local teffectValue  = teffectInfo["teffectValue"]
            local teffectColor  = teffectInfo["teffectColor"]

            local effectStr = LANGUAGE_getAttributeTextById(teffectId)
            local effectNum = zc.getAttributeNumById(teffectId,teffectValue)
            local effectLab = zc.createLabel({
                text = effectStr.."：",
                outLine = true,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(posX, posH),
                color = zc.getColorByQuality(teffectColor), 
                pixel = 1.3
            })
            contentbg:addChild(effectLab)
            local effectNumLab = zc.createLabel({
                text = "+"..effectNum,
                outLine = true,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(effectLab:getPositionX()+effectLab:getContentSize().width, effectLab:getPositionY()),
                color = zc.getColorByQuality(teffectColor),
                pixel = 1.3
            })
            contentbg:addChild(effectNumLab)
        end
    end

    -- 如果达到条件就显示分享按钮, 与武器的品质和资质有关
    local platform = cc.Application:getInstance():getTargetPlatform()
    if cc.PLATFORM_OS_ANDROID == platform then

    elseif (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) then
        -- local heroType = tonumber(info["type"])   -- type
        local quality = tonumber(info["quality"])  -- 品质
        -- dump(info, "武器info:")
        local _weponInfo = zc.getShareItemInfo(2, quality)
        if _weponInfo == nil then
            local _zizhi = tonumber(info["trained"]) -- 资质
            _weponInfo = zc.getShareItemInfo(3, _zizhi, true)
        end
        if _weponInfo ~= nil then
            local shareBtn = zc.createShareBtn(true, _weponInfo)
            self:addChild(shareBtn, 10)
        end
    end
end

function makeGodWeaponPop:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/animation/dzcg/dzcg.png")
    textureCache:removeTextureForKey("res/animation/kaishiyouxi/kaishiyouxi.png")
    cc.SpriteFrameCache:getInstance():removeSpriteFramesFromFile("res/Main/smithy/make/makeSuccess/daz/daz_.plist")
    cc.TextureCache:getInstance():removeTextureForKey("res/Main/smithy/make/makeSuccess/daz/daz_.png")
    cc.TextureCache:getInstance():removeTextureForKey("res/animation/shilianchou/shilianchou.png")

    if self._endCallback then
        self._endCallback()
    end
end

return makeGodWeaponPop