--[[
-- 其他玩家功能选择界面
-- @author lph
-- Creation  2016-3-19
]]
local otherPlayerSelectPop = class("otherPlayerSelectPop",function()
    return ZCPopLayer:create()
end);

function otherPlayerSelectPop:create(data)
    local layer = otherPlayerSelectPop.new(data)
    return layer
end
function otherPlayerSelectPop:onCleanup()
    local _forms = PlayerData:getNowFormationFiles()
    for k, v in pairs( self._record ) do
        -- 如果已上阵，不删除
        local _path, _resId = zc.battle.getHeroArmaturePathByResId( k )
        if not _forms[_resId] then
            ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( _path )
        end
    end
    helper.collectMemory()

    local friendPop = zc.getScene("Friend")

    if friendPop then
        friendPop:resetData()
    end

end
function otherPlayerSelectPop:ctor(data)
    self._record = {}
	self._otherPlayerInfo = data    --其他玩家信息
	for k,v in pairs(self._otherPlayerInfo.heros) do
        if tonumber(v.heroId) == 101 then
            self.otherRoleInfo = v
        elseif tonumber(v.heroId) == 102 then
            self.otherRoleInfo = v
        end
    end

    self._heroName = self:getHeroModelId()
    if self._heroName == "" then
        self._heroName = "nanzhu"
    end
    self.weaponData = nil
    for k,v in pairs(self._otherPlayerInfo.weapons) do
        if tonumber(v.heroId) == tonumber(self.otherRoleInfo.id) then
            self.weaponData = v
            break
        end
    end
	self:initUI(data)
    self:show(false)
end
--查找是否是好友
function otherPlayerSelectPop:findIsFriends()
    local friendInfo = PlayerData:getFriendInfo() or {}
    local friends = friendInfo["friends"] or {}
    local playerBase = self._otherPlayerInfo["base"] or {}
    local playerUserId = playerBase["userId"] or 0
    self._playerUserId = tonumber(playerUserId)
    for i = 1, table.nums(friends) do
        local v = friends[i]
        if v and v.userId then
            if tonumber(v.userId) == tonumber(playerUserId) then
                self._thisFriendInfo = v
                return true
            end
        end 
    end
    return false
end
--查找黑名单
function otherPlayerSelectPop:findIsBlack()
    -- body
    local friendInfo = PlayerData:getFriendInfo() or {}
    local blackInfo = friendInfo["blacklists"] or {}
    local playerBase = self._otherPlayerInfo["base"] or {}
    local playerUserId = playerBase["userId"] or 0
    self._playerUserId = tonumber(playerUserId)
    for i = 1, table.nums(blackInfo) do
        local v = blackInfo[i]
        if v and v.userId then
            if tonumber(v.userId) == tonumber(playerUserId) then
                return true
            end
        end 
    end
    return false
end
function otherPlayerSelectPop:initUI(data)
	local bg = zc.createImageView({
        src = "res/Main/otherPlayer/otherPlayerSelect_bg.png",
        pos = cc.p(zc.width/2, zc.height/2),
        ap = cc.p(0.5,0.5)
    })
    self:addContent(bg)

    local frame_s = zc.getScaleNode("res/Main/common/frame_s.png", cc.size(313,337))
    frame_s:setAnchorPoint(cc.p(0.5, 0.5))
    frame_s:setPosition(cc.p(bg:getContentSize().width/2, bg:getContentSize().height/2))
    bg:addChild(frame_s)

    --主角
    local armature = zc.battle.createHeroArmatureWithResId(self._heroName, self._mainRoleWeapon)
    armature:setPosition(cc.p(50, 200))
    bg:addChild(armature,2)
    armature:setScaleX(-1)
    armature:getAnimation():play("idle")
    self._record[self._heroName] = true
     --更换兵器
    local _weaponId = 0
    if self.weaponData then
        _weaponId = self.weaponData.weaponId
    end
    zc.soldierChangeWeapon(armature,_weaponId)

    local nameBg = cc.Sprite:create("res/Main/wushenTower/name_bg_1.png")
    nameBg:setAnchorPoint(0, 0.5)
    nameBg:setPosition(120, 283)
    bg:addChild(nameBg)

    local weaponStatic = gameData.getDataFromCacheWithPrimaryKey("weapon", self.weaponData["weaponId"]) or {}
    local weapon = zc.createSprite( zc.getHeroTypeImg(weaponStatic["type"] or 1) )
    weapon:setAnchorPoint(0, 0.5)
    weapon:setPosition(-10, nameBg:getContentSize().height/2-8)
    nameBg:addChild(weapon)
    weapon:setScale(0.9)

    local name = zc.createLabel({
        text = ""..self._otherPlayerInfo.base.userName,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0),
        pos = cc.p(25, 3),
        pixel = 1.3
    })
    nameBg:addChild(name)

    local countryNamStr = ""
    if self._otherPlayerInfo.base.countryName and self._otherPlayerInfo.base.countryName ~= "" then
        countryNamStr = "<"..self._otherPlayerInfo.base.countryName..">"
    end
    -- countryNamStr = "<五个字的国家>"
    local countryName = zc.createLabel({
        text = countryNamStr,
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(15, nameBg:getContentSize().height),
        color = zc.COLOR_PURPLE,
        pixel = 1.3
    })
    nameBg:addChild(countryName)



    --战斗力img
    local _player_combat_img = zc.createImageView({
        src = "res/Main/hero/hero_zdl.png",
        ap = cc.p(0,0.5), 
        pos = cc.p(5,170)
    })
    bg:addChild(_player_combat_img)
    --战力
    local _fighting_str = tostring(self._otherPlayerInfo.base.fighting)
    local _player_combat = zc.createFntLabel({
        fnt = "res/Main/common/fnt/fight.fnt",
        text = _fighting_str,
        ap = cc.p(0, 0.5),
        pos = cc.p(100, 162),
        addwidth = -5,
    })
    bg:addChild(_player_combat)
    

    --添加好友
    local addFriendBtn
    addFriendBtn = zc.createPushButton({
        normalFile = "res/Main/otherPlayer/otherPlayer_addFriend_u.png",
        selectedFile = "res/Main/otherPlayer/otherPlayer_addFriend_g.png",
        -- disabled = "res/Main/common/button/common_btn_gray.png",
        endCallback = function () 
            -- zc.tipInfo(zc.lang("tips_function_not_open","功能尚未开放")) 
            addFriendBtn:setEnable(false)
            zc.addFriend(self._otherPlayerInfo.base.userId,function() 
                addFriendBtn:setTouchEndedCall(function()
                    zc.tipInfo(zc.lang("tips_add_friend_send_already"))
                end)
                addFriendBtn:setEnable(true)
            end)    
        end,
        pos = cc.p(250, 195),
    })
    bg:addChild(addFriendBtn)

    --是不是好友
    local isFriend = self:findIsFriends()

    --删除好友
    local deleteFriendBtn
    deleteFriendBtn = zc.createPushButton({
        normalFile = "res/Main/otherPlayer/delete_friend.png",
        endCallback = function ()
            if not self._thisFriendInfo or not self._thisFriendInfo.id then
                zc.tipInfo(zc.lang("tips_info_error"))
                return
            end
            local _id = self._thisFriendInfo.id
            if _id then
                local function doDelete()
                    zc.sendHttp({
                        apiName = "Friend_remove",
                        params = {id=_id},
                        successCallback = function (net_data)
                            if net_data and net_data.result and tonumber(net_data.result)==1 then
                                zc.tipInfo(zc.lang("tips_delete_friend_success"))
                                --删除好友
                                local friendInfo = PlayerData:getFriendInfo() or {}
                                local friends = friendInfo["friends"] or {}
                                for i = 1, table.nums(friends) do
                                    local v = friends[i]
                                    if v and v.userId then
                                        if tonumber(v.userId) == tonumber(self._playerUserId) then
                                            table.remove(friends,i)
                                            break
                                        end
                                    end 
                                end
                                --删除之后，状态改变，变为添加好友状态
                                isFriend = not isFriend
                                if isFriend then
                                    addFriendBtn:setVisible(false)
                                    deleteFriendBtn:setVisible(true)
                                else
                                    deleteFriendBtn:setVisible(false)
                                    addFriendBtn:setVisible(true)
                                end
                            end
                        end,
                        errorCallback = function(_errorCode,_msg)
                            print("-----------log--------ad-------------_msg ", _msg)
                            zc.tipInfo(_msg)
                            if _errorCode and tonumber(_errorCode) == 300 then
                                --好友数量减1

                            end
                        end,
                    })
                end
                local msgStr = zc.lang("tips_besure_delete_friend")
                local comfirm = ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    msg = msgStr,
                    showDi = true,
                    rightCallback = function()
                        doDelete()
                    end
                })  
                self:addChild(comfirm, 11)
            end
        end,
        pos = cc.p(250, 195),
    })
    bg:addChild(deleteFriendBtn)

    if isFriend then
        addFriendBtn:setVisible(false)
        deleteFriendBtn:setVisible(true)
    else
        deleteFriendBtn:setVisible(false)
        addFriendBtn:setVisible(true)
    end
        
    local isBlack = false
    if not isFriend then --如果不是好友，检查是否是在黑名单
        isBlack = self:findIsBlack()
    end
    local _text = LANGUAGE_ARENA.ignore
    if isBlack then
        _text = zc.lang("unblock")
    end
    --解除屏蔽
    local unblockBtn
    unblockBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/btn_sec_u.png",
        selectedFile = "res/Main/common/button/btn_sec_d.png",
        text = _text,
        fontSize = 30,
        scale = 0.7,
        outLine = true,
        color2 = cc.c3b(76, 18, 18),
        endCallback = function () 
            if isBlack then --在黑名单中
                zc.removePlayerFromBlacklist(self._otherPlayerInfo.base.userId, function()
                    local friendInfo = PlayerData:getFriendInfo() or {}
                    local blackInfo = friendInfo["blacklists"] or {}
                    --从黑名单中移除
                    for i = 1, table.nums(blackInfo) do
                        local v = blackInfo[i]
                        if v and v.userId then
                            if tonumber(v.userId) == self._playerUserId then
                                table.remove(blackInfo, i)
                                break
                            end
                        end 
                    end
                    ---
                    isBlack = false
                    unblockBtn:setString(LANGUAGE_ARENA.ignore)
                end)
            else --不是黑名单
                zc.maskThePlayer(self._otherPlayerInfo.base.userId, function() 
                    local friendInfo = PlayerData:getFriendInfo() or {}
                    local friends = friendInfo.friends or {}
                    local blackInfo = {} --记录加入黑名单的信息
                    --加入黑名单，如果是好友则先从好友列表删除，如果不是直接加入黑名单
                    for i = 1, #friends do
                        local v = friends[i]
                        if v and v.userId then
                            if tonumber(v.userId) == self._playerUserId then
                                blackInfo = table.copy(v)
                                table.remove(friends, i)
                                break
                            end 
                        end
                    end
                    if next(blackInfo) then
                        local friendInfo = PlayerData:getFriendInfo() or {}
                    else
                        local base = self._otherPlayerInfo.base
                        blackInfo = {
                            ["countryId"]         = base.countryId,
                            ["countryName"]       = base.countryName,
                            ["fighting"]          = base.fighting,
                            ["godName"]           = base.godName,
                            ["heroId"]            = base.heroId,
                            ["iconId"]            = base.iconId,
                            ["lastLoginTime"]     = base.loginTime,
                            ["level"]             = base.level,
                            ["seigniorId"]        = base.seigniorId,
                            ["userId"]            = base.userId,
                            ["userName"]          = base.userName,
                            ["vip"]               = base.vip,
                        }
                    end
                    friendInfo.blacklists[#friendInfo.blacklists+1] = blackInfo
                    --
                    isBlack = true
                    unblockBtn:setString(zc.lang("unblock"))
                end)
            end 
        end,
        pos = cc.p(85, 102),
    })
    bg:addChild(unblockBtn)

    --切磋
    local fightBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/btn_sec_u.png",
        selectedFile = "res/Main/common/button/btn_sec_d.png",
        text = zc.lang("qiecuo_2"),
        fontSize = 30,
        scale = 0.7,
        outLine = true,
        color2 = cc.c3b(76, 18, 18),
        endCallback = function () 
            -- zc.tipInfo(zc.lang("tips_function_not_open","功能尚未开放")) 
            local kaheiUid = self._otherPlayerInfo.base.userId
            LayerManager.removeLayout(true)
            zc.kahei( kaheiUid ) 
        end,
        pos = cc.p(85, 43),
    })
    bg:addChild(fightBtn)



    --私聊
    local privateChatBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/btn_sec_u.png",
        selectedFile = "res/Main/common/button/btn_sec_d.png",
        text = zc.lang("private_chat"),
        fontSize = 30,
        scale = 0.7,
        outLine = true,
        color2 = cc.c3b(76, 18, 18),
        endCallback = function ()
            local _friendPop = zc.getPop("Friend")
            local uId = self._otherPlayerInfo.base.userId
            local uName = self._otherPlayerInfo.base.userName
            local uGodName = self._otherPlayerInfo.base.godName

            local _data = {toUserId = uId, toGodName = uGodName, toUserName = uName, channel = 3, isClose = true}
            self:hide({noAction=true})
            local _chatPanel = zc.getPop("ChatPanel")
            if _chatPanel then
                _chatPanel:toChatWithUser(_data)
                -- _chatPanel:setShow(false)
            else
                zc.createSourceScene("ChatPanel", "src/layer/chat/ChatPanelPop.lua", _data)
            end
        end,
        pos = cc.p(bg:getContentSize().width/2+65, 102),
    })
    bg:addChild(privateChatBtn)
    --查看信息
    local lookInfoBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/btn_sec_u.png",
        selectedFile = "res/Main/common/button/btn_sec_d.png",
        text = zc.lang("see_info"),
        fontSize = 30,
        scale = 0.7,
        outLine = true,
        color2 = cc.c3b(76, 18, 18),
        endCallback = function () 
            local _data = self._otherPlayerInfo 
            LayerManager.removeLayout(true)
            zc.createPop("otherPlayerDetail",_data)
        end,
        pos = cc.p(bg:getContentSize().width/2+65, 43),
    })
    bg:addChild(lookInfoBtn)

    -- self:setCloseContent(bg)
end

--给武将添加modelId  字段
function otherPlayerSelectPop:getHeroModelId()
    self._sexId = self._otherPlayerInfo["base"]["seigniorId"] or 1 -- 1男、2女
    self._mainHeroId = self._otherPlayerInfo["base"]["heroId"]
    local weapons = self._otherPlayerInfo["weapons"]
    --{"长柄","钝器","法杖","剑","扇子","法球"}
    if weapons and next(weapons) then
        for i = 1, #weapons do
            if self._mainHeroId and tonumber(self._mainHeroId) == tonumber(weapons[i]["heroId"]) then
                local weaponId = weapons[i]["weaponId"]
                self._mainRoleWeapon = weaponId
                break
            end
        end
    end
    return self._sexId == 1 and "nanzhu" or "nvzhujue"
end

return otherPlayerSelectPop